
//  ------------------------------------------------------------------
//  GoldED. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gccfgg.cpp,v 1.1.1.1 1998/11/21 19:38:01 odinn Exp $
//  ------------------------------------------------------------------
//  Main GOLDED.CFG compiler.
//  ------------------------------------------------------------------


#include "golded.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif


//  ------------------------------------------------------------------

extern char __FAR v7nodeflags[16][9];
extern char __FAR v7modemtype[8][9];


//  ------------------------------------------------------------------

int CheckStamp(const Stamp* fntm) {

  return(GetFiletime(fntm->fn) != fntm->ft ? YES : NO);
}


//  ------------------------------------------------------------------
//  Read GOLDED.CFG

int ReadGoldedCfg(int& force) {

  gfile fp;
  register int n;
  CfgVer vers;
  uint compile=YES;
  //int filecheck = false;

  // Check if the binary file needs recompile
  fp.fopen(AddPath(CFG->goldpath, CFG->goldged), "rb", CFG->sharemode);
  if(fp.isopen()) {

    fp.setvbuf(NULL, _IOFBF, 8192);
    fp.fread(&vers, sizeof(CfgVer));

    if(NOT force) {

      // If version is not the same, make sure we recompile everything (force=YES+YES)

      if(NOT streql(vers.date, CFG->vers.date))
        force = YES + YES;
      else if(NOT streql(vers.time, CFG->vers.time))
        force = YES + YES;
    }

    compile = force ? YES : CheckStamp(&vers.cfg);

    // Check if any files needs compiling
    if(NOT compile) {
      fp.fread(&stamps, sizeof(int));
      stamp = (Stamp*)throw_calloc(stamps+1, sizeof(Stamp));
      fp.fread(stamp, sizeof(Stamp), stamps);
      for(n=0; n<stamps AND NOT compile; n++) {
        compile = CheckStamp(&stamp[n]);
        //if(compile and NOT filecheck)
          //filecheck = stamp[n].fc;
      }
    }

    // Read the complete file if no compile needed
    if(NOT compile) {

      fp.fseek(((long)stamps*(long)sizeof(Stamp))+(long)sizeof(CfgVer)+(long)sizeof(int), SEEK_SET);

      fp.fread(CFG, sizeof(CfgGed));

      CFG->addressmacro    =  (AddrMacro*) throw_malloc(1+(sizeof(AddrMacro)*CFG->addressmacros));
      CFG->aka             =       (gaka*) throw_malloc(1+(sizeof(gaka)*CFG->akas));
      CFG->akamatch        =  (AkaMatchG*) throw_malloc(1+(sizeof(AkaMatchG)*CFG->akamatches));
      CFG->event           =     (GEvent*) throw_malloc(1+(sizeof(GEvent)*CFG->events));
      CFG->externutil      =    (ExtUtil*) throw_malloc(1+(sizeof(ExtUtil)*CFG->externutils));
      CFG->filealias       =  (FileAlias*) throw_malloc(1+(sizeof(FileAlias)*CFG->filealiases));
      CFG->frqext          =     (FrqExt*) throw_malloc(1+(sizeof(FrqExt)*CFG->frqexts));
      CFG->frqnodemap      = (FrqNodeMap*) throw_malloc(1+(sizeof(FrqNodeMap)*CFG->frqnodemaps));
      CFG->gif             =    (Gifname*) throw_malloc(1+(sizeof(Gifname)*CFG->gifs));
      CFG->kludge          =     (Kludge*) throw_malloc(1+(sizeof(Kludge)*CFG->kludges));
      CFG->mailinglist     =   (MailList*) throw_malloc(1+(sizeof(MailList)*CFG->mailinglists));
      CFG->mappath         =   (MapPathE*) throw_malloc(1+(sizeof(MapPathE)*CFG->mappaths*2));
      CFG->origin          =       (Orig*) throw_malloc(1+(sizeof(Orig)*CFG->origins));
      CFG->robotname       =       (Name*) throw_malloc(1+(sizeof(Name)*CFG->robotnames));
      CFG->tagline         =    (Tagline*) throw_malloc(1+(sizeof(Tagline)*CFG->taglines));
      CFG->tpl             =        (Tpl*) throw_malloc(1+(sizeof(Tpl)*CFG->tpls));
      CFG->twitname        =       (Node*) throw_malloc(1+(sizeof(Node)*CFG->twitnames));
      CFG->twitsubj        =       (Subj*) throw_malloc(1+(sizeof(Subj)*CFG->twitsubjs));
      CFG->username        =       (Node*) throw_malloc(1+(sizeof(Node)*CFG->usernames));
      CFG->xlatcharset     =        (Map*) throw_malloc(1+(sizeof(Map)*CFG->xlatcharsets));
      CFG->xlatescset      =        (Map*) throw_malloc(1+(sizeof(Map)*CFG->xlatescsets));

      fp.fread(CFG->addressmacro,   sizeof(AddrMacro),  CFG->addressmacros);
      fp.fread(CFG->aka,            sizeof(gaka),       CFG->akas);
      fp.fread(CFG->akamatch,       sizeof(AkaMatchG),  CFG->akamatches);
      fp.fread(CFG->event,          sizeof(GEvent),     CFG->events);
      fp.fread(CFG->externutil,     sizeof(ExtUtil),    CFG->externutils);
      fp.fread(CFG->filealias,      sizeof(FileAlias),  CFG->filealiases);
      fp.fread(CFG->frqext,         sizeof(FrqExt),     CFG->frqexts);
      fp.fread(CFG->frqnodemap,     sizeof(FrqNodeMap), CFG->frqnodemaps);
      fp.fread(CFG->gif,            sizeof(Gifname),    CFG->gifs);
      fp.fread(CFG->kludge,         sizeof(Kludge),     CFG->kludges);
      fp.fread(CFG->mailinglist,    sizeof(MailList),   CFG->mailinglists);
      fp.fread(CFG->mappath,        sizeof(MapPathE),   CFG->mappaths*2);
      fp.fread(CFG->origin,         sizeof(Orig),       CFG->origins);
      fp.fread(CFG->robotname,      sizeof(Name),       CFG->robotnames);
      fp.fread(CFG->tagline,        sizeof(Tagline),    CFG->taglines);
      fp.fread(CFG->tpl,            sizeof(Tpl),        CFG->tpls);
      fp.fread(CFG->twitname,       sizeof(Node),       CFG->twitnames);
      fp.fread(CFG->twitsubj,       sizeof(Subj),       CFG->twitsubjs);
      fp.fread(CFG->username,       sizeof(Node),       CFG->usernames);
      fp.fread(CFG->xlatcharset,    sizeof(Map),        CFG->xlatcharsets);
      fp.fread(CFG->xlatescset,     sizeof(Map),        CFG->xlatescsets);

      CFG->cmdkey = (CmdKey*)throw_malloc(1+(sizeof(CmdKey)*CFG->cmdkeys));
      fp.fread(CFG->cmdkey, sizeof(CmdKey), CFG->cmdkeys);

      CFG->macro = (Macro*)throw_malloc(1+(sizeof(Macro)*CFG->macros));
      fp.fread(CFG->macro, sizeof(Macro), CFG->macros);

      fp.fread(v7nodeflags, 9, 16);
      fp.fread(v7modemtype, 9, 8);

      EDIT->Load(fp);
      GRP->Load(fp);
      QWK->Load(fp);
      AL.Load(fp);

    }
    fp.fclose();
  }

  // Call the general config reader to do the work
  if(compile) {

    CfgInit2();

    stamps = 0;
    throw_release(stamp);

    //if(filecheck)
      //ShellToDos(CFG->filecheckcall, "", LGREY|_BLACK, true, false, false);

    if(ReadCfg(AddPath(CFG->goldpath, CFG->goldcfg))) {

      strcpy(CFG->vers.cfg.fn, AddPath(CFG->goldpath, CFG->goldcfg));
      CFG->vers.cfg.ft = GetFiletime(AddPath(CFG->goldpath, CFG->vers.cfg.fn));

      // Unallocate echolist
      AFILE->echolist.FreeAll();

      // Set default paths

      if(*CFG->temppath == NUL)       strcpy(CFG->temppath,      CFG->goldpath);
      if(*CFG->swappath == NUL)       strcpy(CFG->swappath,      CFG->temppath);
      if(*CFG->areapath == NUL)       strcpy(CFG->areapath,      CFG->goldpath);
      if(*CFG->inboundpath == NUL)    strcpy(CFG->inboundpath,   CFG->goldpath);
      if(*CFG->soundpath == NUL)      strcpy(CFG->soundpath,     CFG->goldpath);
      if(*CFG->cookiepath == NUL)     strcpy(CFG->cookiepath,    CFG->goldpath);
      if(*CFG->templatepath == NUL)   strcpy(CFG->templatepath,  CFG->goldpath);

      if(*CFG->squishuserpath == NUL) {
        char* ptr = getenv("MAXIMUS");
        if(ptr) {
          if(is_dir(ptr))
            AddBackslash(strcpy(CFG->squishuserpath, ptr));
        }
        else {
          ptr = getenv("SQUISH");
          if(ptr)
            AddBackslash(strcpy(CFG->squishuserpath, ptr));
          else
            strcpy(CFG->squishuserpath, CFG->areapath);
        }
      }

      if(*CFG->hudsonpath == NUL)       strcpy(CFG->hudsonpath, CFG->goldpath);
      if(*CFG->hudsonsyspath == NUL)    strcpy(CFG->hudsonsyspath, CFG->hudsonpath);
      if(*CFG->goldbasepath == NUL)     strcpy(CFG->goldbasepath, CFG->hudsonpath);
      if(*CFG->goldbasesyspath == NUL)  strcpy(CFG->goldbasesyspath, CFG->goldbasepath);
      if(*CFG->jampath == NUL)          strcpy(CFG->jampath, CFG->hudsonpath);

      MakePathname(CFG->goldcfg,    CFG->goldpath, CFG->goldcfg);
      MakePathname(CFG->helpcfg.fn, CFG->goldpath, CFG->helpcfg.fn);
      MakePathname(CFG->keyscfg.fn, CFG->goldpath, CFG->keyscfg.fn);
      MakePathname(CFG->langcfg.fn, CFG->goldpath, CFG->langcfg.fn);
      MakePathname(CFG->randcfg.fn, CFG->goldpath, CFG->randcfg.fn);

      MakePathname(CFG->goldged, CFG->goldpath, CFG->goldged);
      MakePathname(CFG->helpged, CFG->goldpath, CFG->helpged);
      MakePathname(CFG->langged, CFG->goldpath, CFG->langged);
      MakePathname(CFG->randged, CFG->goldpath, CFG->randged);
      MakePathname(CFG->xlatged, CFG->goldpath, CFG->xlatged);

      MakePathname(CFG->confirmfile, CFG->goldpath, CFG->confirmfile);
      MakePathname(CFG->logfile, CFG->goldpath, CFG->logfile);
      MakePathname(CFG->userlistfile, CFG->nodepath, CFG->userlistfile);
      MakePathname(CFG->outputfile, CFG->goldpath, CFG->outputfile);
      MakePathname(CFG->inputfile, CFG->goldpath, CFG->inputfile);

      if(*CFG->souptosslog)
        MakePathname(CFG->souptosslog, CFG->goldpath, CFG->souptosslog);

      for(n=0; n<CFG->tpls; n++)
        MakePathname(CFG->tpl[n].file, CFG->templatepath, CFG->tpl[n].file);

      MakePathname(CFG->semaphore.importlist, CFG->areapath, CFG->semaphore.importlist);
      MakePathname(CFG->semaphore.exportlist, CFG->areapath, CFG->semaphore.exportlist);
      MakePathname(CFG->semaphore.echoscan,   CFG->areapath, CFG->semaphore.echoscan);
      MakePathname(CFG->semaphore.netscan,    CFG->areapath, CFG->semaphore.netscan);

      MakePathname(CFG->semaphore.scanall,    CFG->goldpath, CFG->semaphore.scanall);
      MakePathname(CFG->semaphore.scanthis,   CFG->goldpath, CFG->semaphore.scanthis);
      MakePathname(CFG->semaphore.scannetmail,CFG->goldpath, CFG->semaphore.scannetmail);
      MakePathname(CFG->semaphore.pmscanall,  CFG->goldpath, CFG->semaphore.pmscanall);
      MakePathname(CFG->semaphore.pmscanthis, CFG->goldpath, CFG->semaphore.pmscanthis);
      MakePathname(CFG->semaphore.pmscannetmail, CFG->goldpath, CFG->semaphore.pmscannetmail);

      MakePathname(CFG->semaphore.qwkimport,  CFG->goldpath, CFG->semaphore.qwkimport);
      MakePathname(CFG->semaphore.qwkexport,  CFG->goldpath, CFG->semaphore.qwkexport);
      MakePathname(CFG->semaphore.soupimport, CFG->goldpath, CFG->semaphore.soupimport);
      MakePathname(CFG->semaphore.soupexport, CFG->goldpath, CFG->semaphore.soupexport);
      MakePathname(CFG->semaphore.exitnow,    CFG->goldpath, CFG->semaphore.exitnow);

      strschg_environ(CFG->jampath);
      strschg_environ(CFG->semaphore.importlist);
      strschg_environ(CFG->semaphore.exportlist);
      strschg_environ(CFG->semaphore.echoscan);
      strschg_environ(CFG->semaphore.netscan);

      if(strieql(CFG->semaphore.exportlist, AddPath(CFG->jampath, "echomail.jam"))) {
        printf("\n* Warning: SEMAPHORE EXPORTLIST must not be the same as ECHOMAIL.JAM!");
        if(NOT disablesound)
          beep();
        cfgerrors++;
      }
    }

    // Set default xlatimport
    if(*CFG->xlatimport == NUL)
      strcpy(CFG->xlatimport, CFG->xlatlocalset);

    ReadXlatTables();

    // Free all mapfile name allocations
    for(n=0; n<CFG->xlatescsets; n++)
      throw_release(CFG->xlatescset[n].mapfile);
    for(n=0; n<CFG->xlatcharsets; n++)
      throw_release(CFG->xlatcharset[n].mapfile);
  }

  return compile;
}


//  ------------------------------------------------------------------
//  Write GOLDED.GED

void WriteGoldGed() {

  // Mark areas according to scan/pmscan in/excludes
  if(AL.First()) {

    register int s, x, i;

    do {

      register Area* ap = AL.pointer;

      // Check scan in/excludes
      for(s=0; s<CFG->areascans; s++) {
        if(strwild(ap->echoid(), CFG->areascan[s])) {
          ap->set_scan(true);
          break;
        }
      }
      for(x=0; x<CFG->areascanexcls; x++) {
        if(strwild(ap->echoid(), CFG->areascanexcl[x])) {
          ap->set_scanexcl(true);
          break;
        }
      }
      for(i=0; i<CFG->areascanincls; i++) {
        if(strwild(ap->echoid(), CFG->areascanincl[i])) {
          ap->set_scanincl(true);
          break;
        }
      }

      // Check pmscan in/excludes
      for(s=0; s<CFG->areapmscans; s++) {
        if(strwild(ap->echoid(), CFG->areapmscan[s])) {
          ap->set_pmscan(true);
          break;
        }
      }
      for(x=0; x<CFG->areapmscanexcls; x++) {
        if(strwild(ap->echoid(), CFG->areapmscanexcl[x])) {
          ap->set_pmscanexcl(true);
          break;
        }
      }
      for(i=0; i<CFG->areapmscanincls; i++) {
        if(strwild(ap->echoid(), CFG->areapmscanincl[i])) {
          ap->set_pmscanincl(true);
          break;
        }
      }
    } while(AL.Next());
  }

  // Release lists memory
  throw_release(CFG->areaexcl);        CFG->areaexcls = 0;
  throw_release(CFG->areaincl);        CFG->areaincls = 0;
  throw_release(CFG->areaisemail);     CFG->areaisemails = 0;
  throw_release(CFG->areaisnews);      CFG->areaisnewss = 0;
  throw_release(CFG->areascan);        CFG->areascans = 0;
  throw_release(CFG->areascanexcl);    CFG->areascanexcls = 0;
  throw_release(CFG->areascanincl);    CFG->areascanincls = 0;
  throw_release(CFG->arearename);      CFG->arearenames = 0;
  throw_release(CFG->areapmscan);      // Keep count for later use
  throw_release(CFG->areapmscanexcl);  // Keep count for later use
  throw_release(CFG->areapmscanincl);  // Keep count for later use

  // Write the binary config
  gfile fp;
  fp.fopen(AddPath(CFG->goldpath, CFG->goldged), "wb", CFG->sharemode);
  if(fp.isopen()) {
    fp.setvbuf(NULL, _IOFBF, 8192);
    update_statusline(LNG->WritingCfg+1);
    fp.fwrite(&CFG->vers,          sizeof(CfgVer));
    fp.fwrite(&stamps,             sizeof(int));
    fp.fwrite(stamp,               sizeof(Stamp), stamps);
    fp.fwrite(CFG,                 sizeof(CfgGed));
    fp.fwrite(CFG->addressmacro,   sizeof(AddrMacro),  CFG->addressmacros);
    fp.fwrite(CFG->aka,            sizeof(gaka),       CFG->akas);
    fp.fwrite(CFG->akamatch,       sizeof(AkaMatchG),  CFG->akamatches);
    fp.fwrite(CFG->event,          sizeof(GEvent),     CFG->events);
    fp.fwrite(CFG->externutil,     sizeof(ExtUtil),    CFG->externutils);
    fp.fwrite(CFG->filealias,      sizeof(FileAlias),  CFG->filealiases);
    fp.fwrite(CFG->frqext,         sizeof(FrqExt),     CFG->frqexts);
    fp.fwrite(CFG->frqnodemap,     sizeof(FrqNodeMap), CFG->frqnodemaps);
    fp.fwrite(CFG->gif,            sizeof(Gifname),    CFG->gifs);
    fp.fwrite(CFG->kludge,         sizeof(Kludge),     CFG->kludges);
    fp.fwrite(CFG->mailinglist,    sizeof(MailList),   CFG->mailinglists);
    fp.fwrite(CFG->mappath,        sizeof(MapPathE),   CFG->mappaths*2);
    fp.fwrite(CFG->origin,         sizeof(Orig),       CFG->origins);
    fp.fwrite(CFG->robotname,      sizeof(Name),       CFG->robotnames);
    fp.fwrite(CFG->tagline,        sizeof(Tagline),    CFG->taglines);
    fp.fwrite(CFG->tpl,            sizeof(Tpl),        CFG->tpls);
    fp.fwrite(CFG->twitname,       sizeof(Node),       CFG->twitnames);
    fp.fwrite(CFG->twitsubj,       sizeof(Subj),       CFG->twitsubjs);
    fp.fwrite(CFG->username,       sizeof(Node),       CFG->usernames);
    fp.fwrite(CFG->xlatcharset,    sizeof(Map),        CFG->xlatcharsets);
    fp.fwrite(CFG->xlatescset,     sizeof(Map),        CFG->xlatescsets);

    fp.fwrite(CFG->cmdkey,       sizeof(CmdKey),     CFG->cmdkeys);
    fp.fwrite(CFG->macro,        sizeof(Macro),      CFG->macros);

    fp.fwrite(v7nodeflags, 9, 16);
    fp.fwrite(v7modemtype, 9, 8);

    EDIT->Save(fp);
    GRP->Save(fp);
    QWK->Save(fp);
    AL.Save(fp);

    fp.fclose();

    // Write a config dump
    //#define CONFIGDUMP
    #ifdef CONFIGDUMP
    char* gbug = getenv("GBUG");
    if(strieql(gbug ? gbug : "", "TEST")) {
      FILE* fp = fsopen(AddPath(CFG->goldpath, "GOLDDUMP.CFG"), "wt", CFG->sharemode);
      if(fp) {
        setvbuf(fp, NULL, _IOFBF, 8192);
        for(int n=0; n<13; n++) {
          fprintf(fp, "{%d, { %3d, %3d, %3d, %3d, %3d, %3d, %3d, %3d, %3d, %3d, %3d, %3d}, %d},  // Color %02d\n",
            CFG->color[n].btype,
            CFG->color[n].c[ 0], CFG->color[n].c[ 1],
            CFG->color[n].c[ 2], CFG->color[n].c[ 3],
            CFG->color[n].c[ 4], CFG->color[n].c[ 5],
            CFG->color[n].c[ 6], CFG->color[n].c[ 7],
            CFG->color[n].c[ 8], CFG->color[n].c[ 9],
            CFG->color[n].c[10], CFG->color[n].c[11],
            CFG->color[n].w, n
          );
        }
      }
      fclose(fp);
    }
    #endif
  }
}


//  ------------------------------------------------------------------

static int EnterString(char* prompt, char* string, uint length) {

  printf("\n%s\n> ", prompt);

  *string = NUL;
  char* ptr = string;
  uint pos = 0;
  Key k;
  while(1) {
    k = kbxget();
    if(k == Key_BS) {
      if(pos) {
        fputc('\b', stdout);
        fputc(' ',  stdout);
        fputc('\b', stdout);
        pos--;
        *(--ptr) = NUL;
      }
    }
    else if(k == Key_Esc) {
      *string = NUL;
      return -1;
    }
    else if(k == Key_Ent) {
      *ptr = NUL;
      break;
    }
    else {
      if(pos < length) {
        char c = (char)k;
        if(c) {
          fputc(c, stdout);
          *ptr++ = c;
          pos++;
        }
      }
    }
  }
  if(*string == NUL)
    return 1;
  return 0;
}


//  ------------------------------------------------------------------

struct AF_entry {

  char* env;
  char* configname;
  char* name;

};

#define MAX_IDETECT 18

struct AF_entry __FAR idetect[MAX_IDETECT] = {
  {    "DUTCHIE",  "DUTCHIE.ARE", "Dutchie"      },
  {        "EZY", "CONSTANT.EZY", "Ezycom"       },
  {   "FASTECHO", "FASTECHO.CFG", "Fastecho"     },
  {    "FIDOPCB",  "FIDOPCB.CFG", "FidoPCB"      },
  {      "FMAIL",    "FMAIL.CFG", "FMail"        },
  {      "IMAIL",     "IMAIL.CF", "IMAIL"        },
  {    "PCBOARD",  "PCBOARD.DAT", "PCBoard"      },
  { "POPCMDLINE",   "PORTAL.ARE", "Portal"       },
  {         "RA",   "CONFIG.PRO", "ProBoard"     },
  {     "QFRONT",   "QECHOS.DAT", "QFront"       },
  {     "RAECHO",    "AREAS.RAE", "RA-ECHO"      },
  {         "RA",    "CONFIG.RA", "RemoteAccess" },
  {      "TIMED",    "TIMED.CFG", "timEd"        },
  {         "TM",       "TM.CFG", "Termail"      },
  {      "WMAIL",    "WMAIL.PRM", "WMail"        },
  {         "XM",    "XMAIL.CFG", "XMail"        },
  {         "FD",  "AREAFILE.FD", "TosScan"      },
  {         "GE",     "SETUP.GE", "GEcho"        },
#if 0
  {       "OPUS",   "SYSMSG.DAT", "Opus"         },
#endif

};


void InstallDetect(char* path) {

  // Create GOLDED.BAK file if there is an existing GOLDED.CFG
  if(fexist(cmdlinecfg)) {
    Path cmdlinecfgbak;
    char drive[GMAXDRIVE], dir[GMAXDIR], file[GMAXFILE], ext[GMAXEXT];
    _splitpath(cmdlinecfg, drive, dir, file, ext);
    _makepath(cmdlinecfgbak, drive, dir, file, "bak");
    remove(cmdlinecfgbak);
    rename(cmdlinecfg, cmdlinecfgbak);
    printf("\nWARNING: Existing GOLDED.CFG renamed to GOLDED.BAK!!!");
  }

  printf("\nPlease wait while GoldED is detecting your software.");

  FILE* fp = fopen(cmdlinecfg, "wt");
  if(fp) {

    if(*path) {
      PathCopy(CFG->areapath, path);
      fprintf(fp, "AREAPATH %s\n", path);
    }

    Path pth;
    char* ptr;
    int gotareasbbs = FALSE;
    int detected = 0;

    // simple detection
    for(uint i = 0; i < MAX_IDETECT; i++) {
      strcpy(pth, CFG->areapath);
      ptr = getenv(idetect[i].env);
      if(ptr) {
        PathCopy(pth, ptr);
        // skip additional information
        ptr = strchr(pth, ' ');
        if(ptr)
          *ptr = NUL;
      }
      if(fexist(AddPath(pth, idetect[i].configname))) {
        fprintf(fp, "AREAFILE %s %s\n", idetect[i].name, pth);
        printf("\nFound %s.", idetect[i].name);
        detected++;
      }
    }

    // Detect FrontDoor
    strcpy(pth, CFG->areapath);
    ptr = getenv("FD");
    if(ptr)
      PathCopy(pth, ptr);
    if(fexist(AddPath(pth, "SETUP.FD"))) {
      fprintf(fp, "AREAFILE FrontDoor %s\n", pth);
      printf("\nFound FrontDoor.");
      detected++;
    }
    else if(fexist(AddPath(pth, "FD.SYS")) AND fexist(AddPath(pth, "FD.EXE"))) {
      fprintf(fp, "AREAFILE FrontDoor %s\n", pth);
      printf("\nFound FrontDoor.");
      detected++;
    }

    // Detect InterMail
    strcpy(pth, CFG->areapath);
    ptr = getenv("IM");
    if(ptr)
      PathCopy(pth, ptr);
    if(fexist(AddPath(pth, "IM.EXE")) OR fexist(AddPath(pth, "INTRECHO.EXE"))) {
      fprintf(fp, "AREAFILE InterMail %s\n", pth);
      printf("\nFound InterMail and/or InterEcho.");
      detected++;
    }

    // Detect LoraBBS
    strcpy(pth, CFG->areapath);
    ptr = getenv("LORA");
    if(ptr)
      PathCopy(pth, ptr);
    ptr = getenv("LORABBS");
    if(ptr)
      PathCopy(pth, ptr);
    if(fexist(AddPath(pth, "SYSMSG.DAT"))) {
      fprintf(fp, "AREAFILE LoraBBS %s\n", pth);
      printf("\nFound LoraBBS.");
      detected++;
    }

    // Detect Maximus
    strcpy(pth, CFG->areapath);
    ptr = getenv("MAXIMUS");
    if(ptr) {
      if(is_dir(ptr))
        PathCopy(pth, ptr);
      else {
        char drive[GMAXDRIVE], dir[GMAXDIR], file[GMAXFILE], ext[GMAXEXT];
        _splitpath(ptr, drive, dir, file, ext);
        _makepath(pth, drive, dir, "", "");
      }
    }

    int gotsquish = FALSE;
    if(fexist(AddPath(pth, "MAX.PRM"))) {
      fprintf(fp, "AREAFILE Maximus %s\n", pth);
      printf("\nFound Maximus.");
      detected++;
    }
    if(fexist(AddPath(pth, "SQUISH.CFG"))) {
      fprintf(fp, "AREAFILE Squish %s\n", pth);
      printf("\nFound Squish.");
      gotsquish = TRUE;
      detected++;
    }

    // Detect ME2
    strcpy(pth, CFG->areapath);
    if(fexist(AddPath(pth, "AREADESC.ME2"))) {
      fprintf(fp, "AREAFILE ME2 %sAREADESC.ME2 %sAREAS.BBS\n", pth, pth);
      printf("\nFound ME2.");
      gotareasbbs = TRUE;
      detected++;
    }

    // Detect QuickBBS
    strcpy(pth, CFG->areapath);
    ptr = getenv("QUICKBBS");
    if(ptr)
      PathCopy(pth, ptr);
    ptr = getenv("QBBS");
    if(ptr)
      PathCopy(pth, ptr);
    if(fexist(AddPath(pth, "QUICKCFG.DAT")) OR fexist(AddPath(pth, "CONFIG.BBS"))) {
      fprintf(fp, "AREAFILE QuickBBS %s\n", pth);
      printf("\nFound QuickBBS.");
      detected++;
    }

    // Detect Squish
    if(NOT gotsquish) {
      strcpy(pth, CFG->areapath);
      ptr = getenv("SQUISH");
      if(ptr) {
        strcpy(pth, ptr);
        if(is_dir(pth))
          strcat(pth, GOLD_SLASH_STR "squish.cfg");
        if(fexist(pth)) {
          fprintf(fp, "AREAFILE Squish %s\n", pth);
          printf("\nFound Squish.");
          detected++;
        }
      }
    }

    // Detect SuperBBS
    strcpy(pth, CFG->areapath);
    ptr = getenv("SUPERBBS");
    if(ptr)
      PathCopy(pth, ptr);
    ptr = getenv("SBBS");
    if(ptr)
      PathCopy(pth, ptr);
    if(fexist(AddPath(pth, "SCONFIG.BBS"))) {
      fprintf(fp, "AREAFILE SuperBBS %s\n", pth);
      printf("\nFound SuperBBS.");
      detected++;
    }

    // Detect D'Bridge
    strcpy(pth, CFG->areapath);
    ptr = getenv("DBRIDGE");
    if(ptr)
      PathCopy(pth, ptr);
    ptr = getenv("DB");
    if(ptr)
      PathCopy(pth, ptr);
    if(fexist(AddPath(pth, "DBRIDGE.PRM"))) {
      fprintf(fp, "AREAFILE D'Bridge %s\n", pth);
      printf("\nFound D'Bridge.");
      detected++;
    }

    // Detect AREAS.BBS
    if(NOT gotareasbbs) {
      strcpy(pth, CFG->areapath);
      if(fexist(AddPath(pth, "AREAS.BBS"))) {
        fprintf(fp, "AREAFILE AreasBBS %sAREAS.BBS\n", pth);
        printf("\nFound AREAS.BBS.");
        detected++;
      }
    }

    if(NOT detected)
      printf("\nSorry, could not find any supported software. Try another path.");

    fclose(fp);
  }

  printf("\n");
}


//  ------------------------------------------------------------------

int InstallFinish() {

  FILE* fp = fopen(cmdlinecfg, "at");
  if(fp) {

    char buf[77];

    // Check what we have

    if(CFG->usernames == 0) {
      if(EnterString("Please enter your name:", buf, sizeof(buf)))
        return -1;
      fprintf(fp, "USERNAME %s\n", buf);
      CfgUsername(buf);
    }
    if(CFG->akas == 0) {
      if(EnterString("Please enter your FidoNet address:", buf, sizeof(buf)))
        return -1;
      fprintf(fp, "ADDRESS %s\n", buf);
      CfgAddress(buf);
    }
    if(AL.msgbases == 0) {
      if(EnterString("Please enter the path to your *.MSG netmail area:", buf, sizeof(buf)))
        return -1;
      fprintf(fp, "AREADEF NETMAIL \"Netmail\" 0 Net Opus %s\n", buf);
      AreaCfg aa;
      aa.reset();
      aa.setdesc("Netmail");
      aa.setechoid("NETMAIL");
      aa.msgbase = MT_OPUS;
      aa.type = AT_NET;
      aa.setpath(buf);
      aa.attr = CFG->attribsnet;
      AL.AddNewArea(&aa);
      if(EnterString("Please enter the path *and* filename of your AREAS.BBS file:", buf, sizeof(buf)))
        return -1;
      fprintf(fp, "AREAFILE AreasBBS %s\n", buf);
      {
        char buf2[200];
        strcpy(buf2, "AreaBBS ");
        strcat(buf2, buf);
        AL.GetAreafile(buf2);
      }
    }
    if((AL.msgbases & MT_HUDSON) AND (*CFG->hudsonpath == NUL)) {
      if(EnterString("Please enter the path to your Hudson msgbase files:", buf, sizeof(buf)))
        return -1;
      fprintf(fp, "HUDSONPATH %s\n", buf);
      PathCopy(CFG->hudsonpath, buf);
    }
    if((AL.msgbases & MT_GOLDBASE) AND (*CFG->goldbasepath == NUL)) {
      if(EnterString("Please enter the path to your Goldbase msgbase files:", buf, sizeof(buf)))
        return -1;
      fprintf(fp, "GOLDBASEPATH %s\n", buf);
      PathCopy(CFG->goldbasepath, buf);
    }
    if((AL.msgbases & MT_JAM) AND (*CFG->jampath == NUL)) {
      if(EnterString("Please enter the path where NET/ECHOMAIL.JAM can be placed:", buf, sizeof(buf)))
        return -1;
      fprintf(fp, "JAMPATH %s\n", buf);
      PathCopy(CFG->jampath, buf);
    }
    if((AL.msgbases & MT_PCBOARD) AND (*CFG->pcboardpath == NUL)) {
      if(EnterString("Please enter the path to PCBoard:", buf, sizeof(buf)))
        return -1;
      fprintf(fp, "PCBOARDPATH %s\n", buf);
      PathCopy(CFG->pcboardpath, buf);
    }

    fclose(fp);
  }

  return 0;
}


//  ------------------------------------------------------------------

GoldedCfgEdit::GoldedCfgEdit() {

  memset(&cfg, 0, sizeof(cfg));

  // Set Boolean values
  AutoAttach(TRUE);
  AutoSave(30);
  ChangeDate(TRUE);
  CharPara(' ');
  CharSpace(' ');
  FieldClear(TRUE);
  HardLines(TRUE);
  HdrNamePos(8);
  HdrNameLen(36);
  HdrNodePos(44);
  HdrNodeLen(36);
  HeaderAttrs(TRUE);
  HeaderFirst(EDITHEADERFIRST_YES);
  Internal(TRUE);
  Margin(80);
  Menu(TRUE);
#if defined(__MSDOS__) and not defined(__386__)
  MsgSize(64000L);
#else
  MsgSize(512000L);
#endif
  QuoteMargin(75);
  SaveMenu(TRUE);
  UnDelete(50);

  cfg.external = str.Add("");
  cfg.file = str.Add("golded.msg");
  cfg.hardline = str.Add("<<");
  cfg.spellchecker = str.Add("");
}


//  ------------------------------------------------------------------

void GoldedCfgEdit::Save(gfile& fp) {

  fp.fwrite(&cfg, sizeof(cfg));
  str.Save(fp);
  Comment.Save(fp);
  Completion.Save(fp);
  SaveUtil.Save(fp);
}


//  ------------------------------------------------------------------

void GoldedCfgEdit::Load(gfile& fp) {

  fp.fread(&cfg, sizeof(cfg));
  str.Load(fp);
  Comment.Load(fp);
  Completion.Load(fp);
  SaveUtil.Load(fp);
}


//  ------------------------------------------------------------------

