
//  ------------------------------------------------------------------
//  GoldED. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gccfgg1.cpp,v 1.1.1.1 1998/11/21 19:38:01 odinn Exp $
//  ------------------------------------------------------------------
//  Configuration functions, part 1.
//  ------------------------------------------------------------------


#include "golded.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#include "gcprot.h"


//  ------------------------------------------------------------------

extern char* val;


//  ------------------------------------------------------------------

void CfgAddress()  { CfgAddress(val); }
void CfgAddress(char* v) {

  if(NOT strblank(v)) {

    if(veryverbose)
      printf("\n  CfgAddress(%s)", v);

    gaka aka;
    memset(&aka, 0, sizeof(gaka));

    char* ptr = strchr(v, ',');
    if(ptr) {
      aka.pointnet = atow(ptr+1);
      *ptr = NUL;
    }
    if(CFG->akas) {
      aka.addr = CFG->aka[0].addr;
      strcpy(aka.domain, CFG->aka[0].domain);
    }
    aka.addr.set(v, aka.domain);

    if(cfgingroup)
      GRP->AddItm(GRP_AKA, &aka, sizeof(gaka));

    int gotaka = GetAkaNo(aka.addr);
    if(gotaka == -1) {
      CFG->aka = (gaka*)throw_realloc(CFG->aka, (CFG->akas+1)*sizeof(gaka));
      CFG->aka[CFG->akas++] = aka;
    }
  }
}

//  ------------------------------------------------------------------

void CfgAddressbookadd() {

  CFG->addressbookadd = GetYesno(val);
}

//  ------------------------------------------------------------------

void CfgAddressmacro(char* v)  { val = v; CfgAddressmacro(); }
void CfgAddressmacro() {
            
  CFG->addressmacro = (AddrMacro*)throw_realloc(CFG->addressmacro, (CFG->addressmacros+1)*sizeof(AddrMacro));
  AddrMacro* addrmacrop = CFG->addressmacro + CFG->addressmacros++;
  memset(addrmacrop, 0, sizeof(AddrMacro));
  int subjwasquoted = NO;
  char* ptr = val;
  char* ptr2 = strchr(ptr, ',');                                 //  macro^,name,address,subj,attribs
  if(ptr2) {
    // Got macroname
    *ptr2++ = NUL;
    strxcpy(addrmacrop->macro, ptr, 20);
    ptr = ptr2;
    ptr = SkipWht(ptr);
    ptr2 = strchr(ptr, ',');                                    //  macro,name^,address,subj,attribs
    if(ptr2) {
      // Got real name
      *ptr2++ = NUL;
      //strchg(ptr, '_', ' ');
      strxcpy(addrmacrop->name, ptr, sizeof(IAdr));
      ptr = ptr2;
      ptr = SkipWht(ptr);
      ptr2 = strchr(ptr, ',');                                  //  macro,name,address^,subj,attribs
      if(ptr2)
        *ptr2++ = NUL;
      // Got address
      if(CFG->akas)
        addrmacrop->addr = CFG->aka[0].addr;
      addrmacrop->addr.set(ptr);
      if(ptr2) {
        // Got subject
        ptr = SkipWht(ptr2);
        if((*ptr == '\"') OR (*ptr == '\'')) {
          ptr2 = strchr(ptr+1, *ptr);
          if(ptr2) {
            subjwasquoted = YES;
            *ptr2++ = NUL;
            ptr++;
          }
        }
        strxcpy(addrmacrop->subj, ptr, sizeof(Subj));

        // Got quoted subj, so look for attribs
        if(subjwasquoted) {
          ptr2 = strchr(ptr2, ',');                             //  macro,name,address,subj^,attribs
          if(ptr2) {
            GetAttribstr(&addrmacrop->attr, ptr2+1);
          }
        }
      }
    }
  }
}

//  ------------------------------------------------------------------

void CfgAdeptxbbspath() {

  PathCopy(CFG->adeptxbbspath, val);
}

//  ------------------------------------------------------------------

void CfgAdeptxbbsuserno() {

  CFG->adeptxbbsuserno = atoi(val);
}

//  ------------------------------------------------------------------

void CfgAkamatch() {

  char* key;
  getkeyval(&key, &val);

  CFG->akamatch = (AkaMatchG*)throw_realloc(CFG->akamatch, (CFG->akamatches+1)*sizeof(AkaMatchG));
  AkaMatchG* akamatchp = CFG->akamatch + CFG->akamatches++;

  akamatchp->mask.set_all(GFTN_ALL);
  akamatchp->mask.set(key);

  akamatchp->aka.reset(val);
}

//  ------------------------------------------------------------------

void CfgAkamatching() {

  int _flag = GetYesno(val);
  if(cfgingroup)
    GRP->AddItm(GRP_AKAMATCHING, &_flag, sizeof(int));
}

//  ------------------------------------------------------------------

void CfgArea() {

  AL.GetArea(val);
}

//  ------------------------------------------------------------------

void CfgAreaautoid() {

  if(striinc("VERBOSE", val))
    CFG->areaautoid = AUTOID_VERBOSE;
  if(striinc("SHORT", val))
    CFG->areaautoid = AUTOID_SHORT;
  if(striinc("LONG", val))
    CFG->areaautoid = AUTOID_LONG;
}

//  ------------------------------------------------------------------

void CfgAreacopydirect() {

  int _flag = GetYesno(val);
  if(cfgingroup)
    GRP->AddItm(GRP_AREACOPYDIRECT, &_flag, sizeof(int));
  else
    CFG->areacopydirect = _flag;
}

//  ------------------------------------------------------------------

void CfgAreacopyto() {

  Echo buf;
  strxcpy(buf, val, sizeof(buf));
  if(cfgingroup)
    GRP->AddItm(GRP_AREACOPYTO, buf, strlen(buf)+1);
  else
    strcpy(CFG->areacopyto, buf);
}

//  ------------------------------------------------------------------

void CfgAreacopyaddid() {

  int flag = GetYesno(val);
  if(cfgingroup)
    GRP->AddItm(GRP_AREACOPYADDID, &flag, sizeof(int));
  else
    CFG->areacopyaddid = flag;
}

//  ------------------------------------------------------------------

void CfgAreadef() {

  AL.GetAreaDef(val);
}

//  ------------------------------------------------------------------

void CfgAreadesc() {

  AL.GetAreaDesc(val);
}

//  ------------------------------------------------------------------

void CfgAreaexcl() {

  GTok t;
  if(t.First(val)) {
    do {
      CFG->areaexcl = (Echo*)throw_realloc(CFG->areaexcl, (CFG->areaexcls+1)*sizeof(Echo));
      strxcpy(CFG->areaexcl[CFG->areaexcls++], t.Token(), sizeof(Echo));
    } while(t.Next());
  }
}


//  ------------------------------------------------------------------

void CfgAreafreqdirect() {

  int _flag = GetYesno(val);
  if(cfgingroup)
    GRP->AddItm(GRP_AREAFREQDIRECT, &_flag, sizeof(int));
  else
    CFG->areafreqdirect = _flag;
}

//  ------------------------------------------------------------------

void CfgAreafreqto() {

  Echo buf;
  strxcpy(buf, val, sizeof(buf));
  if(cfgingroup)
    GRP->AddItm(GRP_AREAFREQTO, buf, strlen(buf)+1);
  else
    strcpy(CFG->areafreqto, buf);
}

//  ------------------------------------------------------------------

void CfgAreaincl() {

  val = strtok(val, ", \t");
  while(val) {
    CFG->areaincl = (Echo*)throw_realloc(CFG->areaincl, (CFG->areaincls+1)*sizeof(Echo));
    strxcpy(CFG->areaincl[CFG->areaincls++], val, sizeof(Echo));
    val = strtok(NULL, ", \t");
  }
}

//  ------------------------------------------------------------------

void CfgAreaisemail() {

  val = strtok(val, ", \t");
  while(val) {
    CFG->areaisemail = (Echo*)throw_realloc(CFG->areaisemail, (CFG->areaisemails+1)*sizeof(Echo));
    strxcpy(CFG->areaisemail[CFG->areaisemails++], val, sizeof(Echo));
    val = strtok(NULL, ", \t");
  }
}

//  ------------------------------------------------------------------

void CfgAreaisnews() {

  val = strtok(val, ", \t");
  while(val) {
    CFG->areaisnews = (Echo*)throw_realloc(CFG->areaisnews, (CFG->areaisnewss+1)*sizeof(Echo));
    strxcpy(CFG->areaisnews[CFG->areaisnewss++], val, sizeof(Echo));
    val = strtok(NULL, ", \t");
  }
}

//  ------------------------------------------------------------------

void CfgArealistechomax() {

  CFG->arealistechomax = atoi(val);
}

//  ------------------------------------------------------------------

void CfgArealistformat() {

  strcpy(CFG->arealistformat, StripQuotes(val));
}


//  ------------------------------------------------------------------

void CfgArealistscan() {

  char* _key;
  getkeyval(&_key, &val);
  AL.ListScan.Add(StripQuotes(_key), val);
}

//  ------------------------------------------------------------------

void CfgArealistsort() {

  strupr(strxcpy(CFG->arealistsort, val, sizeof(CFG->arealistsort)));
}

//  ------------------------------------------------------------------

void CfgArealisttype() {

  if(strieql(val, "New"))
    CFG->arealisttype = AL_TOTNEW;
  else if(strieql(val, "Last"))
    CFG->arealisttype = AL_TOTLST;
  else if(strieql(val, "TotalNew"))   // Obsolete syntax
    CFG->arealisttype = AL_TOTNEW;
  else if(strieql(val, "TotalLast"))  // Obsolete syntax
    CFG->arealisttype = AL_TOTLST;
}

//  ------------------------------------------------------------------

void CfgAreapath() {

  PathCopy(CFG->areapath, val);
}

//  ------------------------------------------------------------------

void CfgAreapmscan() {

  val = strtok(val, ", \t");
  while(val) {
    CFG->areapmscan = (Echo*)throw_realloc(CFG->areapmscan, (CFG->areapmscans+1)*sizeof(Echo));
    strxcpy(CFG->areapmscan[CFG->areapmscans++], val, sizeof(Echo));
    val = strtok(NULL, ", \t");
  }
}

//  ------------------------------------------------------------------

void CfgAreapmscanexcl() {

  val = strtok(val, ", \t");
  while(val) {
    CFG->areapmscanexcl = (Echo*)throw_realloc(CFG->areapmscanexcl, (CFG->areapmscanexcls+1)*sizeof(Echo));
    strxcpy(CFG->areapmscanexcl[CFG->areapmscanexcls++], val, sizeof(Echo));
    val = strtok(NULL, ", \t");
  }
}

//  ------------------------------------------------------------------

void CfgAreapmscanincl() {

  val = strtok(val, ", \t");
  while(val) {
    CFG->areapmscanincl = (Echo*)throw_realloc(CFG->areapmscanincl, (CFG->areapmscanincls+1)*sizeof(Echo));
    strxcpy(CFG->areapmscanincl[CFG->areapmscanincls++], val, sizeof(Echo));
    val = strtok(NULL, ", \t");
  }
}

//  ------------------------------------------------------------------

void CfgAreareadonly() {
  
  if(strieql(val, "Soft"))
    CFG->areareadonly = READONLY_SOFT;
  else if(strieql(val, "Hard"))
    CFG->areareadonly = READONLY_HARD;
}

//  ------------------------------------------------------------------

void CfgArearename() {

  char* key;
  CFG->arearename = (EchoRen*)throw_realloc(CFG->arearename, (CFG->arearenames+1)*sizeof(EchoRen));
  getkeyval(&key, &val);
  strxcpy(CFG->arearename[CFG->arearenames].from, key, sizeof(Echo));
  strxcpy(CFG->arearename[CFG->arearenames].to, strtrim(val), sizeof(Echo));
  CFG->arearenames++;
}

//  ------------------------------------------------------------------

