
//  ------------------------------------------------------------------
//  GoldED. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gccfgg3.cpp,v 1.1.1.1 1998/11/21 19:38:01 odinn Exp $
//  ------------------------------------------------------------------
//  Configuration functions, part 3.
//  ------------------------------------------------------------------


#include "golded.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#include "gcprot.h"


//  ------------------------------------------------------------------

extern char* val;

//  ------------------------------------------------------------------

void CfgDispmargin() {

  CFG->cfgdispmargin = atoi(val);
  CFG->dispmargin = CFG->cfgdispmargin;
}

//  ------------------------------------------------------------------

void CfgDispmsgsize() {

  if(strieql("NO", val))
    CFG->dispmsgsize = NO;
  else if(strieql("BYTES", val))
    CFG->dispmsgsize = DISPMSGSIZE_BYTES;
  else if(strieql("KBYTES", val))
    CFG->dispmsgsize = DISPMSGSIZE_KBYTES;
  else if(strieql("LINES", val))
    CFG->dispmsgsize = DISPMSGSIZE_KBYTES+1;
}

//  ------------------------------------------------------------------

void CfgDispareano() {

  CFG->dispareano = GetYesno(val);
}

//  ------------------------------------------------------------------

void CfgDisptabsize() {

  CFG->disptabsize = atoi(val);
}

//  ------------------------------------------------------------------

void CfgDosswap() {

  #if defined(USE_SPAWNO) OR defined(USE_EXECSWAP)

  CFG->dosswap = atoi(val);
  if(CFG->dosswap == 0) {
    char* ptr = strtok(val, ",. \t");
    while(ptr) {
      if(strieql(ptr, "YES")) {
        CFG->dosswap |= GSWAP_ALL;
      }
      else if(strieql(ptr, "NO")) {
        CFG->dosswap = GSWAP_NONE;
        break;
      }
      else if(strieql(ptr, "XMS")) {
        CFG->dosswap |= GSWAP_XMS;
        if(NOT(CFG->dosswap & GSWAP_EMS))
          CFG->dosswap |= GSWAP_XMS_FIRST;
      }
      else if(strieql(ptr, "EMS")) {
        CFG->dosswap |= GSWAP_EMS;
        if(NOT(CFG->dosswap & GSWAP_XMS))
          CFG->dosswap |= GSWAP_EMS_FIRST;
      }
      else if(strieql(ptr, "Disk")) {
        CFG->dosswap |= GSWAP_DISK;
      }
      else if(strieql(ptr, "Hide")) {
        CFG->dosswap |= GSWAP_HIDE_FILE;
      }
      else if(strieql(ptr, "NoPreAlloc")) {
        CFG->dosswap |= GSWAP_NO_PREALLOC;
      }
      else if(strieql(ptr, "CheckNet")) {
        CFG->dosswap |= GSWAP_CHECK_NET;
      }
      ptr = strtok(NULL, ", \t");
    }
  }

  #endif
}

//  ------------------------------------------------------------------

void CfgEditautoattach() {

  EDIT->AutoAttach(GetYesno(val));
}

//  ------------------------------------------------------------------

void CfgEditautosave() {

  EDIT->AutoSave(atoi(val));
}

//  ------------------------------------------------------------------

void CfgEditchangedate() {

  EDIT->ChangeDate(GetYesno(val));
}

//  ------------------------------------------------------------------

void CfgEditcharpara() {

  char ch = *StripQuotes(val);
  if(ch)
    EDIT->CharPara(ch);
}

//  ------------------------------------------------------------------

void CfgEditcharspace() {

  char ch = *StripQuotes(val);
  if(ch)
    EDIT->CharSpace(ch);
}

//  ------------------------------------------------------------------

void CfgEditcomment() {

  char* key;
  getkeyval(&key, &val);
  StripQuotes(key);
  StripQuotes(val);
  EDIT->Comment.Add(key, val);
}

//  ------------------------------------------------------------------

void CfgEditcompletion() {

  char* key;
  getkeyval(&key, &val);
  StripQuotes(key);
  StripQuotes(val);
  EDIT->Completion.Add(key, val);
}

//  ------------------------------------------------------------------

void CfgEditcrlfterm() {

  EDIT->CrLfTerm(GetYesno(val));
}

//  ------------------------------------------------------------------

void CfgEditfieldclear() {

  EDIT->FieldClear(GetYesno(val));
}

//  ------------------------------------------------------------------

void CfgEdithardline() {

  EDIT->HardLine(StripQuotes(val));
}

//  ------------------------------------------------------------------

void CfgEdithardlines() {

  EDIT->HardLines(GetYesno(val));
}

//  ------------------------------------------------------------------

void CfgEdithardterm() {

  int yn = GetYesno(val);
  if(cfgingroup)
    GRP->AddItm(GRP_EDITHARDTERM, &yn, sizeof(int));
  else
    EDIT->HardTerm(yn);
}

//  ------------------------------------------------------------------

void CfgEdithdrnameset() {

  char* key;
  getkeyval(&key, &val);
  EDIT->HdrNamePos(atoi(key));
  EDIT->HdrNameLen(atoi(val));
}

//  ------------------------------------------------------------------

void CfgEdithdrnodeset() {

  char* key;
  getkeyval(&key, &val);
  EDIT->HdrNodePos(atoi(key));
  EDIT->HdrNodeLen(atoi(val));
}

//  ------------------------------------------------------------------

void CfgEditheaderattrs() {

  EDIT->HeaderAttrs(GetYesno(val));
}

//  ------------------------------------------------------------------

void CfgEditheaderfirst() {

  int v = EDITHEADERFIRST_NO;
  GTok t;
  if(t.First(val)) {
    do {
      if(strieql("NEW", t.Token()))
        v |= EDITHEADERFIRST_NEW;
      else if(strieql("CHANGES", t.Token()))
        v |= EDITHEADERFIRST_CHANGES;
      else if(strieql("REPLIES", t.Token()))
        v |= EDITHEADERFIRST_REPLIES;
      else if(strieql("FORWARDS", t.Token()))
        v |= EDITHEADERFIRST_FORWARDS;
      else
        v = GetYesno(t.Token()) ? EDITHEADERFIRST_YES : EDITHEADERFIRST_NO;
    } while(t.Next());
  }
  EDIT->HeaderFirst(v);
}

//  ------------------------------------------------------------------

void CfgEditinternal() {

  EDIT->Internal(GetYesno(val));
}

//  ------------------------------------------------------------------

void CfgEditmargin() {

  EDIT->Margin(atoi(val));
}

//  ------------------------------------------------------------------

void CfgEditmenu() {

  EDIT->Menu(GetYesno(val));
}

//  ------------------------------------------------------------------

void CfgEditmixcase() {

  int yn = GetYesno(val);
  if(cfgingroup)
    GRP->AddItm(GRP_EDITMIXCASE, &yn, sizeof(int));
  else
    EDIT->MixCase(yn);
}

//  ------------------------------------------------------------------

void CfgEditmsgsize() {

  EDIT->MsgSize(atol(val));
}

//  ------------------------------------------------------------------

void CfgEditor() {

  EDIT->External(val);
}

//  ------------------------------------------------------------------

void CfgEditorfile() {

  EDIT->File(val);
}

//  ------------------------------------------------------------------

void CfgEditorversion() {

  // No longer supported
}

//  ------------------------------------------------------------------

void CfgEditquotemargin() {

  EDIT->QuoteMargin(atoi(val));
}

//  ------------------------------------------------------------------

void CfgEditreplyre() {

  int replyre;
  if(strieql(val, "NUMERIC"))
    replyre = REPLYRE_NUMERIC;
  else
    replyre = GetYesno(val) ? REPLYRE_YES : REPLYRE_NO;

  if(cfgingroup)
    GRP->AddItm(GRP_EDITREPLYRE, &replyre, sizeof(int));
  else
    EDIT->ReplyRe(replyre);
}

//  ------------------------------------------------------------------

void CfgEditsavemenu() {

  EDIT->SaveMenu(GetYesno(val));
}

//  ------------------------------------------------------------------

void CfgEditsaveutil() {

  char* _key;
  getkeyval(&_key, &val);
  int n = atoi(_key);
  EDIT->SaveUtil.Add(n, StripQuotes(val));
}

//  ------------------------------------------------------------------

void CfgEditsoftcrxlat() {

  EDIT->SoftCrXlat(*val);
}

//  ------------------------------------------------------------------

void CfgEditspellcheck() {

  EDIT->SpellChecker(val);
}

//  ------------------------------------------------------------------

void CfgEditundelete() {

  EDIT->UnDelete(atoi(val));
}

//  ------------------------------------------------------------------

void CfgEndgroup() {

  cfgingroup = FALSE;
}

//  ------------------------------------------------------------------

void CfgEvent(char* v)  { val = v; CfgEvent(); }
void CfgEvent() {

  char* key;
  register word n, x;

  x = getkeyvalcrc(&key, &val);

  for(n=0; n<CFG->events; n++)
    if(x == CFG->event[n].type)
      break;

  if(n == CFG->events) {
    CFG->event = (GEvent*)throw_realloc(CFG->event, (CFG->events+1)*sizeof(GEvent));
    CFG->events++;
  }

  CFG->event[n].type = x;
  getkeyval(&key, &val);
  if(strieql(key, "PLAY")) {
    CFG->event[n].command = EVTC_PLAY;
    FileToGPlay(&CFG->event[n].play, val);
  }
}

//  ------------------------------------------------------------------

