
//  ------------------------------------------------------------------
//  GoldED. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gccfgg6.cpp,v 1.2 1999/02/02 02:09:41 damware Exp $
//  ------------------------------------------------------------------
//  Configuration functions, part 6.
//  ------------------------------------------------------------------


#include "golded.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#include "gcprot.h"


//  ------------------------------------------------------------------

extern char* val;


//  ------------------------------------------------------------------

void CfgMsglistfirst() {

  int _flag = GetYesno(val);
  if(cfgingroup)
    GRP->AddItm(GRP_MSGLISTFIRST, &_flag, sizeof(int));
  else
    CFG->msglistfirst = _flag;
}

//  ------------------------------------------------------------------

void CfgMsglistheader() {

  int _flag = GetYesno(val);
  if(cfgingroup)
    GRP->AddItm(GRP_MSGLISTHEADER, &_flag, sizeof(int));
  else
    CFG->msglistheader = _flag;
}

//  ------------------------------------------------------------------

void CfgMsglistwidesubj() {

  int _flag = GetYesno(val);
  if(cfgingroup)
    GRP->AddItm(GRP_MSGLISTWIDESUBJ, &_flag, sizeof(int));
  else
    CFG->msglistwidesubj = _flag;
}

//  ------------------------------------------------------------------

void CfgNamesfile() {

  strcpy(CFG->namesfile, val);
}

//  ------------------------------------------------------------------

void CfgNickname() {
  
  Name buf;
  
  strxcpy(buf, val, sizeof(buf));
  if(cfgingroup)
    GRP->AddItm(GRP_NICKNAME, buf, strlen(buf)+1);
  else
    strcpy(CFG->nickname, buf);
}
  
//  ------------------------------------------------------------------

void CfgNetname() {

  StripQuotes(val);
  Netn buf;
  strxcpy(buf, val, sizeof(buf));
  if(cfgingroup)
    GRP->AddItm(GRP_NETNAME, buf, strlen(buf)+1);
  else
    strcpy(CFG->netname, buf);
}

//  ------------------------------------------------------------------

void CfgNettear() {

  CFG->ctrlinfonet &= ~CI_TEAR;
  CFG->ctrlinfonet |= GetYesno(val) ? CI_TEAR : CI_NONE;
}

//  ------------------------------------------------------------------

void CfgNodelist() {

  // Only used by GoldNODE
}

//  ------------------------------------------------------------------

void CfgNodepath() {

  PathCopy(CFG->nodepath, val);
}

//  ------------------------------------------------------------------

void CfgNodepathfd() {

  PathCopy(CFG->nodepathfd, val);
}

//  ------------------------------------------------------------------

void CfgNodepathv7() {

  PathCopy(CFG->nodepathv7, val);
}

//  ------------------------------------------------------------------

extern char __FAR v7nodeflags[16][9];

void CfgNodev7flags() {

  GTok t;
  char* flagstring = t.First(val);
  char* flagvals = t.Next();
  uint flagval;
  if(tolower(*flagvals) == 'b')
    flagval = atoi(flagvals+1);
  else {
    flagval = atoi(flagvals);
    switch(flagval) {
      case    32: flagval =  5; break;
      case    64: flagval =  6; break;
      case   128: flagval =  7; break;
      case   256: flagval =  8; break;
      case   512: flagval =  9; break;
      case  1024: flagval = 10; break;
      case  2048: flagval = 11; break;
      case  8192: flagval = 13; break;
      case 16384: flagval = 14; break;
      default:    flagval = 0;
    }
  }
  if(flagval)
    sprintf(v7nodeflags[flagval], "%s,", flagstring);
}

//  ------------------------------------------------------------------

extern char __FAR v7modemtype[8][9];

void CfgNodev7modem() {

  GTok t;
  char* modemstring = t.First(val);
  char* modemvals = t.Next();
  int modemval;
  if(tolower(*modemvals) == 'b')
    modemval = atoi(modemvals+1);
  else {
    modemval = atoi(modemvals);
    switch(modemval) {
      case   1: modemval = 0; break;
      case   2: modemval = 1; break;
      case   4: modemval = 2; break;
      case   8: modemval = 3; break;
      case  16: modemval = 4; break;
      case  32: modemval = 5; break;
      case  64: modemval = 6; break;
      case 128: modemval = 7; break;
      default:  modemval = -1;
    }
  }
  if(modemval >= 0)
    sprintf(v7modemtype[modemval], "%s,", modemstring);
}

//  ------------------------------------------------------------------

void CfgOrganization() {

  INam buf;
  strxcpy(buf, val, sizeof(buf));
  if(cfgingroup)
    GRP->AddItm(GRP_ORGANIZATION, buf, strlen(buf)+1);
  else
    strcpy(CFG->organization, buf);
}

//  ------------------------------------------------------------------

void CfgOrigin(const char* v)  { char buf[256]; val = strcpy(buf, v); CfgOrigin(); }
void CfgOrigin() {

  if(NOT strblank(val)) {
    StripQuotes(val);
    Orig buf;
    strxcpy(buf, val, sizeof(buf));
    if(cfgingroup)
      GRP->AddItm(GRP_ORIGIN, buf, strlen(buf)+1);
    else {
      CFG->origin = (Orig*)throw_realloc(CFG->origin, (CFG->origins+1)*sizeof(Orig));
      strcpy(CFG->origin[CFG->origins++], buf);
    }
  }
}

//  ------------------------------------------------------------------

void CfgOutboundpath() {

  PathCopy(CFG->outboundpath, val);
}

//  ------------------------------------------------------------------

void CfgOutputfile() {

  Path buf;
  strxcpy(buf, val, sizeof(buf));
  if(cfgingroup)
    GRP->AddItm(GRP_OUTPUTFILE, buf, strlen(buf)+1);
  else
    strcpy(CFG->outputfile, buf);
}

//  ------------------------------------------------------------------

void CfgOverlay() {

  if(strieql(val, "EMS"))
    CFG->overlay = OVL_EMS;
  else if(strieql(val, "EXT"))
    CFG->overlay = OVL_EXT;
  else if(strieql(val, "DISK"))
    CFG->overlay = OVL_DISK;
}

//  ------------------------------------------------------------------

void CfgOverlayems() {

  CFG->overlay = GetYesno(val) ? OVL_EMS : OVL_DISK;
}

//  ------------------------------------------------------------------

void CfgOverlayext() {

  CFG->overlay = GetYesno(val) ? OVL_EXT : OVL_DISK;
}

//  ------------------------------------------------------------------

void CfgPathreportfile() {

  PathCopy(CFG->pathreportfile, val);
}

//  ------------------------------------------------------------------

void CfgPcboardmailer() {

  if(strieql(val, "PCBOARD"))
    CFG->pcboardmailer = PCBOARDMAILER_PCBOARD;
  else
    CFG->pcboardmailer = PCBOARDMAILER_OTHER;
}

//  ------------------------------------------------------------------

void CfgPcboardpath() {
  
  PathCopy(CFG->pcboardpath, val);
}

//  ------------------------------------------------------------------

void CfgPcboarduserno() {

  CFG->pcboarduserno = atoi(val);
}

//  ------------------------------------------------------------------

void CfgPersonalmail() {

  if(striinc("STARTUP", val))
    CFG->personalmail |= PM_STARTUP;
  if(striinc("NOTSTARTUP", val))
    CFG->personalmail &= ~PM_STARTUP;
  if(striinc("ALLNAMES", val))
    CFG->personalmail |= PM_ALLNAMES;
  if(striinc("NOTALLNAMES", val))
    CFG->personalmail &= ~PM_ALLNAMES;
  if(striinc("LISTONLY", val))
    CFG->personalmail |= PM_LISTONLY;
  if(striinc("NOTLISTONLY", val))
    CFG->personalmail &= ~PM_LISTONLY;
}

//  ------------------------------------------------------------------

void CfgPlay() {

  Path buf;
  strxcpy(buf, val, sizeof(buf));
  if(cfgingroup)
    GRP->AddItm(GRP_PLAY, buf, strlen(buf)+1);
  else
    FileToGPlay(&CFG->play, buf);
}

//  ------------------------------------------------------------------

void CfgPrintdevice() {

  strcpy(CFG->printdevice, val);
}

//  ------------------------------------------------------------------

void CfgPrintinit() {

  CvtPrnstr(CFG->printinit, val);
}

//  ------------------------------------------------------------------

void CfgPrintlength() {

 CFG->printlength = atoi(val);
}

//  ------------------------------------------------------------------

void CfgPrintmargin() {

 CFG->printmargin = atoi(val);
}

//  ------------------------------------------------------------------

void CfgPrintreset() {

  CvtPrnstr(CFG->printreset, val);
}

//  ------------------------------------------------------------------

void CfgQbbsincrescan() {

  // Obsolete
}

//  ------------------------------------------------------------------

void CfgQbbsrebuild() {

  // Obsolete;
}

//  ------------------------------------------------------------------

void CfgQbbsscan() {

  // Obsolete
}

//  ------------------------------------------------------------------

void CfgQuotebuffile() {

  Path buf;
  strxcpy(buf, val, sizeof(buf));
  if(cfgingroup)
    GRP->AddItm(GRP_QUOTEBUFFILE, buf, strlen(buf)+1);
  else
    strcpy(CFG->quotebuffile, buf);
}

//  ------------------------------------------------------------------

void CfgQuotebufmode() {

  if(strieql(val, "ASK"))
    CFG->quotebufmode = QBUF_ASK;
  else if(strieql(val, "APPEND"))
    CFG->quotebufmode = QBUF_APPEND;
  else if(strieql(val, "OVERWRITE"))
    CFG->quotebufmode = QBUF_OVERWRITE;
}

//  ------------------------------------------------------------------

void CfgQuotechars() {

  char buf[11];
  strxcpy(buf, StripQuotes(val), sizeof(buf));
  if(cfgingroup)
    GRP->AddItm(GRP_QUOTECHARS, buf, strlen(buf)+1);
  else
    strcpy(CFG->quotechars, buf);
}

//  ------------------------------------------------------------------

void CfgQuotemargin() {

  CFG->cfgquotemargin = atoi(val);
  CFG->quotemargin = CFG->cfgquotemargin;
}


