
//  ------------------------------------------------------------------
//  GoldED. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gccfgg8.cpp,v 1.1.1.1 1998/11/21 19:38:01 odinn Exp $
//  ------------------------------------------------------------------
//  Configuration functions, part 8.
//  ------------------------------------------------------------------


#include "golded.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#include "gcprot.h"


//  ------------------------------------------------------------------

extern char* val;


//  ------------------------------------------------------------------

void CfgSquishuserno() {

  CFG->squishuserno = atoi(val);
}

//  ------------------------------------------------------------------

void CfgSquishuserpath() {

  PathCopy(CFG->squishuserpath, val);
}

//  ------------------------------------------------------------------

void CfgStatuslinehelp() {

  CFG->statuslinehelp = strieql(val, "NOLOGO") ? -1 : GetYesno(val);
}

//  ------------------------------------------------------------------

void CfgStylecodepunct() {

  char* key;
  getkeyval(&key, &val);
  strxcpy(CFG->stylecodepunct, strcvtc(key), sizeof(CFG->stylecodepunct));
}

//  ------------------------------------------------------------------

void CfgStylecodestops() {

  char* key;
  getkeyval(&key, &val);
  strxcpy(CFG->stylecodestops, strcvtc(key), sizeof(CFG->stylecodestops));
}

//  ------------------------------------------------------------------

void CfgSwappath() {

  PathCopy(CFG->swappath, val);
}

//  ------------------------------------------------------------------

void CfgTagline() {

  Tagline buf;
  strxcpy(buf, val, sizeof(buf));
  if(cfgingroup)
    GRP->AddItm(GRP_TAGLINE, buf, strlen(buf)+1);
  else {
    CFG->tagline = (Tagline*)throw_realloc(CFG->tagline, (CFG->taglines+1)*sizeof(Tagline));
    strcpy(CFG->tagline[CFG->taglines++], buf);
  }
}

//  ------------------------------------------------------------------

void CfgTaglinechar() {

  StripQuotes(val);
  if(cfgingroup)
    GRP->AddItm(GRP_TAGLINECHAR, val, 1);
  else
    CFG->taglinechar = *val;
}

//  ------------------------------------------------------------------

void CfgTaglinefile() {

  Path buf;
  strxcpy(buf, val, sizeof(buf));
  if(cfgingroup)
    GRP->AddItm(GRP_TAGLINEFILE, buf, strlen(buf)+1);
  else
    strcpy(CFG->taglinefile, buf);
}

//  ------------------------------------------------------------------

void CfgTaglinesupport() {

  int _flag = GetYesno(val);
  if(cfgingroup)
    GRP->AddItm(GRP_TAGLINESUPPORT, &_flag, sizeof(int));
  else
    CFG->taglinesupport = _flag;
}

//  ------------------------------------------------------------------

void CfgTearline() {

  StripQuotes(val);
  Tear buf;
  strxcpy(buf, val, sizeof(buf));
  if(cfgingroup)
    GRP->AddItm(GRP_TEARLINE, buf, strlen(buf)+1);
  else
    strcpy(CFG->tearline, buf);
}

//  ------------------------------------------------------------------

void CfgTemplate() {

  if(cfgingroup) {
    Path buf;
    strxcpy(buf, val, sizeof(buf));
    GRP->AddItm(GRP_TEMPLATE, buf, strlen(buf)+1);
  }
  else {
    char* key;
    CFG->tpl = (Tpl*)throw_realloc(CFG->tpl, (CFG->tpls+1)*sizeof(Tpl));
    Tpl* tp = CFG->tpl + CFG->tpls;
    *tp->name = NUL;
    tp->match.reset();
    getkeyval(&key, &val);
    strcpy(tp->file, key);
    if((*val == '\'') OR (*val == '\"')) {
      getkeyval(&key, &val);
      strcpy(tp->name, key);
      if(*val)
        tp->match.set(val);
    }
    else if(*val)
      tp->match.set(val);
    if(NOT *tp->name)
      strcpy(tp->name, tp->file);
    CFG->tpls++;
  }
}

//  ------------------------------------------------------------------

void CfgTemplatematch() {

  int _flag = GetYesno(val);
  if(cfgingroup)
    GRP->AddItm(GRP_TEMPLATEMATCH, &_flag, sizeof(int));
  else
    CFG->templatematch = _flag;
}


//  ------------------------------------------------------------------

void CfgTemplatepath() {

  PathCopy(CFG->templatepath, val);
}

//  ------------------------------------------------------------------

void CfgTemppath() {

  PathCopy(CFG->temppath, val);
}

//  ------------------------------------------------------------------

void CfgTimeout() {

  CFG->timeout = atoi(val);
}

//  ------------------------------------------------------------------

void CfgTimeslice() {

  // Obsolete
  //CFG->timeslice = GetYesno(val);
}

//  ------------------------------------------------------------------

void CfgTimezoneoffset() {

  CFG->timezoneoffset = atoi(val);
}

//  ------------------------------------------------------------------

void CfgTwitmode() {

  int tmp = TWIT_SHOW;
  if(strieql(val, "Skip"))          tmp = TWIT_SKIP;
  else if(strieql(val, "Blank"))    tmp = TWIT_BLANK;
  else if(strieql(val, "Show"))     tmp = TWIT_SHOW;
  else if(strieql(val, "Ignore"))   tmp = TWIT_IGNORE;
  else if(strieql(val, "Kill"))     tmp = TWIT_KILL;
  else tmp = GetYesno(val) ? TWIT_SHOW : TWIT_BLANK;

  if(cfgingroup)
    GRP->AddItm(GRP_TWITMODE, &tmp, sizeof(int));
  else
    CFG->twitmode = tmp;
}

//  ------------------------------------------------------------------

void CfgTwitname() {

  CFG->twitname = (Node*)throw_realloc(CFG->twitname, (CFG->twitnames+1)*sizeof(Node));
  CFG->twitname[CFG->twitnames].addr.zone = GFTN_ALL;
  CFG->twitname[CFG->twitnames].addr.net = GFTN_ALL;
  CFG->twitname[CFG->twitnames].addr.node = GFTN_ALL;
  CFG->twitname[CFG->twitnames].addr.point = GFTN_ALL;
  char* ptr = strrchr(val, ' ');
  if(ptr == NULL)
    ptr = val;
  ptr = SkipWht(ptr);
  if(isdigit(*ptr)) {
    if(CFG->akas)
      CFG->twitname[CFG->twitnames].addr = CFG->aka[0].addr;
    CFG->twitname[CFG->twitnames].addr.set(ptr);
    if(CFG->twitname[CFG->twitnames].addr.net) {
      // Address was given
      *ptr = NUL;
      strbtrim(val);
    }
  }
  strcpy(CFG->twitname[CFG->twitnames++].name, val);
}

//  ------------------------------------------------------------------

void CfgTwitsubj() {

  CFG->twitsubj = (Subj*)throw_realloc(CFG->twitsubj, (CFG->twitsubjs+1)*sizeof(Subj));
  strcpy(CFG->twitsubj[CFG->twitsubjs++], StripQuotes(val));
}

//  ------------------------------------------------------------------

void CfgUsefwd() {

  int flag = GetYesno(val);
  if(cfgingroup)
    GRP->AddItm(GRP_USEFWD, &flag, sizeof(int));
  else
    CFG->usefwd = flag;
}

//  ------------------------------------------------------------------

void CfgUseintl() {

  CFG->useintl = GetYesno(val);
}

//  ------------------------------------------------------------------

void CfgUserlist() {

  // Only used by GoldNODE
}

//  ------------------------------------------------------------------

void CfgUserlistfile() {

  strcpy(CFG->userlistfile, val);
}

//  ------------------------------------------------------------------

void CfgUsername(char* v)  { val = v; CfgUsername(); }
void CfgUsername() {

  StripQuotes(val);
  if(NOT strblank(val)) {
    if(cfgingroup) {
      char buf[256];
      strxcpy(buf, val, sizeof(buf));
      GRP->AddItm(GRP_USERNAME, buf, strlen(buf)+1);
    }
    else {

      Node tmp;
      char* aptr = strrchr(val, ',');
      if(aptr) {
        *aptr++ = NUL;
        fastSkipWht(aptr);
      }
      else {
        aptr = strrchr(val, ' ');
        if(aptr) {
          tmp.addr.reset(aptr+1);
          if(tmp.addr.net == 0)
            aptr = NULL;
          else
            *aptr++ = NUL;
        }
      }

      tmp.addr.set_all(GFTN_ALL);
      if(aptr) {
        if(CFG->akas)
          tmp.addr = CFG->aka[0].addr;
        tmp.addr.set(aptr);
        if(not CFG->akas)
          CfgAddress(tmp.addr.make_string(tmp.name));  // tmp.name is temp-var
      }

      strxcpy(tmp.name, strbtrim(val), sizeof(Name));

      // Check if we have it already
      for(uint u=0; u<CFG->usernames; u++)
        if(strieql(tmp.name, CFG->username[u].name))
          return;

      CFG->username = (Node*)throw_realloc(CFG->username, (CFG->usernames+1)*sizeof(Node));
      Node* tmp2 = CFG->username + CFG->usernames++;
      memcpy(tmp2, &tmp, sizeof(Node));
    }
  }
}

//  ------------------------------------------------------------------

void CfgUudecodepath() {

  PathCopy(CFG->uudecodepath, val);
}

//  ------------------------------------------------------------------

void CfgViewhidden() {

  int tmp = GetYesno(val);
  if(cfgingroup)
    GRP->AddItm(GRP_VIEWHIDDEN, &tmp, sizeof(int));
  else
    CFG->viewhidden = tmp;
}

//  ------------------------------------------------------------------

void CfgViewkludge() {

  int tmp = GetYesno(val);
  if(cfgingroup)
    GRP->AddItm(GRP_VIEWKLUDGE, &tmp, sizeof(int));
  else
    CFG->viewkludge = tmp;
}

//  ------------------------------------------------------------------

void CfgViewquote() {

  int tmp = GetYesno(val);
  if(cfgingroup)
    GRP->AddItm(GRP_VIEWQUOTE, &tmp, sizeof(int));
  else
    CFG->viewquote = tmp;
}

//  ------------------------------------------------------------------

void CfgWhoto() {

  Name buf;
  strxcpy(buf, val, sizeof(buf));
  if(cfgingroup)
    GRP->AddItm(GRP_WHOTO, buf, strlen(buf)+1);
  else
    strcpy(CFG->whoto, buf);
}

//  ------------------------------------------------------------------

void CfgWildcatuserno() {

  CFG->wildcatuserno = atoi(val);
}

//  ------------------------------------------------------------------

void CfgXlatcharset() {

  CFG->xlatcharset = (Map*)throw_realloc(CFG->xlatcharset, (CFG->xlatcharsets+1)*sizeof(Map));
  char* ptr = strtok(val, " \t\n\r");
  if(ptr) {
    strchg(strupr(strcpy(CFG->xlatcharset[CFG->xlatcharsets].import, ptr)), '_', ' ');
    ptr = strtok(NULL, " \t\n\r");
    if(ptr) {
      strchg(strupr(strcpy(CFG->xlatcharset[CFG->xlatcharsets].export, ptr)), '_', ' ');
      ptr = strtok(NULL, " \t\n\r");
      if(ptr) {
        if(*CFG->xlatpath == NUL)
          strcpy(CFG->xlatpath, CFG->goldpath);
        MakePathname(ptr, CFG->xlatpath, ptr);
        CFG->xlatcharset[CFG->xlatcharsets].mapfile = throw_strdup(ptr);
        CFG->xlatcharsets++;
      }
    }
  }
}

//  ------------------------------------------------------------------

void CfgXlatescset() {

  CFG->xlatescset = (Map*)throw_realloc(CFG->xlatescset, (CFG->xlatescsets+1)*sizeof(Map));
  char* ptr = strtok(val, " \t\n\r");
  if(ptr) {
    strchg(strupr(strcpy(CFG->xlatescset[CFG->xlatescsets].import, ptr)), '_', ' ');
    ptr = strtok(NULL, " \t\n\r");
    if(ptr) {
      strchg(strupr(strcpy(CFG->xlatescset[CFG->xlatescsets].export, ptr)), '_', ' ');
      ptr = strtok(NULL, " \t\n\r");
      if(ptr) {
        if(*CFG->xlatpath == NUL)
          strcpy(CFG->xlatpath, CFG->goldpath);
        MakePathname(ptr, CFG->xlatpath, ptr);
        CFG->xlatescset[CFG->xlatescsets].mapfile = throw_strdup(ptr);
        CFG->xlatescsets++;
      }
    }
  }
}

//  ------------------------------------------------------------------

void CfgXlatexport() {

  XlatName buf;
  strchg(strupr(strxcpy(buf, val, sizeof(buf))), '_', ' ');
  if(cfgingroup)
    GRP->AddItm(GRP_XLATEXPORT, buf, strlen(buf)+1);
  else
    strcpy(CFG->xlatexport, buf);
}

//  ------------------------------------------------------------------

void CfgXlatimport() {

  XlatName buf;
  strchg(strupr(strxcpy(buf, val, sizeof(buf))), '_', ' ');
  if(cfgingroup)
    GRP->AddItm(GRP_XLATIMPORT, buf, strlen(buf)+1);
  else
    strcpy(CFG->xlatimport, buf);
}

//  ------------------------------------------------------------------

void CfgXlatlocalset() {

  strupr(strxcpy(CFG->xlatlocalset, val, sizeof(CFG->xlatlocalset)));
}

//  ------------------------------------------------------------------

void CfgXlatpath() {

  PathCopy(CFG->xlatpath, val);
}

//  ------------------------------------------------------------------

void CfgZonegating() {

  CFG->zonegating = GetYesno(val);
}

//  ------------------------------------------------------------------

