
//  ------------------------------------------------------------------
//  GoldED. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gecarb.cpp,v 1.1.1.1 1998/11/21 19:38:01 odinn Exp $
//  ------------------------------------------------------------------
//  Carbon Copy.
//  ------------------------------------------------------------------


#include "golded.h"

#ifdef __BORLANDC__
#pragma hdrstop
//#pragma option -Od
#endif

//  ------------------------------------------------------------------

int DoCarboncopy(GMsg* msg, GMsg** carbon) {

  FILE* fp;
  Addr addr;
  Attr attr;
  register int n, x, cc = 0;
  char* ptr;
  char* ptr2;
  char* tptr2;
  int hidecc;
  int ignorecc = NO;
  char buf[256], buf2[256], name[256];
  Line* line;
  Line* newline;
  Line* ccline = NULL;
  
  // Insert empty line at the top first for practical purposes

  newline = (Line*)throw_xcalloc(1, sizeof(Line));
  msg->lin = newline = line = InsertLine(newline, msg->lin, DIR_PREV);

  // Deal with carbon copies

  attr = msg->attr;
  if(NOT AA->isecho() AND line) {
    do {
      ptr = newline->text;
      if(ptr AND strnieql(ptr, "CC:", 3)) {
        if(NOT ignorecc) {
          if(NOT cc) {
            msg->attr.nwm1();

            AttrAdd(&msg->attr, &CFG->attribscc);

            //DispHeader(msg, -1);
            HeaderView.Use(AA, msg);
            HeaderView.Paint();
            GMenuCarbon MenuCarbon;
            ignorecc = !MenuCarbon.Run(msg);
            if(ignorecc)                    // Do not process carcon copies
              break;
            if(newline)
              ccline = newline->prev;       // Store the position of first line
            else
              ccline = NULL;
          }
          update_statusline(LNG->ProcessCC);
          ptr = strcpy(buf2, ptr+3);
          if(CFG->carboncopylist != CC_KEEP) {
            newline = DeleteLine(newline);  // Now at the next line
            if(newline AND newline->prev)
              newline = newline->prev;      // Go back one line
          }
          do {
            ptr = SkipWht(ptr);
            ptr2 = strchr(ptr, ',');
            if(ptr2)
              *ptr2++ = NUL;
            if(*ptr == '#') {
              ptr = SkipWht(ptr+1);
              hidecc = YES;
            }
            else
              hidecc = NO;
            if(*ptr == '@') {
              tptr2 = ptr2;
              ptr++;
              fp = fsopen(AddPath(CFG->goldpath, ptr), "rt", CFG->sharemode);
              if(fp) {
                while(fgets(buf, sizeof(buf), fp)) {
                  ptr = buf;
                  do {
                    ptr = SkipWht(ptr);
                    if(*ptr == NUL)
                      break;
                    ptr2 = strchr(ptr, ',');
                    if(ptr2)
                      *ptr2++ = NUL;
                    if(*ptr == '#') {
                      ptr = SkipWht(ptr+1);
                      hidecc = YES;
                    }
                    else
                      hidecc = NO;
                    if(*ptr != '@') {   // No nesting, please!
                      addr.reset_fast();
                      strtrim(strcpy(name, ptr));
                      (*carbon) = (GMsg*)throw_realloc((*carbon), sizeof(GMsg)*(cc+2));
                      (*carbon)[cc] = *msg;
                      (*carbon)[cc].dest.reset_fast();
                      (*carbon)[cc].odest.reset_fast();
                      strxcpy((*carbon)[cc].to, name, sizeof(Name));
                      (*carbon)[cc].attr.nwm1();
                      //DispHeader(&(*carbon)[cc], -1);
                      HeaderView.Use(AA, &(*carbon)[cc]);
                      HeaderView.Paint();
                      if(AA->isnet()) {
                        addr = (*carbon)[cc].orig;
                        Lookup(&(*carbon)[cc], &addr, name, 6, LNG->DestinationCC);
                      }
                      else
                        addr = AA->Aka().addr;
                      update_statusline(LNG->ProcessCC);
                      if(addr.net OR AA->islocal()) {
                        // Create a CC if either address or name is different than the original.
                        if(memcmp(&addr, &msg->dest, sizeof(Addr)) OR stricmp(name, msg->to)) {
                          (*carbon)[cc].odest = addr;
                          (*carbon)[cc].dest = addr;
                          if(hidecc)
                            (*carbon)[cc].attr.tou0();
                          else
                            (*carbon)[cc].attr.tou1();
                          strxcpy((*carbon)[cc].to, name, sizeof(Name));
                          cc++;
                        }
                      }
                    }
                    ptr = ptr2;
                  } while(ptr2);
                }
                fclose(fp);
              }
              ptr2 = tptr2;
            }
            else {
              addr.reset_fast();
              strtrim(strcpy(name, ptr));
              (*carbon) = (GMsg*)throw_realloc((*carbon), sizeof(GMsg)*(cc+2));
              (*carbon)[cc] = *msg;
              (*carbon)[cc].dest.reset_fast();
              (*carbon)[cc].odest.reset_fast();
              strxcpy((*carbon)[cc].to, name, sizeof(Name));
              (*carbon)[cc].attr.nwm1();
              //DispHeader(&(*carbon)[cc], -1);
              HeaderView.Use(AA, &(*carbon)[cc]);
              HeaderView.Paint();
              if(AA->isnet()) {
                addr = (*carbon)[cc].orig;
                Lookup(&(*carbon)[cc], &addr, name, 6, LNG->DestinationCC);
              }
              else {
                addr = AA->Aka().addr;
              }
              update_statusline(LNG->ProcessCC);
              if(addr.net OR AA->islocal()) {
                // Create a CC if either address or name is different than the original.
                if(memcmp(&addr, &msg->dest, sizeof(Addr)) OR stricmp(name, msg->to)) {
                  (*carbon)[cc].odest = addr;
                  (*carbon)[cc].dest = addr;
                  if(hidecc)
                    (*carbon)[cc].attr.tou0();
                  else
                    (*carbon)[cc].attr.tou1();
                  strxcpy((*carbon)[cc].to, name, sizeof(Name));
                  cc++;
                }
              }
            }
            ptr = ptr2;
          } while(ptr2);
        }
      }
      newline = newline->next;
    } while(newline != NULL);

    // Fix the CC list in the message
    if(cc AND ccline) {
      switch(CFG->carboncopylist) {
        case CC_REMOVE:
          // No list
          break;
        case CC_KEEP:
          // Keep list as it was entered
          break;
        case CC_HIDDEN:
          sprintf(buf2, "\001CC: %s", LNG->ListCC);
          sprintf(buf, buf2, msg->to, msg->dest.zone, msg->dest.net, msg->dest.node, msg->dest.point);
          ccline = AddKludge(ccline, buf);
          for(n=0; n<cc; n++) {
            if((*carbon)[n].attr.tou()) {
              sprintf(buf, buf2, (*carbon)[n].to, (*carbon)[n].dest.zone, (*carbon)[n].dest.net, (*carbon)[n].dest.node, (*carbon)[n].dest.point);
              ccline = AddKludge(ccline, buf);
            }
          }
          break;
        case CC_VISIBLE:
          sprintf(buf2, "CC: %s", LNG->ListCC);
          sprintf(buf, buf2, msg->to, msg->dest.zone, msg->dest.net, msg->dest.node, msg->dest.point);
          ccline = AddLine(ccline, buf);
          for(n=0; n<cc; n++) {
            if((*carbon)[n].attr.tou()) {
              sprintf(buf, buf2, (*carbon)[n].to, (*carbon)[n].dest.zone, (*carbon)[n].dest.net, (*carbon)[n].dest.node, (*carbon)[n].dest.point);
              ccline = AddLine(ccline, buf);
            }
          }
          break;
        case CC_NAMES:
          sprintf(buf, "CC: %s", msg->to);
          for(n=0; n<cc; n++) {
            if((*carbon)[n].attr.tou()) {
              x = strlen(buf) + strlen((*carbon)[n].to) + 2;
              if(x < CFG->dispmargin) {
                if(strlen(buf) > 4)
                  strcat(buf, ", ");
                strcat(buf, (*carbon)[n].to);
              }
              else {
                ccline = AddLine(ccline, buf);
                strcpy(buf, "CC: ");
                strcat(buf, (*carbon)[n].to);
              }
            }
          }
          AddLine(ccline, buf);
          break;
      }
    }
  }

  // Reset line pointer

  msg->lin = DeleteLine(msg->lin);  // Delete the empty top line again
  msg->attr = attr;

  if(*carbon AND NOT cc)
    throw_release(*carbon);

  return cc;
}


//  ------------------------------------------------------------------

