
//  ------------------------------------------------------------------
//  GoldED. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gecfgg.h,v 1.3 1999/02/02 02:09:43 damware Exp $
//  ------------------------------------------------------------------
//  The main GoldED configuration structure.
//  ------------------------------------------------------------------


//  ------------------------------------------------------------------

enum en_gswitches {
  internetlookup,
  kludgechrs,
  mouse,
  displocalhigh,
  arealistgroupid,
  askdelorig,
  lookuplocal,
  dispstatusline,
  screenusebios,
  highlightunread,
  akamatchlocal,
  stylecodes,
  fidonullfix,
  dispautonext,
  lookupuserbase,
  areakeeplast,
  filelistpagebar,
  printformfeed,
  screenelimsnow,
  arealistnos,
  disppagebar,
  internetreply,
  arealistpagebar,
  usemsgid,
  lookupnet,
  squishdirect,
  fidohwmarks,
  msglistpagebar,
  beepnoises,
  screenshadows,
  dispsoftcr,
  emptytearline,
  menudropmsg,
  beeplocalmsg,
  statuslineclock,
  twitto,
  keybdefaults,
  displistwrap,
  quotespacing,
  lookupecho,
  keybext,
  beepcomment,
  quoteblank,
  keybclear,
  dosprompt,
  areacatchupread,
  useflags,
  jamharddelete,
  disprealmsgno,
  frqwazoo,
  msglistviewsubj,
  akamatchecho,
  areafilegroups,
  areaautonext,
  timeoutsavemsg,
  nodelistwarn,
  nodelistpagebar,
  akamatchnet,

  gswitches_last
};

class gswitches {

public:

  inline bool get(en_gswitches what) { return cfg[what]; }
  inline void set(en_gswitches what, bool value) { cfg[what] = value; }

  bool handle(word crc, const char* value);

  gswitches() { for(uint i=0; i<gswitches_last; i++) {cfg[i] = false; } };

private:

  bool cfg[gswitches_last];
};


//  ------------------------------------------------------------------

struct CfgGed {

  CfgVer      vers;

  Path        goldcfg;
  Path        goldged;
  Stamp       helpcfg;
  Path        helpged;
  Stamp       keyscfg;
  Stamp       langcfg;
  Path        langged;
  Stamp       randcfg;
  Path        randged;
  Path        xlatged;

  int         cfgdispmargin;
  int         cfgeditquotemargin;
  int         cfgquotemargin;

  CmdKey*     cmdkey;
  int         cmdkeys;
  Macro*      macro;
  int         macros;

  int         addressbookadd;
  AddrMacro*  addressmacro;         // addrmacro;
  int         addressmacros;        // addrmacros;
  Path        adeptxbbspath;
  int         adeptxbbsuserno;
  gaka*       aka;
  uint        akas;
  AkaMatchG*  akamatch;
  int         akamatches;
  int         areaautoid;
  int         areacopydirect;
  Echo        areacopyto;
  int         areacopyaddid;
  Echo*       areaexcl;             // exclarea;
  int         areaexcls;            // exclareas;
  int         areafilegroups;       // areausegroups;
  int         areafreqdirect;
  Echo        areafreqto;
  Echo*       areaincl;             // inclarea;
  int         areaincls;            // inclareas;
  Echo*       areaisemail;
  int         areaisemails;
  Echo*       areaisnews;
  int         areaisnewss;
  int         arealistechomax;
  char        arealistformat[80];
  char        arealistsort[20];     // areasort[10];
  int         arealisttype;
  Path        areapath;
  Echo*       areapmscan;
  int         areapmscans;
  Echo*       areapmscanexcl;
  int         areapmscanexcls;
  Echo*       areapmscanincl;
  int         areapmscanincls;
  int         areareadonly;
  EchoRen*    arearename;           // renarea;
  int         arearenames;          // renareas;
  int         areareplydirect;
  Echo        areareplyto;
  Echo*       areascan;             // scanarea;
  int         areascans;            // scanareas;
  Echo*       areascanexcl;
  int         areascanexcls;
  Echo*       areascanincl;
  int         areascanincls;
  char        areascansort[20];
  Echo        areastart;            // startecho;
  int         areatypeorder[17];
  Echo        areayouwroteto;
  Path        attachpath;
  Attr        attribsattach;
  Attr        attribscc;            // ccattrib;
  Attr        attribscfm;           // cfmattrib;
  Attr        attribsecho;          // echoattrib;
  Attr        attribsemail;
  Attr        attribsfrq;
  Attr        attribslocal;         // localattrib;
  Attr        attribsnet;           // netattrib;
  Attr        attribsnews;
  int         beepfactor;           // noisefactor;
  int         beepyourmail;
  int         carboncopylist;       // cclist;
  Win         color[16];
  Path        confirmfile;          // goldedcfm;
  int         confirmresponse;
  Path        cookiepath;
  int         crosspostlist;        // xplist;
  uint        ctrlinfoecho;
  uint        ctrlinfoemail;
  uint        ctrlinfolocal;
  uint        ctrlinfonet;
  uint        ctrlinfonews;
  int         dispareano;
  int         dispattachsize;
  PosLen      disphdrdateset;
  PosLen      disphdrnameset;
  PosLen      disphdrnodeset;
  int         displistcursor;
  int         dispmargin;           // rightmargin;
  int         dispmsgsize;
  uint        disptabsize;          // tabsize;
  int         dosswap;              // swapall;
  GEvent*     event;
  int         events;
  int         externoptions;
  ExtUtil*    externutil;
  int         externutils;
  Ezycom      ezycom;
  int         ezycomuserno;
  Path        fidolastread;         // lastread;
  int         fidomsgtype;
  Path        fidouserlist;
  int         fidouserno;           // lastreaduser;
  FileAlias*  filealias;
  int         filealiases;
  Path        filecheckcall;
  int         forcetemplate;
  FrqExt*     frqext;
  int         frqexts;
  FrqNodeMap* frqnodemap;
  int         frqnodemaps;
  int         frqoptions;
  Gifname*    gif;
  int         gifs;
  int         gifno;
  Path        gifpath;
  Path        goldbasepath;
  Path        goldbasesyspath;
  int         goldbaseuserno;
  Path        goldpath;
  int         happybirthday;
  bool        hidestylies;
  Path        hudsonpath;
  long        hudsonsizewarn;
  Path        hudsonsyspath;
  int         hudsonuserno;
  char        importbegin[80];
  char        importend[80];
  Path        inboundpath;
  Path        inputfile;
  int         intensecolors;        // intcolors;
  char        internetaddress[128];
  char        internetdomain[96];
  Node        internetgate;
  int         internetmsgid;
  int         internetrfcbody;
  InetServers internetserver;
  Invalidate  invalidate;
  Path        jampath;
  int         keybmode;
  char        keybstack[80];        // keybuf[80];
  Kludge*     kludge;
  int         kludges;
  Path        loadlanguage;
  Path        logfile;              // goldedlog;
  int         logformat;
  MailList*   mailinglist;
  int         mailinglists;
  MapPathE*   mappath;
  uint        mappaths;
  int         menumarked;
  int         msglistdate;
  int         msglistfast;          // dispmsglistfast
  int         msglistfirst;         // dispmsglist
  int         msglistheader;
  int         msglistwidesubj;
  Path        namesfile;            // goldednam;
  Netn        netname;
  Name        nickname;
  Path        nodepath;
  Path        nodepathfd;
  Path        nodepathv7;
  INam        organization;
  Orig*       origin;
  int         origins;
  int         originno;
  Path        outboundpath;
  Path        outputfile;
  int         overlay;
  Path        pathreportfile;
  int         pcboardmailer;
  Path        pcboardpath;
  int         pcboarduserno;
  int         personalmail;
  GPlay       play;
  Path        printdevice;          // p_device;
  char        printinit[80];        // p_init[80];
  int         printlength;          // p_length;
  int         printmargin;          // p_margin;
  char        printreset[80];       // p_reset[80];
  Path        quotebuffile;
  int         quotebufmode;
  char        quotechars[11];
  int         quotemargin;
  char        quotestring[10];
  int         quotewraphard;
  int         ra2usersbbs;          // RA2;
  int         replylink;
  int         replylinklist;
  Name*       robotname;            // robot;
  int         robotnames;           // robots;
  int         screenblanker;        // blanktime;
  int         screenblankertype;
  int         screenmaxcol;         // maxcols;
  int         screenmaxrow;         // maxrows;
  int         screenpalette[17];
  int         screensize;
  int         screenuseansi;
  INam        searchfor;
  Semaphore   semaphore;
  int         sharemode;            // share;
  Path        soundpath;
  Echo        soupbadmsgs;
  Echo        soupemail;
  int         soupexportmargin;
  Path        soupexportpath;
  Path        soupimportpath;
  Path        soupnewsrcfile;
  Path        soupreplylinker;
  char        soupreplyto[60];
  Path        souptosslog;
  int         squishrecycle;
  int         squishscan;
  int         squishuserno;
  Path        squishuserpath;
  int         statuslinehelp;
  char        stylecodepunct[41];
  char        stylecodestops[41];
  Path        swappath;
  Tagline*    tagline;
  int         taglines;
  int         taglineno;
  char        taglinechar;
  Path        taglinefile;
  int         taglinesupport;
  Tear        tearline;
  Tpl*        tpl;
  int         tpls;
  int         tplno;
  int         templatematch;
  Path        templatepath;
  Path        temppath;
  int         timeout;
  int         timeslice;
  int         timezoneoffset;
  int         twitmode;             // showtwits;
  Node*       twitname;
  int         twitnames;
  Subj*       twitsubj;
  int         twitsubjs;
  int         usefwd;
  int         useintl;
  Path        userlistfile;         // goldedlst;
  Node*       username;
  uint        usernames;
  int         usernameno;
  Path        uudecodepath;
  int         viewhidden;
  int         viewkludge;
  int         viewquote;
  Name        whoto;
  int         wildcatuserno;
  Map*        xlatcharset;          // charset;
  int         xlatcharsets;         // charsets;
  Map*        xlatescset;           // escset;
  int         xlatescsets;          // escsets;
  char        xlatexport[17];       // exportcharset[17];
  char        xlatimport[17];       // localcharset[17];
  char        xlatlocalset[17];
  Path        xlatpath;
  int         zonegating;

  gswitches   switches;

  char        filler[1];
};



//  ------------------------------------------------------------------

class GSaveUtil : public GStrBag2 {

public:

  void Add(int n, char* s)  { GStrBag2::Add((void*)&n, sizeof(n), s); }

  int Number()       { return *(int*)Current1(); }
  const char* Text()         { return Current2(); }

  int Number(int i)       { return *(int*)Index1(i); }
  const char* Text(int i)         { return Index2(i); }
};


//  ------------------------------------------------------------------

class GEditTrigger : public GStrBag2 {

public:

  const char* Trigger()  { return Current1(); }
  const char* Text()     { return Current2(); }

  const char* Trigger(int i)  { return Index1(i); }
  const char* Text(int i)     { return Index2(i); }
};


//  ------------------------------------------------------------------

class GoldedCfgEdit {

protected:

  // -----------------------------------------------------------------
  // Configuration data

  struct {

    // Boolean values
    uint autoattach  : 1;
    uint changedate  : 1;
    uint crlfterm    : 1;
    uint fieldclear  : 1;
    uint hardlines   : 1;
    uint hardterm    : 1;
    uint headerattrs : 1;
    uint internal    : 1;
    uint menu        : 1;
    uint mixcase     : 1;
    uint savemenu    : 1;

    // Multi values
    int  autosave;
    char charpara;
    char charspace;
    int  hdrnamepos;
    int  hdrnamelen;
    int  hdrnodepos;
    int  hdrnodelen;
    int  headerfirst;
    int  margin;
    long msgsize;
    int  quotemargin;
    int  replyre;
    char softcrxlat;
    int  undelete;

    // String handles
    int external;
    int file;
    int hardline;
    int spellchecker;
  } cfg;
  
  // -----------------------------------------------------------------
  // String bag

  GStrBag str;

public:

  // -----------------------------------------------------------------
  // Configuration data

  GEditTrigger Comment;
  GEditTrigger Completion;
  GSaveUtil    SaveUtil;


  // -----------------------------------------------------------------
  // Constructor/destructor

  GoldedCfgEdit();

  // -----------------------------------------------------------------
  // Return values

  int AutoAttach()               { return cfg.autoattach; }
  int AutoSave()                 { return cfg.autosave; }
  int ChangeDate()               { return cfg.changedate; }
  char CharPara()                 { return cfg.charpara; }
  char CharSpace()                { return cfg.charspace; }
  int CrLfTerm()                 { return cfg.crlfterm; }
  const char* External()                 { return str[cfg.external]; }
  int FieldClear()               { return cfg.fieldclear; }
  const char* File()                     { return str[cfg.file]; }
  const char* HardLine()                 { return str[cfg.hardline]; }
  int HardLines()                { return cfg.hardlines; }
  int HardTerm()                 { return cfg.hardterm; }
  int HdrNamePos()               { return cfg.hdrnamepos; }
  int HdrNameLen()               { return cfg.hdrnamelen; }
  int HdrNodePos()               { return cfg.hdrnodepos; }
  int HdrNodeLen()               { return cfg.hdrnodelen; }
  int HeaderAttrs()              { return cfg.headerattrs; }
  int HeaderFirst()              { return cfg.headerfirst; }
  int Internal()                 { return cfg.internal; }
  int Margin()                   { return cfg.margin; }
  int Menu()                     { return cfg.menu; }
  int MixCase()                  { return cfg.mixcase; }
  long MsgSize()                  { return cfg.msgsize; }
  int QuoteMargin()              { return cfg.quotemargin; }
  int ReplyRe()                  { return cfg.replyre; }
  int SaveMenu()                 { return cfg.savemenu; }
  char SoftCrXlat()               { return cfg.softcrxlat; }
  const char* SpellChecker()             { return str[cfg.spellchecker]; }
  int UnDelete()                 { return cfg.undelete; }

  // -----------------------------------------------------------------
  // Set values

  void AutoAttach(int s)         { cfg.autoattach = s; }
  void AutoSave(int s)           { cfg.autosave = s; }
  void ChangeDate(int s)         { cfg.changedate = s; }
  void CharPara(char s)           { cfg.charpara = s; }
  void CharSpace(char s)          { cfg.charspace = s; }
  void CrLfTerm(int s)           { cfg.crlfterm = s; }
  void External(char* s)           { str.Change(cfg.external, s); }
  void FieldClear(int s)         { cfg.fieldclear = s; }
  void File(char* s)               { str.Change(cfg.file, s); }
  void HardLine(char* s)           { str.Change(cfg.hardline, s); }
  void HardLines(int s)          { cfg.hardlines = s; }
  void HardTerm(int s)           { cfg.hardterm = s; }
  void HdrNamePos(int p)         { cfg.hdrnamepos = p; }
  void HdrNameLen(int l)         { cfg.hdrnamelen = l; }
  void HdrNodePos(int p)         { cfg.hdrnodepos = p; }
  void HdrNodeLen(int l)         { cfg.hdrnodelen = l; }
  void HeaderAttrs(int s)        { cfg.headerattrs = s; }
  void HeaderFirst(int s)        { cfg.headerfirst = s; }
  void Internal(int s)           { cfg.internal = s; }
  void Margin(int s)             { cfg.margin = s; }
  void Menu(int s)               { cfg.menu = s; }
  void MixCase(int s)            { cfg.mixcase = s; }
  void MsgSize(long s)            { cfg.msgsize = s; }
  void QuoteMargin(int s)        { cfg.quotemargin = s; }
  void ReplyRe(int s)            { cfg.replyre = s; }
  void SaveMenu(int s)           { cfg.savemenu = s; }
  void SoftCrXlat(char s)         { cfg.softcrxlat = s; }
  void SpellChecker(char* s)       { str.Change(cfg.spellchecker, s); }
  void UnDelete(int s)           { cfg.undelete = s; }

  // -----------------------------------------------------------------
  // Disk storage

  void Save(gfile& fp);
  void Load(gfile& fp);
};


//  ------------------------------------------------------------------

