
//  ------------------------------------------------------------------
//  GoldED. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: geglob.cpp,v 1.1.1.1 1998/11/21 19:38:02 odinn Exp $
//  ------------------------------------------------------------------
//  Global data.
//  ------------------------------------------------------------------


#include "golded.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#include "gcprot.h"


//  ------------------------------------------------------------------
//  Various global data

#if defined(__MSDOS__)
#ifdef __DJGPP__
unsigned _stklen = 32768u;
#else
extern unsigned _stklen = 10000u;
#endif
#endif

GLog __FAR LOG;

gareafile* AFILE = NULL;
CfgGed* CFG = NULL;
LangGed* LNG = NULL;
NodeIxl* NODE = NULL;
Grp* GRP = NULL;
Qwk* QWK = NULL;
GoldedCfgEdit* EDIT = NULL;

uint locpost=0, netpost=0, echopost=0;

Subj __FAR information;

Area* AA = NULL;

char m_title[80];         // Menu title string
int m_titlepos;           // Menu title position
int m_titleattr;          // Menu title color

char* tconv;

CmdKey* AreaKey = NULL;   int AreaKeys = 0;
CmdKey* ReadKey = NULL;   int ReadKeys = 0;
CmdKey* ListKey = NULL;   int ListKeys = 0;
CmdKey* NodeKey = NULL;   int NodeKeys = 0;
CmdKey* EditKey = NULL;   int EditKeys = 0;
CmdKey* FileKey = NULL;   int FileKeys = 0;

int inforow = 18;

char goldmark = ' ';

int startecho = -1;
Echo __FAR stecho;

int fieldupd = 2;  // State of field mode in winpdef()

int CurrArea = 0;
int OrigArea = 0;

Esc* MNETable = NULL;
Esc* I51Table = NULL;
Esc* CompTable = NULL;
Chs* CharTable = NULL;
EscTab* CompTP = NULL;
EscTab* I51TP = NULL;
EscTab* MNETP = NULL;
ChsTab* ChsTP = NULL;

//char gversion[20];

int stamps=0;
Stamp* stamp=NULL;

int quiet = YES;
int ignore = NO;
int cfgerrors = NO;
int veryverbose = 0;
int shellvid = YES;
word* oldscreen = NULL;

int disablesound = NO;

int _in_editor = NO;
int _in_msglist = NO;
int savedirect = NO;

void(*SIGINT_OldHandler)(void) = NULL;

int arealistnumgrps = false;

int startupscan_success = false;

extern int __FAR cmdlinesharemode;


//  ------------------------------------------------------------------
//        0    1    2    3    4    5    6    7    8    9   10   11

Win __FAR gold_color1[16] = {
  {5, {   7,   0,   7,   7,   7,   7,   7,   7,   7,   7,   7,   0}, 2},  // Back  0
  {5, {  31,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7}, 1},  // Stat  1
  {0, {  15,  14,  14,   7,  12,   7,   7,   9,   7,   7,   7,  14}, 0},  // Brag  2
  {0, {   7,   9,  14,  31,  15,   7,   7,   7,   7,   7,   7,   9}, 0},  // Area  3
  {0, {   7,   7,  15,  14, 143,   8,  15,  79,  15,  15,   8,   7}, 5},  // Read  4
  {0, {   7,   9,  14,   7,  15,   7,  15, 113,   7,   7,   7,   9}, 0},  // Head  5
  {0, {   7,  12,  14,  31,  15,   8,   7,   7,   7,   7,   7,  12}, 0},  // Ask   6
  {0, {   7,  12,  14,  31,  15,   8,   7,   2,  12,  15,   7,  12}, 0},  // Menu  7
  {0, {   7,  14,   7,  79,  15,   7,   7,   7,   7,   7,   7,  14}, 0},  // Help  8
  {3, {   7,  12,  14,  31,  15,   8,   7,   7,   7,   7,   7,  12}, 0},  // Cfg   9
  {0, {  15,  12,  14,   7,   7,   7,   7,   7,   7,   7,   7,  12}, 0},  // Info  10
  {3, {   7,  12,  14,  31,  15,   8,   7,   7,   7,   7,   7,  12}, 0},  // Cfgb  11
  {0, {  15,  15,  15,  15,  15,  15,  15,  15,  15,  15,  15,  15}, 0},  // Style 12
  {0, {   7,   7,   7,   7,   7,   7,   7,   8,   7,   7,   7,   7}, 0},  // Shad  13
  {0, {   0,   0,   0,   0,   0,   0,   8,  15,   0,   0,   0,   0}, 0},  // Read2 14
};


//  ------------------------------------------------------------------
//        0    1    2    3    4    5    6    7    8    9

Win __FAR gold_color2[16] = {
  {5, { 240,  15,   7,   7,   7,   7,   7,   7,   7,   7,   7,  15}, 2},  // Back  0
  {5, { 143,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7}, 1},  // Stat  1
  {0, {  15,  14,  14,   7,  12,   7,   7,   9,   7,   7,   7,  14}, 0},  // Brag  2
  {0, { 240, 241, 244, 143, 244,   7,   7,   7,   7,   7,   7, 241}, 0},  // Area  3
  {0, { 241, 240, 242, 244,  64, 248, 240,  64, 240, 240, 248, 240}, 5},  // Read  4
  {0, { 135, 142, 142, 135, 143,   7, 143,  64, 135, 135,   7, 142}, 0},  // Head  5
  {0, { 224, 230, 232, 143, 228, 231,   7,   7,   7,   7,   7, 230}, 0},  // Ask   6
  {0, { 112, 126, 116, 143, 126, 120, 117, 113, 125, 121,   7, 126}, 0},  // Menu  7
  {0, { 135, 142,   7, 228, 143,   7,   7,   7,   7,   7,   7, 142}, 0},  // Help  8
  {3, { 224, 230, 232, 143, 228, 231,   7,   7,   7,   7,   7, 230}, 0},  // Cfg   9
  {0, {  15,  12,  14,   7,   7,   7,   7,   7,   7,   7,   7,  12}, 0},  // Info  10
  {3, { 240, 241, 244, 143, 244,   7,   7,   7,   7,   7,   7, 241}, 0},  // Cfgb  11
  {0, { 249, 249, 249, 249, 249, 249, 249, 249, 249, 249, 249, 249}, 0},  // Style 12
  {0, {   7,   7,   7,   7,   7,   7,   7,   8,   7,   7,   7,   7}, 0},  // Shad  13
  {0, {   0,   0,   0,   0,   0,   0, 248, 241,   0,   0,   0,   0}, 0},  // Read2 14
};


//  ------------------------------------------------------------------
//        0    1    2    3    4    5    6    7    8    9

Win __FAR gold_mono1[16] = {
  {5, {  15,   0,   7,   7,   7,   7,   7,   7,   7,   7,   7,   0}, 2},  // Back  0
  {5, { 112,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7}, 1},  // Stat  1
  {0, {  15,   7,  15,   7,  15,   7,   7,   7,   7,   7,   7,   7}, 0},  // Brag  2
  {0, {   7,   7,  15, 112,  15,   7,   7,   7,   7,   7,   7,   7}, 0},  // Area  3
  {0, {   7,   7,  15,  15, 143,  15,   7,   7,   7,   7,  15,   7}, 5},  // Read  4
  {0, {   7,   7,  15,   7,  15,   7, 112,  15,   7,   7,   7,   7}, 0},  // Head  5
  {0, { 112, 112, 112,  15,  15,   7,   7,   7,   7,   7,   7, 112}, 0},  // Ask   6
  {0, {   7,   7, 112, 112,  15,   7,  15,  15,  15,  15,   7,   7}, 0},  // Menu  7
  {0, { 112, 112,   7,  15, 112,   7,   7,   7,   7,   7,   7, 112}, 0},  // Help  8
  {3, {   7,   7, 112, 112,  15,   7,   7,   7,   7,   7,   7,   7}, 0},  // Cfg   9
  {0, {  15,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7}, 0},  // Info  A
  {3, {   7,   7, 112, 112,  15,   7,   7,   7,   7,   7,   7,   7}, 0},  // Cfgb  B
  {0, {   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7}, 0},  // Style C
  {0, {   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7}, 0},  // Shad  F
  {0, {   0,   0,   0,   0,   0,   0,   7,  15,   0,   0,   0,   0}, 0},  // Read2 14
};


//  ------------------------------------------------------------------
//  Deallocate CFG at exit

static void _stdc CfgReset(void) {

  throw_delete(QWK);
  throw_delete(GRP);
  throw_delete(EDIT);
  throw_delete(AFILE);

  if(NODE)
    throw_release(NODE->nodelist);
  throw_release(NODE);
  throw_release(CFG);
}


//  ------------------------------------------------------------------
//  Assign default CFG values

void CfgInit() {

  atexit(CfgReset);

  CFG = (CfgGed*)throw_calloc(1, sizeof(CfgGed));
  NODE = (NodeIxl*)throw_calloc(1, sizeof(NodeIxl));

  AFILE = new gareafile;
  throw_new(AFILE);

  EDIT = new GoldedCfgEdit;
  throw_new(EDIT);

  GRP = new Grp(GRP_MAX, sizeof(Echo));
  throw_new(GRP);

  QWK = new Qwk;
  throw_new(QWK);

  LangInit();


  //  ----------------------------------------------------------------

  CFG->vers.vers = sizeof(CfgGed);
  strcpy(CFG->vers.date, __gver_date__);
  strcpy(CFG->vers.time, __gver_time__);

  //  ----------------------------------------------------------------

  strcpy(CFG->arealistformat, "AM D CPUN E G ");
  strcpy(CFG->arealistsort, "FYTUE");
  strcpy(CFG->areascansort, "XZBE");
  strcpy(CFG->confirmfile, "golded.cfm");
  strcpy(CFG->fidolastread, "lastread");
  strcpy(CFG->goldcfg, "golded.cfg");
  sprintf(CFG->goldged, "golded%s", __gver_cfgext__);
  strcpy(CFG->helpcfg.fn, "goldhelp.cfg");
  sprintf(CFG->helpged, "goldhelp%s", __gver_cfgext__);
  strcpy(CFG->importbegin, "=== Cut ===");
  strcpy(CFG->invalidate.origin[0], " * Origin: ");
  strcpy(CFG->invalidate.origin[1], " + Origin: ");
  strcpy(CFG->invalidate.seenby[0], "SEEN-BY");
  strcpy(CFG->invalidate.seenby[1], "SEEN+BY");
  strcpy(CFG->invalidate.tearline[0], "---");
  strcpy(CFG->invalidate.tearline[1], "-+-");
  strcpy(CFG->keyscfg.fn, "goldkeys.cfg");
  strcpy(CFG->langcfg.fn, "goldlang.cfg");
  sprintf(CFG->langged, "goldlang%s", __gver_cfgext__);
  strcpy(CFG->logfile, "golded.log");
  strcpy(CFG->namesfile, "names.fd");
  #if defined(__UNIX__)
  strcpy(CFG->printdevice, "/usr/bin/lpr > /dev/null 2>&1");
  #else
  strcpy(CFG->printdevice, "PRN");
  #endif
  strcpy(CFG->quotestring, " FL> ");
  strcpy(CFG->randcfg.fn, "goldrand.cfg");
  sprintf(CFG->randged, "goldrand%s", __gver_cfgext__);
  strcpy(CFG->stylecodepunct, " !?\"$%&()+,.:;<=>@[\\]^`{|}~\n\r\t");
  strcpy(CFG->stylecodestops, "");
  strcpy(CFG->tearline, "@longpid @version");
  strcpy(CFG->userlistfile, "golded.lst");
  strcpy(CFG->whoto, "All");
  sprintf(CFG->xlatged, "goldxlat%s", __gver_cfgext__);
  #if defined(__UNIX__)
  strcpy(CFG->xlatlocalset, "LATIN-1");
  #else
  strcpy(CFG->xlatlocalset, "IBMPC");
  #endif

  //  ----------------------------------------------------------------

  for(int n=0; n<16; n++)
    CFG->screenpalette[n] = -1;

  //  ----------------------------------------------------------------

  if(gvid.adapter & V_MONO)
    memcpy(CFG->color, gold_mono1, sizeof(CFG->color));
  else
    memcpy(CFG->color, gold_color1, sizeof(CFG->color));

  //  ----------------------------------------------------------------

  CFG->cfgeditquotemargin = 75;
  CFG->cfgquotemargin = 70;

  //  ----------------------------------------------------------------

  CFG->addressbookadd = YES;
  CFG->switches.set(akamatchnet, true);
  CFG->switches.set(areaautonext, true);
  CFG->switches.set(areacatchupread, true);
  CFG->areafilegroups = true;
  CFG->switches.set(areakeeplast, true);
  CFG->switches.set(arealistgroupid, true);
  CFG->switches.set(arealistpagebar, true);
  CFG->arealisttype = AL_TOTNEW;
  CFG->areareadonly = READONLY_SOFT;
  CFG->switches.set(askdelorig, true);
  CFG->attribsattach.loc1();
  CFG->attribscc.loc1();
  CFG->attribscfm.loc1();
  CFG->attribsecho.loc1();
  CFG->attribsfrq.loc1();
  CFG->attribslocal.loc1();
  CFG->attribsnet.loc1();
  CFG->switches.set(beepcomment, true);
  CFG->beepfactor = 5;
  CFG->switches.set(beepnoises, true);
  CFG->beepyourmail = true;
  CFG->carboncopylist = CC_NAMES;
  CFG->confirmresponse = ASK;
  CFG->crosspostlist = CC_NAMES;
  CFG->ctrlinfoecho  = CI_TAGL|CI_TEAR|CI_ORIG;
  CFG->ctrlinfolocal = CI_TAGL;
  CFG->ctrlinfonet = CI_TAGL|CI_TEAR;
  CFG->dispareano = true;
  CFG->dispattachsize = ATTACH_KBYTES;
  CFG->switches.set(dispautonext, true);
  CFG->disphdrdateset.len = 20;
  CFG->disphdrdateset.pos = -20;
  CFG->disphdrnameset.len = 36;
  CFG->disphdrnameset.pos = 8;
  CFG->disphdrnodeset.len = 16;
  CFG->disphdrnodeset.pos = 44;
  CFG->switches.set(displocalhigh, true);
  CFG->dispmsgsize = DISPMSGSIZE_BYTES;
  CFG->switches.set(disppagebar, true);
  CFG->switches.set(dispstatusline, true);
  CFG->disptabsize = 4;
  CFG->switches.set(dosprompt, true);
  CFG->dosswap = GSWAP_ALL | GSWAP_EMS_FIRST | GSWAP_CHECK_NET | GSWAP_HIDE_FILE;
  CFG->externoptions = EXTUTIL_CLS | EXTUTIL_SWAP | EXTUTIL_CURSOR | EXTUTIL_RELOAD | EXTUTIL_PAUSEONERROR | EXTUTIL_KEEPCTRL;
  CFG->fidomsgtype = MT_OPUS;
  CFG->switches.set(filelistpagebar, true);
  CFG->frqoptions = FREQ_FROMTOP;
  CFG->hidestylies = true;
  CFG->hudsonsizewarn = 16000000L;
  CFG->switches.set(internetreply, true);
  CFG->switches.set(keybdefaults, true);
  CFG->switches.set(keybext, true);
  CFG->keybmode = KEYB_POLL;
  CFG->switches.set(kludgechrs, true);
  CFG->switches.set(lookupnet, true);
  CFG->menumarked = MODE_DONT;
  CFG->msglistdate = MSGLISTDATE_WRITTEN;
  CFG->msglistfast = true;
  CFG->switches.set(msglistpagebar, true);
  CFG->switches.set(msglistviewsubj, true);
  CFG->switches.set(nodelistpagebar, true);
  CFG->switches.set(nodelistwarn, true);
  CFG->overlay = OVL_EMS;
  CFG->switches.set(printformfeed, true);
  CFG->printlength = 60;
  CFG->printmargin = 80;
  CFG->quotebufmode = QBUF_ASK;
  CFG->quotemargin = 70;
  CFG->quotewraphard = true;
  CFG->screenblanker = 180;
  CFG->screenblankertype = BLANK_SLIDEWIN;
  CFG->switches.set(screenshadows, true);
  CFG->sharemode = cmdlinesharemode;
  CFG->soupexportmargin = 76;
  CFG->squishrecycle = true;      // SQUISHRECYCLE_YES
  CFG->squishscan = 2;            // SQS_QUICK
  CFG->switches.set(statuslineclock, true);
  CFG->taglinechar = '.';
  CFG->taglinesupport = true;
  CFG->switches.set(timeoutsavemsg, true);
  CFG->twitmode = TWIT_BLANK;
  CFG->switches.set(useflags, true);
  CFG->useintl = true;
  CFG->switches.set(usemsgid, true);
  CFG->viewquote = true;
  CFG->zonegating  = ASK;

  //  ----------------------------------------------------------------

  CFG->areatypeorder[AT_NET]               = 1;
  CFG->areatypeorder[AT_NET|AT_EMAIL]      = 2;
  CFG->areatypeorder[AT_ECHO]              = 3;
  CFG->areatypeorder[AT_ECHO|AT_NEWSGROUP] = 4;
  CFG->areatypeorder[AT_LOCAL]             = 5;

  //  ----------------------------------------------------------------
}


//  ------------------------------------------------------------------
//  Assign default CFG values before reading the .CFG's

void CfgInit2() {

  //  ----------------------------------------------------------------
  //  Set some default robotnames

  CfgRobotname("AreaFix");
  CfgRobotname("AreaMgr");
  CfgRobotname("FileFix");
  CfgRobotname("AreaLink");
  CfgRobotname("AllFix");
  CfgRobotname("Raid");
  CfgRobotname("GEcho");


  //  ----------------------------------------------------------------
  //  Set some default filerequest extensions

  CfgFrqext(".ARC");
  CfgFrqext(".ARJ");
  CfgFrqext(".EXE");
  CfgFrqext(".LHA");
  CfgFrqext(".LZH");
  CfgFrqext(".PAK");
  CfgFrqext(".RUN");
  CfgFrqext(".SDA");
  CfgFrqext(".SDN");
  CfgFrqext(".ZIP");
  CfgFrqext(".ZOO");
  CfgFrqext(".DOC");
  CfgFrqext(".TXT");
  CfgFrqext(".GIF");
  CfgFrqext(".RAR");
  CfgFrqext(".PNG");
  CfgFrqext(".JPG");


  //  ----------------------------------------------------------------
  //  Setup the standard beeping effects

  char buf[256];
  CfgEvent(strcpy(buf, "Attention PLAY ToYou"));
  CfgEvent(strcpy(buf, "EditComment PLAY ToYou"));
  CfgEvent(strcpy(buf, "EndOfMsgs PLAY TheEnd"));
  CfgEvent(strcpy(buf, "JobDone PLAY GotIt"));
  CfgEvent(strcpy(buf, "JobFailed PLAY TooBad"));
  CfgEvent(strcpy(buf, "MsgIsLocal PLAY ToYou"));
  CfgEvent(strcpy(buf, "MsgToYou PLAY ToYou"));
  CfgEvent(strcpy(buf, "SayBiBi PLAY SayBiBi"));
  CfgEvent(strcpy(buf, "SearchFailed PLAY TooBad"));
  CfgEvent(strcpy(buf, "SearchSuccess PLAY GotIt"));


  //  ----------------------------------------------------------------
}


//  ------------------------------------------------------------------

inline int isstylechar(char c) { return (c == '*') OR (c == '/') OR (c == '_') OR (c == '#'); }

void StyleCodeHighlight(char* text, int row, int col, bool dohide, int color, VidPutStrCP fp) {

  uint sclen = 0;
  uint txlen = 0;
  char buf[200];
  register char* ptr = text;
  char* stylemargins = " -|\\";    // we probably have to make a keyword for it
  char* punctchars = CFG->stylecodepunct;
  char* stylestopchars = CFG->stylecodestops;
  char prevchar = ' ';
  while(*ptr) {
    if(isstylechar(*ptr)) {
      if(strchr(punctchars, prevchar)) {
        int bb = 0, bi = 0, bu = 0, br = 0;
        char* beginstyle = ptr;
        while(isstylechar(*ptr)) {
          switch(*ptr) {
            case '*': bb++; break;
            case '/': bi++; break;
            case '_': bu++; break;
            case '#': br++; break;
          }
          ptr++;
        }
        if((bb <= 1) AND (bi <= 1) AND (br <= 1) AND (bu <= 1)) {
          char* beginword = ptr;                       //  _/*>another*/_
          char endchar = NUL;
          char* end = ptr;
          do {
            end = strpbrk(++end, punctchars);
          } while ((end) and not isstylechar(*(end-1)));
          if(end)
            endchar = *end;
          else
            end = ptr+strlen(ptr);
          *end = NUL;
          char* endstyle = end-1;                      //  _/*another*/>_
          if(isstylechar(*endstyle) and not strchr(stylemargins, *beginword)) {
            char* endword = endstyle;
            int eb = 0, ei = 0, eu = 0, er = 0;
            while(isstylechar(*endword)) {
              switch(*endword) {
                case '*': eb++; break;
                case '/': ei++; break;
                case '_': eu++; break;
                case '#': er++; break;
              }
              endword--;
            }                                          //  _/*anothe>r*/_
            if(endword >= beginword and not strchr(stylemargins, *endword)) {
              if((bb == eb) AND (bi == ei) AND (bu == eu) AND (br == er)) {
                char endwordchar = *endword;
                *endword = NUL;
                char* style_stops_present = strpbrk(beginword, stylestopchars);
                *endword = endwordchar;
                if(NOT style_stops_present) {
                  int colorindex = (bb ? 1 : 0) | (bi ? 2 : 0) | (bu ? 4 : 0) | (br ? 8 : 0);
                  if(dohide) {
                    strxcpy(buf, text+txlen, (uint)(beginstyle-text-txlen)+1);
                    (*fp)(row, col+sclen, color, buf);
                    sclen += strlen(buf);
                    strxcpy(buf, beginword, (uint)(endword-beginword)+2);
                    (*fp)(row, col+sclen, C_STYLE[colorindex], buf);
                    sclen += strlen(buf);
                    txlen = (uint) (end-text);
                  }
                  else {
                    strxcpy(buf, beginstyle, (uint)(endstyle-beginstyle)+2);
                    sclen += strlen(buf);
                    txlen = sclen;
                    (*fp)(row, col+(uint)(beginstyle-text), C_STYLE[colorindex], buf);
                  }
                }
              }
            }
          }
          *end = endchar;
          ptr = end-1;
        }
      }
    }
    if(*ptr)
      prevchar = *ptr++;
  }
  if(dohide) {
    strxcpy(buf, text+txlen, strlen(text+txlen)+1);
    (*fp)(row, col+sclen, color, buf);
    sclen += strlen(buf);
    txlen = strlen(text) - sclen;
    memset(buf, ' ', txlen);buf[txlen] = NUL;
    (*fp)(row, col+sclen, color, buf);
  }
}


//  ------------------------------------------------------------------

int IsMacro(Key key, int type) {

  int n = 0;
  Macro* m = CFG->macro;
  while(n < CFG->macros) {
    if((key == m->key) and (type == m->type))
      return true;
    m++;
    n++;
  }

  return false;
}


//  ------------------------------------------------------------------

int PlayMacro(Key key, int type) {

  int n = 0;
  Macro* m = CFG->macro;
  while(n < CFG->macros) {
    if((key == m->key) AND (type == m->type)) {
      RunMacro(m);
      return true;
    }
    m++;
    n++;
  }

  return false;
}


//  ------------------------------------------------------------------

