
//  ------------------------------------------------------------------
//  GoldED. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: geglob.h,v 1.2 1998/11/23 02:12:59 damware Exp $
//  ------------------------------------------------------------------
//  Global data.
//  ------------------------------------------------------------------


//  ------------------------------------------------------------------

extern GLog __FAR LOG;

extern gareafile* AFILE;
extern CfgGed* CFG;
extern LangGed* LNG;
extern NodeIxl* NODE;
extern Grp* GRP;
extern Qwk* QWK;
extern GoldedCfgEdit* EDIT;

// GCCFGG.CPP
extern int cfgingroup;
extern int cfggroups;
extern gfile grpfp;

// GCKEYS.CPP
extern CmdKey __FAR DefaultKeyset[];

// GEAREA.CPP
extern int  area_pos;
extern int  area_width;
extern int  marked_pos;
extern int  marked_width;
extern const char marked_char;
extern int  desc_pos;
extern int  desc_width;
extern int  count_pos;
extern int  count_width;
extern int  pmark_pos;
extern int  pmark_width;
extern const char pmark_char;
extern int  unread_pos;
extern int  unread_width;
extern int  changed_pos;
extern int  changed_width;
extern const char changed_char;
extern int  echoid_pos;
extern int  echoid_width;
extern int  groupid_pos;
extern int  groupid_width;

// GEFILE.CPP
extern int fspecs;
extern int specfiles;
extern FileSpec* fspec;

// GEMENU.CPP
extern GMsg* MenuMsgPtr;

// GEPOST.CPP
extern uint position;
extern ulong msgcount;

// GEREAD.CPP
extern int reader_finished;
extern int reader_done;
extern int reader_topline;
extern int reader_keyok;
extern int reader_direction;
extern int reader_rcv_noise;
extern Key reader_keycode;
extern GMsgHeaderView HeaderView;
extern GMsgBodyView BodyView;

// Other

extern uint locpost, netpost, echopost;

extern Subj __FAR information;

extern Area* AA;

extern char m_title[];
extern int m_titlepos;
extern int m_titleattr;

extern char* tconv;

extern CmdKey*  AreaKey;
extern int     AreaKeys;
extern CmdKey*  ReadKey;
extern int     ReadKeys;
extern CmdKey*  ListKey;
extern int     ListKeys;
extern CmdKey*  NodeKey;
extern int     NodeKeys;
extern CmdKey*  EditKey;
extern int     EditKeys;
extern CmdKey*  FileKey;
extern int     FileKeys;

extern int inforow;

extern char goldmark;

extern int startecho;
extern Echo __FAR stecho;

extern int fieldupd;

extern int CurrArea;
extern int OrigArea;

extern Esc* MNETable;
extern Esc* I51Table;
extern Esc* CompTable;
extern Chs* CharTable;
extern EscTab* CompTP;
extern EscTab* I51TP;
extern EscTab* MNETP;
extern ChsTab* ChsTP;

//extern char gversion[];

extern int stamps;
extern Stamp* stamp;

extern int quiet;
extern int ignore;
extern int cfgerrors;
extern int veryverbose;
extern int shellvid;
extern word* oldscreen;
extern int keysread;

extern int disablesound;

extern int _in_editor;
extern int _in_msglist;
extern int savedirect;

extern void(*SIGINT_OldHandler)(void);

extern Path __FAR cmdlinecfg;
extern int  __FAR cmdlinedebughg;
extern int  __FAR cmdlineimportsoup;
extern int  __FAR cmdlineoldkeyw;

extern int pmscanning;

extern Win __FAR gold_color1[];
extern Win __FAR gold_color2[];
extern Win __FAR gold_mono1[];

extern Echo area_maybe;

extern int __FAR blanked;

extern int startupscan_success;


//  ------------------------------------------------------------------
//  Global compile constants

extern const char* __gver_vendor_name__;
extern const char* __gver_vendor_fido__;
extern const char* __gver_vendor_email__;
extern const char* __gver_prename__;
extern const char* __gver_preshortname__;
extern const char* __gver_name__;
extern const char* __gver_shortname__;
extern const char* __gver_shortlogname__;
extern const char* __gver_postshortname__;
extern const char* __gver_postname__;
extern const char* __gver_platform__;
extern const char* __gver_shortplatform__;
extern const char* __gver_cfgext__;
extern const char* __gver_preversion__;
extern const char* __gver_postversion__;
extern int         __gver_major__;
extern int         __gver_minor__;
extern int         __gver_release__;
extern const char* __gver_releasename__;
extern const char* __gver_date__;
extern const char* __gver_time__;
extern char        __gver_longpid__[];
extern char        __gver_shortpid__[];


//  ------------------------------------------------------------------

