
//  ------------------------------------------------------------------
//  GoldED. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gemain.cpp,v 1.1.1.1 1998/11/21 19:38:02 odinn Exp $
//  ------------------------------------------------------------------
//  Main entry point and overlay size setting function.
//  ------------------------------------------------------------------


#include "golded.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif


//  ------------------------------------------------------------------

#if defined(__DJGPP__)
#include <crt0.h>
#include <sys/stat.h>
//int _crt0_startup_flags = _CRT0_FLAG_NO_LFN | _CRT0_FLAG_USE_DOS_SLASHES | _CRT0_FLAG_PRESERVE_UPPER_CASE | _CRT0_FLAG_UNIX_SBRK;
int _crt0_startup_flags = _CRT0_FLAG_NO_LFN | _CRT0_FLAG_USE_DOS_SLASHES | _CRT0_FLAG_PRESERVE_UPPER_CASE;
extern unsigned short _djstat_flags;
#endif


//  ------------------------------------------------------------------
//  Main function

//extern int _malloc_debug;

int _stdc main(int argc, char *argv[]) {

  #if defined(__DJGPP__)
  _djstat_flags = _STAT_INODE | _STAT_EXEC_EXT | _STAT_EXEC_MAGIC | _STAT_DIRSIZE | _STAT_ROOT_TIME | _STAT_WRITEBIT;
  #endif

  #if defined(__BORLANDC__) and defined(__MSDOS__)
  set_new_handler(0);
  #endif

  // Allow more than 20 files to be opened
  #if defined(__WATCOMC__)
  _grow_handles(30);
  #endif

  Initialize(argc, argv);
  Reader();
  return errorlevel;
}


//  ------------------------------------------------------------------
//  Set overlay buffer size based on commandline/environment variable
//  Called from the init code

#if defined(__BORLANDC__) && defined(__MSDOS__)

//unsigned _ovrbuffer = 100*64;    // Set default overlay buffer to 100k

void _stdc setovrbuf(void) {

  word* wptr;
  int gotit=NO;
  char buf[256];
  char* ptr;
  char* ptr2;

  ptr = (char*)MK_FP(_psp, 0x80);

  // First try commandline parameters
  strncpy(buf, ptr+1, *ptr);
  buf[(byte)*ptr] = 0;
  ptr = buf;
  while(*ptr) {
    ptr = SkipWht(ptr);
    if(strchr("-/", *ptr++)) {
      if(toupper(*ptr++) == 'O') {
        _ovrbuffer = atoi(*ptr== '=' ? ptr+1 : ptr)*64;
        gotit = YES;
        break;
      }
    }
    ptr = SkipTxt(ptr);
  }
  if(NOT gotit) {
    // Then check environment
    wptr = (word*)MK_FP(_psp, 0x2C);
    ptr = (char*)MK_FP(*wptr, 0);
    do {
      if(strnieql(ptr, "GEDCMD=", 7)) {
        ptr2 = ptr+7;
        while(*ptr2) {
          ptr2 = SkipWht(ptr2);
          if(strchr("-/", *ptr2++)) {
            if(toupper(*ptr2++) == 'O') {
              _ovrbuffer = atoi(*ptr2== '=' ? ptr2+1 : ptr2)*64;
              gotit = YES;
              break;
            }
          }
          ptr2 = SkipTxt(ptr2);
        }
        break;
      }
      ptr += strlen(ptr) + 1;
    } while(*ptr);
  }
}

//  ------------------------------------------------------------------
//  The following pragma makes the startup (C0) code call setovrbuf()
//  as the highest priority. Priority 0 comes just before the overlay
//  manager is called (which has priority 1).
//
//  NOTE: This has only been tested with BC++ 3.0 and 3.1, but should
//        work with earlier versions too.
//  ------------------------------------------------------------------

#pragma startup setovrbuf 0

#endif


//  ------------------------------------------------------------------
//  Remove exception handling in Borland C++ 4.xx

#if defined(__MSDOS__) AND (__BCPLUSPLUS__ > 0x310)

extern "C" void _ExceptInit(void) {}

new_handler _new_handler = NULL;

new_handler set_new_handler(new_handler p) {

  new_handler t = _new_handler;
  _new_handler = p;
  return t;
}

void *operator new( size_t size ) {

  void * p = 0;

  size = size ? size : 1;
  while((p = malloc(size)) == NULL && _new_handler != NULL)
    _new_handler();

  return p;
}

#endif


//  ------------------------------------------------------------------

