
//  ------------------------------------------------------------------
//  GoldED. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gemenu.cpp,v 1.1.1.1 1998/11/21 19:38:02 odinn Exp $
//  ------------------------------------------------------------------
//  Menus.
//  ------------------------------------------------------------------


#include "golded.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif


//  ------------------------------------------------------------------

GMsg* MenuMsgPtr;


//  ------------------------------------------------------------------

void DispHeadAttrs(GMsg* msg) {

  char atrs[200];
  MakeAttrStr(atrs, &msg->attr);
  strsetsz(atrs, MAXCOL-CFG->disphdrnodeset.pos);

  HeaderView.window.prints(1, CFG->disphdrnodeset.pos, HeaderView.window_color, atrs);
  HeaderView.window.prints(4, 0, HeaderView.window_color, (msg->attr.att() OR msg->attr.frq() OR msg->attr.urq()) ? LNG->File : LNG->Subj);
}


//  ------------------------------------------------------------------

static void DispHeadAttrs() {

  DispHeadAttrs(MenuMsgPtr);
}


//  ------------------------------------------------------------------

static void toggle_pvt() {

  MenuMsgPtr->attr.pvtX();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_received() {

  MenuMsgPtr->attr.rcvX();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_crash() {

  MenuMsgPtr->attr.craX();
  if(MenuMsgPtr->attr.cra())
    MenuMsgPtr->attr.hld0();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_hold() {

  MenuMsgPtr->attr.hldX();
  if(MenuMsgPtr->attr.hld())
    MenuMsgPtr->attr.cra0();
    MenuMsgPtr->attr.imm0();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_file() {

  MenuMsgPtr->attr.attX();
  if(MenuMsgPtr->attr.att()) {
    AttrAdd(&MenuMsgPtr->attr, &CFG->attribsattach);
    MenuMsgPtr->attr.urq0();
    MenuMsgPtr->attr.frq0();
  }
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_freq() {

  MenuMsgPtr->attr.frqX();
  if(MenuMsgPtr->attr.frq()) {
    MenuMsgPtr->attr.att0();
    MenuMsgPtr->attr.urq0();
  }
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_updreq() {

  MenuMsgPtr->attr.urqX();
  if(MenuMsgPtr->attr.urq()) {
    MenuMsgPtr->attr.att0();
    MenuMsgPtr->attr.frq0();
  }
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_kill() {

  MenuMsgPtr->attr.k_sX();
  if(MenuMsgPtr->attr.k_s())
    MenuMsgPtr->attr.a_s0();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_sent() {

  MenuMsgPtr->attr.sntX();
  if(MenuMsgPtr->attr.snt()) {
    MenuMsgPtr->attr.uns0();
    MenuMsgPtr->attr.scn1();
  }
  else {
    MenuMsgPtr->attr.uns1();
    MenuMsgPtr->attr.scn0();
    MenuMsgPtr->attr.loc1();
  }

  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_trunc() {

  MenuMsgPtr->attr.tfsX();
  if(MenuMsgPtr->attr.tfs())
    MenuMsgPtr->attr.kfs0();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_delsent() {

  MenuMsgPtr->attr.kfsX();
  if(MenuMsgPtr->attr.kfs())
    MenuMsgPtr->attr.tfs0();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_direct() {

  MenuMsgPtr->attr.dirX();
  if(MenuMsgPtr->attr.dir()) {
    MenuMsgPtr->attr.zon0();
    MenuMsgPtr->attr.hub0();
  }
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_imm() {

  MenuMsgPtr->attr.immX();
  if(MenuMsgPtr->attr.imm())
    MenuMsgPtr->attr.hld0();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_locked() {

  MenuMsgPtr->attr.lokX();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_reserved() {

  MenuMsgPtr->attr.rsvX();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_groupmsg() {

  MenuMsgPtr->attr.grpX();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_arcsent() {

  MenuMsgPtr->attr.a_sX();
  if(MenuMsgPtr->attr.a_s())
    MenuMsgPtr->attr.k_s0();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_zonegate() {

  MenuMsgPtr->attr.zonX();
  if(MenuMsgPtr->attr.zon()) {
    MenuMsgPtr->attr.dir0();
    MenuMsgPtr->attr.hub0();
  }
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_transit() {

  MenuMsgPtr->attr.trsX();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_retrecreq() {

  MenuMsgPtr->attr.rrqX();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_retrec() {

  MenuMsgPtr->attr.rrcX();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_orphan() {

  MenuMsgPtr->attr.orpX();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_audit() {

  MenuMsgPtr->attr.arqX();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_hubhost() {

  MenuMsgPtr->attr.hubX();
  if(MenuMsgPtr->attr.hub()) {
    MenuMsgPtr->attr.dir0();
    MenuMsgPtr->attr.zon0();
  }
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_local() {

  MenuMsgPtr->attr.locX();
  if(MenuMsgPtr->attr.loc())
    MenuMsgPtr->attr.trs0();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_xmail() {

  MenuMsgPtr->attr.xmaX();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_cfmrecreq() {

  MenuMsgPtr->attr.cfmX();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_scanned() {

  MenuMsgPtr->attr.scnX();
  if(MenuMsgPtr->attr.scn()) {
    MenuMsgPtr->attr.snt1();
    MenuMsgPtr->attr.uns0();
  }
  else {
    MenuMsgPtr->attr.snt0();
    MenuMsgPtr->attr.uns1();
    MenuMsgPtr->attr.loc1();
  }
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void clear_attrib() {

  MenuMsgPtr->attr.reset();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void DispAttrWindow(int show=-1) {

  static int wh_background = -1;
  static int wh_attributes = -1;

  if(show == -1)
    show = wh_attributes == -1;

  if(show) {
    wh_background = whandle();
    int wide = MaxV(strlen(LNG->AttrTitle)+2, strlen(LNG->AttrPvt)+2);
    wh_attributes = wopen_(6,0,17, wide, W_BMENU, C_MENUB, C_MENUW);
    set_title(LNG->AttrTitle, TCENTER, C_MENUT);
    if(*LNG->AttrTurnOff)
      wtitle(LNG->AttrTurnOff, TCENTER|TBOTTOM, C_MENUT);
    title_shadow();
    int n = 0;
    wprints(n++, 0, C_MENUW, LNG->AttrPvt);
    wprints(n++, 0, C_MENUW, LNG->AttrRcv);
    wprints(n++, 0, C_MENUW, LNG->AttrSnt);
    wprints(n++, 0, C_MENUW, LNG->AttrCrs);
    wprints(n++, 0, C_MENUW, LNG->AttrHld);
    wprints(n++, 0, C_MENUW, LNG->AttrFil);
    wprints(n++, 0, C_MENUW, LNG->AttrFrq);
    wprints(n++, 0, C_MENUW, LNG->AttrUpd);
    wprints(n++, 0, C_MENUW, LNG->AttrKS );
    wprints(n++, 0, C_MENUW, LNG->AttrKfs);
    wprints(n++, 0, C_MENUW, LNG->AttrTfs);
    wprints(n++, 0, C_MENUW, LNG->AttrDir);
    wprints(n++, 0, C_MENUW, LNG->AttrImm);
    wprints(n++, 0, C_MENUW, LNG->AttrLok);
    wprints(n++, 0, C_MENUW, LNG->AttrZap);
    wactiv_(wh_background);
  }
  else if(wh_attributes != -1) {
    wactiv_(wh_attributes);
    wclose();
    wactiv_(wh_background);
    wh_attributes = -1;
  }
}


//  ------------------------------------------------------------------

static void toggle_dispattrwindow() {

  DispAttrWindow();
}


//  ------------------------------------------------------------------

void ChgAttrs(int mode, GMsg* __msg) {

  static KBnd* k1;

  if(mode) {
    MenuMsgPtr = __msg;

    if(EDIT->HeaderAttrs() OR (mode == ALWAYS))
      DispAttrWindow(TRUE);
    k1 = chgonkey(NULL);
    setonkey(Key_A_F1, toggle_dispattrwindow, 0);
    setonkey(Key_A_1, toggle_reserved   , 0);
    setonkey(Key_A_2, toggle_groupmsg   , 0);
    setonkey(Key_A_4, toggle_scanned    , 0);
    setonkey(Key_A_A, toggle_file       , 0);
    setonkey(Key_A_B, toggle_arcsent    , 0);
    setonkey(Key_A_C, toggle_crash      , 0);
    setonkey(Key_A_D, toggle_direct     , 0);
    setonkey(Key_A_E, toggle_delsent    , 0);
    setonkey(Key_A_F, toggle_freq       , 0);
    setonkey(Key_A_G, toggle_zonegate   , 0);
    setonkey(Key_A_H, toggle_hold       , 0);
    setonkey(Key_A_I, toggle_imm        , 0);
    setonkey(Key_A_J, toggle_transit    , 0);
    setonkey(Key_A_K, toggle_kill       , 0);
    setonkey(Key_A_L, toggle_locked     , 0);
    setonkey(Key_A_M, toggle_retrecreq  , 0);
    setonkey(Key_A_N, toggle_retrec     , 0);
    setonkey(Key_A_O, toggle_orphan     , 0);
    setonkey(Key_A_P, toggle_pvt        , 0);
    setonkey(Key_A_Q, toggle_audit      , 0);
    setonkey(Key_A_R, toggle_received   , 0);
    setonkey(Key_A_S, toggle_sent       , 0);
    setonkey(Key_A_T, toggle_trunc      , 0);
    setonkey(Key_A_U, toggle_updreq     , 0);
    setonkey(Key_A_V, toggle_hubhost    , 0);
    setonkey(Key_A_W, toggle_local      , 0);
    setonkey(Key_A_X, toggle_xmail      , 0);
    setonkey(Key_A_Y, toggle_cfmrecreq  , 0);
    setonkey(Key_A_Z, clear_attrib      , 0);
  }
  else {
    DispAttrWindow(FALSE);
    freonkey();
    chgonkey(k1);
  }
}


//  ------------------------------------------------------------------

void AskAttributes(GMsg* __msg) {

  ChgAttrs(ALWAYS, __msg);
  update_statusline(LNG->ChangeAttrs);
  whelpdef(CFG->helpged, Key_F1, C_HELPB, C_HELPW, C_HELPQ, C_HELPS, NULL);
  whelppcat(H_Attributes);
  getxch();
  whelpop();
  ChgAttrs(FALSE, __msg);
}


//  ------------------------------------------------------------------

int SelectFromFile(const char* file, char* selection, const char* title, const char* nolines) {

  char buf[256];
  register int n;
  bool retval=false;
  char** Listi;
  int lines = 0;

  FILE* fp = fsopen(AddPath(CFG->goldpath, file), "rt", CFG->sharemode);
  if(fp) {
    while(fgets(buf, sizeof(buf), fp))
      lines++;
  }

  if(lines) {
    Listi = (char**)throw_calloc(lines+1, sizeof(char*));
    rewind(fp);
    for(n=0; n<lines; n++) {
      fgets(buf, sizeof(buf)-2, fp);
      strtrim(buf);
      strins(" ", buf, 0);
      strcat(buf, " ");
      if(strlen(buf) > gvid.numcols-2-2)
        buf[gvid.numcols-2-2] = NUL;
      Listi[n] = throw_strdup(buf);
    }
    n = MinV(n, (MAXROW-10));
    set_title(title,TCENTER,C_ASKT);
    n = wpickstr(6,0,6+n+1,-1,W_BASK,C_ASKB,C_ASKW,C_ASKS,Listi,0,title_shadow);
    if(n != -1) {
      strcpy(selection, Listi[n]);
      retval = true;
    }
    for(n=0; n<lines; n++)
      throw_free(Listi[n]);
    throw_free(Listi);
  }
  else {
    w_info(nolines);
    waitkeyt(10000);
    w_info(NULL);
  }

  if(fp)
    fclose(fp);

  return retval;
}


//  ------------------------------------------------------------------

int ChangeTagline() {

  char buf[256];
  register int n;
  bool retval=false;
  char** Listi;

  if(CFG->taglines) {
    Listi = (char**)throw_calloc(CFG->taglines+1, sizeof(char*));
    for(n=0; n<CFG->taglines; n++) {
      if(CFG->tagline[n][0] == '@') {
        char* ptr = strrchr(CFG->tagline[n], GOLD_SLASH_CHR);
        sprintf(buf, " [%s] ", ptr ? ptr+1 : CFG->tagline[n]+1);
      }
      else
        sprintf(buf, " %s ", CFG->tagline[n]);
      if(strlen(buf)>gvid.numcols-2-2)
        buf[gvid.numcols-2-2] = NUL;
      Listi[n] = throw_strdup(buf);
    }
    n = MinV(n, (MAXROW-10));
    set_title(LNG->Taglines,TCENTER,C_ASKT);
    update_statusline(LNG->ChangeTagline);
    whelppcat(H_ChangeTagline);
    n = wpickstr(6,0,6+n+1,-1,W_BASK,C_ASKB,C_ASKW,C_ASKS,Listi,CFG->taglineno,title_shadow);
    if(n != -1) {
      if(CFG->tagline[n][0] == '@') {
        char* ptr = strrchr(CFG->tagline[n], GOLD_SLASH_CHR);
        sprintf(buf, "%s [%s] ", LNG->Taglines, ptr ? ptr+1 : CFG->tagline[n]+1);
        if(SelectFromFile(CFG->tagline[n]+1, buf, LNG->Taglines, LNG->NoTagline)) {
          AA->SetTagline(buf);
          retval = true;
        }
      }
      else {
        CFG->taglineno = n;
        AA->SetTagline(CFG->tagline[n]);
        retval = true;
      }
    }
    for(n=0; n<CFG->taglines; n++)
      throw_free(Listi[n]);
    throw_free(Listi);
    whelpop();
  }
  else {
    w_info(LNG->NoTagline);
    waitkeyt(10000);
    w_info(NULL);
  }
  return(retval);
}


//  ------------------------------------------------------------------

int ChangeOrigin() {

  char buf[256];
  register int n;
  bool retval=false;
  char** Listi;

  if(CFG->origins) {
    Listi = (char**)throw_calloc(CFG->origins+1, sizeof(char*));
    for(n=0; n<CFG->origins; n++) {
      if(CFG->origin[n][0] == '@') {
        char* ptr = strrchr(CFG->origin[n], GOLD_SLASH_CHR);
        sprintf(buf, " [%s] ", ptr ? ptr+1 : CFG->origin[n]+1);
      }
      else
        sprintf(buf, " %s ", CFG->origin[n]);
      if(strlen(buf) > gvid.numcols-2-2)
        buf[gvid.numcols-2-2] = NUL;
      Listi[n] = throw_strdup(buf);
    }
    n = MinV(n, (MAXROW-10));
    set_title(LNG->Origins,TCENTER,C_ASKT);
    update_statusline(LNG->ChangeOrigin);
    whelppcat(H_ChangeOrigin);
    n = wpickstr(6,0,6+n+1,-1,W_BASK,C_ASKB,C_ASKW,C_ASKS,Listi,CFG->originno,title_shadow);
    if(n != -1) {
      if(CFG->origin[n][0] == '@') {
        char* ptr = strrchr(CFG->origin[n], GOLD_SLASH_CHR);
        sprintf(buf, "%s [%s] ", LNG->Origins, ptr ? ptr+1 : CFG->origin[n]+1);
        if(SelectFromFile(CFG->origin[n]+1, buf, LNG->Origins, LNG->NoOrigDefined)) {
          AA->SetOrigin(buf);
          retval = true;
        }
      }
      else {
        CFG->originno = n;
        AA->SetOrigin(CFG->origin[n]);
        retval = true;
      }
    }
    for(n=0; n<CFG->origins; n++)
      throw_free(Listi[n]);
    throw_free(Listi);
    whelpop();
  }
  else {
    w_info(LNG->NoOrigDefined);
    waitkeyt(10000);
    w_info(NULL);
  }
  return(retval);
}


//  ------------------------------------------------------------------

int ChangeUsername() {

  char buf[256], adrs[40];
  register int n;
  char** Listi;

  if(CFG->usernames) {
    Listi = (char**)throw_calloc(CFG->usernames+1, sizeof(char*));
    for(uint x=0; x<CFG->usernames; x++) {
      CFG->username[x].addr.make_string(adrs);
      sprintf(buf, " %-35s %s ", CFG->username[x].name, adrs);
      Listi[x] = throw_strdup(buf);
    }
    n = MinV(CFG->usernames, (uint) (MAXROW-10));
    set_title(LNG->Usernames,TCENTER,C_ASKT);
    update_statusline(LNG->ChangeUsername);
    whelppcat(H_ChangeUsername);
    n = wpickstr(6,0,6+n+1,-1,W_BASK,C_ASKB,C_ASKW,C_ASKS,Listi,CFG->usernameno,title_shadow);
    if(n != -1) {
      CFG->usernameno = n;
      AA->SetUsername(CFG->username[n]);
      for(uint a=0; a<CFG->akas; a++) {
        if(AA->Username().addr.match(CFG->aka[a].addr)) {
          AA->SetAka(CFG->aka[a].addr);
          break;
        }
      }
    }
    for(uint i=0; i<CFG->usernames; i++)
      throw_free(Listi[i]);
    throw_free(Listi);
    whelpop();
  }
  else {
    w_info(LNG->NoUserDefined);
    waitkeyt(10000);
    w_info(NULL);
  }
  return(YES);
}


//  ------------------------------------------------------------------

int ChangeTemplate() {

  char buf[256], adrs[40];
  register int n;
  int selected=-1;
  char** Listi;

  if(CFG->tpls) {
    Listi = (char**)throw_calloc(CFG->tpls+1, sizeof(char*));
    for(n=0; n<CFG->tpls; n++) {
      CFG->tpl[n].match.make_string(adrs);
      sprintf(buf, " %-45s %s ", CFG->tpl[n].name, adrs);
      Listi[n] = throw_strdup(buf);
    }
    n = MinV(n, (MAXROW-10));
    set_title(LNG->Templates,TCENTER,C_ASKT);
    update_statusline(LNG->ChangeTemplate);
    whelppcat(H_ChangeTemplate);
    n = wpickstr(6,0,6+n+1,-1,W_BASK,C_ASKB,C_ASKW,C_ASKS,Listi,CFG->tplno,title_shadow);
    whelpop();
    if(n != -1) {
      AA->SetTpl(CFG->tpl[n].file);
      CFG->tplno = n;
    }
    selected = n;
    for(n=0; n<CFG->tpls; n++)
      throw_free(Listi[n]);
    throw_free(Listi);
  }
  else {
    w_info(LNG->NoTplDefined);
    waitkeyt(10000);
    w_info(NULL);
  }
  return selected;
}


//  ------------------------------------------------------------------

int ChangeAka() {
  int n;
  int startat = 0;
  char** Listi;
  char addr[100], buf[100];

  if(CFG->akas > 1) {
    Listi = (char**)throw_calloc(CFG->akas+1, sizeof(char*));
    for(n=0; n<CFG->akas; n++) {
      CFG->aka[n].addr.make_string(addr, CFG->aka[n].domain);
      sprintf(buf, " %s ", addr);
      Listi[n] = throw_strdup(buf);
      if(AA->Aka().addr.equals(CFG->aka[n].addr))
        startat = n;
    }
    n = MinV(n, (MAXROW-10));
    set_title(LNG->Akas,TCENTER,C_ASKT);
    update_statusline(LNG->ChangeAka);
    whelppcat(H_ChangeAka);
    n = wpickstr(6,0,6+n+1,-1,W_BASK,C_ASKB,C_ASKW,C_ASKS,Listi,startat,title_shadow);
    whelpop();
    if(n != -1)
      AA->SetAka(CFG->aka[n].addr);
    for(n=0; n<CFG->akas; n++)
      throw_free(Listi[n]);
    throw_free(Listi);
  }
  else {
    w_info(LNG->NoAkaDefined);
    waitkeyt(10000);
    w_info(NULL);
  }
  return(YES);
}


//  ------------------------------------------------------------------

int ChangeXlatImport() {

  int n, startat = 0;
  int xlatimports = 0;
  int maximport = 0;
  int maxexport = 0;
  char** Listi;
  char buf[100];

  if(CFG->xlatcharsets > 1) {
    Listi = (char**)throw_calloc(CFG->xlatcharsets+1, sizeof(char*));
    for(n=0; n<CFG->xlatcharsets; n++) {
      if(strieql(CFG->xlatcharset[n].export, CFG->xlatlocalset)) {
        maximport = MaxV(maximport, (int)strlen(CFG->xlatcharset[n].import));
        maxexport = MaxV(maxexport, (int)strlen(CFG->xlatcharset[n].export));
        if(strieql(CFG->xlatcharset[n].import, AA->Xlatimport()))
          startat = xlatimports;
        xlatimports++;
      }
    }
    xlatimports = 0;
    for(n=0; n<CFG->xlatcharsets; n++) {
      if(strieql(CFG->xlatcharset[n].export, CFG->xlatlocalset)) {
        sprintf(buf, " %*.*s -> %-*.*s ",
          maximport, maximport, CFG->xlatcharset[n].import,
          maxexport, maxexport, CFG->xlatcharset[n].export
        );
        Listi[xlatimports++] = throw_strdup(buf);
      }
    }
    n = MinV(xlatimports, (MAXROW-10));
    set_title(LNG->Charsets,TCENTER,C_ASKT);
    update_statusline(LNG->ChangeXlatImp);
    whelppcat(H_ChangeXlatImport);
    n = wpickstr(6,0,6+n+1,-1,W_BASK,C_ASKB,C_ASKW,C_ASKS,Listi,startat,title_shadow);
    whelpop();
    if(n != -1)
      AA->SetXlatimport(strtok(Listi[n], " "));
    for(n=0; n<xlatimports; n++)
      throw_free(Listi[n]);
    throw_free(Listi);
  }
  else {
    w_info(LNG->NoXlatImport);
    waitkeyt(10000);
    w_info(NULL);
  }
  return TRUE;
}


//  ------------------------------------------------------------------

