
//  ------------------------------------------------------------------
//  GoldED. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gccfgg.cpp,v 1.1.1.1 1998/11/21 19:38:03 odinn Exp $
//  ------------------------------------------------------------------
//  Configuration functions, part 0.
//  ------------------------------------------------------------------


#include "golded.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#include "gccfgg.h"
#include "gcprot.h"


//  ------------------------------------------------------------------

int group_active = false;
int cfggroups = 0;
gfile grpfp;
char* val;


//  ------------------------------------------------------------------

int SwitchCfg(word crc, char k, char* v) {

  val = v;
  int found = true;

  // Switch the first letter of the keyword
  switch(toupper(k)) {
    case 'A': goto SwitchA;
    case 'B': goto SwitchB;
    case 'C': goto SwitchC;
    case 'D': goto SwitchD;
    case 'E': goto SwitchE;
    case 'F': goto SwitchF;
    case 'G': goto SwitchG;
    case 'H': goto SwitchH;
    case 'I': goto SwitchI;
    case 'J': goto SwitchJ;
    case 'K': goto SwitchK;
    case 'L': goto SwitchL;
    case 'M': goto SwitchM;
    case 'N': goto SwitchN;
    case 'O': goto SwitchO;
    case 'P': goto SwitchP;
    case 'Q': goto SwitchQ;
    case 'R': goto SwitchR;
    case 'S': goto SwitchS;
    case 'T': goto SwitchT;
    case 'U': goto SwitchU;
    case 'V': goto SwitchV;
    case 'W': goto SwitchW;
    case 'X': goto SwitchX;
    case 'Y': goto SwitchY;
    case 'Z': goto SwitchZ;
    default:  found = false;
  }
  goto End;

SwitchA:
  switch(crc) {
    case CRC_ADDRESS         :  CfgAddress         ();  break;
    case CRC_ADDRESSMACRO    :  CfgAddressmacro    ();  break;
    case CRC_ADEPTXBBSPATH   :  CfgAdeptxbbspath   ();  break;
    case CRC_ADEPTXBBSUSERNO :  CfgAdeptxbbsuserno ();  break;
    case CRC_AKA             :  CfgAddress         ();  break;
    case CRC_AKAMATCH        :  CfgAkamatch        ();  break;
    case CRC_AKAMATCHECHO    :  CfgAkamatchecho    ();  break;
    case CRC_AKAMATCHING     :  CfgAkamatching     ();  break;
    case CRC_AKAMATCHLOCAL   :  CfgAkamatchlocal   ();  break;
    case CRC_AKAMATCHNET     :  CfgAkamatchnet     ();  break;
    case CRC_AREA            :  CfgArea            ();  break;
    case CRC_AREAAUTOID      :  CfgAreaautoid      ();  break;
    case CRC_AREAAUTONEXT    :  CfgAreaautonext    ();  break;
    case CRC_AREACOPYADDID   :  CfgAreacopyaddid   ();  break;
    case CRC_AREACOPYDIRECT  :  CfgAreacopydirect  ();  break;
    case CRC_AREACOPYTO      :  CfgAreacopyto      ();  break;
    case CRC_AREADEF         :  CfgAreadef         ();  break;
    case CRC_AREADESC        :  CfgAreadesc        ();  break;
    case CRC_AREAEXCL        :  CfgAreaexcl        ();  break;
    case CRC_AREAFILEGROUPS  :  CfgAreafilegroups  ();  break;
    case CRC_AREAFREQDIRECT  :  CfgAreafreqdirect  ();  break;
    case CRC_AREAFREQTO      :  CfgAreafreqto      ();  break;
    case CRC_AREAINCL        :  CfgAreaincl        ();  break;
    case CRC_AREAISEMAIL     :  CfgAreaisemail     ();  break;
    case CRC_AREAISNEWS      :  CfgAreaisnews      ();  break;
    case CRC_AREAKEEPLAST    :  CfgAreakeeplast    ();  break;
    case CRC_AREALISTECHOMAX :  CfgArealistechomax ();  break;
    case CRC_AREALISTFORMAT  :  CfgArealistformat  ();  break;
    case CRC_AREALISTGROUPID :  CfgArealistgroupid ();  break;
    case CRC_AREALISTNOS     :  CfgArealistnos     ();  break;
    case CRC_AREALISTPAGEBAR :  CfgArealistpagebar ();  break;
    case CRC_AREALISTSCAN    :  CfgArealistscan    ();  break;
    case CRC_AREALISTSORT    :  CfgArealistsort    ();  break;
    case CRC_AREALISTTYPE    :  CfgArealisttype    ();  break;
    case CRC_AREAPATH        :  CfgAreapath        ();  break;
    case CRC_AREAPMSCAN      :  CfgAreapmscan      ();  break;
    case CRC_AREAPMSCANEXCL  :  CfgAreapmscanexcl  ();  break;
    case CRC_AREAPMSCANINCL  :  CfgAreapmscanincl  ();  break;
    case CRC_AREAREADONLY    :  CfgAreareadonly    ();  break;
    case CRC_AREARENAME      :  CfgArearename      ();  break;
    case CRC_AREAREPLYDIRECT :  CfgAreareplydirect ();  break;
    case CRC_AREAREPLYTO     :  CfgAreareplyto     ();  break;
    case CRC_AREASCAN        :  CfgAreascan        ();  break;
    case CRC_AREASCANEXCL    :  CfgAreascanexcl    ();  break;
    case CRC_AREASCANINCL    :  CfgAreascanincl    ();  break;
    case CRC_AREASCANSORT    :  CfgAreascansort    ();  break;
    case CRC_AREASEP         :  CfgAreasep         ();  break;
    case CRC_AREASTART       :  CfgAreastart       ();  break;
    case CRC_AREATYPEORDER   :  CfgAreatypeorder   ();  break;
    case CRC_ASKDELORIG      :  CfgAskdelorig      ();  break;
    case CRC_ATTRIBSATTACH   :  CfgAttribsattach   ();  break;
    case CRC_ATTRIBSCC       :  CfgAttribscc       ();  break;
    case CRC_ATTRIBSCFM      :  CfgAttribscfm      ();  break;
    case CRC_ATTRIBSECHO     :  CfgAttribsecho     ();  break;
    case CRC_ATTRIBSEMAIL    :  CfgAttribsemail    ();  break;
    case CRC_ATTRIBSFRQ      :  CfgAttribsfrq      ();  break;
    case CRC_ATTRIBSLOCAL    :  CfgAttribslocal    ();  break;
    case CRC_ATTRIBSNET      :  CfgAttribsnet      ();  break;
    case CRC_ATTRIBSNEWS     :  CfgAttribsnews     ();  break;
    case CRC_ATTRIBUTES      :  CfgAttributes      ();  break;
    default                  :  found = false;
  }
  goto End;

SwitchB:
  switch(crc) {
    case CRC_BASEON          :  CfgBaseon          ();  break;
    case CRC_BEEPCOMMENT     :  CfgBeepcomment     ();  break;
    case CRC_BEEPFACTOR      :  CfgBeepfactor      ();  break;
    case CRC_BEEPLOCALMSG    :  CfgBeeplocalmsg    ();  break;
    case CRC_BEEPNOISES      :  CfgBeepnoises      ();  break;
    case CRC_BEEPYOURMAIL    :  CfgBeepyourmail    ();  break;
    default                  :  found = false;
  }
  goto End;

SwitchC:
  switch(crc) {
    case CRC_CARBONCOPYLIST  :  CfgCarboncopylist  ();  break;
    case CRC_COLOR           :  CfgColor           ();  break;
    case CRC_COLORSET        :  CfgColorset        ();  break;
    case CRC_COLOUR          :  CfgColor           ();  break;
    case CRC_CONFIRMFILE     :  CfgConfirmfile     ();  break;
    case CRC_CONFIRMRESPONSE :  CfgConfirmresponse ();  break;
    case CRC_COOKIEFILE      :  CfgCookiefile      ();  break;
    case CRC_COOKIEPATH      :  CfgCookiepath      ();  break;
    case CRC_CROSSPOSTLIST   :  CfgCrosspostlist   ();  break;
    case CRC_CTRLINFO        :  CfgCtrlinfo        ();  break;
    case CRC_CTRLINFOECHO    :  CfgCtrlinfoecho    ();  break;
    case CRC_CTRLINFOEMAIL   :  CfgCtrlinfoemail   ();  break;
    case CRC_CTRLINFOLOCAL   :  CfgCtrlinfolocal   ();  break;
    case CRC_CTRLINFONET     :  CfgCtrlinfonet     ();  break;
    case CRC_CTRLINFONEWS    :  CfgCtrlinfonews    ();  break;
    default                  :  found = false;
  }
  goto End;

SwitchD:
  switch(crc) {
    case CRC_DISPAREANO      :  CfgDispareano      ();  break;
    case CRC_DISPATTACHSIZE  :  CfgDispattachsize  ();  break;
    case CRC_DISPAUTONEXT    :  CfgDispautonext    ();  break;
    case CRC_DISPHDRDATESET  :  CfgDisphdrdateset  ();  break;
    case CRC_DISPHDRNAMESET  :  CfgDisphdrnameset  ();  break;
    case CRC_DISPHDRNODESET  :  CfgDisphdrnodeset  ();  break;
    case CRC_DISPLISTCURSOR  :  CfgDisplistcursor  ();  break;
    case CRC_DISPLISTWRAP    :  CfgDisplistwrap    ();  break;
    case CRC_DISPLOCALHIGH   :  CfgDisplocalhigh   ();  break;
    case CRC_DISPMARGIN      :  CfgDispmargin      ();  break;
    case CRC_DISPMSGSIZE     :  CfgDispmsgsize     ();  break;
    case CRC_DISPPAGEBAR     :  CfgDisppagebar     ();  break;
    case CRC_DISPREALMSGNO   :  CfgDisprealmsgno   ();  break;
    case CRC_DISPSOFTCR      :  CfgDispsoftcr      ();  break;
    case CRC_DISPSTATUSLINE  :  CfgDispstatusline  ();  break;
    case CRC_DISPTABSIZE     :  CfgDisptabsize     ();  break;
    case CRC_DOSPROMPT       :  CfgDosprompt       ();  break;
    case CRC_DOSSWAP         :  CfgDosswap         ();  break;
    default                  :  found = false;
  }
  goto End;

SwitchE:
  switch(crc) {
    case CRC_EDITAUTOATTACH  :  CfgEditautoattach  ();  break;
    case CRC_EDITAUTOSAVE    :  CfgEditautosave    ();  break;
    case CRC_EDITCHANGEDATE  :  CfgEditchangedate  ();  break;
    case CRC_EDITCHARPARA    :  CfgEditcharpara    ();  break;
    case CRC_EDITCHARSPACE   :  CfgEditcharspace   ();  break;
    case CRC_EDITCOMMENT     :  CfgEditcomment     ();  break;
    case CRC_EDITCOMPLETION  :  CfgEditcompletion  ();  break;
    case CRC_EDITCRLFTERM    :  CfgEditcrlfterm    ();  break;
    case CRC_EDITFIELDCLEAR  :  CfgEditfieldclear  ();  break;
    case CRC_EDITHARDLINE    :  CfgEdithardline    ();  break;
    case CRC_EDITHARDLINES   :  CfgEdithardlines   ();  break;
    case CRC_EDITHARDTERM    :  CfgEdithardterm    ();  break;
    case CRC_EDITHDRNAMESET  :  CfgEdithdrnameset  ();  break;
    case CRC_EDITHDRNODESET  :  CfgEdithdrnodeset  ();  break;
    case CRC_EDITHEADERATTRS :  CfgEditheaderattrs ();  break;
    case CRC_EDITHEADERFIRST :  CfgEditheaderfirst ();  break;
    case CRC_EDITINTERNAL    :  CfgEditinternal    ();  break;
    case CRC_EDITMARGIN      :  CfgEditmargin      ();  break;
    case CRC_EDITMENU        :  CfgEditmenu        ();  break;
    case CRC_EDITMIXCASE     :  CfgEditmixcase     ();  break;
    case CRC_EDITMSGSIZE     :  CfgEditmsgsize     ();  break;
    case CRC_EDITOR          :  CfgEditor          ();  break;
    case CRC_EDITORFILE      :  CfgEditorfile      ();  break;
    case CRC_EDITQUOTEMARGIN :  CfgEditquotemargin ();  break;
    case CRC_EDITREPLYRE     :  CfgEditreplyre     ();  break;
    case CRC_EDITSAVEMENU    :  CfgEditsavemenu    ();  break;
    case CRC_EDITSAVEUTIL    :  CfgEditsaveutil    ();  break;
    case CRC_EDITSOFTCRXLAT  :  CfgEditsoftcrxlat  ();  break;
    case CRC_EDITSPELLCHECK  :  CfgEditspellcheck  ();  break;
    case CRC_EDITUNDELETE    :  CfgEditundelete    ();  break;
    case CRC_EMPTYTEARLINE   :  CfgEmptytearline   ();  break;
    case CRC_ENDGROUP        :  CfgEndgroup        ();  break;
    case CRC_EVENT           :  CfgEvent           ();  break;
    case CRC_EXCLUDENODES    :  CfgExcludenodes    ();  break;
    case CRC_EXTERNOPTIONS   :  CfgExternoptions   ();  break;
    case CRC_EXTERNUTIL      :  CfgExternutil      ();  break;
    case CRC_EZYCOMMSGBASE   :  CfgEzycommsgbase   ();  break;
    case CRC_EZYCOMUSERBASE  :  CfgEzycomuserbase  ();  break;
    case CRC_EZYCOMUSERNO    :  CfgEzycomuserno    ();  break;
    default                  :  found = false;
  }
  goto End;

SwitchF:
  switch(crc) {
    case CRC_FIDOHWMARKS     :  CfgFidohwmarks     ();  break;
    case CRC_FIDOLASTREAD    :  CfgFidolastread    ();  break;
    case CRC_FIDOMSGTYPE     :  CfgFidomsgtype     ();  break;
    case CRC_FIDONULLFIX     :  CfgFidonullfix     ();  break;
    case CRC_FIDOUSERLIST    :  CfgFidouserlist    ();  break;
    case CRC_FIDOUSERNO      :  CfgFidouserno      ();  break;
    case CRC_FILEALIAS       :  CfgFilealias       ();  break;
    case CRC_FILECHECK       :  CfgFilecheck       ();  break;
    case CRC_FILECHECKCALL   :  CfgFilecheckcall   ();  break;
    case CRC_FILELISTPAGEBAR :  CfgFilelistpagebar ();  break;
    case CRC_FOLLOWUPTO      :  CfgFollowupto      ();  break;
    case CRC_FORCETEMPLATE   :  CfgForcetemplate   ();  break;
    case CRC_FRQEXT          :  CfgFrqext          ();  break;
    case CRC_FRQNODEMAP      :  CfgFrqnodemap      ();  break;
    case CRC_FRQOPTIONS      :  CfgFrqoptions      ();  break;
    case CRC_FRQWAZOO        :  CfgFrqwazoo        ();  break;
    default                  :  found = false;
  }
  goto End;

SwitchG:
  switch(crc) {
    case CRC_GIF             :  CfgGif             ();  break;
    case CRC_GIFPATH         :  CfgGifpath         ();  break;
    case CRC_GOLDBASEPATH    :  CfgGoldbasepath    ();  break;
    case CRC_GOLDBASESYSPATH :  CfgGoldbasesyspath ();  break;
    case CRC_GOLDBASEUSERNO  :  CfgGoldbaseuserno  ();  break;
    case CRC_GOLDPATH        :  CfgGoldpath        ();  break;
    case CRC_GROUP           :  CfgGroup           ();  break;
    default                  :  found = false;
  }
  goto End;

SwitchH:
  switch(crc) {
    case CRC_HAPPYBIRTHDAY   :  CfgHappybirthday   ();  break;
    case CRC_HIGHLIGHTUNREAD :  CfgHighlightunread ();  break;
    case CRC_HUDSONPATH      :  CfgHudsonpath      ();  break;
    case CRC_HUDSONSIZEWARN  :  CfgHudsonsizewarn  ();  break;
    case CRC_HUDSONSYSPATH   :  CfgHudsonsyspath   ();  break;
    case CRC_HUDSONUSERNO    :  CfgHudsonuserno    ();  break;
    default                  :  found = false;
  }
  goto End;

SwitchI:
  switch(crc) {
    case CRC_IMPORTBEGIN     :  CfgImportbegin     ();  break;
    case CRC_IMPORTEND       :  CfgImportend       ();  break;
    case CRC_INBOUNDPATH     :  CfgInboundpath     ();  break;
    case CRC_INCLUDENODES    :  CfgIncludenodes    ();  break;
    case CRC_INPUTFILE       :  CfgInputfile       ();  break;
    case CRC_INTENSECOLORS   :  CfgIntensecolors   ();  break;
    case CRC_INTERNETADDRESS :  CfgInternetaddress ();  break;
    case CRC_INTERNETGATE    :  CfgInternetgate    ();  break;
    case CRC_INTERNETLOOKUP  :  CfgInternetlookup  ();  break;
    case CRC_INTERNETMSGID   :  CfgInternetmsgid   ();  break;
    case CRC_INTERNETREPLY   :  CfgInternetreply   ();  break;
    case CRC_INTERNETRFCBODY :  CfgInternetrfcbody ();  break;
    case CRC_INVALIDATE      :  CfgInvalidate      ();  break;
    default                  :  found = false;
  }
  goto End;

SwitchJ:
  switch(crc) {
    case CRC_JAMHARDDELETE   :  CfgJamharddelete   ();  break;
    case CRC_JAMPATH         :  CfgJampath         ();  break;
    case CRC_JAMSKIPDELETED  :  CfgJamskipdeleted  ();  break;
    default                  :  found = false;
  }
  goto End;

SwitchK:
  switch(crc) {
    case CRC_KEYBCLEAR       :  CfgKeybclear       ();  break;
    case CRC_KEYBCOMMAND     :  CfgKeybcommand     ();  break;
    case CRC_KEYBDEFAULTS    :  CfgKeybdefaults    ();  break;
    case CRC_KEYBEXT         :  CfgKeybext         ();  break;
    case CRC_KEYBMACRO       :  CfgKeybmacro       ();  break;
    case CRC_KEYBMODE        :  CfgKeybmode        ();  break;
    case CRC_KEYBSTACK       :  CfgKeybstack       ();  break;
    case CRC_KLUDGE          :  CfgKludge          ();  break;
    case CRC_KLUDGECHRS      :  CfgKludgechrs      ();  break;
    default                  :  found = false;
  }
  goto End;

SwitchL:
  switch(crc) {
    case CRC_LANGDEF         :  CfgLangdef         ();  break;
    case CRC_LOADLANGUAGE    :  CfgLoadlanguage    ();  break;
    case CRC_LOGFILE         :  CfgLogfile         ();  break;
    case CRC_LOGFORMAT       :  CfgLogformat       ();  break;
    case CRC_LOOKUPECHO      :  CfgLookupecho      ();  break;
    case CRC_LOOKUPLOCAL     :  CfgLookuplocal     ();  break;
    case CRC_LOOKUPNET       :  CfgLookupnet       ();  break;
    case CRC_LOOKUPUSERBASE  :  CfgLookupuserbase  ();  break;
    default                  :  found = false;
  }
  goto End;

SwitchM:
  switch(crc) {
    case CRC_MAILINGLIST     :  CfgMailinglist     ();  break;
    case CRC_MAPDRIVE        :  CfgMapdrive        ();  break;
    case CRC_MEMBER          :  CfgMember          ();  break;
    case CRC_MENUDROPMSG     :  CfgMenudropmsg     ();  break;
    case CRC_MENUMARKED      :  CfgMenumarked      ();  break;
    case CRC_MOOD            :  CfgMood            ();  break;
    case CRC_MOUSE           :  CfgMouse           ();  break;
    case CRC_MSGLISTDATE     :  CfgMsglistdate     ();  break;
    case CRC_MSGLISTFAST     :  CfgMsglistfast     ();  break;
    case CRC_MSGLISTFIRST    :  CfgMsglistfirst    ();  break;
    case CRC_MSGLISTHEADER   :  CfgMsglistheader   ();  break;
    case CRC_MSGLISTPAGEBAR  :  CfgMsglistpagebar  ();  break;
    case CRC_MSGLISTVIEWSUBJ :  CfgMsglistviewsubj ();  break;
    case CRC_MSGLISTWIDESUBJ :  CfgMsglistwidesubj ();  break;
    default                  :  found = false;
  }
  goto End;

SwitchN:
  switch(crc) {
    case CRC_NAMESFILE       :  CfgNamesfile       ();  break;
    case CRC_NETNAME         :  CfgNetname         ();  break;
    case CRC_NEWSGROUPS      :  CfgNewsgroups      ();  break;
    case CRC_NODELIST        :  CfgNodelist        ();  break;
    case CRC_NODELISTPAGEBAR :  CfgNodelistpagebar ();  break;
    case CRC_NODELISTWARN    :  CfgNodelistwarn    ();  break;
    case CRC_NODEPATH        :  CfgNodepath        ();  break;
    case CRC_NODEPATHFD      :  CfgNodepathfd      ();  break;
    case CRC_NODEPATHIM      :  CfgNodepathfd      ();  break;
    case CRC_NODEPATHV7      :  CfgNodepathv7      ();  break;
    case CRC_NODEV7FLAGS     :  CfgNodev7flags     ();  break;
    case CRC_NODEV7MODEM     :  CfgNodev7modem     ();  break;
    default                  :  found = false;
  }
  goto End;

SwitchO:
  switch(crc) {
    case CRC_ORGANIZATION    :  CfgOrganization    ();  break;
    case CRC_ORIGIN          :  CfgOrigin          ();  break;
    case CRC_OUTBOUNDPATH    :  CfgOutboundpath    ();  break;
    case CRC_OUTPUTFILE      :  CfgOutputfile      ();  break;
    default                  :  found = false;
  }
  goto End;

SwitchP:
  switch(crc) {
    case CRC_PCBOARDMAILER   :  CfgPcboardmailer   ();  break;
    case CRC_PCBOARDPATH     :  CfgPcboardpath     ();  break;
    case CRC_PCBOARDUSERNO   :  CfgPcboarduserno   ();  break;
    case CRC_PERSONALMAIL    :  CfgPersonalmail    ();  break;
    case CRC_PLAY            :  CfgPlay            ();  break;
    case CRC_PRINTDEVICE     :  CfgPrintdevice     ();  break;
    case CRC_PRINTFORMFEED   :  CfgPrintformfeed   ();  break;
    case CRC_PRINTINIT       :  CfgPrintinit       ();  break;
    case CRC_PRINTLENGTH     :  CfgPrintlength     ();  break;
    case CRC_PRINTMARGIN     :  CfgPrintmargin     ();  break;
    case CRC_PRINTRESET      :  CfgPrintreset      ();  break;
    default                  :  found = false;
  }
  goto End;

SwitchQ:
  switch(crc) {
    case CRC_QUOTEBLANK      :  CfgQuoteblank      ();  break;
    case CRC_QUOTEBUFFILE    :  CfgQuotebuffile    ();  break;
    case CRC_QUOTEBUFMODE    :  CfgQuotebufmode    ();  break;
    case CRC_QUOTECHARS      :  CfgQuotechars      ();  break;
    case CRC_QUOTEMARGIN     :  CfgQuotemargin     ();  break;
    case CRC_QUOTESPACING    :  CfgQuotespacing    ();  break;
    case CRC_QUOTESTRING     :  CfgQuotestring     ();  break;
    case CRC_QUOTEWRAPHARD   :  CfgQuotewraphard   ();  break;
    case CRC_QWKBADMSGS      :  CfgQwkbadmsgs      ();  break;
    case CRC_QWKCONFMAP      :  CfgQwkconfmap      ();  break;
    case CRC_QWKEXPORTPATH   :  CfgQwkexportpath   ();  break;
    case CRC_QWKIMPORTPATH   :  CfgQwkimportpath   ();  break;
    case CRC_QWKOPTIONS      :  CfgQwkoptions      ();  break;
    case CRC_QWKREPLYLINKER  :  CfgQwkreplylinker  ();  break;
    case CRC_QWKTOSSLOG      :  CfgQwktosslog      ();  break;
    default                  :  found = false;
  }
  goto End;

SwitchR:
  switch(crc) {
    case CRC_RA2USERSBBS     :  CfgRa2usersbbs     ();  break;
    case CRC_REGISTERKEY     :  CfgRegisterkey     ();  break;
    case CRC_REGISTERNAME    :  CfgRegistername    ();  break;
    case CRC_REPLYLINK       :  CfgReplylink       ();  break;
    case CRC_REPLYLINKLIST   :  CfgReplylinklist   ();  break;
    case CRC_REPLYTO         :  CfgReplyto         ();  break;
    case CRC_ROBOTNAME       :  CfgRobotname       ();  break;
    default                  :  found = false;
  }
  goto End;

SwitchS:
  switch(crc) {
    case CRC_SCREENBLANKER   :  CfgScreenblanker   ();  break;
    case CRC_SCREENELIMSNOW  :  CfgScreenelimsnow  ();  break;
    case CRC_SCREENMAXCOL    :  CfgScreenmaxcol    ();  break;
    case CRC_SCREENMAXROW    :  CfgScreenmaxrow    ();  break;
    case CRC_SCREENPALETTE   :  CfgScreenpalette   ();  break;
    case CRC_SCREENSHADOWS   :  CfgScreenshadows   ();  break;
    case CRC_SCREENSIZE      :  CfgScreensize      ();  break;
    case CRC_SCREENUSEBIOS   :  CfgScreenusebios   ();  break;
    case CRC_SEARCHFOR       :  CfgSearchfor       ();  break;
    case CRC_SEMAPHORE       :  CfgSemaphore       ();  break;
    case CRC_SENDER          :  CfgSender          ();  break;
    case CRC_SERIALNO        :  CfgSerialno        ();  break;
    case CRC_SHAREMODE       :  CfgSharemode       ();  break;
    case CRC_SIGNATURE       :  CfgSignature       ();  break;
    case CRC_SOUNDPATH       :  CfgSoundpath       ();  break;
    case CRC_SOUPBADMSGS     :  CfgSoupbadmsgs     ();  break;
    case CRC_SOUPEMAIL       :  CfgSoupemail       ();  break;
    case CRC_SOUPEXPORTPATH  :  CfgSoupexportpath  ();  break;
    case CRC_SOUPIMPORTPATH  :  CfgSoupimportpath  ();  break;
    case CRC_SOUPNEWSRCFILE  :  CfgSoupnewsrcfile  ();  break;
    case CRC_SOUPREPLYLINKER :  CfgSoupreplylinker ();  break;
    case CRC_SOUPTOSSLOG     :  CfgSouptosslog     ();  break;
    case CRC_SQUISHDIRECT    :  CfgSquishdirect    ();  break;
    case CRC_SQUISHSCAN      :  CfgSquishscan      ();  break;
    case CRC_SQUISHUSERNO    :  CfgSquishuserno    ();  break;
    case CRC_SQUISHUSERPATH  :  CfgSquishuserpath  ();  break;
    case CRC_STATUSLINECLOCK :  CfgStatuslineclock ();  break;
    case CRC_STATUSLINEHELP  :  CfgStatuslinehelp  ();  break;
    case CRC_STYLECODES      :  CfgStylecodes      ();  break;
    case CRC_STYLECODEPUNCT  :  CfgStylecodepunct  ();  break;
    case CRC_STYLECODESTOPS  :  CfgStylecodestops  ();  break;
    case CRC_SWAPPATH        :  CfgSwappath        ();  break;
    default                  :  found = false;
  }
  goto End;

SwitchT:
  switch(crc) {
    case CRC_TAGLINE         :  CfgTagline         ();  break;
    case CRC_TAGLINECHAR     :  CfgTaglinechar     ();  break;
    case CRC_TAGLINEFILE     :  CfgTaglinefile     ();  break;
    case CRC_TAGLINESUPPORT  :  CfgTaglinesupport  ();  break;
    case CRC_TEARLINE        :  CfgTearline        ();  break;
    case CRC_TEMPLATE        :  CfgTemplate        ();  break;
    case CRC_TEMPLATEMATCH   :  CfgTemplatematch   ();  break;
    case CRC_TEMPLATEPATH    :  CfgTemplatepath    ();  break;
    case CRC_TEMPPATH        :  CfgTemppath        ();  break;
    case CRC_TIMEOUT         :  CfgTimeout         ();  break;
    case CRC_TIMEOUTSAVEMSG  :  CfgTimeoutsavemsg  ();  break;
    case CRC_TIMEZONEOFFSET  :  CfgTimezoneoffset  ();  break;
    case CRC_TWITMODE        :  CfgTwitmode        ();  break;
    case CRC_TWITNAME        :  CfgTwitname        ();  break;
    case CRC_TWITSUBJ        :  CfgTwitsubj        ();  break;
    case CRC_TWITTO          :  CfgTwitto          ();  break;
    default                  :  found = false;
  }
  goto End;

SwitchU:
  switch(crc) {
    case CRC_USEFLAGS        :  CfgUseflags        ();  break;
    case CRC_USEFWD          :  CfgUsefwd          ();  break;
    case CRC_USEINTL         :  CfgUseintl         ();  break;
    case CRC_USEMSGID        :  CfgUsemsgid        ();  break;
    case CRC_USERLIST        :  CfgUserlist        ();  break;
    case CRC_USERLISTFILE    :  CfgUserlistfile    ();  break;
    case CRC_USERNAME        :  CfgUsername        ();  break;
    case CRC_UUDECODEPATH    :  CfgUudecodepath    ();  break;
    default                  :  found = false;
  }
  goto End;

SwitchV:
  switch(crc) {
    case CRC_VIEWHIDDEN      :  CfgViewhidden      ();  break;
    case CRC_VIEWKLUDGE      :  CfgViewkludge      ();  break;
    case CRC_VIEWQUOTE       :  CfgViewquote       ();  break;
    default                  :  found = false;
  }
  goto End;

SwitchW:
  switch(crc) {
    case CRC_WHOTO           :  CfgWhoto           ();  break;
    case CRC_WILDCATUSERNO   :  CfgWildcatuserno   ();  break;
    default                  :  found = false;
  }
  goto End;

SwitchX:
  switch(crc) {
    case CRC_XLATCHARSET     :  CfgXlatcharset     ();  break;
    case CRC_XLATESCSET      :  CfgXlatescset      ();  break;
    case CRC_XLATEXPORT      :  CfgXlatexport      ();  break;
    case CRC_XLATIMPORT      :  CfgXlatimport      ();  break;
    case CRC_XLATLOCALSET    :  CfgXlatlocalset    ();  break;
    case CRC_XLATPATH        :  CfgXlatpath        ();  break;
    default                  :  found = false;
  }
  goto End;

SwitchY:
  switch(crc) {
    default                  :  found = false;
  }
  goto End;

SwitchZ:
  switch(crc) {
    case CRC_ZONEGATING      :  CfgZonegating      ();  break;
    default                  :  found = false;
  }
  goto End;

End:
  if(found)
    return true;
  //found = true;

  if(cmdlineoldkeyw == false)
    return false;

  // Obsolete keywords
  switch(crc) {
    case CRC_AREAAUTOFREQ    :  CfgAreafreqto      ();  break;
    case CRC_AREABADMSGS     :  CfgSoupbadmsgs     ();  break;
    case CRC_AREASORT        :  CfgArealistsort    ();  break;
    case CRC_ASSIGNTO        :  CfgMember          ();  break;
    case CRC_AUTOATTACH      :  CfgEditautoattach  ();  break;
    case CRC_BLANKTIME       :  CfgScreenblanker   ();  break;
    case CRC_BOARDNOS        :  CfgArealistnos     ();  break;
    case CRC_CCATTRIB        :  CfgAttribscc       ();  break;
    case CRC_CCLIST          :  CfgCarboncopylist  ();  break;
    case CRC_CFMATTRIB       :  CfgAttribscfm      ();  break;
    case CRC_CHANGEDATE      :  CfgEditchangedate  ();  break;
    case CRC_CHANGEPROMPT    :  CfgDosprompt       ();  break;
    case CRC_CHARSET         :  CfgXlatcharset     ();  break;
    case CRC_CLEARKEYS       :  CfgKeybclear       ();  break;
    case CRC_COMMENTNOISE    :  CfgBeepcomment     ();  break;
    case CRC_CRLFTERM        :  CfgEditcrlfterm    ();  break;
    case CRC_DELORIG         :  CfgAskdelorig      ();  break;
    case CRC_DISPMSGLIST     :  CfgMsglistfirst    ();  break;
    case CRC_DISPMSGLISTFAST :  CfgMsglistfast     ();  break;
    case CRC_DISPSTYLECODES  :  CfgStylecodes      ();  break;
    case CRC_ECHOATTRIB      :  CfgAttribsecho     ();  break;
    case CRC_ECHOINFO        :  CfgCtrlinfoecho    ();  break;
    case CRC_EDITORVERSION   :  CfgEditorversion   ();  break;
    case CRC_ELIMSNOW        :  CfgScreenelimsnow  ();  break;
    case CRC_ESCSET          :  CfgXlatescset      ();  break;
    case CRC_EXCLAREA        :  CfgAreaexcl        ();  break;
    case CRC_EXPORTCHARSET   :  CfgXlatexport      ();  break;
    case CRC_EXTKEYS         :  CfgKeybext         ();  break;
    case CRC_FIDOLASTREADNO  :  CfgFidouserno      ();  break;
    case CRC_FIELDCLEAR      :  CfgEditfieldclear  ();  break;
    case CRC_FREEAREA        :  CfgFreearea        ();  break;
    case CRC_FREETEAR        :  CfgFreearea        ();  break;
    case CRC_GOLDEDCFM       :  CfgConfirmfile     ();  break;
    case CRC_GOLDEDLOG       :  CfgLogfile         ();  break;
    case CRC_GOLDEDLST       :  CfgUserlistfile    ();  break;
    case CRC_GOLDEDMSG       :  CfgEditorfile      ();  break;
    case CRC_GOLDEDNAM       :  CfgNamesfile       ();  break;
    case CRC_GOLDEDPRN       :  CfgOutputfile      ();  break;
    case CRC_GOLDHELP        :  CfgGoldhelp        ();  break;
    case CRC_GOLDKEYS        :  CfgGoldkeys        ();  break;
    case CRC_GOLDLANG        :  CfgGoldlang        ();  break;
    case CRC_GOLDRAND        :  CfgGoldrand        ();  break;
    case CRC_GOLDXLAT        :  CfgGoldxlat        ();  break;
    case CRC_HARDLINE        :  CfgEdithardline    ();  break;
    case CRC_HARDLINES       :  CfgEdithardlines   ();  break;
    case CRC_HWMARKS         :  CfgFidohwmarks     ();  break;
    case CRC_INCLAREA        :  CfgAreaincl        ();  break;
    case CRC_INTERNALEDITOR  :  CfgEditinternal    ();  break;
    case CRC_LASTREAD        :  CfgFidolastread    ();  break;
    case CRC_LASTREADUSER    :  CfgFidouserno      ();  break;
    case CRC_LISTWRAP        :  CfgDisplistwrap    ();  break;
    case CRC_LOCALATTRIB     :  CfgAttribslocal    ();  break;
    case CRC_LOCALCHARSET    :  CfgXlatimport      ();  break;
    case CRC_LOCALHIGHLIGHT  :  CfgDisplocalhigh   ();  break;
    case CRC_LOCALINFO       :  CfgCtrlinfolocal   ();  break;
    case CRC_LOCALNOISE      :  CfgBeeplocalmsg    ();  break;
    case CRC_MATCHAKA        :  CfgAkamatchnet     ();  break;
    case CRC_MAXCOLS         :  CfgScreenmaxcol    ();  break;
    case CRC_MAXMSGSIZE      :  CfgEditmsgsize     ();  break;
    case CRC_MAXROWS         :  CfgScreenmaxrow    ();  break;
    case CRC_MIXCASE         :  CfgEditmixcase     ();  break;
    case CRC_MULTIQBBS       :  CfgQbbsincrescan   ();  break;
    case CRC_NETATTRIB       :  CfgAttribsnet      ();  break;
    case CRC_NETINFO         :  CfgCtrlinfonet     ();  break;
    case CRC_NETTEAR         :  CfgNettear         ();  break;
    case CRC_NEXTAREA        :  CfgAreaautonext    ();  break;
    case CRC_NEXTMSGS        :  CfgDispautonext    ();  break;
    case CRC_NOISEFACTOR     :  CfgBeepfactor      ();  break;
    case CRC_OVERLAY         :  CfgOverlay         ();  break;
    case CRC_OVERLAYEMS      :  CfgOverlay         ();  break;
    case CRC_OVERLAYEXT      :  CfgOverlay         ();  break;
    case CRC_PAGEBAR         :  CfgDisppagebar     ();  break;
    case CRC_QBBSINCRESCAN   :  CfgQbbsincrescan   ();  break;
    case CRC_QBBSPATH        :  CfgHudsonpath      ();  break;
    case CRC_QBBSREBUILD     :  CfgQbbsrebuild     ();  break;
    case CRC_QBBSSCAN        :  CfgQbbsscan        ();  break;
    case CRC_QMSGPATH        :  CfgHudsonpath      ();  break;
    case CRC_REALMSGNO       :  CfgDisprealmsgno   ();  break;
    case CRC_REBUILD         :  CfgQbbsrebuild     ();  break;
    case CRC_RENAREA         :  CfgArearename      ();  break;
    case CRC_REPLYRE         :  CfgEditreplyre     ();  break;
    case CRC_RIGHTMARGIN     :  CfgDispmargin      ();  break;
    case CRC_SAVEMENU        :  CfgEditsavemenu    ();  break;
    case CRC_SAVETIME        :  CfgEditautosave    ();  break;
    case CRC_SAYBIBI         :  CfgBeepnoises      ();  break;
    case CRC_SCANAREA        :  CfgAreascan        ();  break;
    case CRC_SCREENUSEANSI   :  CfgScreenuseansi   ();  break;
    case CRC_SHADOWS         :  CfgScreenshadows   ();  break;
    case CRC_SHARE           :  CfgSharemode       ();  break;
    case CRC_SHOWTWITS       :  CfgTwitmode        ();  break;
    case CRC_SIGNALFILE      :  CfgSemaphore       ();  break;
    case CRC_SOUNDDEVICE     :  CfgSounddevice     ();  break;
    case CRC_SPACEQUOTES     :  CfgQuotespacing    ();  break;
    case CRC_SPELLCHECKER    :  CfgEditspellcheck  ();  break;
    case CRC_STACKKEYS       :  CfgKeybstack       ();  break;
    case CRC_STARTECHO       :  CfgAreastart       ();  break;
    case CRC_SWAPALL         :  CfgDosswap         ();  break;
    case CRC_SYSOP           :  CfgUsername        ();  break;
    case CRC_TABSIZE         :  CfgDisptabsize     ();  break;
    case CRC_TIMESLICE       :  CfgTimeslice       ();  break;
    case CRC_TIMESREAD       :  CfgHighlightunread ();  break;
    case CRC_UNDELETELINES   :  CfgEditundelete    ();  break;
    case CRC_USEBIOS         :  CfgScreenusebios   ();  break;
    case CRC_XPLIST          :  CfgCrosspostlist   ();  break;
    default                  :  return false;
  }

  return true;
}
               

//  ------------------------------------------------------------------

static bool do_if(char* val) {

  if(strieql(val, "OS/2") or strieql(val, "OS2")) {
    #ifdef __OS2__
    return true;
    #else
    return false;
    #endif
  }
  else if(strieql(val, "NT") or strieql(val, "W32") or strieql(val, "WIN32")) {
    #ifdef __WIN32__
    return true;
    #else
    return false;
    #endif
  }
  else if(strieql(val, "386")) {
    #if defined(__MSDOS__) and defined(__386__)
    return true;
    #else
    return false;
    #endif
  }
  else if(strieql(val, "DOS")) {
    #ifdef __MSDOS__
    return true;
    #else
    return false;
    #endif
  }
  else if(strieql(val, "LINUX") or strieql(val, "UNIX")) {
    #ifdef __linux__
    return true;
    #else
    return false;
    #endif
  }
  else if(strieql(val, "INOS2")) {
    #ifdef __OS2__
    return true;
    #else
    return _osmajor >= 10;
    #endif
  }
  else if(strieql(val, "FIREBIRD")) {
    #if defined(GOLDED_FIREBIRD)
    return true;
    #else
    return false;
    #endif
  }
  else if(strieql(val, __gver__))
    return true;
  else if(strieql(val, "YES") or strieql(val, "TRUE") or strieql(val, "ON"))
    return true;
  return !!atoi(val);
}


//  ------------------------------------------------------------------
//  Display a "twirly"

#if 0
     
#define TWIRLY_FACTOR 25
#define TWIRLY(n) if((((n)%TWIRLY_FACTOR)==0) and quiet) twirly()

void twirly() {

  static int n = 0;

  switch((n++)%4) {
    case 0:  fputs("|\b", stderr);  break;
    case 1:  fputs("/\b", stderr);  break;
    case 2:  fputs("-\b", stderr);  break;
    case 3:  fputs("\\\b",stderr);  break;
  }
}
#endif


//  ------------------------------------------------------------------
//  Compile a GoldED text config file

int ReadCfg(const gstring& cfgfile, int ignoreunknown) {

  const word CRC_APP      = 0x08B5;
  const word CRC_AREAFILE = 0xB487;
  const word CRC_ELIF     = 0x3237;
  const word CRC_ELSE     = 0x2834;
  const word CRC_ELSEIF   = 0xB0DE;
  const word CRC_ENDIF    = 0x9998;
  const word CRC_IF       = 0x4946;
  const word CRC_IGNORE   = 0xC07B;
  const word CRC_INCLUDE  = 0x379B;
  const word CRC_REM      = 0x3FFA;

  FILE* fp;
  gstring cfg;
  char buf[1024];
  static int __FAR inuse = 0;
  static int __FAR in_if = false;
  static int __FAR in_else = false;
  static int __FAR if_status = false;
  static int __FAR keyfileread = false;
  char* val;
  char* key;
  const char* cfgname;
  word crc;
  int cfgignore=NO, line=0;

  // Open the file
  cfg = cfgfile;
  MakePathname(cfg, CFG->goldpath, cfg);
  fp = fsopen(cfg.c_str(), "rt", CFG->sharemode);
  if(fp) {
    AddStamp(cfg.c_str());
    cfgname = strrchr(cfg.c_str(), '\\');
    cfgname = cfgname ? cfgname+1 : cfg.c_str();
    if(inuse == 0) {

      // Working ...
      printf(" ... ");
    }
    inuse++;

    if(not quiet)
      printf("\n* Reading %s", cfg.c_str());

    // Assign file buffer
    setvbuf(fp, NULL, _IOFBF, 8192);

    // Read each line
    while(fgets((val=buf), sizeof(buf), fp)) {

      #if 0
      TWIRLY(line);
      #endif

      line++;

      val = strskip_wht(val);

      if(isalpha(*val)) {

        // Extract key and val
        crc = getkeyvalcrc(&key, &val);

        int _gotcond = true;
        switch(crc) {
          case CRC_IF:
            if(in_if) {
              printf("\n* %s: Misplaced IF at line %u. IF's cannot be nested.", cfgname, line);
              cfgerrors++;
            }
            in_if = true;
            if_status = do_if(val);
            cfgignore = !if_status;
            break;
          case CRC_ELIF:
          case CRC_ELSEIF:
            if((not in_if) or in_else) {
              printf("\n* %s: Misplaced ELIF/ELSEIF at line %u.", cfgname, line);
              cfgerrors++;
            }
            if(if_status)
              cfgignore = true;
            else {
              if_status = do_if(val);
              cfgignore = !if_status;
            }
            break;
          case CRC_ELSE:
            if((not in_if) or in_else) {
              printf("\n* %s: Misplaced ELSE at line %u.", cfgname, line);
              cfgerrors++;
            }
            in_else = true;
            if_status ^= true;
            cfgignore = !if_status;
            break;
          case CRC_ENDIF:
            if(not in_if) {
              printf("\n* %s: Misplaced ENDIF at line %u.", cfgname, line);
              cfgerrors++;
            }
            cfgignore = false;
            in_if = in_else = false;
            break;
          case CRC_IGNORE:
            cfgignore ^= true;
            break;
          default:
            _gotcond = false;
        }

        // Tell the world what we found
        if(veryverbose)
          printf("\n %c%04u: %s %s", cfgignore ? '-' : '+', line, key, val);

        // Call switch function to act on the key
        if(not cfgignore) {
          if(not _gotcond) {
            switch(crc) {
              case CRC_INCLUDE:
                if(not quiet)
                  printf("\n* Including %s", val);
                ReadCfg(val);          // NOTE! This is a recursive call!
                if(not quiet)
                  printf("\n* Resuming %s", cfg.c_str());
                break;
              case CRC_AREAFILE:
                if(not quiet)
                  printf("\n* Handling %s %s", key, val);
                AL.get_areafile(val);
                if(not quiet)
                  printf("\n* Resuming %s", cfg.c_str());
                break;
              case CRC_APP:
                // Ignore 3rd party application lines
                break;
              case CRC_REM:
                // Ignore remark lines
                break;
              default:
                if(not SwitchCfg(crc, *key, val)) {
                  if(not ignoreunknown) {
                    printf("\n* %s: Unknown keyword \"%s\" at line %u.", cfgname, key, line);
                    if(not disablesound)
                      beep();
                    cfgerrors++;
                  }
                }
            }
          }
        }
      }
    }

    // GOLDRAND.CFG is no longer read separately, so if there were
    // no groups and a GOLDRAND.CFG exists, include it from here
    // after reading the main configuration.
    if(inuse == 1) {
      if(not cfggroups) {
        MakePathname(CFG->randcfg.fn, CFG->goldpath, CFG->randcfg.fn);
        if(fexist(CFG->randcfg.fn)) {
          ReadCfg(CFG->randcfg.fn);   // NOTE! This is a recursive call!
          cfggroups = -1;             // Tell us that we've been here ...
        }
      }
    }

    // Read key file if there is one
    if(inuse == 1) {
      if(not keyfileread) {
        const char* keyfile = AddPath(CFG->goldpath, "golded.key");
        if(fexist(keyfile)) {
          ReadCfg(keyfile, true);   // NOTE! This is a recursive call!
          keyfileread = true;       // Tell us that we've been here ...
        }
      }
    }

    // Close and return all OK
    fclose(fp);
    inuse--;

    // When the final cfg is compiled
    if(inuse == 0) {

      // Read help file
      const char* helpfile = AddPath(CFG->goldpath, "goldhelp.cfg");
      if(not quiet)
        printf("\n* Reading %s", helpfile);
      CFG->helpoffset = offset;
      whelpcompile(helpfile, offset);

      // Read address macros from NAMES.FD file
      ReadNamesfile();

      // Sort the group items and close the file
      GRP->Sort();
      grpfp.fclose();

      // Mark all areas listed in the NEWSRC file as newsgroups
      gfile fp;
      fp.fopen(CFG->soupnewsrcfile, "rt");
      if(fp.isopen()) {
        AddStamp(CFG->soupnewsrcfile);
        char buf[512];
        while(fp.fgets(buf, sizeof(buf))) {
          char* ptr = strpbrk(buf, ":! ");
          if(ptr) {
            *ptr = NUL;
            garealistdata* ap = AL.echoid_to_pointer(buf);
            if(ap) {
              ap->set_echoid(buf);
              ap->set_type(ap->isnet() ? GMB_SOUP|GMB_EMAIL|GMB_NET : GMB_SOUP|GMB_NEWSGROUP|GMB_ECHO);
            }
          }
        }
        fp.fclose();
      }
      if(*CFG->soupemail) {
        garealistdata* ap = AL.echoid_to_pointer(CFG->soupemail);
        if(ap) {
          ap->set_echoid(CFG->soupemail);
          ap->set_type(GMB_SOUP|GMB_EMAIL|GMB_NET);
        }
      }

      // Mark all QWK areas
      if(QWK->FirstBBS()) {
        do {
          if(QWK->FirstConf()) {
            do {
              garealistdata* ap = AL.echoid_to_pointer(buf);
              if(ap)
                ap->set_type(ap->type() | GMB_QWK);
            } while(QWK->NextConf());
          }
        } while(QWK->NextBBS());
      }
    }

    return 1;
  }

  // Error opening file
  return 0;
}


//  ------------------------------------------------------------------

