
//  ------------------------------------------------------------------
//  GoldED. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gckeys.cpp,v 1.1.1.1 1998/11/21 19:38:03 odinn Exp $
//  ------------------------------------------------------------------
//  Keyboard configuration compile.
//  ------------------------------------------------------------------


#include "golded.h"

#ifdef __BORLANDC__
#pragma hdrstop
//#pragma option -Od
#endif

#include "gckeys.h"


//  ------------------------------------------------------------------

gkbdcmd __FAR DefaultKeyset[] = {

  { K_AA      , KK_AreaAbort            , KT_A },
  { K_AX      , KK_AreaAskExit          , KT_A },
  { K_Esc     , KK_AreaAskExit          , KT_A },
  { K_AF10    , KK_AreaAskExit          , KT_A },
  { K_AB      , KK_AreaBoardnos         , KT_A },
  { K_AO      , KK_AreaDosShell         , KT_A },
  { K_AH      , KK_AreaHeat             , KT_A },
  { K_AJ      , KK_AreaJump             , KT_A },
  { K_CLeft   , KK_AreaJump             , KT_A },
  { K_CRight  , KK_AreaJump             , KT_A },
  { K_Tab     , KK_AreaJumpNextMatch    , KT_A },
  { K_CEnter  , KK_AreaJumpNextMatch    , KT_A },
  { K_CQ      , KK_AreaQuitNow          , KT_A },
  { K_AS      , KK_AreaScan             , KT_A },
  { K_AP      , KK_AreaScanPM           , KT_A },
  { K_Enter   , KK_AreaSelect           , KT_A },
  { K_Right   , KK_AreaSelect           , KT_A },
  { K_AT      , KK_AreaToggle           , KT_A },
  { K_Ins     , KK_AreaToggle           , KT_A },
  { K_CZ      , KK_AreaTouchNetscan     , KT_A },
  { K_AW      , KK_AreaWriteGoldlast    , KT_A },
  { K_AZ      , KK_AreaZap              , KT_A },

  { K_Esc     , KK_EditAbort            , KT_E },
  { K_AA      , KK_EditAnchor           , KT_E },
  { K_AX      , KK_EditAskExit          , KT_E },
  { K_AF4     , KK_EditAskExit          , KT_E },
  { K_AF5     , KK_EditClearDeleteBuf   , KT_E },
  { K_AF6     , KK_EditClearPasteBuf    , KT_E },
  { K_AC      , KK_EditCopy             , KT_E },
  { Key_C_Min , KK_EditCopyAboveChar    , KT_E },
  { K_AM      , KK_EditCut              , KT_E },
  { K_Del     , KK_EditDelChar          , KT_E },
  { K_AK      , KK_EditDeleteEOL        , KT_E },
  { K_AY      , KK_EditDeleteEOL        , KT_E },
  { K_BSpace  , KK_EditDelLeft          , KT_E },
  { K_AD      , KK_EditDelLine          , KT_E },
  { K_CY      , KK_EditDelLine          , KT_E },
  { K_CBSpace , KK_EditDelLtWord        , KT_E },
  { K_CF5     , KK_EditDelLtWord        , KT_E },
  { K_CT      , KK_EditDelRtWord        , KT_E },
  { K_CF6     , KK_EditDelRtWord        , KT_E },
  { K_AO      , KK_EditDosShell         , KT_E },
  { K_F4      , KK_EditDupLine          , KT_E },
  { K_AW      , KK_EditExportText       , KT_E },
  { K_Home    , KK_EditGoBegLine        , KT_E },
  { K_CPgDn   , KK_EditGoBotLine        , KT_E },
  { K_CEnd    , KK_EditGoBotMsg         , KT_E },
  { K_Down    , KK_EditGoDown           , KT_E },
  { K_ADown   , KK_EditGoDown           , KT_E },
  { K_CDown   , KK_EditGoDown           , KT_E },
  { K_End     , KK_EditGoEOL            , KT_E },
  { K_Left    , KK_EditGoLeft           , KT_E },
  { K_ALeft   , KK_EditGoLeft           , KT_E },
  { K_PgDn    , KK_EditGoPgDn           , KT_E },
  { K_PgUp    , KK_EditGoPgUp           , KT_E },
  { K_Right   , KK_EditGoRight          , KT_E },
  { K_ARight  , KK_EditGoRight          , KT_E },
  { K_CPgUp   , KK_EditGoTopLine        , KT_E },
  { K_CHome   , KK_EditGoTopMsg         , KT_E },
  { K_Up      , KK_EditGoUp             , KT_E },
  { K_AUp     , KK_EditGoUp             , KT_E },
  { K_CUp     , KK_EditGoUp             , KT_E },
  { K_CLeft   , KK_EditGoWordLeft       , KT_E },
  { K_CRight  , KK_EditGoWordRight      , KT_E },
  { K_AH      , KK_EditHeader           , KT_E },
  { K_AQ      , KK_EditImportQuotebuf   , KT_E },
  { K_AI      , KK_EditImportText       , KT_E },
  { K_AR      , KK_EditImportText       , KT_E },
  { K_F3      , KK_EditImportText       , KT_E },
  { K_F8      , KK_EditLoadFile         , KT_E },
  { K_AL      , KK_EditLookupCursor     , KT_E },
  { K_SF10    , KK_EditLookupDest       , KT_E },
  { K_F10     , KK_EditLookupOrig       , KT_E },
  { K_Enter   , KK_EditNewline          , KT_E },
  { K_AP      , KK_EditPaste            , KT_E },
  { K_CQ      , KK_EditQuitNow          , KT_E },
  { K_AB      , KK_EditReflow           , KT_E },
  { K_F7      , KK_EditSaveFile         , KT_E },
  { K_AS      , KK_EditSaveMsg          , KT_E },
  { K_CZ      , KK_EditSaveMsg          , KT_E },
  { K_F2      , KK_EditSaveMsg          , KT_E },
  { K_F9      , KK_EditSpellCheck       , KT_E },
  { K_Tab     , KK_EditTab              , KT_E },
  { K_A3      , KK_EditToggleCase       , KT_E },
  { K_Ins     , KK_EditToggleInsert     , KT_E },
  { K_A2      , KK_EditToLower          , KT_E },
  { K_A1      , KK_EditToUpper          , KT_E },
  { K_CU      , KK_EditUnDelete         , KT_E },
  { K_AZ      , KK_EditZapQuoteBelow    , KT_E },

  { K_Esc     , KK_FileAbort            , KT_F },
  { K_AX      , KK_FileAskExit          , KT_F },
  { K_AF4     , KK_FileAskExit          , KT_F },
  { K_AO      , KK_FileDosShell         , KT_F },
  { K_Ins     , KK_FileMark             , KT_F },
  { K_CEnter  , KK_FileMarkAll          , KT_F },
  { K_CHome   , KK_FileMarkAll          , KT_F },
  { K_CQ      , KK_FileQuitNow          , KT_F },
  { K_Enter   , KK_FileSelect           , KT_F },
  { K_Space   , KK_FileToggleMark       , KT_F },
  { K_Del     , KK_FileUnMark           , KT_F },
  { K_CEnd    , KK_FileUnMarkAll        , KT_F },

  { K_Esc     , KK_ListAbort            , KT_M },
  { K_AX      , KK_ListAskExit          , KT_M },
  { K_AF4     , KK_ListAskExit          , KT_M },
  { K_AO      , KK_ListDosShell         , KT_M },
  { K_STab    , KK_ListGotoBookMark     , KT_M },
  { K_BSpace  , KK_ListGotoBookMark     , KT_M },
  { K_S       , KK_ListMarkingOptions   , KT_M },
  { K_AS      , KK_ListMarkingOptions   , KT_M },
  { K_AF9     , KK_ListMarkingOptions   , KT_R },
  { K_CQ      , KK_ListQuitNow          , KT_M },
  { K_Enter   , KK_ListSelect           , KT_M },
  { K_Tab     , KK_ListToggleBookMark   , KT_M },
  { K_CD      , KK_ListToggleDate       , KT_M },
  { K_Space   , KK_ListToggleMark       , KT_M },
  { K_CB      , KK_ListToggleWideSubj   , KT_M },

  { K_Esc     , KK_NodeAbort            , KT_N },
  { K_AX      , KK_NodeAskExit          , KT_N },
  { K_AF4     , KK_NodeAskExit          , KT_N },
  { K_AO      , KK_NodeDosShell         , KT_N },
  { K_CQ      , KK_NodeQuitNow          , KT_N },
  { K_Enter   , KK_NodeSelect           , KT_N },

  { K_AF4     , KK_ReadAskExit          , KT_R },
  { K_AX      , KK_ReadAskExit          , KT_R },
  { K_X       , KK_ReadAskExit          , KT_R },
  { K_CA      , KK_ReadChangeAka        , KT_R },
  { K_CS      , KK_ReadChangeAttrs      , KT_R },
  { K_CM      , KK_ReadChangeMood       , KT_R },
  { K_AC      , KK_ReadChangeMsg        , KT_R },
  { K_C       , KK_ReadChangeMsg        , KT_R },
  { K_F2      , KK_ReadChangeMsg        , KT_R },
  { K_CO      , KK_ReadChangeOrigin     , KT_R },
  { K_CI      , KK_ReadChangeTagline    , KT_R },
  { K_CT      , KK_ReadChangeTemplate   , KT_R },
  { K_CU      , KK_ReadChangeUsername   , KT_R },
  { K_CJ      , KK_ReadChangeXlatImport , KT_R },
  { K_AG      , KK_ReadCommentMsg       , KT_R },
  { K_G       , KK_ReadCommentMsg       , KT_R },
  { K_AM      , KK_ReadCopyMoveForward  , KT_R },
  { K_M       , KK_ReadCopyMoveForward  , KT_R },
  { K_SF8     , KK_ReadCopyMoveForward  , KT_R },
  { K_AD      , KK_ReadDeleteMsg        , KT_R },
  { K_D       , KK_ReadDeleteMsg        , KT_R },
  { K_Del     , KK_ReadDeleteMsg        , KT_R },
  { K_AO      , KK_ReadDosShell         , KT_R },
  { K_CF10    , KK_ReadDosShell         , KT_R },
  { K_O       , KK_ReadDosShell         , KT_R },
  { K_CR      , KK_ReadFidoRenumber     , KT_R },
  { K_SF4     , KK_ReadFidoRenumber     , KT_R },
  { K_CF      , KK_ReadFileRequest      , KT_R },
  { K_AF      , KK_ReadFindAll          , KT_R },
  { K_F       , KK_ReadFindAll          , KT_R },
  { K_SF6     , KK_ReadFindAll          , KT_R },
  { K_AZ      , KK_ReadFindHeader       , KT_R },
  { K_F6      , KK_ReadFindHeader       , KT_R },
  { K_Z       , KK_ReadFindHeader       , KT_R },
  { K_BSpace  , KK_ReadGotoBookMark     , KT_R },
  { K_STab    , KK_ReadGotoBookMark     , KT_R },
  { K_CHome   , KK_ReadGotoFirstMsg     , KT_R },
  { K_Lesser  , KK_ReadGotoFirstMsg     , KT_R },
  { K_CEnd    , KK_ReadGotoLastMsg      , KT_R },
  { K_Greater , KK_ReadGotoLastMsg      , KT_R },
  { K_CG      , KK_ReadGotoMsgno        , KT_R },
  { K_CN      , KK_ReadGotoNextArea     , KT_R },
  { K_Right   , KK_ReadGotoNextMsg      , KT_R },
  { K_CP      , KK_ReadGotoPrevArea     , KT_R },
  { K_Left    , KK_ReadGotoPrevMsg      , KT_R },
  { K_ARight  , KK_ReadGotoReplies      , KT_R },
  { K_CRight  , KK_ReadGotoReplies      , KT_R },
  { K_Plus    , KK_ReadGotoReplies      , KT_R },
  { K_Multi   , KK_ReadGotoReplyNext    , KT_R },
  { K_ALeft   , KK_ReadGotoReplyPrev    , KT_R },
  { K_CLeft   , KK_ReadGotoReplyPrev    , KT_R },
  { K_Minus   , KK_ReadGotoReplyPrev    , KT_R },
  { K_SF10    , KK_ReadLookupDest       , KT_R },
  { K_F10     , KK_ReadLookupOrig       , KT_R },
  { K_CL      , KK_ReadMakeUserlist     , KT_R },
  { K_AF9     , KK_ReadMarkingOptions   , KT_R },
  { K_AS      , KK_ReadMarkingOptions   , KT_R },
  { K_S       , KK_ReadMarkingOptions   , KT_R },
  { K_AL      , KK_ReadMessageList      , KT_R },
  { K_F9      , KK_ReadMessageList      , KT_R },
  { K_L       , KK_ReadMessageList      , KT_R },
  { K_AB      , KK_ReadMoveCommentMsg   , KT_R },
  { K_B       , KK_ReadMoveCommentMsg   , KT_R },
  { K_AN      , KK_ReadMoveQuoteMsg     , KT_R },
  { K_F5      , KK_ReadMoveQuoteMsg     , KT_R },
  { K_N       , KK_ReadMoveQuoteMsg     , KT_R },
  { K_Enter   , KK_ReadMsgContinue      , KT_R },
  { K_End     , KK_ReadMsgEnd           , KT_R },
  { K_Home    , KK_ReadMsgHome          , KT_R },
  { K_CDown   , KK_ReadMsgLineDown      , KT_R },
  { K_Down    , KK_ReadMsgLineDown      , KT_R },
  { K_CUp     , KK_ReadMsgLineUp        , KT_R },
  { K_Up      , KK_ReadMsgLineUp        , KT_R },
  { K_PgDn    , KK_ReadMsgPgDn          , KT_R },
  { K_PgUp    , KK_ReadMsgPgUp          , KT_R },
  { K_A       , KK_ReadNewArea          , KT_R },
  { K_AA      , KK_ReadNewArea          , KT_R },
  { K_CF1     , KK_ReadNewArea          , KT_R },
  { K_Esc     , KK_ReadNewArea          , KT_R },
  { K_AE      , KK_ReadNewMsg           , KT_R },
  { K_E       , KK_ReadNewMsg           , KT_R },
  { K_Ins     , KK_ReadNewMsg           , KT_R },
  { K_CQ      , KK_ReadQuitNow          , KT_R },
  { K_CW      , KK_ReadQuoteBuf         , KT_R },
  { K_AQ      , KK_ReadQuoteMsg         , KT_R },
  { K_F4      , KK_ReadQuoteMsg         , KT_R },
  { K_Q       , KK_ReadQuoteMsg         , KT_R },
  { K_AR      , KK_ReadReplyMsg         , KT_R },
  { K_F3      , KK_ReadReplyMsg         , KT_R },
  { K_R       , KK_ReadReplyMsg         , KT_R },
  { K_Tab     , KK_ReadToggleBookMark   , KT_R },
  { K_AI      , KK_ReadToggleHexdump    , KT_R },
  { K_CF9     , KK_ReadToggleHexdump    , KT_R },
  { K_I       , KK_ReadToggleHexdump    , KT_R },
  { K_AH      , KK_ReadToggleHidden     , KT_R },
  { K_CF7     , KK_ReadToggleHidden     , KT_R },
  { K_H       , KK_ReadToggleHidden     , KT_R },
  { K_AV      , KK_ReadToggleHiddKlud   , KT_R },
  { K_CF5     , KK_ReadToggleHiddKlud   , KT_R },
  { K_V       , KK_ReadToggleHiddKlud   , KT_R },
  { K_AK      , KK_ReadToggleKludge     , KT_R },
  { K_CF6     , KK_ReadToggleKludge     , KT_R },
  { K_K       , KK_ReadToggleKludge     , KT_R },
  { K_Space   , KK_ReadToggleMark       , KT_R },
  { K_AF10    , KK_ReadToggleMarkRead   , KT_R },
  { K_AJ      , KK_ReadToggleMarkRead   , KT_R },
  { K_J       , KK_ReadToggleMarkRead   , KT_R },
  { K_AP      , KK_ReadTogglePageBar    , KT_R },
  { K_CF8     , KK_ReadTogglePageBar    , KT_R },
  { K_P       , KK_ReadTogglePageBar    , KT_R },
  { K_CV      , KK_ReadToggleQuote      , KT_R },
  { K_AY      , KK_ReadToggleRealMsgno  , KT_R },
  { K_CF4     , KK_ReadToggleRealMsgno  , KT_R },
  { K_Y       , KK_ReadToggleRealMsgno  , KT_R },
  { K_AU      , KK_ReadToggleROT13      , KT_R },
  { K_CF3     , KK_ReadToggleROT13      , KT_R },
  { K_U       , KK_ReadToggleROT13      , KT_R },
  { K_AT      , KK_ReadToggleTwits      , KT_R },
  { K_T       , KK_ReadToggleTwits      , KT_R },
  { K_CZ      , KK_ReadTouchNetscan     , KT_R },
  { K_CX      , KK_ReadUUDecode         , KT_R },
  { K_AW      , KK_ReadWriteMsg         , KT_R },
  { K_F7      , KK_ReadWriteMsg         , KT_R },
  { K_W       , KK_ReadWriteMsg         , KT_R },

  { 0xFFFF    , 0xFFFF                  , 0xFF }
};


//  ------------------------------------------------------------------

static Key SwitchKeyval(word crc) {

  switch(crc) {

    case CRC_K_F1:                return K_F1;
    case CRC_K_F2:                return K_F2;
    case CRC_K_F3:                return K_F3;
    case CRC_K_F4:                return K_F4;
    case CRC_K_F5:                return K_F5;
    case CRC_K_F6:                return K_F6;
    case CRC_K_F7:                return K_F7;
    case CRC_K_F8:                return K_F8;
    case CRC_K_F9:                return K_F9;
    case CRC_K_F10:               return K_F10;
    case CRC_K_F11:               return K_F11;
    case CRC_K_F12:               return K_F12;

    case CRC_K_SF1:               return K_SF1;
    case CRC_K_SF2:               return K_SF2;
    case CRC_K_SF3:               return K_SF3;
    case CRC_K_SF4:               return K_SF4;
    case CRC_K_SF5:               return K_SF5;
    case CRC_K_SF6:               return K_SF6;
    case CRC_K_SF7:               return K_SF7;
    case CRC_K_SF8:               return K_SF8;
    case CRC_K_SF9:               return K_SF9;
    case CRC_K_SF10:              return K_SF10;
    case CRC_K_SF11:              return K_SF11;
    case CRC_K_SF12:              return K_SF12;

    case CRC_K_AF1:               return K_AF1;
    case CRC_K_AF2:               return K_AF2;
    case CRC_K_AF3:               return K_AF3;
    case CRC_K_AF4:               return K_AF4;
    case CRC_K_AF5:               return K_AF5;
    case CRC_K_AF6:               return K_AF6;
    case CRC_K_AF7:               return K_AF7;
    case CRC_K_AF8:               return K_AF8;
    case CRC_K_AF9:               return K_AF9;
    case CRC_K_AF10:              return K_AF10;
    case CRC_K_AF11:              return K_AF11;
    case CRC_K_AF12:              return K_AF12;

    case CRC_K_CF1:               return K_CF1;
    case CRC_K_CF2:               return K_CF2;
    case CRC_K_CF3:               return K_CF3;
    case CRC_K_CF4:               return K_CF4;
    case CRC_K_CF5:               return K_CF5;
    case CRC_K_CF6:               return K_CF6;
    case CRC_K_CF7:               return K_CF7;
    case CRC_K_CF8:               return K_CF8;
    case CRC_K_CF9:               return K_CF9;
    case CRC_K_CF10:              return K_CF10;
    case CRC_K_CF11:              return K_CF11;
    case CRC_K_CF12:              return K_CF12;

    case CRC_K_A0:                return K_A0;
    case CRC_K_A1:                return K_A1;
    case CRC_K_A2:                return K_A2;
    case CRC_K_A3:                return K_A3;
    case CRC_K_A4:                return K_A4;
    case CRC_K_A5:                return K_A5;
    case CRC_K_A6:                return K_A6;
    case CRC_K_A7:                return K_A7;
    case CRC_K_A8:                return K_A8;
    case CRC_K_A9:                return K_A9;

    case CRC_K_AA:                return K_AA;
    case CRC_K_AB:                return K_AB;
    case CRC_K_AC:                return K_AC;
    case CRC_K_AD:                return K_AD;
    case CRC_K_AE:                return K_AE;
    case CRC_K_AF:                return K_AF;
    case CRC_K_AG:                return K_AG;
    case CRC_K_AH:                return K_AH;
    case CRC_K_AI:                return K_AI;
    case CRC_K_AJ:                return K_AJ;
    case CRC_K_AK:                return K_AK;
    case CRC_K_AL:                return K_AL;
    case CRC_K_AM:                return K_AM;
    case CRC_K_AN:                return K_AN;
    case CRC_K_AO:                return K_AO;
    case CRC_K_AP:                return K_AP;
    case CRC_K_AQ:                return K_AQ;
    case CRC_K_AR:                return K_AR;
    case CRC_K_AS:                return K_AS;
    case CRC_K_AT:                return K_AT;
    case CRC_K_AU:                return K_AU;
    case CRC_K_AV:                return K_AV;
    case CRC_K_AW:                return K_AW;
    case CRC_K_AX:                return K_AX;
    case CRC_K_AY:                return K_AY;
    case CRC_K_AZ:                return K_AZ;

    case CRC_K_CA:                return K_CA;
    case CRC_K_CB:                return K_CB;
    case CRC_K_CC:                return K_CC;
    case CRC_K_CD:                return K_CD;
    case CRC_K_CE:                return K_CE;
    case CRC_K_CF:                return K_CF;
    case CRC_K_CG:                return K_CG;
    case CRC_K_CH:                return K_CH;
    case CRC_K_CI:                return K_CI;
    case CRC_K_CJ:                return K_CJ;
    case CRC_K_CK:                return K_CK;
    case CRC_K_CL:                return K_CL;
    case CRC_K_CM:                return K_CM;
    case CRC_K_CN:                return K_CN;
    case CRC_K_CO:                return K_CO;
    case CRC_K_CP:                return K_CP;
    case CRC_K_CQ:                return K_CQ;
    case CRC_K_CR:                return K_CR;
    case CRC_K_CS:                return K_CS;
    case CRC_K_CT:                return K_CT;
    case CRC_K_CU:                return K_CU;
    case CRC_K_CV:                return K_CV;
    case CRC_K_CW:                return K_CW;
    case CRC_K_CX:                return K_CX;
    case CRC_K_CY:                return K_CY;
    case CRC_K_CZ:                return K_CZ;
    case CRC_K_CMINUS:            return Key_C_Min;

    case CRC_K_ESC:               return K_Esc;

    case CRC_K_TAB:               return K_Tab;
    case CRC_K_STAB:              return K_STab;
    case CRC_K_ATAB:              return K_ATab;

    case CRC_K_BSPACE:            return K_BSpace;
    case CRC_K_ABSPACE:           return K_ABSpace;
    case CRC_K_CBSPACE:           return K_CBSpace;

    case CRC_K_ENTER:             return K_Enter;
    case CRC_K_AENTER:            return K_AEnter;
    case CRC_K_CENTER:            return K_CEnter;

    case CRC_K_INS:               return K_Ins;
    case CRC_K_CINS:              return K_CIns;
    case CRC_K_AINS:              return K_AIns;

    case CRC_K_DEL:               return K_Del;
    case CRC_K_CDEL:              return K_CDel;
    case CRC_K_ADEL:              return K_ADel;

    case CRC_K_HOME:              return K_Home;
    case CRC_K_CHOME:             return K_CHome;
    case CRC_K_AHOME:             return K_AHome;

    case CRC_K_END:               return K_End;
    case CRC_K_CEND:              return K_CEnd;
    case CRC_K_AEND:              return K_AEnd;

    case CRC_K_PGUP:              return K_PgUp;
    case CRC_K_CPGUP:             return K_CPgUp;
    case CRC_K_APGUP:             return K_APgUp;

    case CRC_K_PGDN:              return K_PgDn;
    case CRC_K_CPGDN:             return K_CPgDn;
    case CRC_K_APGDN:             return K_APgDn;

    case CRC_K_LEFT:              return K_Left;
    case CRC_K_CLEFT:             return K_CLeft;
    case CRC_K_ALEFT:             return K_ALeft;

    case CRC_K_RIGHT:             return K_Right;
    case CRC_K_CRIGHT:            return K_CRight;
    case CRC_K_ARIGHT:            return K_ARight;

    case CRC_K_UP:                return K_Up;
    case CRC_K_CUP:               return K_CUp;
    case CRC_K_AUP:               return K_AUp;

    case CRC_K_DOWN:              return K_Down;
    case CRC_K_CDOWN:             return K_CDown;
    case CRC_K_ADOWN:             return K_ADown;

    case CRC_K_CGMUL:             return K_CGMul;

    case CRC_K_KEY5:              return K_Key5;
    case CRC_K_SPACE:             return K_Space;

    case CRC_KK_MACRO:            return KK_Macro;
    case CRC_KK_AUTO:             return KK_Auto;
  }

  return 0;
}


//  ------------------------------------------------------------------

static Key SwitchAreaKeys(word crc) {

  switch(crc) {
    case CRC_AREAABORT:           return KK_AreaAbort;
    case CRC_AREAASKEXIT:         return KK_AreaAskExit;
    case CRC_AREABOARDNOS:        return KK_AreaBoardnos;
    case CRC_AREADOSSHELL:        return KK_AreaDosShell;
    case CRC_AREAHEAT:            return KK_AreaHeat;
    case CRC_AREAMAINMENU:        return KK_AreaMainMenu;
    case CRC_AREAGOTOFIRST:       return KK_AreaGotoFirst;
    case CRC_AREAGOTOLAST:        return KK_AreaGotoLast;
    case CRC_AREAGOTONEXT:        return KK_AreaGotoNext;
    case CRC_AREAGOTOPREV:        return KK_AreaGotoPrev;
    case CRC_AREAJUMP:            return KK_AreaJump;
    case CRC_AREAJUMPNEXTMATCH:   return KK_AreaJumpNextMatch;
    case CRC_AREAMACRO:           return KK_AreaMacro;
    case CRC_AREAMENU:            return KK_AreaMenu;
    case CRC_AREAQUITNOW:         return KK_AreaQuitNow;
    case CRC_AREASCAN:            return KK_AreaScan;
    case CRC_AREASCANPM:          return KK_AreaScanPM;
    case CRC_AREASELECT:          return KK_AreaSelect;
    case CRC_AREASOUNDKILL:       return KK_AreaSoundkill;
    case CRC_AREATOGGLE:          return KK_AreaToggle;
    case CRC_AREATOUCHNETSCAN:    return KK_AreaTouchNetscan;
    case CRC_AREAUNDEFINE:        return KK_AreaUndefine;
    case CRC_AREAWRITEGOLDLAST:   return KK_AreaWriteGoldlast;
    case CRC_AREAZAP:             return KK_AreaZap;
  }

  return 0;
}


//  ------------------------------------------------------------------

static Key SwitchEditKeys(word crc) {

  switch(crc) {
    case CRC_EDITABORT:           return KK_EditAbort;
    case CRC_EDITANCHOR:          return KK_EditAnchor;
    case CRC_EDITASKEXIT:         return KK_EditAskExit;
    case CRC_EDITHEADER:          return KK_EditHeader;
    case CRC_EDITCLEARDELETEBUF:  return KK_EditClearDeleteBuf;
    case CRC_EDITCLEARPASTEBUF:   return KK_EditClearPasteBuf;
    case CRC_EDITCOPYABOVECHAR:   return KK_EditCopyAboveChar;
    case CRC_EDITCOPY:            return KK_EditCopy;
    case CRC_EDITCUT:             return KK_EditCut;
    case CRC_EDITDELCHAR:         return KK_EditDelChar;
    case CRC_EDITDELLEFT:         return KK_EditDelLeft;
    case CRC_EDITDELLINE:         return KK_EditDelLine;
    case CRC_EDITDELLTWORD:       return KK_EditDelLtWord;
    case CRC_EDITDELRTWORD:       return KK_EditDelRtWord;
    case CRC_EDITDELETEEOL:       return KK_EditDeleteEOL;
    case CRC_EDITDOSSHELL:        return KK_EditDosShell;
    case CRC_EDITDUPLINE:         return KK_EditDupLine;
    case CRC_EDITEXITMSG:         return KK_EditExitMsg;
    case CRC_EDITEXPORTTEXT:      return KK_EditExportText;
    case CRC_EDITGOBEGLINE:       return KK_EditGoBegLine;
    case CRC_EDITGOBOTLINE:       return KK_EditGoBotLine;
    case CRC_EDITGOBOTMSG:        return KK_EditGoBotMsg;
    case CRC_EDITGODOWN:          return KK_EditGoDown;
    case CRC_EDITGOEOL:           return KK_EditGoEOL;
    case CRC_EDITGOLEFT:          return KK_EditGoLeft;
    case CRC_EDITGOPGDN:          return KK_EditGoPgDn;
    case CRC_EDITGOPGUP:          return KK_EditGoPgUp;
    case CRC_EDITGORIGHT:         return KK_EditGoRight;
    case CRC_EDITMAINMENU:        return KK_EditMainMenu;
    case CRC_EDITGOTOPLINE:       return KK_EditGoTopLine;
    case CRC_EDITGOTOPMSG:        return KK_EditGoTopMsg;
    case CRC_EDITGOUP:            return KK_EditGoUp;
    case CRC_EDITGOWORDLEFT:      return KK_EditGoWordLeft;
    case CRC_EDITGOWORDRIGHT:     return KK_EditGoWordRight;
    case CRC_EDITIMPORTQUOTEBUF:  return KK_EditImportQuotebuf;
    case CRC_EDITIMPORTTEXT:      return KK_EditImportText;
    case CRC_EDITKILLQUOTES:      return KK_EditKillQuotes;
    case CRC_EDITLOADFILE:        return KK_EditLoadFile;
    case CRC_EDITLOOKUPCURSOR:    return KK_EditLookupCursor;
    case CRC_EDITLOOKUPDEST:      return KK_EditLookupDest;
    case CRC_EDITLOOKUPORIG:      return KK_EditLookupOrig;
    case CRC_EDITMACRO:           return KK_EditMacro;
    case CRC_EDITMENU:            return KK_EditMenu;
    case CRC_EDITNEWLINE:         return KK_EditNewline;
    case CRC_EDITPASTE:           return KK_EditPaste;
    case CRC_EDITQUITNOW:         return KK_EditQuitNow;
    case CRC_EDITREFLOW:          return KK_EditReflow;
    case CRC_EDITSAVEMSG:         return KK_EditSaveMsg;
    case CRC_EDITSAVEFILE:        return KK_EditSaveFile;
    case CRC_EDITSOUNDKILL:       return KK_EditSoundkill;
    case CRC_EDITSPELLCHECK:      return KK_EditSpellCheck;
    case CRC_EDITTAB:             return KK_EditTab;
    case CRC_EDITTOLOWER:         return KK_EditToLower;
    case CRC_EDITTOUPPER:         return KK_EditToUpper;
    case CRC_EDITTOGGLECASE:      return KK_EditToggleCase;
    case CRC_EDITTOGGLEINSERT:    return KK_EditToggleInsert;
    case CRC_EDITUNDEFINE:        return KK_EditUndefine;
    case CRC_EDITUNDELETE:        return KK_EditUnDelete;
    case CRC_EDITZAPQUOTEBELOW:   return KK_EditZapQuoteBelow;
  }

  return 0;
}


//  ------------------------------------------------------------------

static Key SwitchFileKeys(word crc) {

  switch(crc) {
    case CRC_FILEABORT:           return KK_FileAbort;
    case CRC_FILEASKEXIT:         return KK_FileAskExit;
    case CRC_FILEDOSSHELL:        return KK_FileDosShell;
    case CRC_FILEMACRO:           return KK_FileMacro;
    case CRC_FILEMAINMENU:        return KK_FileMainMenu;
    case CRC_FILEGOTOFIRST:       return KK_FileGotoFirst;
    case CRC_FILEGOTOLAST:        return KK_FileGotoLast;
    case CRC_FILEGOTONEXT:        return KK_FileGotoNext;
    case CRC_FILEGOTOPREV:        return KK_FileGotoPrev;
    case CRC_FILEMARK:            return KK_FileMark;
    case CRC_FILEMARKALL:         return KK_FileMarkAll;
    case CRC_FILEMENU:            return KK_FileMenu;
    case CRC_FILEQUITNOW:         return KK_FileQuitNow;
    case CRC_FILESELECT:          return KK_FileSelect;
    case CRC_FILETOGGLEMARK:      return KK_FileToggleMark;
    case CRC_FILEUNDEFINE:        return KK_FileUndefine;
    case CRC_FILEUNMARK:          return KK_FileUnMark;
    case CRC_FILEUNMARKALL:       return KK_FileUnMarkAll;
  }

  return 0;
}


//  ------------------------------------------------------------------
  
static Key SwitchListKeys(word crc) {

  switch(crc) {
    case CRC_LISTABORT:           return KK_ListAbort;
    case CRC_LISTASKEXIT:         return KK_ListAskExit;
    case CRC_LISTDOSSHELL:        return KK_ListDosShell;
    case CRC_LISTGOTOBOOKMARK:    return KK_ListGotoBookMark;
    case CRC_LISTMAINMENU:        return KK_ListMainMenu;
    case CRC_LISTGOTOFIRST:       return KK_ListGotoFirst;
    case CRC_LISTGOTOLAST:        return KK_ListGotoLast;
    case CRC_LISTGOTONEXT:        return KK_ListGotoNext;
    case CRC_LISTGOTOPREV:        return KK_ListGotoPrev;
    case CRC_LISTMACRO:           return KK_ListMacro;
    case CRC_LISTMARKINGOPTIONS:  return KK_ListMarkingOptions;
    case CRC_LISTMENU:            return KK_ListMenu;
    case CRC_LISTQUITNOW:         return KK_ListQuitNow;
    case CRC_LISTSELECT:          return KK_ListSelect;
    case CRC_LISTTOGGLEBOOKMARK:  return KK_ListToggleBookMark;
    case CRC_LISTTOGGLEDATE:      return KK_ListToggleDate;
    case CRC_LISTTOGGLEMARK:      return KK_ListToggleMark;
    case CRC_LISTTOGGLEWIDESUBJ:  return KK_ListToggleWideSubj;
    case CRC_LISTUNDEFINE:        return KK_ListUndefine;
  }

  return 0;
}


//  ------------------------------------------------------------------

static Key SwitchNodeKeys(word crc) {

  switch(crc) {
    case CRC_NODEABORT:           return KK_NodeAbort;
    case CRC_NODEASKEXIT:         return KK_NodeAskExit;
    case CRC_NODEDOSSHELL:        return KK_NodeDosShell;
    case CRC_NODEMACRO:           return KK_NodeMacro;
    case CRC_NODEMAINMENU:        return KK_NodeMainMenu;
    case CRC_NODEGOTOFIRST:       return KK_NodeGotoFirst;
    case CRC_NODEGOTOLAST:        return KK_NodeGotoLast;
    case CRC_NODEGOTONEXT:        return KK_NodeGotoNext;
    case CRC_NODEGOTOPREV:        return KK_NodeGotoPrev;
    case CRC_NODEMENU:            return KK_NodeMenu;
    case CRC_NODEQUITNOW:         return KK_NodeQuitNow;
    case CRC_NODESELECT:          return KK_NodeSelect;
    case CRC_NODEUNDEFINE:        return KK_NodeUndefine;
  }

  return 0;
}


//  ------------------------------------------------------------------

Key SwitchReadKeys(word crc) {

  switch(crc) {

    case CRC_READADDTOUSERLIST:    return KK_ReadAddToUserlist;
    case CRC_READASKEXIT:          return KK_ReadAskExit;
    case CRC_READCHANGEAKA:        return KK_ReadChangeAka;
    case CRC_READCHANGEATTRS:      return KK_ReadChangeAttrs;
    case CRC_READCHANGEMOOD:       return KK_ReadChangeMood;
    case CRC_READCHANGEMSG:        return KK_ReadChangeMsg;
    case CRC_READCHANGEORIGIN:     return KK_ReadChangeOrigin;
    case CRC_READCHANGETAGLINE:    return KK_ReadChangeTagline;
    case CRC_READCHANGETEMPLATE:   return KK_ReadChangeTemplate;
    case CRC_READCHANGEUSERNAME:   return KK_ReadChangeUsername;
    case CRC_READCHANGEXLATIMPORT: return KK_ReadChangeXlatImport;
    case CRC_READCOPYMOVEFORWARD:  return KK_ReadCopyMoveForward;
    case CRC_READDECREASEMARGIN:   return KK_ReadDecreaseMargin;
    case CRC_READDELETEMSG:        return KK_ReadDeleteMsg;
    case CRC_READDOSSHELL:         return KK_ReadDosShell;
    case CRC_READEXTERNUTILMENU:   return KK_ReadExternUtilMenu;
    case CRC_READFIDORENUMBER:     return KK_ReadFidoRenumber;
    case CRC_READFILEREQUEST:      return KK_ReadFileRequest;
    case CRC_READFINDALL:          return KK_ReadFindAll;
    case CRC_READFINDHEADER:       return KK_ReadFindHeader;
    case CRC_READGOTOBOOKMARK:     return KK_ReadGotoBookMark;
    case CRC_READMAINMENU:         return KK_ReadMainMenu;
    case CRC_READGOTODOWNLINK:     return KK_ReadGotoReplyPrev;
    case CRC_READGOTOFIRSTMSG:     return KK_ReadGotoFirstMsg;
    case CRC_READGOTOLASTMSG:      return KK_ReadGotoLastMsg;
    case CRC_READGOTOMSGNO:        return KK_ReadGotoMsgno;
    case CRC_READGOTONEXTAREA:     return KK_ReadGotoNextArea;
    case CRC_READGOTONEXTMSG:      return KK_ReadGotoNextMsg;
    case CRC_READGOTONEXTUNREAD:   return KK_ReadGotoNextUnread;
    case CRC_READGOTOPREVAREA:     return KK_ReadGotoPrevArea;
    case CRC_READGOTOPREVMSG:      return KK_ReadGotoPrevMsg;
    case CRC_READGOTOPREVUNREAD:   return KK_ReadGotoPrevUnread;
    case CRC_READGOTOREPLIES:      return KK_ReadGotoReplies;
    case CRC_READGOTOREPLY1ST:     return KK_ReadGotoReply1st;
    case CRC_READGOTOREPLYNEXT:    return KK_ReadGotoReplyNext;
    case CRC_READGOTOREPLYPREV:    return KK_ReadGotoReplyPrev;
    case CRC_READGOTOUPLINK:       return KK_ReadGotoReplies;
    case CRC_READINCREASEMARGIN:   return KK_ReadIncreaseMargin;
    case CRC_READLOOKUPDEST:       return KK_ReadLookupDest;
    case CRC_READLOOKUPORIG:       return KK_ReadLookupOrig;
    case CRC_READMACRO:            return KK_ReadMacro;
    case CRC_READMAKEUSERLIST:     return KK_ReadMakeUserlist;
    case CRC_READMARKINGOPTIONS:   return KK_ReadMarkingOptions;
    case CRC_READMENU:             return KK_ReadMenu;
    case CRC_READMESSAGELIST:      return KK_ReadMessageList;
    case CRC_READMOVECOMMENTMSG:   return KK_ReadMoveCommentMsg;
    case CRC_READMOVEQUOTEMSG:     return KK_ReadMoveQuoteMsg;
    case CRC_READMSGCONTINUE:      return KK_ReadMsgContinue;
    case CRC_READMSGEND:           return KK_ReadMsgEnd;
    case CRC_READMSGHOME:          return KK_ReadMsgHome;
    case CRC_READMSGLINEDOWN:      return KK_ReadMsgLineDown;
    case CRC_READMSGLINEUP:        return KK_ReadMsgLineUp;
    case CRC_READMSGPGDN:          return KK_ReadMsgPgDn;
    case CRC_READMSGPGUP:          return KK_ReadMsgPgUp;
    case CRC_READNEWAREA:          return KK_ReadNewArea;
    case CRC_READNEWMSG:           return KK_ReadNewMsg;
    case CRC_READQUITNOW:          return KK_ReadQuitNow;
    case CRC_READQUOTEBUF:         return KK_ReadQuoteBuf;
    case CRC_READQUOTEMSG:         return KK_ReadQuoteMsg;
    case CRC_READCOMMENTMSG:       return KK_ReadCommentMsg;
    case CRC_READREPLYMSG:         return KK_ReadReplyMsg;
    case CRC_READSOUNDKILL:        return KK_ReadSoundkill;
    case CRC_READSTEALTAGLINE:     return KK_ReadStealTagline;
    case CRC_READTOGGLEBOOKMARK:   return KK_ReadToggleBookMark;
    case CRC_READTOGGLEHEXDUMP:    return KK_ReadToggleHexdump;
    case CRC_READTOGGLEHIDDKLUD:   return KK_ReadToggleHiddKlud;
    case CRC_READTOGGLEHIDDEN:     return KK_ReadToggleHidden;
    case CRC_READTOGGLEKLUDGE:     return KK_ReadToggleKludge;
    case CRC_READTOGGLEMARK:       return KK_ReadToggleMark;
    case CRC_READTOGGLEMARKREAD:   return KK_ReadToggleMarkRead;
    case CRC_READTOGGLEPAGEBAR:    return KK_ReadTogglePageBar;
    case CRC_READTOGGLEQUOTE:      return KK_ReadToggleQuote;
    case CRC_READTOGGLEROT13:      return KK_ReadToggleROT13;
    case CRC_READTOGGLEREALMSGNO:  return KK_ReadToggleRealMsgno;
    case CRC_READTOGGLETWITS:      return KK_ReadToggleTwits;
    case CRC_READTOUCHNETSCAN:     return KK_ReadTouchNetscan;
    case CRC_READTOUCHSEMAPHORE:   return KK_ReadTouchSemaphore;
    case CRC_READUNDEFINE:         return KK_ReadUndefine;
    case CRC_READUUDECODE:         return KK_ReadUUDecode;
    case CRC_READWRITEMSG:         return KK_ReadWriteMsg;
  }

  return 0;
}


//  ------------------------------------------------------------------

Key SwitchExternUtilKeys(word crc) {

  switch(crc) {

    case CRC_EXTERNUTIL01:  return KK_ExternUtil01;
    case CRC_EXTERNUTIL02:  return KK_ExternUtil02;
    case CRC_EXTERNUTIL03:  return KK_ExternUtil03;
    case CRC_EXTERNUTIL04:  return KK_ExternUtil04;
    case CRC_EXTERNUTIL05:  return KK_ExternUtil05;
    case CRC_EXTERNUTIL06:  return KK_ExternUtil06;
    case CRC_EXTERNUTIL07:  return KK_ExternUtil07;
    case CRC_EXTERNUTIL08:  return KK_ExternUtil08;
    case CRC_EXTERNUTIL09:  return KK_ExternUtil09;
    case CRC_EXTERNUTIL10:  return KK_ExternUtil10;
    case CRC_EXTERNUTIL11:  return KK_ExternUtil11;
    case CRC_EXTERNUTIL12:  return KK_ExternUtil12;
    case CRC_EXTERNUTIL13:  return KK_ExternUtil13;
    case CRC_EXTERNUTIL14:  return KK_ExternUtil14;
    case CRC_EXTERNUTIL15:  return KK_ExternUtil15;
    case CRC_EXTERNUTIL16:  return KK_ExternUtil16;
    case CRC_EXTERNUTIL17:  return KK_ExternUtil17;
    case CRC_EXTERNUTIL18:  return KK_ExternUtil18;
    case CRC_EXTERNUTIL19:  return KK_ExternUtil19;
    case CRC_EXTERNUTIL20:  return KK_ExternUtil20;
    case CRC_EXTERNUTIL21:  return KK_ExternUtil21;
    case CRC_EXTERNUTIL22:  return KK_ExternUtil22;
    case CRC_EXTERNUTIL23:  return KK_ExternUtil23;
    case CRC_EXTERNUTIL24:  return KK_ExternUtil24;
  }

  return 0;
}


//  ------------------------------------------------------------------

static Key SwitchKeyDefs(word crc, int* type) {

  Key keycmd;

  // Check for regular keys
  keycmd = SwitchKeyval(crc);
  if(keycmd) {
    *type = 0;
    return keycmd;
  }

  // Check for arealist keys
  keycmd = SwitchAreaKeys(crc);
  if(keycmd) {
    *type = KT_A;
    return keycmd;
  }

  // Check for editor keys
  keycmd = SwitchEditKeys(crc);
  if(keycmd) {
    *type = KT_E;
    return keycmd;
  }

  // Check for filelist keys
  keycmd = SwitchFileKeys(crc);
  if(keycmd) {
    *type = KT_F;
    return keycmd;
  }

  // Check for message list keys
  keycmd = SwitchListKeys(crc);
  if(keycmd) {
    *type = KT_M;
    return keycmd;
  }

  // Check for nodelist keys
  keycmd = SwitchNodeKeys(crc);
  if(keycmd) {
    *type = KT_N;
    return keycmd;
  }

  // Check for reader keys
  keycmd = SwitchReadKeys(crc);
  if(keycmd) {
    *type = KT_R;
    return keycmd;
  }

  // Check for externutil keys
  keycmd = SwitchExternUtilKeys(crc);
  if(keycmd) {
    *type = KT_R;
    return keycmd;
  }

  *type = 0;
  return 0;
}


//  ------------------------------------------------------------------

void KeyCmdAdd(Key keycmd, Key keyval, int keytype) {

  if(keyval <= 0xFF)
    keyval |= (Key)(scancode(keyval) << 8);

  register gkbdcmd* tmp = CFG->keybcommand.begin();
  if(CFG->keybdefaults) {
    register int k = 0;
    while(k < CFG->cmdkey.size()) {
      if(tmp->type == keytype) {
        if(tmp->key == keyval) {
          tmp->cmd = keycmd;
          return;
        }
      }
      tmp++;
      k++;
    }
  }

  gkbdcmd tmp2;
  tmp2.key  = keyval;
  tmp2.cmd  = keycmd;
  tmp2.type = keytype;
  CFG->keybcommand.push_back(tmp2);
}


//  ------------------------------------------------------------------

void RunMacro(gkbdmacro* m) {

  Key* mac = m->buf;
  while(*mac) {
    kbput(*mac);
    mac++;
  }
}


//  ------------------------------------------------------------------

static void PlayMacro() {

  if(CFG->keybmacro.size())
    RunMacro(&CFG->keybmacro[0xFFFF-gkbd.curronkey->pass]);
}


//  ------------------------------------------------------------------

static void SetKeybDefaults() {

  // Setup default keyset
  register gkbdcmd* tmp = DefaultKeyset;
  register int keys = (sizeof(DefaultKeyset) / sizeof(gkbdcmd)) - 1;
  register int k = 0;
  while(k < keys) {
    if(tmp->key < 0xFF)
      tmp->key = (Key)tolower(tmp->key);
    KeyCmdAdd(tmp->cmd, tmp->key, tmp->type);
    tmp++;
    k++;
  }
}


//  ------------------------------------------------------------------

int ReadKeysCfg(int force) {

  byte ch;
  Key* mac;
  FILE *ifp;
  char* ptr;
  char* ptr2;
  int keytype;
  register int n;
  char buf[1024];
  Key keyval=0, keycmd;
  uint line=0, compile = YES;

  // Check if the binary file needs recompile
  compile = force ? YES : CheckStamp(&CFG->keyscfg);

  if(compile) {

    const char* cfg = AddPath(CFG->goldpath, CFG->keyscfg.fn);
    ifp = fsopen(cfg, "rt", CFG->sharemode);
    if(ifp) {
      AddStamp(cfg);
      CFG->keyscfg.ft = GetFiletime(cfg);

      const char* cfgname = strrchr(cfg, '\\');
      cfgname = cfgname ? cfgname+1 : cfg;

      if(not quiet)
        printf("\n* Reading %s", cfg);

      CFG->keybmacro.resize(0);
      CFG->cmdkey.resize(0);
      if(CFG->keybdefaults)
        SetKeybDefaults();
      while(fgets(buf, sizeof(buf), ifp)) {
        line++;
        ptr = strskip_wht(buf);
        if(*ptr == ';' or strblank(ptr))
          continue;
        ptr2 = ptr;
        ptr = strskip_txt(ptr);
        *ptr++ = NUL;
        keycmd = SwitchKeyDefs(strCrc16(strupr(ptr2)), &keytype);
        if(keycmd) {
          if(keytype) {
            printf("\n* %s: Invalid key \"%s\" in line %d.", cfgname, ptr2, line);
            if(not disablesound)
              beep();
            cfgerrors++;
            continue;
          }
          keyval = keycmd;
        }
        else {  // Either straight Key or $Key
          if(*ptr2 == '$') {
            uint _keyval = keyval;
            sscanf(ptr2, "%4x", &_keyval);
            keyval = (Key)_keyval;
          }
          else if(strlen(ptr2) == 1) {
            keyval = (Key)tolower(*ptr2);  // Always convert to lowercase internally
          }
          else {
            printf("\n* %s: Invalid key \"%s\" in line %d.", cfgname, ptr2, line);
            if(not disablesound)
              beep();
            cfgerrors++;
            continue;
          }
        }
        ptr = strskip_wht(ptr);
        ptr2 = ptr;
        ptr = strskip_txt(ptr);
        *ptr++ = 0;
        keycmd = SwitchKeyDefs(strCrc16(strupr(ptr2)), &keytype);
        if(keycmd) {
          if((keycmd >= KK_Macro) and (keycmd <= KK_ReadMacro)) {
            gkbdmacro tmpmacro;
            memset(&tmpmacro, 0, sizeof(gkbdmacro));
            n = 0;
            ptr = strskip_wht(ptr);
            while(*ptr) {
              if(*ptr == '\"') {  // Start of literal string
                ptr++;
                while(*ptr != '\"' and n < 79) {
                  ch = *ptr++;
                  tmpmacro.buf[n++] = (Key)(ch | (scancode(ch) << 8));
                }
                *ptr++ = NUL;
              }
              else {
                ptr2 = ptr;
                ptr = strskip_txt(ptr);
                *ptr++ = NUL;
                int tmpkt;
                keycmd = SwitchKeyDefs(strCrc16(strupr(ptr2)), &tmpkt);
                if(keycmd) {
                  if(n < 79)
                    tmpmacro.buf[n++] = (Key)keycmd;
                }
                else {
                  printf("\n* %s: Invalid key command \"%s\" in line %d.", cfgname, ptr2, line);
                  if(not disablesound)
                    beep();
                  cfgerrors++;
                  continue;
                }
              }
              ptr = strskip_wht(ptr);
            }
            if(keyval <= 0xFF)
              keyval |= (Key)(scancode(keyval) << 8);
            tmpmacro.key = (Key)keyval;
            tmpmacro.type = keytype;
            CFG->keybmacro.push_back(tmpmacro);
          }
          else if(keytype) {
            KeyCmdAdd(keycmd, keyval, keytype);
          }
          else {
            printf("\n* %s: Invalid key command \"%s\" in line %d.", cfgname, ptr2, line);
            if(not disablesound)
              beep();
            cfgerrors++;
            continue;
          }
        }
        else {
          printf("\n* %s: Invalid key command \"%s\" in line %d.", cfgname, ptr2, line);
          if(not disablesound)
            beep();
          cfgerrors++;
          continue;
        }
      }
      fclose(ifp);
    }
    else {

      #if 0
      LOG.ErrConfig();
      LOG.printf("! Could not open a required configuration file.");
      LOG.printf(": %s.", AddPath(CFG->goldpath, CFG->keyscfg.fn));
      LOG.printf("+ Advice: Make sure you have this file.");
      ConfigErrorExit();
      #endif
    }
  }

  // Setup default keyset when no keys are defined
  if(CFG->cmdkey.empty())
    SetKeybDefaults();

  // Prepare keyboard and macro tables for binary searching
  qsort(CFG->cmdkey.begin(), CFG->cmdkey.size(), sizeof(gkbdcmd), (StdCmpCP)CmdKeyCmp);

  // Count keys
  for(n=0; n<CFG->cmdkey.size(); n++) {
    switch(CFG->cmdkey[n].type) {
      case KT_A:  AreaKeys++;  break;
      case KT_E:  EditKeys++;  break;
      case KT_G:               break;
      case KT_M:  ListKeys++;  break;
      case KT_N:  NodeKeys++;  break;
      case KT_R:  ReadKeys++;  break;
      case KT_F:  FileKeys++;  break;
    }
  }

  // Assign pointers
  AreaKey = CFG->cmdkey.begin();  while(AreaKey->type != KT_A)  AreaKey++;
  EditKey = CFG->cmdkey.begin();  while(EditKey->type != KT_E)  EditKey++;
  ListKey = CFG->cmdkey.begin();  while(ListKey->type != KT_M)  ListKey++;
  NodeKey = CFG->cmdkey.begin();  while(NodeKey->type != KT_N)  NodeKey++;
  ReadKey = CFG->cmdkey.begin();  while(ReadKey->type != KT_R)  ReadKey++;
  FileKey = CFG->cmdkey.begin();  while(FileKey->type != KT_F)  FileKey++;

  // Assign global macros
  for(n=0; n<CFG->keybmacro.size(); n++) {
    if(CFG->keybmacro[n].type == 0) {
      if((CFG->keybmacro[n].key == KK_Auto) or (CFG->keybmacro[n].key == 0x0300)) {
        // Start automacro
        mac = CFG->keybmacro[n].buf;
        while(*mac) {
          kbput(*mac);
          mac++;
        }
      }
      else {
        setonkey(CFG->keybmacro[n].key, PlayMacro, (Key)(0xFFFF-n));
      }
    }
  }

  return compile;
}


//  ------------------------------------------------------------------

