
//  ------------------------------------------------------------------
//  GoldED. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gcsave.cpp,v 1.1.1.1 1998/11/21 19:38:04 odinn Exp $
//  ------------------------------------------------------------------
//  Configuration saving.
//  ------------------------------------------------------------------


#include "golded.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif


//  ------------------------------------------------------------------
//  Write GOLDED.GED

void WriteGoldGed() {

  // Mark areas according to scan/pmscan in/excludes
  for(int n=0; n<AL.areas(); n++) {

    int s, x, i;

    garealistdata* ap = AL[n];

    // Check scan in/excludes
    for(s=0; s<CFG->areascan.size(); s++) {
      if(strwild(ap->echoid().c_str(), CFG->areascan[s])) {
        ap->set_scan();
        break;
      }
    }
    for(x=0; x<CFG->areascanexcl.size(); x++) {
      if(strwild(ap->echoid().c_str(), CFG->areascanexcl[x])) {
        ap->set_scanexcl();
        break;
      }
    }
    for(i=0; i<CFG->areascanincl.size(); i++) {
      if(strwild(ap->echoid().c_str(), CFG->areascanincl[i])) {
        ap->set_scanincl();
        break;
      }
    }

    // Check pmscan in/excludes
    for(s=0; s<CFG->areapmscan.size(); s++) {
      if(strwild(ap->echoid().c_str(), CFG->areapmscan[s])) {
        ap->set_pmscan();
        break;
      }
    }
    for(x=0; x<CFG->areapmscanexcl.size(); x++) {
      if(strwild(ap->echoid().c_str(), CFG->areapmscanexcl[x])) {
        ap->set_pmscanexcl();
        break;
      }
    }
    for(i=0; i<CFG->areapmscanincl.size(); i++) {
      if(strwild(ap->echoid().c_str(), CFG->areapmscanincl[i])) {
        ap->set_pmscanincl();
        break;
      }
    }
  }

  // Release lists memory
  CFG->areaexcl.reset();
  CFG->areaincl.reset();
  CFG->areaisemail.reset();
  CFG->areaisnews.reset();
  CFG->areascan.reset();
  CFG->areascanexcl.reset();
  CFG->areascanincl.reset();
  CFG->arearename.resize(0);
  CFG->areapmscan.reset();
  CFG->areapmscanexcl.reset();
  CFG->areapmscanincl.reset();

  // Write the binary config
  gfile fp;
  fp.fopen(AddPath(CFG->goldpath, CFG->goldged), "wb", CFG->sharemode);
  if(fp.isopen()) {

    fp.setvbuf(NULL, _IOFBF, 8192);

    update_statusline(CFG->language[LNG_WritingCfg]+1);

    CFG->save(fp);
    GRP->Save(fp);
    QWK->Save(fp);
    XLAT->save(fp);
    AL.save(fp);

    fp.fclose();
  }
}


//  ------------------------------------------------------------------
