
//  ------------------------------------------------------------------
//  GoldED. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gearea.cpp,v 1.1.1.1 1998/11/21 19:38:04 odinn Exp $
//  ------------------------------------------------------------------
//  Arealister and other area-specific code.
//  ------------------------------------------------------------------


#include "golded.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif


//  ------------------------------------------------------------------

extern int arealistnumgrps;

bool _in_arealist = false;

Echo area_maybe;
bool a_separator = false;
int areaswithgroupid = 0;
static int __FAR areawin;
static int __FAR tempwin;
static int __FAR areawin1 = 0;
static int __FAR tempwin1 = 0;
static int __FAR areawin2 = 0;
static int __FAR tempwin2 = 0;
static uint __FAR area_fuzidx;
static int __FAR area_first = NO;
static int __FAR esc_abort;
static int __FAR pmareas = 0;
static int __FAR pmails = 0;
static int __FAR pmscan = false;
static PInf* areainfp = NULL;

//            111111111122222222223333333333444444444455555555556666666666777777777
//  0123456789012345678901234567890123456789012345678901234567890123456789012345678
// AreaDescriptionMsgsNewEchoIDGrpĿ
//    1> NET FidoNet Z3/4/5/6                 118+    3* NET.FIDOZX            A 

// AREALISTFORMAT "AM D CPUN E G"

int area_pos      = -1;
int area_width    = 4;
int marked_pos    = -1;
int marked_width  = 1;
char marked_char   = MMRK_MARK;
int desc_pos      = -1;
int desc_width    = -1;
int count_pos     = -1;
int count_width   = 6;
int pmark_pos     = -1;
int pmark_width   = 1;
char pmark_char    = '+';
int unread_pos    = -1;
int unread_width  = 6;
int changed_pos   = -1;
int changed_width = 1;
char changed_char  = '*';
int echoid_pos    = -1;
int echoid_width  = 0;
int groupid_pos   = -1;
int groupid_width = 0;


//  ------------------------------------------------------------------

uint* areanumbers = NULL;

void AreasRenumber() {

  for(int n=0,a=1,t=AL.areas(); n<t; n++)
    areanumbers[n] = AL[n]->isseparator() ? 0 : a++;
}


//  ------------------------------------------------------------------

static void a_dodelayed(PInf* p) {

  garealistdata* area = AL[p->idx];
  char buf[256], tmp[200];

  if(area->isseparator()) {
    update_statusline(area->desc().c_str());
    if(p->direction > 0) {
      if(p->idx < p->maxidx)
        kbput(KK_AreaGotoNext);
      else
        kbput(KK_AreaGotoPrev);
    }
    else if(p->direction < 0) {
      if(p->idx)
        kbput(KK_AreaGotoPrev);
      else
        kbput(KK_AreaGotoNext);
    }
    a_separator = true;
  }
  else {
    strcpy(tmp, area->echoid().c_str());
    update_statuslinef("%s: %u %s, %u %s, %u %s", tmp, area->scancount(), (area->scancount() == 1 ? CFG->language[LNG_msg] : CFG->language[LNG_msgs]), area->unread(), CFG->language[LNG_unread], area->pmscancount(), CFG->language[LNG_personal]);
  }
  sprintf(buf, "%s%s", p->title, area_maybe);
  sprintf(tmp, "%-*s", gvid.numcols, buf);
  wwprintstr(tempwin, 0, 0, p->wattr, tmp);

  #if 0
  sprintf(buf, " Select Area%s%s ", (*area_maybe?": ":""), area_maybe);
  wtitle(buf, TCENTER|TBOTTOM, p->tattr);
  #endif

  if(CFG->arealistpagebar)
    wscrollbar(W_VERT, p->maxidx+1, p->maxidx, p->idx);
}


//  ------------------------------------------------------------------

void a_closeall() {

  if(areawin1)
    wunlink(areawin1);
  if(areawin2)
    wunlink(areawin2);
  if(tempwin1)
    wunlink(tempwin1);
  if(tempwin2)
    wunlink(tempwin2);
}


//  ------------------------------------------------------------------

static void a_dispbuf(char* buf, int areano) {

  garealistdata* area = AL.number_to_pointer(areano);

  memset(buf, ' ', gvid.numcols-2);
  buf[gvid.numcols-2] = NUL;

  char areabuf[33];
  itoa(CFG->arealistnos ? area->board() : areanumbers[areano], areabuf, 10);
  int areawidth = strlen(areabuf);

  char markedbuf[2] = { " " };
  *markedbuf = area->marked() ? marked_char : ' ';
  int markedwidth = 1;

  char descbuf[100];
  int descwidth = strlen(strcpy(descbuf, area->desc().c_str()));

  char countbuf[33];
  if(area->scanned())
    ultoa(area->scancount(), countbuf, 10);
  else
    strcpy(countbuf,  "-");
  int countwidth = strlen(countbuf);

  char pmarkbuf[2] = { " " };
  *pmarkbuf = area->pmscancount() ? pmark_char : ' ';
  int pmarkwidth = 1;

  char unreadbuf[33];
  if(area->scanned())
    ultoa((CFG->arealisttype ? area->unread() : area->lastread()), unreadbuf, 10);
  else
    strcpy(unreadbuf, "-");
  int unreadwidth = strlen(unreadbuf);

  char changedbuf[2] = { " " };
  *changedbuf = area->changed() ? changed_char : ' ';
  int changedwidth = 1;

  char echoidbuf[100];
  int echoidwidth = strlen(strcpy(echoidbuf, area->echoid().c_str()));

  char groupidbuf[10] = { "" };
  if(groupid_width) {
    if(area->groupid() & 0x8000u) {
      if(groupid_width > 2)
        sprintf(groupidbuf, "%u", area->groupid()&0x7FFF);
    }
    else if(isupper(area->groupid()))
      sprintf(groupidbuf, "%c", (char)area->groupid());
  }
  int groupidwidth = strlen(groupidbuf);

  areawidth    = minimum_of_two(areawidth,    area_width);
  markedwidth  = minimum_of_two(markedwidth,  marked_width);
  descwidth    = minimum_of_two(descwidth,    desc_width);
  countwidth   = minimum_of_two(countwidth,   count_width);
  pmarkwidth   = minimum_of_two(pmarkwidth,   pmark_width);
  unreadwidth  = minimum_of_two(unreadwidth,  unread_width);
  changedwidth = minimum_of_two(changedwidth, changed_width);
  echoidwidth  = minimum_of_two(echoidwidth,  echoid_width);
  groupidwidth = minimum_of_two(groupidwidth, groupid_width);

  memcpy(buf+area_pos+area_width-areawidth,          areabuf,    areawidth);
  memcpy(buf+marked_pos,                             markedbuf,  markedwidth);
  memcpy(buf+desc_pos,                               descbuf,    descwidth);
  memcpy(buf+count_pos+count_width-countwidth,       countbuf,   countwidth);
  memcpy(buf+pmark_pos,                              pmarkbuf,   pmarkwidth);
  memcpy(buf+unread_pos+unread_width-unreadwidth,    unreadbuf,  unreadwidth);
  memcpy(buf+changed_pos,                            changedbuf, changedwidth);
  memcpy(buf+echoid_pos,                             echoidbuf,  echoidwidth);
  memcpy(buf+groupid_pos+groupid_width-groupidwidth, groupidbuf, groupidwidth);
}


//  ------------------------------------------------------------------

static void a_printsep(PInf* p, int pos, int areano) {

  char buf[256];
  garealistdata* area = AL.number_to_pointer(areano);

  int sep_pos = (desc_pos != -1) ? desc_pos : echoid_pos;

  memset(buf, _box_table[p->btype][1], sep_pos);  buf[sep_pos] = NUL;
  wprints(pos, 0, p->type==PICK_BAR ? p->sattr : p->battr, buf);

  wprints(pos, sep_pos, p->type==PICK_BAR ? p->sattr : p->tattr, area->desc().c_str());

  int l = area->desc().length();
  int n = gvid.numcols-2-sep_pos-l;
  memset(buf, _box_table[p->btype][1], n);  buf[n] = NUL;
  wprints(pos, sep_pos+l, p->type==PICK_BAR ? p->sattr : p->battr, buf);
}


//  ------------------------------------------------------------------

static void a_page(PInf* p) {

  char buf[256];
  int attr = p->wattr;

  if(p->idx > p->pos)
    p->idx -= p->pos;
  else
    p->idx = 0;
  register uint m = p->maxidx-p->idx;

  uint n;
  for(n=0; n<=p->maxpos and n<=m; n++) {
    if(n == p->pos)
      attr = p->sattr;
    if(AL[p->idx+n]->isseparator()) {
      a_printsep(p, n, p->idx+n);
    }
    else {
      a_dispbuf(buf, p->idx+n);
      wprints(n, 0, attr, buf);
      if(AL[p->idx+n]->marked())
        wprintc(n, marked_pos, n == p->pos ? p->sattr : p->hattr, marked_char);
    }
    if(n == p->pos)
      attr = p->wattr;
  }
  if(n <= p->maxpos) {
    memset(buf, _box_table[p->btype][1], p->xlen-2);
    buf[p->xlen-2] = NUL;
    wprints(n, 0, p->battr, buf);
  }
  memset(buf, ' ', p->xlen-2);
  buf[p->xlen-2] = NUL;
  for(++n; n<=p->maxpos; n++)
    wprints(n, 0, p->wattr, buf);
  p->idx += p->pos;
  a_dodelayed(p);
}


//  ------------------------------------------------------------------

void arealist_page() {

  a_page(areainfp);
}


//  ------------------------------------------------------------------

static void a_center(PInf* p) {

  uint room, toproom, botroom;

  toproom = p->idx;
  botroom = p->maxidx - p->idx;
  if(toproom > p->maxpos/2) {
    if(botroom > p->maxpos/2)
      room = p->maxpos/2;
    else if(botroom)
      room = p->maxpos - botroom;
    else
      room = p->maxpos;
  }
  else
    room = toproom;

  p->pos = room;
  a_page(p);
  p->direction = 1;
}


//  ------------------------------------------------------------------

static void a_jump(PInf* p) {

  register uint n;
  uint maxi=p->maxidx, oidx=p->idx;
  uint idx=p->idx;
  bool found=false, passed=false;

  // Search for next marked area, wrapping 'round if needed
  while(not found) {
    for(n=idx+1; n<=maxi; n++) {
      if(AL[n]->marked()) {
        found = YES;
        break;
      }
    }
    if(n > maxi)
      n = maxi;
    if(passed) {
      if(area_first) {
        area_first = NO;
        n--;
      }
      if(not found) {
        n = oidx+1;
        if(n > maxi)
          n = 0;
      }
      //found = YES;
      break;
    }
    if(not found) {
      passed = YES;
      idx = (uint)-1;
      maxi = p->idx+1;
      if(maxi > p->maxidx)
        maxi = p->maxidx;
    }
  }

  p->idx = n;
  a_center(p);
  area_first = NO;
  p->direction = 1;
}


//  ------------------------------------------------------------------

static void a_jumpmatch(PInf* p) {

  register uint n;
  uint maxi=p->maxidx, oidx=p->idx;
  uint idx=p->idx;
  bool found=false, passed=false;

  // Search for next matching area, wrapping 'round if needed
  while(not found) {
    for(n=idx+1; n<=maxi; n++) {
      if(not AL[n]->isseparator() and (AL[n]->echoid().nieql(area_maybe, area_fuzidx) or striinc(area_maybe, AL[n]->echoid().c_str()))) {
        found = YES;
        break;
      }
    }
    if(n > maxi)
      n = maxi;
    if(passed) {
      if(area_first) {
        area_first = NO;
        n--;
      }
      if(not found) {
        n = oidx+1;
        if(n > maxi)
          n = 0;
      }
      //found = YES;
      break;
    }
    if(not found) {
      passed = YES;
      idx = (uint)-1;
      maxi = p->idx+1;
      if(maxi > p->maxidx)
        maxi = p->maxidx;
    }
  }

  p->idx = n;
  a_center(p);
  area_first = NO;
  p->direction = 1;
}


//  ------------------------------------------------------------------

static void a_open(PInf* p) {

  int active=NO;

  if(p->ypos) {
    if(tempwin1) {
      tempwin = tempwin1;
      areawin = areawin1;
      active = YES;
    }
  }
  else {
    if(tempwin2) {
      tempwin = tempwin2;
      areawin = areawin2;
      active = YES;
    }
  }

  if(active) {
    wunhide(tempwin);
    wprints(0,0, p->wattr, p->title);
    wunhide(areawin);
  }
  else {
    tempwin = wopen_(p->ypos, p->xpos, 1, p->xlen, 5, p->battr, p->wattr, p->sbattr);
    wprints(0,0, p->wattr, p->title);
    areawin = wopen_(p->ypos+1, p->xpos, p->ylen-1, p->xlen, p->btype, p->battr, p->wattr, p->sbattr);

    if(p->ypos) {
      tempwin1 = tempwin;
      areawin1 = areawin;
    }
    else {
      tempwin2 = tempwin;
      areawin2 = areawin;
    }

    if(area_width)
      wmessage(CFG->language[LNG_Area], TP_BORD, 1+area_pos+(marked_pos==area_pos+area_width?1:0), p->tattr);
    if(desc_width)
      wmessage(CFG->language[LNG_Description], TP_BORD, 1+desc_pos, p->tattr);
    if(count_width)
      wmessage(CFG->language[LNG_Msgs], TP_BORD, 1+count_pos+count_width-strlen(CFG->language[LNG_Msgs]), p->tattr);
    if(unread_width) {
      if(CFG->arealisttype == AL_TOTLST)
        wmessage(CFG->language[LNG_Last], TP_BORD, 1+unread_pos+unread_width-strlen(CFG->language[LNG_Last]), p->tattr);
      else if(CFG->arealisttype == AL_TOTNEW)
        wmessage(CFG->language[LNG_New], TP_BORD, 1+unread_pos+unread_width-strlen(CFG->language[LNG_New]), p->tattr);
    }
    if(echoid_width)
      wmessage(CFG->language[LNG_EchoID], TP_BORD, 1+echoid_pos, p->tattr);
    if(groupid_width) {
      char grpbuf[40];
      if(groupid_width > 2)
        strcpy(grpbuf, CFG->language[LNG_Grp]);
      else {
        *grpbuf = *(CFG->language[LNG_Grp]);
        grpbuf[1] = NUL;
      }
      wmessage(grpbuf, TP_BORD, 1+groupid_pos, p->tattr);
    }

    if((p->maxpos == p->maxidx) and (p->maxpos < (p->ylen-4))) {
      char buf[256];
      memset(buf, _box_table[p->btype][1], p->xlen-2);
      buf[p->xlen-2] = NUL;
      wprints(p->maxpos+1, 0, p->wattr, buf);
    }
  }
  if(nextarea and p->ypos == 0) {
    if(p->idx) {   // Back one area
      p->idx--;
      p->idx++;
    }
    else
      p->idx = p->maxidx;
    a_jump(p);
  }
  else
    a_center(p);
}


//  ------------------------------------------------------------------

static void a_close(PInf*) {

  whide();
  whide();
}


//  ------------------------------------------------------------------

static void a_precursor(PInf*) {

  if(not a_separator) {
    memset(area_maybe, 0, sizeof(Echo));
    area_fuzidx = 0;
  }
  a_separator = false;
}


//  ------------------------------------------------------------------

static void a_disp(PInf* p) {

  if(AL[p->idx]->isseparator()) {
    a_printsep(p, p->pos, p->idx);
  }
  else {
    char buf[256];
    a_dispbuf(buf, p->idx);
    wprints(p->pos, 0, p->type==PICK_BAR ? p->sattr : p->wattr, buf);
    if(AL[p->idx]->marked())
      wprintc(p->pos, marked_pos, p->type==PICK_BAR ? p->sattr : p->hattr, marked_char);
  }
}


//  ------------------------------------------------------------------

static void a_scroll(PInf* p, int direction) {

  NW(p);
  wscroll(1, direction);
}


//  ------------------------------------------------------------------

static int a_dokey(PInf* p, Key* keycode) {

  register uint n;
  register uint x;
  const char* adesc;
  char buf[256], tmp[80];
  Key key = *keycode, kk;
  int mode, changed;

  *keycode = 0;
  if(key < KK_Commands) {
    key = key_tolower(key);
    if((key == Key_Esc) and esc_abort)
      key = KK_AreaAbort;
    else {
      kk = SearchKey(key, AreaKey, AreaKeys);
      if(kk)
        key = kk;
    }
  }

  switch(key) {
    case KK_AreaAskExit:
      {
        GMenuQuit MenuQuit;
        p->aborted = gkbd.quitall = MenuQuit.Run();
        if(gkbd.quitall) {
          a_precursor(p);
          return NO;
        }
      }
      break;

    case KK_AreaAbort:
      p->aborted = YES;
      // Drop Through

    case KK_AreaSelect:
      if(AL[p->idx]->isseparator()) {
        if(not PlayMacro(key, KT_A))
          SayBibi();
        break;
      }
      a_precursor(p);
      return NO;

    case KK_AreaQuitNow:
      p->aborted = gkbd.quitall = YES;
      a_precursor(p);
      return NO;

    case KK_AreaToggle:
      AL[p->idx]->toggle_marked();
      a_disp(p);
      break;

    case KK_AreaBoardnos:
      CFG->arealistnos ^= true;
      a_page(p);
      break;

    case KK_AreaJumpNextMatch:
      a_jumpmatch(p);
      break;

    case KK_AreaJump:
      {
        a_precursor(p);
        int old_nextarea = nextarea;
        nextarea = true;
        a_jump(p);
        nextarea = old_nextarea;
      }
      break;

    case KK_AreaDosShell:
      ShellToDos(getenv("COMSPEC"), CFG->language[LNG_DOS_Shell], LGREY|_BLACK, YES);
      break;

    //case KK_AreaGotoConfig:
    //  ConfigMenu();
    //  break;

    case KK_AreaGotoPrev:
      *keycode = Key_Up;
      break;

    case KK_AreaGotoNext:
      *keycode = Key_Dwn;
      break;

    case KK_AreaGotoFirst:
      *keycode = Key_Home;
      break;

    case KK_AreaGotoLast:
      *keycode = Key_End;
      break;

    case KK_AreaSoundkill:
      HandleGEvent(EVTT_STOPVOICE);
      break;

    case KK_AreaTouchNetscan:
      TouchNetscan();
      break;

    case KK_AreaHeat:
      {
        GMenuAreaHeat MenuAreaHeat;
        mode = MenuAreaHeat.Run();
        if(mode != SCAN_QUIT) {
          for(int n=0; n<AL.areas(); n++) {
            garealistdata* ap = AL[n];
            if((ap->marked()) or mode == SCAN_ALL or (mode == SCAN_CURRENT and n == p->idx)) {
              update_statuslinef("%s %s", 1+CFG->language[LNG_ScanningArea], ap->echoid().c_str());
              gactivearea* area = AL.activate(ap->areaid());
              area->sethighwatermark();
              AL.deactivate(area);
            }
          }
        }
      }
      break;

    case KK_AreaZap:
      {
        GMenuAreaZap MenuAreaZap;
        mode = MenuAreaZap.Run();
        if(mode != SCAN_QUIT) {
          for(int n=0; n<AL.areas(); n++) {
            garealistdata* ap = AL[n];
            if((ap->marked()) or mode == SCAN_ALL or (mode == SCAN_CURRENT and n == p->idx)) {
              update_statuslinef("%s %s", 1+CFG->language[LNG_ScanningArea], ap->echoid().c_str());
              gactivearea* area = AL.activate(ap->areaid());
              area->resethighwatermark();
              AL.deactivate(area);
            }
          }
        }
      }
      break;

    case KK_AreaScanPM:
      pmscan = true;
      pmails = 0;
      pmareas = 0;
      // DROP THROUGH //

    case KK_AreaScan:
      {
        GMenuAreaScan MenuAreaScan;
        mode = MenuAreaScan.Run(pmscan);
        if(mode != SCAN_QUIT) {

          w_info(CFG->language[LNG_Wait]);

          startecho = AL[p->idx]->echoid();

          if(mode == SCAN_IMPORTQWK)
            changed = ImportQWK();
          else if(mode == SCAN_EXPORTQWK)
            changed = ExportQWK();
          else if(mode == SCAN_IMPORTSOUP)
            changed = ImportSOUP();
          else if(mode == SCAN_EXPORTSOUP)
            changed = ExportSOUP();
          else {
            if(cmdlinedebughg)
              LOG.printf("- AreaScan from arealist");
            changed = AL.scan_areas(mode, AL[p->idx]->areaid(), pmscan, pmails, pmareas);
          }

          w_info();

          if(changed) {
            AL.sort();
            AreasRenumber();
            p->idx = AL.echoid_to_number(startecho);
            a_center(p);
          }

          if(pmscan) {
            if(pmails) {
              w_infof(CFG->language[LNG_FoundPersonal],
                pmails, (pmails==1?"":"s"),
                pmareas, (pmareas==1?"":"s")
              );
            }
            else {
              w_info(CFG->language[LNG_NoPersonal]);
            }
            waitkeyt(10000);
            w_info();
          }
        }
        pmscan = false;
      }
      break;

    case Key_Tick:
      CheckTick(KK_AreaQuitNow);
      break;

    case KK_AreaUndefine:
      break;

    case KK_AreaWriteGoldlast:
      w_info(CFG->language[LNG_Wait]);
      AL.write_goldlast();
      w_info();
      break;

    default:
      if(key < KK_Macro) {
        p->direction = 1;
        n = toupper(key & 0xFF);
        if((area_fuzidx < 60) or key == Key_BS) {

          // Incremental search in the echoids
          if(not iscntrl(n) or key == Key_BS) {
            if(n == ' ')
              n = '_';
            if(key != Key_BS)
              area_maybe[area_fuzidx++] = (char)n;
            else if(area_fuzidx)
              area_maybe[--area_fuzidx] = 0;
            sprintf(buf, "%s%s", p->title, area_maybe);
            sprintf(tmp, "%-80s", buf);
            wwprintstr(tempwin, 0, 0, p->wattr, tmp);
            #if 0
            sprintf(buf, " Select Area%s%s ", (*area_maybe?": ":""), area_maybe);
            wtitle(buf, TCENTER|TBOTTOM, p->tattr);
            #endif
            if(area_fuzidx) {

              x = atoi(area_maybe);
              if(x) {
                if(CFG->arealistnos and (isdigit(area_maybe[1]) or (area_maybe[1] == NUL))) {
                  for(n=0; n<AL.areas(); n++) {
                    if(AL[n]->board() == x) {
                      x = n;
                      goto RedrawAreas;
                    }
                  }
                  x = 0;  // No match found
                }
                else {
                  for(n=0; n<area_fuzidx; n++) {
                    if(not isdigit(area_maybe[n])) {
                      x = 0;
                      break;
                    }
                  }
                }
              }

              if(x >= 1 and x<=AL.areas()) {
                {
                  for(int a=0, at=AL.areas(); a<at; a++) {
                    if(areanumbers[a] == x) {
                      x = a;
                      goto RedrawAreas;
                    }
                  }
                }
                x = (uint)-1;

              RedrawAreas:

                if(x == (uint)-1)
                  x = p->idx;
                if(x != p->idx)
                  a_disp(p);
                #define _topidx (p->idx-p->pos)               // Shorthand..
                #define _botidx (p->idx+(p->maxpos-p->pos))   // Shorthand..
                if((_topidx <= x) and (x <= _botidx)) {
                  p->pos += (x-p->idx);
                  p->idx = x;
                  a_page(p);    /////////// NEW
                }
                else {
                  p->idx = x;
                  a_center(p);
                }
                break;
              }
              else {
                // Regular search
                for(n=0; n<AL.areas(); n++) {
                  adesc = AL[n]->echoid().c_str();
                  if(strnicmp(area_maybe, adesc, area_fuzidx) == 0) {
                    //x = n;
                    AL.sort();
                    AreasRenumber();
                    x = AL.echoid_to_number(adesc);
                    goto RedrawAreas;
                  }
                }
                // Search inside
                for(n=0; n<AL.areas(); n++) {
                  adesc = AL[n]->echoid().c_str();
                  if(striinc(area_maybe, adesc)) {
                    //x = n;
                    AL.sort();
                    AreasRenumber();
                    x = AL.echoid_to_number(adesc);
                    goto RedrawAreas;
                  }
                }
              }
            }
            else {
              adesc = AL[p->idx]->echoid().c_str();
              AL.sort();
              AreasRenumber();
              p->idx = AL.echoid_to_number(adesc);
              a_center(p);
            }
            break;
          }
        }
      }
      if(not PlayMacro(key, KT_A))
        SayBibi();
  }
  return YES;
}


//  ------------------------------------------------------------------

int AreaPick(char* title, int wpos, int* idx) {

  Pick pick;
  PInf p;

  HandleGEvent(EVTT_AREALIST);

  memset(&p, 0, sizeof(PInf));
  memset(&pick, 0, sizeof(Pick));
  p.helpcat = H_Area;
  p.btype = W_BAREA;
  p.battr = C_AREAB;
  p.wattr = C_AREAW;
  p.sattr = C_AREAS;
  p.tattr = C_AREAT;
  p.hattr = C_AREAQ;
  p.sbattr = C_AREAPB;
  p.xlen = gvid.numcols;
  p.listwrap = CFG->displistwrap;

  pick.open      = a_open;
  pick.close     = a_close;
  pick.disp      = a_disp;
  pick.page      = a_page;
  pick.scroll    = a_scroll;
  pick.dokey     = a_dokey;
  pick.dodelayed = a_dodelayed;
  pick.precursor = a_precursor;

  p.idx = AL.id_to_number(*idx);
  p.ypos = wpos;
  p.ylen = gvid.numrows-wpos-1;
  p.title = title;
  p.maxidx = AL.areas()-1;
  p.maxpos = minimum_of_two((uint)(p.ylen-4), p.maxidx);
  p.aborted = NO;
  esc_abort = wpos;

  goldmark = ' ';

  areanumbers = (uint*)throw_calloc(AL.areas(), sizeof(uint));
  AreasRenumber();

  _in_arealist = true;
  areainfp = &p;
  Picker(&p, &pick);
  areainfp = NULL;
  _in_arealist = false;

  throw_release(areanumbers);

  if(not p.aborted)
    return AL[p.idx]->areaid();
  *idx = AL[p.idx]->areaid();

  return -1;
}


//  ------------------------------------------------------------------

