
//  ------------------------------------------------------------------
//  GoldED. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gecfgs.h,v 1.1.1.1 1998/11/21 19:38:04 odinn Exp $
//  ------------------------------------------------------------------


#include <gftnadrs.h>


//  ------------------------------------------------------------------
//  Control info types

const int CI_NONE = 0x0000;
const int CI_TEAR = 0x0001;
const int CI_ORIG = 0x0002;
const int CI_TAGL = 0x0004;


//  ------------------------------------------------------------------

class gtpl {

public:

  gtpl& operator=(const gtpl& o) { file=o.file; name=o.name; match=o.match; return *this; }

  gstring  file;
  gstring  name;
  ftn_addr match;
};


//  ------------------------------------------------------------------

class garearename {

public:

  garearename& operator=(const garearename& o) { from=o.from; to=o.to; return *this; }

  gstring from;
  gstring to;
};


//  ------------------------------------------------------------------

class gfilealias {

public:

  gfilealias& operator=(const gfilealias& o) { alias=o.alias; file=o.file; return *this; }

  gstring alias;
  gstring file;
};


//  ------------------------------------------------------------------

class gexternutil {

public:

  enum {
    cls          = 0x0001,
    swap         = 0x0002,
    cursor       = 0x0004,
    reload       = 0x0008,
    pause        = 0x0010,
    pauseonerror = 0x0020,
    wipe         = 0x0040,
    keepctrl     = 0x0080
  };

  gexternutil() { utilno=options=0; }

  gexternutil& operator=(const gexternutil& o) { utilno=o.utilno; options=o.options; cmdline=o.cmdline; return *this; }

  int     utilno;
  int     options;
  gstring cmdline;
};


//  ------------------------------------------------------------------

struct gposlen {

  int pos;
  int len;
};


//  ------------------------------------------------------------------

struct ginvalidate {

  gstring origin[2];
  gstring seenby[2];
  gstring tearline[2];
};


//  ------------------------------------------------------------------

struct gsemaphore {

  gstring netscan;
  gstring echoscan;
  gstring exportlist;
  gstring importlist;
  gstring scanall;
  gstring scanthis;
  gstring scannetmail;
  gstring pmscanall;
  gstring pmscanthis;
  gstring pmscannetmail;
  gstring qwkimport;
  gstring qwkexport;
  gstring soupimport;
  gstring soupexport;
  int     idletime;
};


//  ------------------------------------------------------------------

class gmailinglist {

public:

  gmailinglist& operator=(const gmailinglist& o) { echoid=o.echoid; sender=o.sender; contribution=o.contribution; return *this; }

  gstring echoid;
  gstring sender;
  gstring contribution;
};


//  ------------------------------------------------------------------

class gfrqnodemap {

public:

  gfrqnodemap& operator=(const gfrqnodemap& o) { from=o.from; to=o.to; return *this; }

  gftnaddrs from;
  gftnaddrs to;
};


//  ------------------------------------------------------------------

class geditsaveutil {

public:

  geditsaveutil& operator=(const geditsaveutil& o) { number=o.number; text=o.text; return *this; }

  int     number;
  gstring text;
};


//  ------------------------------------------------------------------

class gedittrigger {

public:

  gedittrigger& operator=(const gedittrigger& o) { trigger=o.trigger; text=o.text; return *this; }

  gstring trigger;
  gstring text;
};


//  ------------------------------------------------------------------

struct gcolor {

  int btype;        // Border type
  int c[12];        // Colors
  int w;            // Window handle
};


//  ------------------------------------------------------------------

