
//  ------------------------------------------------------------------
//  GoldED. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: geglob.cpp,v 1.1.1.1 1998/11/21 19:38:04 odinn Exp $
//  ------------------------------------------------------------------
//  Global data.
//  ------------------------------------------------------------------


#include "golded.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif


//  ------------------------------------------------------------------
//  Various global data

#if defined(__MSDOS__)
#ifdef __DJGPP__
unsigned _stklen = 32768u;
#else
extern unsigned _stklen = 10000u;
#endif
#endif

GLog __FAR LOG;

gareafile* AFILE = NULL;
golded_cfg* CFG = NULL;
LangGed* LNG = NULL;
NodeIxl* NODE = NULL;
GGrp* GRP = NULL;
Qwk* QWK = NULL;
golded_xlat* XLAT = NULL;

uint locpost=0, netpost=0, echopost=0;

char information[150];

Echo* echoin = NULL;
Echo* echoout = NULL;

char m_title[80];          // Menu title string
int m_titlepos;           // Menu title position
int m_titleattr;          // Menu title color

char* tconv;

CmdKey* AreaKey = NULL;   int AreaKeys = 0;
CmdKey* ReadKey = NULL;   int ReadKeys = 0;
CmdKey* ListKey = NULL;   int ListKeys = 0;
CmdKey* NodeKey = NULL;   int NodeKeys = 0;
CmdKey* EditKey = NULL;   int EditKeys = 0;
CmdKey* FileKey = NULL;   int FileKeys = 0;

int inforow = 18;

char goldmark = ' ';

gstring startecho;

int fieldupd = 2;  // State of field mode in winpdef()

int nextarea = false;

char gversion[20];

int stamps=0;
Stamp* stamp=NULL;

int quiet = YES;
int ignore = NO;
int cfgerrors = NO;
int veryverbose = 0;
word* oldscreen = NULL;

int disablesound = NO;

int _in_editor = NO;
int _in_msglist = NO;
BmhArg* find_pattern = NULL;
BmhPat* find_patstr = NULL;
int     find_pats = 0;

void(*SIGINT_OldHandler)(void) = NULL;

int tplselected = false;

int arealistnumgrps = false;

int startupscan_success = false;

extern int __FAR cmdlinesharemode;

int _use_fwd = true;


//  ------------------------------------------------------------------
//        0    1    2    3    4    5    6    7    8    9

Win __FAR gold_color1[14] = {
  {5, {   7,   0,   7,   7,   7,   7,   7,   7,   7,   7,   7,   0}, 2},  // Back  0
  {5, {  31,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7}, 1},  // Stat  1
  {0, {  15,  14,  14,   7,  12,   7,   7,   9,   7,   7,   7,  14}, 0},  // Brag  2
  {0, {   7,   9,  14,  31,  15,   7,   7,   7,   7,   7,   7,   9}, 0},  // Area  3
  {0, {   7,   7,  15,  14, 143,   8,  15,  79,  15,  15,   8,   7}, 5},  // Read  4
  {0, {   7,   9,  14,   7,  15,   7,  15, 113,   7,   7,   7,   9}, 0},  // Head  5
  {0, {   7,  12,  14,  31,  15,   8,   7,   7,   7,   7,   7,  12}, 0},  // Ask   6
  {0, {   7,  12,  14,  31,  15,   8,   7,   7,   7,   7,   7,  12}, 0},  // Menu  7
  {0, {   7,  14,   7,  79,  15,   7,   7,   7,   7,   7,   7,  14}, 0},  // Help  8
  {3, {   7,  12,  14,  31,  15,   8,   7,   7,   7,   7,   7,  12}, 0},  // Cfg   9
  {0, {  15,  12,  14,   7,   7,   7,   7,   7,   7,   7,   7,  12}, 0},  // Info  10
  {3, {   7,  12,  14,  31,  15,   8,   7,   7,   7,   7,   7,  12}, 0},  // Cfgb  11
  {0, {   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7}, 0},  // Style 12
  {0, {   7,   7,   7,   7,   7,   7,   7,   8,   7,   7,   7,   7}, 0},  // Shad  13
};


//  ------------------------------------------------------------------
//        0    1    2    3    4    5    6    7    8    9

Win __FAR gold_color2[14] = {
  {5, { 240,  15,   7,   7,   7,   7,   7,   7,   7,   7,   7,  15}, 2},  // Back  0
  {5, { 143,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7}, 1},  // Stat  1
  {0, {  15,  14,  14,   7,  12,   7,   7,   9,   7,   7,   7,  14}, 0},  // Brag  2
  {0, { 240, 241, 244, 143, 244,   7,   7,   7,   7,   7,   7, 241}, 0},  // Area  3
  {0, { 241, 240, 242, 244,  64, 248, 240,  64, 240, 240, 248, 240}, 5},  // Read  4
  {0, { 135, 142, 142, 135, 143,   7, 143,  64, 135, 135,   7, 142}, 0},  // Head  5
  {0, { 224, 230, 232, 143, 228, 231,   7,   7,   7,   7,   7, 230}, 0},  // Ask   6
  {0, { 112, 126, 116, 143, 126, 120,   7,   7,   7,   7,   7, 126}, 0},  // Menu  7
  {0, { 135, 142,   7, 228, 143,   7,   7,   7,   7,   7,   7, 142}, 0},  // Help  8
  {3, { 224, 230, 232, 143, 228, 231,   7,   7,   7,   7,   7, 230}, 0},  // Cfg   9
  {0, {  15,  12,  14,   7,   7,   7,   7,   7,   7,   7,   7,  12}, 0},  // Info  10
  {3, { 240, 241, 244, 143, 244,   7,   7,   7,   7,   7,   7, 241}, 0},  // Cfgb  11
  {0, { 241, 241, 241, 241, 241, 241, 241, 241, 241, 241, 241, 241}, 0},  // Style 12
  {0, {   7,   7,   7,   7,   7,   7,   7,   8,   7,   7,   7,   7}, 0},  // Shad  13
};


//  ------------------------------------------------------------------
//        0    1    2    3    4    5    6    7    8    9

Win __FAR gold_mono1[16] = {
  {5, {  15,   0,   7,   7,   7,   7,   7,   7,   7,   7,   7,   0}, 2},  // Back  0
  {5, { 112,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7}, 1},  // Stat  1
  {0, {  15,   7,  15,   7,  15,   7,   7,   7,   7,   7,   7,   7}, 0},  // Brag  2
  {0, {   7,   7,  15, 112,  15,   7,   7,   7,   7,   7,   7,   7}, 0},  // Area  3
  {0, {   7,   7,  15,  15, 143,  15,   7,   7,   7,   7,  15,   7}, 5},  // Read  4
  {0, {   7,   7,  15,   7,  15,   7, 112,  15,   7,   7,   7,   7}, 0},  // Head  5
  {0, { 112, 112, 112,  15,  15,   7,   7,   7,   7,   7,   7, 112}, 0},  // Ask   6
  {0, {   7,   7, 112, 112,  15,   7,   7,   7,   7,   7,   7,   7}, 0},  // Menu  7
  {0, { 112, 112,   7,  15, 112,   7,   7,   7,   7,   7,   7, 112}, 0},  // Help  8
  {3, {   7,   7, 112, 112,  15,   7,   7,   7,   7,   7,   7,   7}, 0},  // Cfg   9
  {0, {  15,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7}, 0},  // Info  A
  {3, {   7,   7, 112, 112,  15,   7,   7,   7,   7,   7,   7,   7}, 0},  // Cfgb  B
  {0, {   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7}, 0},  // Style C
  {0, {   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7}, 0},  // Shad  F
};


//  ------------------------------------------------------------------
//  Deallocate CFG at exit

static void _stdc CfgReset(void) {

  throw_delete(CFG);
  throw_delete(QWK);
  throw_delete(GRP);
  throw_delete(XLAT);
  throw_delete(EDIT);
  throw_delete(AFILE);

  if(NODE)
    throw_release(NODE->nodelist);
  throw_release(NODE);
  throw_release(CFG);
}


//  ------------------------------------------------------------------
//  Assign default CFG values

void golded_cfg::initialize() {

  atexit(CfgReset);

  CFG = new golded_cfg;
  throw_new(CFG);

  NODE = (NodeIxl*)throw_calloc(1, sizeof(NodeIxl));

  AFILE = new gareafile;
  throw_new(AFILE);

  GRP = new Grp(GRP_MAX, sizeof(Echo));
  throw_new(GRP);

  QWK = new Qwk;
  throw_new(QWK);

  XLAT = new golded_xlat;
  throw_new(XLAT);

  LangInit();


  //  ----------------------------------------------------------------

  CFG->vers.vers = sizeof(golded_cfg);
  strcpy(CFG->vers.date, __date__);
  strcpy(CFG->vers.time, __time__);
  strcpy(CFG->pid, __gpid__);
  strcpy(CFG->ver, __gver__);

  //  ----------------------------------------------------------------

  strcpy(CFG->goldcfg, "golded.cfg");
  strcpy(CFG->goldged, "golded" GCFG_EXT);
  strcpy(CFG->helpcfg.fn, "goldhelp.cfg");
  strcpy(CFG->helpged, "goldhelp" GCFG_EXT);
  strcpy(CFG->keyscfg.fn, "goldkeys.cfg");
  strcpy(CFG->langcfg.fn, "goldlang.cfg");
  strcpy(CFG->langged, "goldlang" GCFG_EXT);
  strcpy(CFG->randcfg.fn, "goldrand.cfg");
  strcpy(CFG->randged, "goldrand" GCFG_EXT);

  //  ----------------------------------------------------------------

  CFG->arealistformat = "AM D CPUN E G ";
  CFG->arealistsort = "FYTUE";
  CFG->areascansort = "XZBE";
  CFG->confirmfile = "golded.cfm";
  CFG->fidolastread = "LASTREAD";
  CFG->importbegin = "=== Cut ===";
  CFG->invalidate.origin[0] = " * Origin: ";
  CFG->invalidate.origin[1] = " + Origin: ";
  CFG->invalidate.seenby[0] = "SEEN-BY";
  CFG->invalidate.seenby[1] = "SEEN+BY";
  CFG->invalidate.tearline[0] = "--- ";
  CFG->invalidate.tearline[1] = "-+- ";
  CFG->mapdrive = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
  CFG->namesfile = "names.fd";
  CFG->printdevice = "PRN";
  CFG->quotestring = " FL> ";
  CFG->stylecodepunct = " !\"$%&()+ =.:;<=>@[\\]^`{|}~\n\r\t";
  CFG->stylecodestops = "";
  CFG->tearline = "@longpid @version";
  CFG->userlistfile = "golded.lst";
  CFG->whoto = "All";
  XLAT->xlatfile = "goldxlat" GCFG_EXT;
  XLAT->localset = "IBMPC";

  //  ----------------------------------------------------------------

  CFG->logfile = "golded.log";

  //  ----------------------------------------------------------------

  for(int n=0; n<16; n++)
    CFG->screenpalette[n] = -1;

  //  ----------------------------------------------------------------

  if(gvid.adapter & V_MONO)
    memcpy(CFG->color, gold_mono1, sizeof(CFG->color));
  else
    memcpy(CFG->color, gold_color1, sizeof(CFG->color));

  //  ----------------------------------------------------------------

  CFG->cfgeditquotemargin = 75;
  CFG->cfgquotemargin = 70;

  //  ----------------------------------------------------------------

  CFG->akamatchnet = true;
  CFG->areaautonext = true;
  CFG->areafilegroups = true;
  CFG->areakeeplast = true;
  CFG->arealistgroupid = true;
  CFG->arealistpagebar = true;
  CFG->arealisttype = AL_TOTNEW;
  CFG->areareadonly = READONLY_SOFT;
  CFG->askdelorig = true;
  CFG->attribsattach.loc1();
  CFG->attribscc.loc1();
  CFG->attribscfm.loc1();
  CFG->attribsecho.loc1();
  CFG->attribsfrq.loc1();
  CFG->attribslocal.loc1();
  CFG->attribsnet.loc1();
  CFG->beepcomment = true;
  CFG->beepfactor = 5;
  CFG->beepnoises = true;
  CFG->beepyourmail = true;
  CFG->carboncopylist = CC_NAMES;
  CFG->confirmresponse = ASK;
  CFG->crosspostlist = CC_NAMES;
  CFG->ctrlinfoecho  = CI_TAGL|CI_TEAR|CI_ORIG;
  CFG->ctrlinfolocal = CI_TAGL;
  CFG->ctrlinfonet = CI_TAGL|CI_TEAR;
  CFG->dispareano = true;
  CFG->dispattachsize = ATTACH_KBYTES;
  CFG->dispautonext = true;
  CFG->disphdrdateset.len = 20;
  CFG->disphdrdateset.pos = -20;
  CFG->disphdrnameset.len = 36;
  CFG->disphdrnameset.pos = 8;
  CFG->disphdrnodeset.len = 16;
  CFG->disphdrnodeset.pos = 44;
  CFG->displocalhigh = true;
  CFG->dispmsgsize = DISPMSGSIZE_BYTES;
  CFG->disppagebar = true;
  CFG->dispstatusline = true;
  CFG->disptabsize = 4;
  CFG->dosprompt = true;
  CFG->dosswap = GSWAP_ALL | GSWAP_EMS_FIRST | GSWAP_CHECK_NET | GSWAP_HIDE_FILE;
  CFG->externoptions = EXTUTIL_CLS | EXTUTIL_SWAP | EXTUTIL_CURSOR | EXTUTIL_RELOAD | EXTUTIL_PAUSEONERROR | EXTUTIL_KEEPCTRL;
  CFG->fidomsgtype = GMB_OPUS;
  CFG->filelistpagebar = true;
  CFG->frqoptions = FREQ_FROMTOP;
  CFG->hudsonsizewarn = 16000000L;
  CFG->internetreply = true;
  CFG->keybdefaults = true;
  CFG->keybext = -1;
  CFG->keybmode = KEYB_POLL;
  CFG->kludgechrs = true;
  CFG->lookupnet = true;
  CFG->menumarked = MODE_DONT;
  CFG->msglistdate = MSGLISTDATE_WRITTEN;
  CFG->msglistfast = true;
  CFG->msglistpagebar = true;
  CFG->msglistviewsubj = true;
  CFG->nodelistpagebar = true;
  CFG->nodelistwarn = true;
  CFG->overlay = OVL_EMS;
  CFG->printformfeed = true;
  CFG->printlength = 60;
  CFG->printmargin = 80;
  CFG->quotebufmode = QBUF_ASK;
  CFG->quotemargin = 70;
  CFG->quotewraphard = true;
  CFG->screenblanker = 180;
  CFG->screenblankertype = BLANK_SLIDEWIN;
  CFG->screenshadows = true;
  CFG->sharemode = cmdlinesharemode;
  CFG->squishscan = 2;            // SQS_QUICK
  CFG->statuslineclock = true;
  CFG->taglinechar = '.';
  CFG->taglinesupport = true;
  CFG->timeoutsavemsg = true;
  CFG->twitmode = TWIT_BLANK;
  CFG->useflags = true;
  CFG->useintl = true;
  CFG->usemsgid = true;
  CFG->viewquote = true;
  CFG->zonegating  = ASK;

  //  ----------------------------------------------------------------

  CFG->areatypeorder[GMB_NET]               = 1;
  CFG->areatypeorder[GMB_NET|GMB_EMAIL]      = 2;
  CFG->areatypeorder[GMB_ECHO]              = 3;
  CFG->areatypeorder[GMB_ECHO|GMB_NEWSGROUP] = 4;
  CFG->areatypeorder[GMB_LOCAL]             = 5;

  //  ----------------------------------------------------------------
}


//  ------------------------------------------------------------------
//  Assign default CFG values before reading the .CFG's

void golded_cfg::initialize2() {

  //  ----------------------------------------------------------------
  //  Set some default robotnames

  CfgRobotname("AreaFix");
  CfgRobotname("AreaMgr");
  CfgRobotname("FileFix");
  CfgRobotname("AreaLink");
  CfgRobotname("AllFix");
  CfgRobotname("Raid");
  CfgRobotname("GEcho");


  //  ----------------------------------------------------------------
  //  Set some default filerequest extensions

  CfgFrqext(".arc");
  CfgFrqext(".arj");
  CfgFrqext(".exe");
  CfgFrqext(".lha");
  CfgFrqext(".lzh");
  CfgFrqext(".pak");
  CfgFrqext(".run");
  CfgFrqext(".sda");
  CfgFrqext(".sdn");
  CfgFrqext(".zip");
  CfgFrqext(".zoo");
  CfgFrqext(".doc");
  CfgFrqext(".txt");
  CfgFrqext(".gif");
  CfgFrqext(".rar");
  CfgFrqext(".png");
  CfgFrqext(".jpg");


  //  ----------------------------------------------------------------
  //  Setup the standard beeping effects

  CfgEvent("Attention PLAY ToYou");
  CfgEvent("EditComment PLAY ToYou");
  CfgEvent("EndOfMsgs PLAY TheEnd");
  CfgEvent("JobDone PLAY GotIt");
  CfgEvent("JobFailed PLAY TooBad");
  CfgEvent("MsgIsLocal PLAY ToYou");
  CfgEvent("MsgToYou PLAY ToYou");
  CfgEvent("SayBiBi PLAY SayBiBi");
  CfgEvent("SearchFailed PLAY TooBad");
  CfgEvent("SearchSuccess PLAY GotIt");


  //  ----------------------------------------------------------------
}


//  ------------------------------------------------------------------

golded_cfgEdit::golded_cfgEdit() {

  memset(&cfg, 0, sizeof(cfg));

  // Set Boolean values
  AutoAttach(true);
  AutoSave(30);
  ChangeDate(true);
  CharPara(' ');
  CharSpace(' ');
  FieldClear(true);
  HardLines(true);
  HdrNamePos(8);
  HdrNameLen(36);
  HdrNodePos(44);
  HdrNodeLen(36);
  HeaderAttrs(true);
  HeaderFirst(EDITHEADERFIRST_YES);
  Internal(true);
  Margin(80);
  Menu(true);
  #if defined(__MSDOS__) and not defined(__386__)
  MsgSize(64000L);
  #else
  MsgSize(512000L);
  #endif
  QuoteMargin(75);
  SaveMenu(true);
  UnDelete(50);

  cfg.external = str.Add("");
  cfg.file = str.Add("golded.msg");
  cfg.hardline = str.Add("<<");
  cfg.spellchecker = str.Add("");
}


//  ------------------------------------------------------------------

inline int isstylechar(char c) { return (c == '*') or (c == '/') or (c == '_') or (c == '#'); }

void StyleCodeHighlight(const char* text, int row, int col, VidPutStrCP fp) {

  char buf[256];
  register char* ptr = strcpy(buf, text);
  char* punctchars = CFG->stylecodepunct;
  char* stylestopchars = CFG->stylecodestops;
  char prevchar = ' ';
  while(*ptr) {
    if(isstylechar(*ptr)) {
      if(strchr(punctchars, prevchar)) {
        int bb = 0, bi = 0, bu = 0, br = 0;
        char* beginstyle = ptr;
        while(isstylechar(*ptr)) {
          switch(*ptr) {
            case '*': bb++; break;
            case '/': bi++; break;
            case '_': bu++; break;
            case '#': br++; break;
          }
          ptr++;
        }
        if((bb <= 1) and (bi <= 1) and (br <= 1) and (bu <= 1)) {
          char* beginword = ptr;                       //  _/*>another*/_
          char endchar = NUL;
          char* end = strpbrk(ptr, punctchars);
          if(end)
            endchar = *end;
          else
            end = ptr+strlen(ptr);
          *end = NUL;
          char* endstyle = end-1;                      //  _/*another*/>_
          if(isstylechar(*endstyle)) {
            char* endword = endstyle;
            int eb = 0, ei = 0, eu = 0, er = 0;
            while(isstylechar(*endword)) {
              switch(*endword) {
                case '*': eb++; break;
                case '/': ei++; break;
                case '_': eu++; break;
                case '#': er++; break;
              }
              endword--;
            }
            if(endword >= beginword) {                //  _/*anothe>r*/_
              if((bb == eb) and (bi == ei) and (bu == eu) and (br == er)) {
                char endwordchar = *endword;
                *endword = NUL;
                char* style_stops_present = strpbrk(beginword, stylestopchars);
                *endword = endwordchar;
                if(not style_stops_present) {
                  char buf[200];
                  strxcpy(buf, beginstyle, (uint)(endstyle-beginstyle)+2);
                  int colorindex = (bb ? 1 : 0) | (bi ? 2 : 0) | (bu ? 4 : 0) | (br ? 8 : 0);
                  (*fp)(row, col+(uint)(beginstyle-text), C_STYLE[colorindex], buf);
                }
              }
            }
          }
          *end = endchar;
          ptr = end-1;
        }
      }
    }
    prevchar = *ptr++;
  }
}


//  ------------------------------------------------------------------

int IsMacro(Key key, int type) {

  int n = 0;
  gmacro* m = CFG->macro;
  while(n < CFG->macros) {
    if((key == m->key) and (type == m->type))
      return true;
    m++;
    n++;
  }

  return false;
}


//  ------------------------------------------------------------------

int PlayMacro(Key key, int type) {

  int n = 0;
  gmacro* m = CFG->macro;
  while(n < CFG->macros) {
    if((key == m->key) and (type == m->type)) {
      RunMacro(m);
      return true;
    }
    m++;
    n++;
  }

  return false;
}


//  ------------------------------------------------------------------

