
//  ------------------------------------------------------------------
//  GoldED. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: geglob.h,v 1.1.1.1 1998/11/21 19:38:04 odinn Exp $
//  ------------------------------------------------------------------
//  Global data.
//  ------------------------------------------------------------------


//  ------------------------------------------------------------------

extern glog __FAR LOG;

extern gareafile* AFILE;
extern GoldedCfg* CFG;
extern NodeIxl* NODE;
extern GGrp* GRP;
extern Qwk* QWK;
extern golded_xlat* XLAT;

// GCCFGG.CPP
extern int cfgingroup;
extern int cfggroups;
extern gfile grpfp;

// GCKEYS.CPP
extern gcmdkey __FAR DefaultKeyset[];

// GEAREA.CPP
extern int  area_pos;
extern int  area_width;
extern int  marked_pos;
extern int  marked_width;
extern char marked_char;
extern int  desc_pos;
extern int  desc_width;
extern int  count_pos;
extern int  count_width;
extern int  pmark_pos;
extern int  pmark_width;
extern char pmark_char;
extern int  unread_pos;
extern int  unread_width;
extern int  changed_pos;
extern int  changed_width;
extern char changed_char;
extern int  echoid_pos;
extern int  echoid_width;
extern int  groupid_pos;
extern int  groupid_width;

// GEFIND.CPP
extern BmhArg* find_pattern;
extern BmhPat* find_patstr;
extern int    find_pats;

// GEFILE.CPP
extern int fspecs, specfiles;
//extern gfilespec* fspec;

// GEMENU.CPP
extern GMsg* MenuMsgPtr;
extern gactivearea* MenuAreaPtr;

// GEPOST.CPP
extern int _use_fwd;

// GEREAD.CPP
extern int reader_finished;
extern int reader_done;
extern int reader_topline;
extern int reader_keyok;
extern int reader_rcv_noise;
extern int reader_gen_confirm;
extern Key reader_keycode;
extern GMsgHeaderView HeaderView;
extern GMsgBodyView BodyView;

// Other

extern uint locpost, netpost, echopost;

extern char information[150];

extern Echo* echoin;
extern Echo* echoout;

extern char m_title[];
extern int m_titlepos;
extern int m_titleattr;

extern char* tconv;

extern gcmdkey* AreaKey;
extern int      AreaKeys;
extern gcmdkey* EditKey;
extern int      EditKeys;
extern gcmdkey* FileKey;
extern int      FileKeys;
extern gcmdkey* ListKey;
extern int      ListKeys;
extern gcmdkey* NodeKey;
extern int      NodeKeys;
extern gcmdkey* ReadKey;
extern int      ReadKeys;

extern int inforow;

extern char goldmark;

extern gstring startecho;

extern int fieldupd;

extern int CurrArea;
extern int OrigArea;

extern int nextarea;

extern char gversion[];

extern int stamps;
extern gstamp* stamp;

extern int quiet;
extern int ignore;
extern int cfgerrors;
extern int veryverbose;
extern word* oldscreen;
extern int keysread;

extern int disablesound;

extern int _in_editor;
extern int _in_msglist;

extern void(*SIGINT_OldHandler)(void);

extern Path __FAR cmdlinecfg;
extern int  __FAR cmdlinedebughg;
extern int  __FAR cmdlineimportsoup;
extern int  __FAR cmdlineoldkeyw;

extern int pmscanning;

extern gcolor __FAR gold_color1[];
extern gcolor __FAR gold_color2[];
extern gcolor __FAR gold_mono1[];

extern Echo area_maybe;

extern int tplselected;

extern int __FAR blanked;

extern int startupscan_success;


//  ------------------------------------------------------------------
//  Global compile constants

extern char* __shortgpid__;    // Program name, short version
extern char* __gpid__;         // Program name, long version
extern char* __gver__;         // Program version
extern char* __grev__;         // Program revision
extern char* __date__;         // Date compiled
extern char* __time__;         // Time compiled
extern int __golded_major__;
extern int __golded_minor__;
extern int __golded_mipid__;
extern int __golded_rev__;
extern char __pid__[];        // Program ID (PID)


//  ------------------------------------------------------------------

