
//  ------------------------------------------------------------------
//  GoldED. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gegrps.h,v 1.1.1.1 1998/11/21 19:38:04 odinn Exp $
//  ------------------------------------------------------------------


#include <gfile.h>
#include <gftnadrs.h>
#include <gmsgattr.h>
#include <ggrpmgr.h>

#include "geplay.h"


//  ------------------------------------------------------------------

class golded_grp : public group_mgr_file {

protected:

  enum {
    GROUP_ADDRESS,
    GROUP_AKAMATCHING,
    GROUP_AREACOPYADDID,
    GROUP_AREACOPYDIRECT,
    GROUP_AREACOPYTO,
    GROUP_AREAFREQDIRECT,
    GROUP_AREAFREQTO,
    GROUP_AREAREPLYDIRECT,
    GROUP_AREAREPLYTO,
    GROUP_ATTRIBUTES,
    GROUP_CTRLINFO,
    GROUP_EDITHARDTERM,
    GROUP_EDITMIXCASE,
    GROUP_EDITREPLYRE,
    GROUP_FOLLOWUPTO,
    GROUP_FORCETEMPLATE,
    GROUP_GIF,
    GROUP_INPUTFILE,
    GROUP_INTERNETADDRESS,
    GROUP_INTERNETGATE,
    GROUP_INTERNETMSGID,
    GROUP_INTERNETRFCBODY,
    GROUP_LOADLANGUAGE,
    GROUP_MOOD,
    GROUP_MSGLISTDATE,
    GROUP_MSGLISTFAST,
    GROUP_MSGLISTFIRST,
    GROUP_MSGLISTHEADER,
    GROUP_MSGLISTWIDESUBJ,
    GROUP_NETNAME,
    GROUP_NEWSGROUPS,
    GROUP_ORGANIZATION,
    GROUP_ORIGIN,
    GROUP_OUTPUTFILE,
    GROUP_PLAY,
    GROUP_QUOTEBUFFILE,
    GROUP_QUOTECHARS,
    GROUP_QUOTESTRING,
    GROUP_QUOTEWRAPHARD,
    GROUP_REPLYTO,
    GROUP_SEARCHFOR,
    GROUP_SENDER,
    GROUP_SIGNATURE,
    GROUP_TAGLINE,
    GROUP_TAGLINECHAR,
    GROUP_TAGLINEFILE,
    GROUP_TAGLINESUPPORT,
    GROUP_TEARLINE,
    GROUP_TEMPLATE,
    GROUP_TEMPLATEMATCH,
    GROUP_TWITMODE,
    GROUP_USEFWD,
    GROUP_USERNAME,
    GROUP_VIEWHIDDEN,
    GROUP_VIEWKLUDGE,
    GROUP_VIEWQUOTE,
    GROUP_WHOTO,
    GROUP_XLATEXPORT,
    GROUP_XLATIMPORT,

    GROUP_MAX
  };

public:

  golded_grp() { set_types(GROUP_MAX); }
  ~golded_grp() { }

  void add_address(const gftnaddrs& a)       { add_item(GROUP_ADDRESS,         fp->ftell()); *fp << a; }
  void add_akamatching(bool a)               { add_item(GROUP_AKAMATCHING,     fp->ftell()); *fp << a; }
  void add_areacopyaddid(bool a)             { add_item(GROUP_AREACOPYADDID,   fp->ftell()); *fp << a; }
  void add_areacopydirect(bool a)            { add_item(GROUP_AREACOPYDIRECT,  fp->ftell()); *fp << a; }
  void add_areacopyto(const gstring& a)      { add_item(GROUP_AREACOPYTO,      fp->ftell()); *fp << a; }
  void add_areafreqdirect(bool a)            { add_item(GROUP_AREAFREQDIRECT,  fp->ftell()); *fp << a; }
  void add_areafreqto(const gstring& a)      { add_item(GROUP_AREAFREQTO,      fp->ftell()); *fp << a; }
  void add_areareplydirect(bool a)           { add_item(GROUP_AREAREPLYDIRECT, fp->ftell()); *fp << a; }
  void add_areareplyto(const gstring& a)     { add_item(GROUP_AREAREPLYTO,     fp->ftell()); *fp << a; }
  void add_attr(const ftn_attr& a)           { add_item(GROUP_ATTRIBUTES,      fp->ftell()); *fp << a; }
  void add_ctrlinfo(int a)                   { add_item(GROUP_CTRLINFO,        fp->ftell()); *fp << a; }
  void add_edithardterm(bool a)              { add_item(GROUP_EDITHARDTERM,    fp->ftell()); *fp << a; }
  void add_editmixcase(bool a)               { add_item(GROUP_EDITMIXCASE,     fp->ftell()); *fp << a; }
  void add_editreplyre(int a)                { add_item(GROUP_EDITREPLYRE,     fp->ftell()); *fp << a; }
  void add_followupto(const gstring& a)      { add_item(GROUP_FOLLOWUPTO,      fp->ftell()); *fp << a; }
  void add_forcetemplate(bool a)             { add_item(GROUP_FORCETEMPLATE,   fp->ftell()); *fp << a; }
  void add_gif(const gstring& a)             { add_item(GROUP_GIF,             fp->ftell()); *fp << a; }
  void add_inputfile(const gstring& a)       { add_item(GROUP_INPUTFILE,       fp->ftell()); *fp << a; }
  void add_internetaddress(const gstring& a) { add_item(GROUP_INTERNETADDRESS, fp->ftell()); *fp << a; }
  void add_internetgate(const gftnnode& a)   { add_item(GROUP_INTERNETGATE,    fp->ftell()); *fp << a; }
  void add_internetmsgid(bool a)             { add_item(GROUP_INTERNETMSGID,   fp->ftell()); *fp << a; }
  void add_internetrfcbody(bool a)           { add_item(GROUP_INTERNETRFCBODY, fp->ftell()); *fp << a; }
  void add_loadlanguage(const gstring& a)    { add_item(GROUP_LOADLANGUAGE,    fp->ftell()); *fp << a; }
  void add_mood(const gstring& a)            { add_item(GROUP_MOOD,            fp->ftell()); *fp << a; }
  void add_msglistdate(int a)                { add_item(GROUP_MSGLISTDATE,     fp->ftell()); *fp << a; }
  void add_msglistfast(bool a)               { add_item(GROUP_MSGLISTFAST,     fp->ftell()); *fp << a; }
  void add_msglistfirst(bool a)              { add_item(GROUP_MSGLISTFIRST,    fp->ftell()); *fp << a; }
  void add_msglistheader(bool a)             { add_item(GROUP_MSGLISTHEADER,   fp->ftell()); *fp << a; }
  void add_msglistwidesubj(bool a)           { add_item(GROUP_MSGLISTWIDESUBJ, fp->ftell()); *fp << a; }
  void add_netname(const gstring& a)         { add_item(GROUP_NETNAME,         fp->ftell()); *fp << a; }
  void add_newsgroups(const gstring& a)      { add_item(GROUP_NEWSGROUPS,      fp->ftell()); *fp << a; }
  void add_organization(const gstring& a)    { add_item(GROUP_ORGANIZATION,    fp->ftell()); *fp << a; }
  void add_origin(const gstring& a)          { add_item(GROUP_ORIGIN,          fp->ftell()); *fp << a; }
  void add_outputfile(const gstring& a)      { add_item(GROUP_OUTPUTFILE,      fp->ftell()); *fp << a; }
  void add_play(const gplay& a)              { add_item(GROUP_PLAY,            fp->ftell()); *fp << a; }
  void add_quotebuffile(const gstring& a)    { add_item(GROUP_QUOTEBUFFILE,    fp->ftell()); *fp << a; }
  void add_quotechars(const gstring& a)      { add_item(GROUP_QUOTECHARS,      fp->ftell()); *fp << a; }
  void add_quotestring(const gstring& a)     { add_item(GROUP_QUOTESTRING,     fp->ftell()); *fp << a; }
  void add_quotewraphard(bool a)             { add_item(GROUP_QUOTEWRAPHARD,   fp->ftell()); *fp << a; }
  void add_replyto(const gstring& a)         { add_item(GROUP_REPLYTO,         fp->ftell()); *fp << a; }
  void add_searchfor(const gstring& a)       { add_item(GROUP_SEARCHFOR,       fp->ftell()); *fp << a; }
  void add_sender(const gstring& a)          { add_item(GROUP_SENDER,          fp->ftell()); *fp << a; }
  void add_signature(const gstring& a)       { add_item(GROUP_SIGNATURE,       fp->ftell()); *fp << a; }
  void add_tagline(const gstring& a)         { add_item(GROUP_TAGLINE,         fp->ftell()); *fp << a; }
  void add_taglinechar(char a)               { add_item(GROUP_TAGLINECHAR,     fp->ftell()); *fp << a; }
  void add_taglinefile(const gstring& a)     { add_item(GROUP_TAGLINEFILE,     fp->ftell()); *fp << a; }
  void add_taglinesupport(bool a)            { add_item(GROUP_TAGLINESUPPORT,  fp->ftell()); *fp << a; }
  void add_tearline(const gstring& a)        { add_item(GROUP_TEARLINE,        fp->ftell()); *fp << a; }
  void add_templatematch(bool a)             { add_item(GROUP_TEMPLATE,        fp->ftell()); *fp << a; }
  void add_tpl(const gstring& a)             { add_item(GROUP_TEMPLATEMATCH,   fp->ftell()); *fp << a; }
  void add_twitmode(int a)                   { add_item(GROUP_TWITMODE,        fp->ftell()); *fp << a; }
  void add_usefwd(bool a)                    { add_item(GROUP_USEFWD,          fp->ftell()); *fp << a; }
  void add_username(const gftnnode& a)       { add_item(GROUP_USERNAME,        fp->ftell()); *fp << a; }
  void add_viewhidden(bool a)                { add_item(GROUP_VIEWHIDDEN,      fp->ftell()); *fp << a; }
  void add_viewkludge(bool a)                { add_item(GROUP_VIEWKLUDGE,      fp->ftell()); *fp << a; }
  void add_viewquote(bool a)                 { add_item(GROUP_VIEWQUOTE,       fp->ftell()); *fp << a; }
  void add_whoto(const gstring& a)           { add_item(GROUP_WHOTO,           fp->ftell()); *fp << a; }
  void add_xlatexport(const gstring& a)      { add_item(GROUP_XLATEXPORT,      fp->ftell()); *fp << a; }
  void add_xlatimport(const gstring& a)      { add_item(GROUP_XLATIMPORT,      fp->ftell()); *fp << a; }

  int count_address() const         { return groups[current][GROUP_ADDRESS].size(); }
  int count_akamatching() const     { return groups[current][GROUP_AKAMATCHING].size(); }
  int count_areacopyaddid() const   { return groups[current][GROUP_AREACOPYADDID].size(); }
  int count_areacopydirect() const  { return groups[current][GROUP_AREACOPYDIRECT].size(); }
  int count_areacopyto() const      { return groups[current][GROUP_AREACOPYTO].size(); }
  int count_areafreqdirect() const  { return groups[current][GROUP_AREAFREQDIRECT].size(); }
  int count_areafreqto() const      { return groups[current][GROUP_AREAFREQTO].size(); }
  int count_areareplydirect() const { return groups[current][GROUP_AREAREPLYDIRECT].size(); }
  int count_areareplyto() const     { return groups[current][GROUP_AREAREPLYTO].size(); }
  int count_attributes() const      { return groups[current][GROUP_ATTRIBUTES].size(); }
  int count_ctrlinfo() const        { return groups[current][GROUP_CTRLINFO].size(); }
  int count_edithardterm() const    { return groups[current][GROUP_EDITHARDTERM].size(); }
  int count_editmixcase() const     { return groups[current][GROUP_EDITMIXCASE].size(); }
  int count_editreplyre() const     { return groups[current][GROUP_EDITREPLYRE].size(); }
  int count_followupto() const      { return groups[current][GROUP_FOLLOWUPTO].size(); }
  int count_forcetemplate() const   { return groups[current][GROUP_FORCETEMPLATE].size(); }
  int count_gif() const             { return groups[current][GROUP_GIF].size();}
  int count_inputfile() const       { return groups[current][GROUP_INPUTFILE].size(); }
  int count_internetaddress() const { return groups[current][GROUP_INTERNETADDRESS].size(); }
  int count_internetgate() const    { return groups[current][GROUP_INTERNETGATE].size(); }
  int count_internetmsgid() const   { return groups[current][GROUP_INTERNETMSGID].size(); }
  int count_internetrfcbody() const { return groups[current][GROUP_INTERNETRFCBODY].size(); }
  int count_loadlanguage() const    { return groups[current][GROUP_LOADLANGUAGE].size(); }
  int count_mood() const            { return groups[current][GROUP_MOOD].size();}
  int count_msglistdate() const     { return groups[current][GROUP_MSGLISTDATE].size(); }
  int count_msglistfast() const     { return groups[current][GROUP_MSGLISTFAST].size(); }
  int count_msglistfirst() const    { return groups[current][GROUP_MSGLISTFIRST].size(); }
  int count_msglistheader() const   { return groups[current][GROUP_MSGLISTHEADER].size(); }
  int count_msglistwidesubj() const { return groups[current][GROUP_MSGLISTWIDESUBJ].size(); }
  int count_netname() const         { return groups[current][GROUP_NETNAME].size(); }
  int count_newsgroups() const      { return groups[current][GROUP_NEWSGROUPS].size(); }
  int count_organization() const    { return groups[current][GROUP_ORGANIZATION].size(); }
  int count_origin() const          { return groups[current][GROUP_ORIGIN].size();}
  int count_outputfile() const      { return groups[current][GROUP_OUTPUTFILE].size(); }
  int count_play() const            { return groups[current][GROUP_PLAY].size();}
  int count_quotebuffile() const    { return groups[current][GROUP_QUOTEBUFFILE].size(); }
  int count_quotechars() const      { return groups[current][GROUP_QUOTECHARS].size(); }
  int count_quotestring() const     { return groups[current][GROUP_QUOTESTRING].size(); }
  int count_quotewraphard() const   { return groups[current][GROUP_QUOTEWRAPHARD].size(); }
  int count_replyto() const         { return groups[current][GROUP_REPLYTO].size(); }
  int count_searchfor() const       { return groups[current][GROUP_SEARCHFOR].size(); }
  int count_sender() const          { return groups[current][GROUP_SENDER].size();}
  int count_signature() const       { return groups[current][GROUP_SIGNATURE].size(); }
  int count_tagline() const         { return groups[current][GROUP_TAGLINE].size(); }
  int count_taglinechar() const     { return groups[current][GROUP_TAGLINECHAR].size(); }
  int count_taglinefile() const     { return groups[current][GROUP_TAGLINEFILE].size(); }
  int count_taglinesupport() const  { return groups[current][GROUP_TAGLINESUPPORT].size(); }
  int count_tearline() const        { return groups[current][GROUP_TEARLINE].size(); }
  int count_template() const        { return groups[current][GROUP_TEMPLATE].size(); }
  int count_templatematch() const   { return groups[current][GROUP_TEMPLATEMATCH].size(); }
  int count_twitmode() const        { return groups[current][GROUP_TWITMODE].size(); }
  int count_usefwd() const          { return groups[current][GROUP_USEFWD].size();}
  int count_username() const        { return groups[current][GROUP_USERNAME].size(); }
  int count_viewhidden() const      { return groups[current][GROUP_VIEWHIDDEN].size(); }
  int count_viewkludge() const      { return groups[current][GROUP_VIEWKLUDGE].size(); }
  int count_viewquote() const       { return groups[current][GROUP_VIEWQUOTE].size(); }
  int count_whoto() const           { return groups[current][GROUP_WHOTO].size();}
  int count_xlatexport() const      { return groups[current][GROUP_XLATEXPORT].size(); }
  int count_xlatimport() const      { return groups[current][GROUP_XLATIMPORT].size(); }

  bool get_address(gftnaddrs& a, int n=-1)       { if(get_item(GROUP_ADDRESS,         n)) { *fp >> a; return true; } return false; }
  bool get_akamatching(bool& a, int n=-1)        { if(get_item(GROUP_AKAMATCHING,     n)) { *fp >> a; return true; } return false; }
  bool get_areacopyaddid(bool& a, int n=-1)      { if(get_item(GROUP_AREACOPYADDID,   n)) { *fp >> a; return true; } return false; }
  bool get_areacopydirect(bool& a, int n=-1)     { if(get_item(GROUP_AREACOPYDIRECT,  n)) { *fp >> a; return true; } return false; }
  bool get_areacopyto(gstring& a, int n=-1)      { if(get_item(GROUP_AREACOPYTO,      n)) { *fp >> a; return true; } return false; }
  bool get_areafreqdirect(bool& a, int n=-1)     { if(get_item(GROUP_AREAFREQDIRECT,  n)) { *fp >> a; return true; } return false; }
  bool get_areafreqto(gstring& a, int n=-1)      { if(get_item(GROUP_AREAFREQTO,      n)) { *fp >> a; return true; } return false; }
  bool get_areareplydirect(bool& a, int n=-1)    { if(get_item(GROUP_AREAREPLYDIRECT, n)) { *fp >> a; return true; } return false; }
  bool get_areareplyto(gstring& a, int n=-1)     { if(get_item(GROUP_AREAREPLYTO,     n)) { *fp >> a; return true; } return false; }
  bool get_attr(ftn_attr& a, int n=-1)           { if(get_item(GROUP_ATTRIBUTES,      n)) { *fp >> a; return true; } return false; }
  bool get_ctrlinfo(int& a, int n=-1)            { if(get_item(GROUP_CTRLINFO,        n)) { *fp >> a; return true; } return false; }
  bool get_edithardterm(bool& a, int n=-1)       { if(get_item(GROUP_EDITHARDTERM,    n)) { *fp >> a; return true; } return false; }
  bool get_editmixcase(bool& a, int n=-1)        { if(get_item(GROUP_EDITMIXCASE,     n)) { *fp >> a; return true; } return false; }
  bool get_editreplyre(int& a, int n=-1)         { if(get_item(GROUP_EDITREPLYRE,     n)) { *fp >> a; return true; } return false; }
  bool get_followupto(gstring& a, int n=-1)      { if(get_item(GROUP_FOLLOWUPTO,      n)) { *fp >> a; return true; } return false; }
  bool get_forcetemplate(bool& a, int n=-1)      { if(get_item(GROUP_FORCETEMPLATE,   n)) { *fp >> a; return true; } return false; }
  bool get_gif(gstring& a, int n=-1)             { if(get_item(GROUP_GIF,             n)) { *fp >> a; return true; } return false; }
  bool get_inputfile(gstring& a, int n=-1)       { if(get_item(GROUP_INPUTFILE,       n)) { *fp >> a; return true; } return false; }
  bool get_internetaddress(gstring& a, int n=-1) { if(get_item(GROUP_INTERNETADDRESS, n)) { *fp >> a; return true; } return false; }
  bool get_internetgate(gftnnode& a, int n=-1)   { if(get_item(GROUP_INTERNETGATE,    n)) { *fp >> a; return true; } return false; }
  bool get_internetmsgid(bool& a, int n=-1)      { if(get_item(GROUP_INTERNETMSGID,   n)) { *fp >> a; return true; } return false; }
  bool get_internetrfcbody(bool& a, int n=-1)    { if(get_item(GROUP_INTERNETRFCBODY, n)) { *fp >> a; return true; } return false; }
  bool get_loadlanguage(gstring& a, int n=-1)    { if(get_item(GROUP_LOADLANGUAGE,    n)) { *fp >> a; return true; } return false; }
  bool get_mood(gstring& a, int n=-1)            { if(get_item(GROUP_MOOD,            n)) { *fp >> a; return true; } return false; }
  bool get_msglistdate(int& a, int n=-1)         { if(get_item(GROUP_MSGLISTDATE,     n)) { *fp >> a; return true; } return false; }
  bool get_msglistfast(bool& a, int n=-1)        { if(get_item(GROUP_MSGLISTFAST,     n)) { *fp >> a; return true; } return false; }
  bool get_msglistfirst(bool& a, int n=-1)       { if(get_item(GROUP_MSGLISTFIRST,    n)) { *fp >> a; return true; } return false; }
  bool get_msglistheader(bool& a, int n=-1)      { if(get_item(GROUP_MSGLISTHEADER,   n)) { *fp >> a; return true; } return false; }
  bool get_msglistwidesubj(bool& a, int n=-1)    { if(get_item(GROUP_MSGLISTWIDESUBJ, n)) { *fp >> a; return true; } return false; }
  bool get_netname(gstring& a, int n=-1)         { if(get_item(GROUP_NETNAME,         n)) { *fp >> a; return true; } return false; }
  bool get_newsgroups(gstring& a, int n=-1)      { if(get_item(GROUP_NEWSGROUPS,      n)) { *fp >> a; return true; } return false; }
  bool get_organization(gstring& a, int n=-1)    { if(get_item(GROUP_ORGANIZATION,    n)) { *fp >> a; return true; } return false; }
  bool get_origin(gstring& a, int n=-1)          { if(get_item(GROUP_ORIGIN,          n)) { *fp >> a; return true; } return false; }
  bool get_outputfile(gstring& a, int n=-1)      { if(get_item(GROUP_OUTPUTFILE,      n)) { *fp >> a; return true; } return false; }
  bool get_play(gplay& a, int n=-1)              { if(get_item(GROUP_PLAY,            n)) { *fp >> a; return true; } return false; }
  bool get_quotebuffile(gstring& a, int n=-1)    { if(get_item(GROUP_QUOTEBUFFILE,    n)) { *fp >> a; return true; } return false; }
  bool get_quotechars(gstring& a, int n=-1)      { if(get_item(GROUP_QUOTECHARS,      n)) { *fp >> a; return true; } return false; }
  bool get_quotestring(gstring& a, int n=-1)     { if(get_item(GROUP_QUOTESTRING,     n)) { *fp >> a; return true; } return false; }
  bool get_quotewraphard(bool& a, int n=-1)      { if(get_item(GROUP_QUOTEWRAPHARD,   n)) { *fp >> a; return true; } return false; }
  bool get_replyto(gstring& a, int n=-1)         { if(get_item(GROUP_REPLYTO,         n)) { *fp >> a; return true; } return false; }
  bool get_searchfor(gstring& a, int n=-1)       { if(get_item(GROUP_SEARCHFOR,       n)) { *fp >> a; return true; } return false; }
  bool get_sender(gstring& a, int n=-1)          { if(get_item(GROUP_SENDER,          n)) { *fp >> a; return true; } return false; }
  bool get_signature(gstring& a, int n=-1)       { if(get_item(GROUP_SIGNATURE,       n)) { *fp >> a; return true; } return false; }
  bool get_tagline(gstring& a, int n=-1)         { if(get_item(GROUP_TAGLINE,         n)) { *fp >> a; return true; } return false; }
  bool get_taglinechar(char a, int n=-1)         { if(get_item(GROUP_TAGLINECHAR,     n)) { *fp >> a; return true; } return false; }
  bool get_taglinefile(gstring& a, int n=-1)     { if(get_item(GROUP_TAGLINEFILE,     n)) { *fp >> a; return true; } return false; }
  bool get_taglinesupport(bool& a, int n=-1)     { if(get_item(GROUP_TAGLINESUPPORT,  n)) { *fp >> a; return true; } return false; }
  bool get_tearline(gstring& a, int n=-1)        { if(get_item(GROUP_TEARLINE,        n)) { *fp >> a; return true; } return false; }
  bool get_templatematch(bool& a, int n=-1)      { if(get_item(GROUP_TEMPLATE,        n)) { *fp >> a; return true; } return false; }
  bool get_tpl(gstring& a, int n=-1)             { if(get_item(GROUP_TEMPLATEMATCH,   n)) { *fp >> a; return true; } return false; }
  bool get_twitmode(int& a, int n=-1)            { if(get_item(GROUP_TWITMODE,        n)) { *fp >> a; return true; } return false; }
  bool get_usefwd(bool& a, int n=-1)             { if(get_item(GROUP_USEFWD,          n)) { *fp >> a; return true; } return false; }
  bool get_username(gftnnode& a, int n=-1)       { if(get_item(GROUP_USERNAME,        n)) { *fp >> a; return true; } return false; }
  bool get_viewhidden(bool& a, int n=-1)         { if(get_item(GROUP_VIEWHIDDEN,      n)) { *fp >> a; return true; } return false; }
  bool get_viewkludge(bool& a, int n=-1)         { if(get_item(GROUP_VIEWKLUDGE,      n)) { *fp >> a; return true; } return false; }
  bool get_viewquote(bool& a, int n=-1)          { if(get_item(GROUP_VIEWQUOTE,       n)) { *fp >> a; return true; } return false; }
  bool get_whoto(gstring& a, int n=-1)           { if(get_item(GROUP_WHOTO,           n)) { *fp >> a; return true; } return false; }
  bool get_xlatexport(gstring& a, int n=-1)      { if(get_item(GROUP_XLATEXPORT,      n)) { *fp >> a; return true; } return false; }
  bool get_xlatimport(gstring& a, int n=-1)      { if(get_item(GROUP_XLATIMPORT,      n)) { *fp >> a; return true; } return false; }

};


//  ------------------------------------------------------------------

