
//  ------------------------------------------------------------------
//  GoldED. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gekeys.cpp,v 1.1.1.1 1998/11/21 19:38:04 odinn Exp $
//  ------------------------------------------------------------------
//  Keyboard configuration compile.
//  ------------------------------------------------------------------


#include "golded.h"

#ifdef __BORLANDC__
#pragma hdrstop
//#pragma option -Od
#endif

#include "gckeys.h"


//  ------------------------------------------------------------------

gkbdcmd __FAR DefaultKeyset[] = {

  { K_AA      , KK_AreaAbort            , KT_A },
  { K_AX      , KK_AreaAskExit          , KT_A },
  { K_Esc     , KK_AreaAskExit          , KT_A },
  { K_AF10    , KK_AreaAskExit          , KT_A },
  { K_AB      , KK_AreaBoardnos         , KT_A },
  { K_AO      , KK_AreaDosShell         , KT_A },
  { K_AH      , KK_AreaHeat             , KT_A },
  { K_AJ      , KK_AreaJump             , KT_A },
  { K_CLeft   , KK_AreaJump             , KT_A },
  { K_CRight  , KK_AreaJump             , KT_A },
  { K_Tab     , KK_AreaJumpNextMatch    , KT_A },
  { K_CEnter  , KK_AreaJumpNextMatch    , KT_A },
  { K_CQ      , KK_AreaQuitNow          , KT_A },
  { K_AS      , KK_AreaScan             , KT_A },
  { K_AP      , KK_AreaScanPM           , KT_A },
  { K_Enter   , KK_AreaSelect           , KT_A },
  { K_Right   , KK_AreaSelect           , KT_A },
  { K_AT      , KK_AreaToggle           , KT_A },
  { K_Ins     , KK_AreaToggle           , KT_A },
  { K_CZ      , KK_AreaTouchNetscan     , KT_A },
  { K_AW      , KK_AreaWriteGoldlast    , KT_A },
  { K_AZ      , KK_AreaZap              , KT_A },

  { K_Esc     , KK_EditAbort            , KT_E },
  { K_AA      , KK_EditAnchor           , KT_E },
  { K_AX      , KK_EditAskExit          , KT_E },
  { K_AF4     , KK_EditAskExit          , KT_E },
  { K_AF5     , KK_EditClearDeleteBuf   , KT_E },
  { K_AF6     , KK_EditClearPasteBuf    , KT_E },
  { K_AC      , KK_EditCopy             , KT_E },
  { Key_C_Min , KK_EditCopyAboveChar    , KT_E },
  { K_AM      , KK_EditCut              , KT_E },
  { K_Del     , KK_EditDelChar          , KT_E },
  { K_AK      , KK_EditDeleteEOL        , KT_E },
  { K_AY      , KK_EditDeleteEOL        , KT_E },
  { K_BSpace  , KK_EditDelLeft          , KT_E },
  { K_AD      , KK_EditDelLine          , KT_E },
  { K_CY      , KK_EditDelLine          , KT_E },
  { K_CBSpace , KK_EditDelLtWord        , KT_E },
  { K_CF5     , KK_EditDelLtWord        , KT_E },
  { K_CT      , KK_EditDelRtWord        , KT_E },
  { K_CF6     , KK_EditDelRtWord        , KT_E },
  { K_AO      , KK_EditDosShell         , KT_E },
  { K_F4      , KK_EditDupLine          , KT_E },
  { K_AW      , KK_EditExportText       , KT_E },
  { K_Home    , KK_EditGoBegLine        , KT_E },
  { K_CPgDn   , KK_EditGoBotLine        , KT_E },
  { K_CEnd    , KK_EditGoBotMsg         , KT_E },
  { K_Down    , KK_EditGoDown           , KT_E },
  { K_ADown   , KK_EditGoDown           , KT_E },
  { K_CDown   , KK_EditGoDown           , KT_E },
  { K_End     , KK_EditGoEOL            , KT_E },
  { K_Left    , KK_EditGoLeft           , KT_E },
  { K_ALeft   , KK_EditGoLeft           , KT_E },
  { K_PgDn    , KK_EditGoPgDn           , KT_E },
  { K_PgUp    , KK_EditGoPgUp           , KT_E },
  { K_Right   , KK_EditGoRight          , KT_E },
  { K_ARight  , KK_EditGoRight          , KT_E },
  { K_CPgUp   , KK_EditGoTopLine        , KT_E },
  { K_CHome   , KK_EditGoTopMsg         , KT_E },
  { K_Up      , KK_EditGoUp             , KT_E },
  { K_AUp     , KK_EditGoUp             , KT_E },
  { K_CUp     , KK_EditGoUp             , KT_E },
  { K_CLeft   , KK_EditGoWordLeft       , KT_E },
  { K_CRight  , KK_EditGoWordRight      , KT_E },
  { K_AH      , KK_EditHeader           , KT_E },
  { K_AQ      , KK_EditImportQuotebuf   , KT_E },
  { K_AI      , KK_EditImportText       , KT_E },
  { K_AR      , KK_EditImportText       , KT_E },
  { K_F3      , KK_EditImportText       , KT_E },
  { K_F8      , KK_EditLoadFile         , KT_E },
  { K_AL      , KK_EditLookupCursor     , KT_E },
  { K_SF10    , KK_EditLookupDest       , KT_E },
  { K_F10     , KK_EditLookupOrig       , KT_E },
  { K_Enter   , KK_EditNewline          , KT_E },
  { K_AP      , KK_EditPaste            , KT_E },
  { K_CQ      , KK_EditQuitNow          , KT_E },
  { K_AB      , KK_EditReflow           , KT_E },
  { K_F7      , KK_EditSaveFile         , KT_E },
  { K_AS      , KK_EditSaveMsg          , KT_E },
  { K_CZ      , KK_EditSaveMsg          , KT_E },
  { K_F2      , KK_EditSaveMsg          , KT_E },
  { K_F9      , KK_EditSpellCheck       , KT_E },
  { K_Tab     , KK_EditTab              , KT_E },
  { K_A3      , KK_EditToggleCase       , KT_E },
  { K_Ins     , KK_EditToggleInsert     , KT_E },
  { K_A2      , KK_EditToLower          , KT_E },
  { K_A1      , KK_EditToUpper          , KT_E },
  { K_CU      , KK_EditUnDelete         , KT_E },
  { K_AZ      , KK_EditZapQuoteBelow    , KT_E },

  { K_Esc     , KK_FileAbort            , KT_F },
  { K_AX      , KK_FileAskExit          , KT_F },
  { K_AF4     , KK_FileAskExit          , KT_F },
  { K_AO      , KK_FileDosShell         , KT_F },
  { K_Ins     , KK_FileMark             , KT_F },
  { K_CEnter  , KK_FileMarkAll          , KT_F },
  { K_CHome   , KK_FileMarkAll          , KT_F },
  { K_CQ      , KK_FileQuitNow          , KT_F },
  { K_Enter   , KK_FileSelect           , KT_F },
  { K_Space   , KK_FileToggleMark       , KT_F },
  { K_Del     , KK_FileUnMark           , KT_F },
  { K_CEnd    , KK_FileUnMarkAll        , KT_F },

  { K_Esc     , KK_ListAbort            , KT_M },
  { K_AX      , KK_ListAskExit          , KT_M },
  { K_AF4     , KK_ListAskExit          , KT_M },
  { K_AO      , KK_ListDosShell         , KT_M },
  { K_STab    , KK_ListGotoBookMark     , KT_M },
  { K_BSpace  , KK_ListGotoBookMark     , KT_M },
  { K_S       , KK_ListMarkingOptions   , KT_M },
  { K_AS      , KK_ListMarkingOptions   , KT_M },
  { K_AF9     , KK_ListMarkingOptions   , KT_R },
  { K_CQ      , KK_ListQuitNow          , KT_M },
  { K_Enter   , KK_ListSelect           , KT_M },
  { K_Tab     , KK_ListToggleBookMark   , KT_M },
  { K_CD      , KK_ListToggleDate       , KT_M },
  { K_Space   , KK_ListToggleMark       , KT_M },
  { K_CB      , KK_ListToggleWideSubj   , KT_M },

  { K_Esc     , KK_NodeAbort            , KT_N },
  { K_AX      , KK_NodeAskExit          , KT_N },
  { K_AF4     , KK_NodeAskExit          , KT_N },
  { K_AO      , KK_NodeDosShell         , KT_N },
  { K_CQ      , KK_NodeQuitNow          , KT_N },
  { K_Enter   , KK_NodeSelect           , KT_N },

  { K_AF4     , KK_ReadAskExit          , KT_R },
  { K_AX      , KK_ReadAskExit          , KT_R },
  { K_X       , KK_ReadAskExit          , KT_R },
  { K_CA      , KK_ReadChangeAka        , KT_R },
  { K_CS      , KK_ReadChangeAttrs      , KT_R },
  { K_CM      , KK_ReadChangeMood       , KT_R },
  { K_AC      , KK_ReadChangeMsg        , KT_R },
  { K_C       , KK_ReadChangeMsg        , KT_R },
  { K_F2      , KK_ReadChangeMsg        , KT_R },
  { K_CO      , KK_ReadChangeOrigin     , KT_R },
  { K_CI      , KK_ReadChangeTagline    , KT_R },
  { K_CT      , KK_ReadChangeTemplate   , KT_R },
  { K_CU      , KK_ReadChangeUsername   , KT_R },
  { K_CJ      , KK_ReadChangeXlatImport , KT_R },
  { K_AG      , KK_ReadCommentMsg       , KT_R },
  { K_G       , KK_ReadCommentMsg       , KT_R },
  { K_AM      , KK_ReadCopyMoveForward  , KT_R },
  { K_M       , KK_ReadCopyMoveForward  , KT_R },
  { K_SF8     , KK_ReadCopyMoveForward  , KT_R },
  { K_AD      , KK_ReadDeleteMsg        , KT_R },
  { K_D       , KK_ReadDeleteMsg        , KT_R },
  { K_Del     , KK_ReadDeleteMsg        , KT_R },
  { K_AO      , KK_ReadDosShell         , KT_R },
  { K_CF10    , KK_ReadDosShell         , KT_R },
  { K_O       , KK_ReadDosShell         , KT_R },
  { K_CR      , KK_ReadFidoRenumber     , KT_R },
  { K_SF4     , KK_ReadFidoRenumber     , KT_R },
  { K_CF      , KK_ReadFileRequest      , KT_R },
  { K_AF      , KK_ReadFindAll          , KT_R },
  { K_F       , KK_ReadFindAll          , KT_R },
  { K_SF6     , KK_ReadFindAll          , KT_R },
  { K_AZ      , KK_ReadFindHeader       , KT_R },
  { K_F6      , KK_ReadFindHeader       , KT_R },
  { K_Z       , KK_ReadFindHeader       , KT_R },
  { K_BSpace  , KK_ReadGotoBookMark     , KT_R },
  { K_STab    , KK_ReadGotoBookMark     , KT_R },
  { K_CHome   , KK_ReadGotoFirstMsg     , KT_R },
  { K_Lesser  , KK_ReadGotoFirstMsg     , KT_R },
  { K_CEnd    , KK_ReadGotoLastMsg      , KT_R },
  { K_Greater , KK_ReadGotoLastMsg      , KT_R },
  { K_CG      , KK_ReadGotoMsgno        , KT_R },
  { K_CN      , KK_ReadGotoNextArea     , KT_R },
  { K_Right   , KK_ReadGotoNextMsg      , KT_R },
  { K_CP      , KK_ReadGotoPrevArea     , KT_R },
  { K_Left    , KK_ReadGotoPrevMsg      , KT_R },
  { K_ARight  , KK_ReadGotoReplies      , KT_R },
  { K_CRight  , KK_ReadGotoReplies      , KT_R },
  { K_Plus    , KK_ReadGotoReplies      , KT_R },
  { K_Multi   , KK_ReadGotoReplyNext    , KT_R },
  { K_ALeft   , KK_ReadGotoReplyPrev    , KT_R },
  { K_CLeft   , KK_ReadGotoReplyPrev    , KT_R },
  { K_Minus   , KK_ReadGotoReplyPrev    , KT_R },
  { K_SF10    , KK_ReadLookupDest       , KT_R },
  { K_F10     , KK_ReadLookupOrig       , KT_R },
  { K_CL      , KK_ReadMakeUserlist     , KT_R },
  { K_AF9     , KK_ReadMarkingOptions   , KT_R },
  { K_AS      , KK_ReadMarkingOptions   , KT_R },
  { K_S       , KK_ReadMarkingOptions   , KT_R },
  { K_AL      , KK_ReadMessageList      , KT_R },
  { K_F9      , KK_ReadMessageList      , KT_R },
  { K_L       , KK_ReadMessageList      , KT_R },
  { K_AB      , KK_ReadMoveCommentMsg   , KT_R },
  { K_B       , KK_ReadMoveCommentMsg   , KT_R },
  { K_AN      , KK_ReadMoveQuoteMsg     , KT_R },
  { K_F5      , KK_ReadMoveQuoteMsg     , KT_R },
  { K_N       , KK_ReadMoveQuoteMsg     , KT_R },
  { K_Enter   , KK_ReadMsgContinue      , KT_R },
  { K_End     , KK_ReadMsgEnd           , KT_R },
  { K_Home    , KK_ReadMsgHome          , KT_R },
  { K_CDown   , KK_ReadMsgLineDown      , KT_R },
  { K_Down    , KK_ReadMsgLineDown      , KT_R },
  { K_CUp     , KK_ReadMsgLineUp        , KT_R },
  { K_Up      , KK_ReadMsgLineUp        , KT_R },
  { K_PgDn    , KK_ReadMsgPgDn          , KT_R },
  { K_PgUp    , KK_ReadMsgPgUp          , KT_R },
  { K_A       , KK_ReadNewArea          , KT_R },
  { K_AA      , KK_ReadNewArea          , KT_R },
  { K_CF1     , KK_ReadNewArea          , KT_R },
  { K_Esc     , KK_ReadNewArea          , KT_R },
  { K_AE      , KK_ReadNewMsg           , KT_R },
  { K_E       , KK_ReadNewMsg           , KT_R },
  { K_Ins     , KK_ReadNewMsg           , KT_R },
  { K_CQ      , KK_ReadQuitNow          , KT_R },
  { K_CW      , KK_ReadQuoteBuf         , KT_R },
  { K_AQ      , KK_ReadQuoteMsg         , KT_R },
  { K_F4      , KK_ReadQuoteMsg         , KT_R },
  { K_Q       , KK_ReadQuoteMsg         , KT_R },
  { K_AR      , KK_ReadReplyMsg         , KT_R },
  { K_F3      , KK_ReadReplyMsg         , KT_R },
  { K_R       , KK_ReadReplyMsg         , KT_R },
  { K_Tab     , KK_ReadToggleBookMark   , KT_R },
  { K_AI      , KK_ReadToggleHexdump    , KT_R },
  { K_CF9     , KK_ReadToggleHexdump    , KT_R },
  { K_I       , KK_ReadToggleHexdump    , KT_R },
  { K_AH      , KK_ReadToggleHidden     , KT_R },
  { K_CF7     , KK_ReadToggleHidden     , KT_R },
  { K_H       , KK_ReadToggleHidden     , KT_R },
  { K_AV      , KK_ReadToggleHiddKlud   , KT_R },
  { K_CF5     , KK_ReadToggleHiddKlud   , KT_R },
  { K_V       , KK_ReadToggleHiddKlud   , KT_R },
  { K_AK      , KK_ReadToggleKludge     , KT_R },
  { K_CF6     , KK_ReadToggleKludge     , KT_R },
  { K_K       , KK_ReadToggleKludge     , KT_R },
  { K_Space   , KK_ReadToggleMark       , KT_R },
  { K_AF10    , KK_ReadToggleMarkRead   , KT_R },
  { K_AJ      , KK_ReadToggleMarkRead   , KT_R },
  { K_J       , KK_ReadToggleMarkRead   , KT_R },
  { K_AP      , KK_ReadTogglePageBar    , KT_R },
  { K_CF8     , KK_ReadTogglePageBar    , KT_R },
  { K_P       , KK_ReadTogglePageBar    , KT_R },
  { K_CV      , KK_ReadToggleQuote      , KT_R },
  { K_AY      , KK_ReadToggleRealMsgno  , KT_R },
  { K_CF4     , KK_ReadToggleRealMsgno  , KT_R },
  { K_Y       , KK_ReadToggleRealMsgno  , KT_R },
  { K_AU      , KK_ReadToggleROT13      , KT_R },
  { K_CF3     , KK_ReadToggleROT13      , KT_R },
  { K_U       , KK_ReadToggleROT13      , KT_R },
  { K_AT      , KK_ReadToggleTwits      , KT_R },
  { K_T       , KK_ReadToggleTwits      , KT_R },
  { K_CZ      , KK_ReadTouchNetscan     , KT_R },
  { K_CX      , KK_ReadUUDecode         , KT_R },
  { K_AW      , KK_ReadWriteMsg         , KT_R },
  { K_F7      , KK_ReadWriteMsg         , KT_R },
  { K_W       , KK_ReadWriteMsg         , KT_R },

  { 0xFFFF    , 0xFFFF                  , 0xFF }
};


//  ------------------------------------------------------------------

gkey golded_kbd::switch_it(char cmd) {

  command = 0;
  switch(toupper(cmd)) {
    case 'A':  switch_area();  break;
    case 'E':  switch_edit();  break;
    case 'F':  switch_file();  break;
    case 'L':  switch_list();  break;
    case 'N':  switch_node();  break;
    case 'R':  switch_read();  break;
  }

  return command;
}


//  ------------------------------------------------------------------

void golded_kbd::add_to_macro(gkeymacro& macro, gkey cmd, int& pos) {

  if(pos < gkeymacro::max_commands)
    macro[pos++] = cmd;
}

//  ------------------------------------------------------------------

int golded_kbd::add_macro(gkeyset& set, gkeymacro& macro) {

  addit = false;

  int n = 0;
  char* ptr = macrostring;
  while(*ptr) {
    if(*ptr == '\"') {  // Start of literal string
      ptr++;
      while(*ptr != '\"') {
        char ch = *ptr++;
        add_to_macro(macro, (gkey)(ch | (scancode(ch) << 8)), n);
      }
      *ptr++ = NUL;
    }
    else {
      char* ptr2 = ptr;
      ptr = strskip_txt(ptr);
      *ptr++ = NUL;
      word crc = strCrc16(strupr(ptr2));
      key = gkeyname_to_keycode(crc);
      if(not key)
        key = switch_it(*ptr2);
      if(key)
        add_to_macro(macro, key, n);
      else
        return error_unknown_in_macro;
    }
    ptr = strskip_wht(ptr);
  }

  return success;
}


//  ------------------------------------------------------------------

void golded_kbd::add(gkeyset& set, gkey macrocmd) {

  if(addit) {
    if(command) {
      if(command == macrocmd) {
        gkeymacro k(keycode);
        error = add_macro(set, macrostring);
        return;
      }
      else {
        gkeycommand k(keycode, command);
        set.add_command(k);
        error = success;
        return;
      }
    }
    error = error_unknown_command;
  }
}


//  ------------------------------------------------------------------

void golded_kbd::switch_area() {

  switch(command_crc) {
    case CRC_AREAABORT:           command = KK_AreaAbort;             break;
    case CRC_AREAASKEXIT:         command = KK_AreaAskExit;           break;
    case CRC_AREABOARDNOS:        command = KK_AreaBoardnos;          break;
    case CRC_AREADOSSHELL:        command = KK_AreaDosShell;          break;
    case CRC_AREAHEAT:            command = KK_AreaHeat;              break;
    case CRC_AREAMAINMENU:        command = KK_AreaMainMenu;          break;
    case CRC_AREAGOTOFIRST:       command = KK_AreaGotoFirst;         break;
    case CRC_AREAGOTOLAST:        command = KK_AreaGotoLast;          break;
    case CRC_AREAGOTONEXT:        command = KK_AreaGotoNext;          break;
    case CRC_AREAGOTOPREV:        command = KK_AreaGotoPrev;          break;
    case CRC_AREAJUMP:            command = KK_AreaJump;              break;
    case CRC_AREAJUMPNEXTMATCH:   command = KK_AreaJumpNextMatch;     break;
    case CRC_AREAMACRO:           command = KK_AreaMacro;             break;
    case CRC_AREAMENU:            command = KK_AreaMenu;              break;
    case CRC_AREAQUITNOW:         command = KK_AreaQuitNow;           break;
    case CRC_AREASCAN:            command = KK_AreaScan;              break;
    case CRC_AREASCANPM:          command = KK_AreaScanPM;            break;
    case CRC_AREASELECT:          command = KK_AreaSelect;            break;
    case CRC_AREASOUNDKILL:       command = KK_AreaSoundkill;         break;
    case CRC_AREATOGGLE:          command = KK_AreaToggle;            break;
    case CRC_AREATOUCHNETSCAN:    command = KK_AreaTouchNetscan;      break;
    case CRC_AREAUNDEFINE:        command = KK_AreaUndefine;          break;
    case CRC_AREAWRITEGOLDLAST:   command = KK_AreaWriteGoldlast;     break;
    case CRC_AREAZAP:             command = KK_AreaZap;               break;
  }

  add(area, KK_AreaMacro);
}


//  ------------------------------------------------------------------

void golded_kbd::switch_edit() {

  switch(command_crc) {
    case CRC_EDITABORT:           command = KK_EditAbort;             break;
    case CRC_EDITANCHOR:          command = KK_EditAnchor;            break;
    case CRC_EDITASKEXIT:         command = KK_EditAskExit;           break;
    case CRC_EDITHEADER:          command = KK_EditHeader;            break;
    case CRC_EDITCLEARDELETEBUF:  command = KK_EditClearDeleteBuf;    break;
    case CRC_EDITCLEARPASTEBUF:   command = KK_EditClearPasteBuf;     break;
    case CRC_EDITCOPYABOVECHAR:   command = KK_EditCopyAboveChar;     break;
    case CRC_EDITCOPY:            command = KK_EditCopy;              break;
    case CRC_EDITCUT:             command = KK_EditCut;               break;
    case CRC_EDITDELCHAR:         command = KK_EditDelChar;           break;
    case CRC_EDITDELLEFT:         command = KK_EditDelLeft;           break;
    case CRC_EDITDELLINE:         command = KK_EditDelLine;           break;
    case CRC_EDITDELLTWORD:       command = KK_EditDelLtWord;         break;
    case CRC_EDITDELRTWORD:       command = KK_EditDelRtWord;         break;
    case CRC_EDITDELETEEOL:       command = KK_EditDeleteEOL;         break;
    case CRC_EDITDOSSHELL:        command = KK_EditDosShell;          break;
    case CRC_EDITDUPLINE:         command = KK_EditDupLine;           break;
    case CRC_EDITEXITMSG:         command = KK_EditExitMsg;           break;
    case CRC_EDITEXPORTTEXT:      command = KK_EditExportText;        break;
    case CRC_EDITGOBEGLINE:       command = KK_EditGoBegLine;         break;
    case CRC_EDITGOBOTLINE:       command = KK_EditGoBotLine;         break;
    case CRC_EDITGOBOTMSG:        command = KK_EditGoBotMsg;          break;
    case CRC_EDITGODOWN:          command = KK_EditGoDown;            break;
    case CRC_EDITGOEOL:           command = KK_EditGoEOL;             break;
    case CRC_EDITGOLEFT:          command = KK_EditGoLeft;            break;
    case CRC_EDITGOPGDN:          command = KK_EditGoPgDn;            break;
    case CRC_EDITGOPGUP:          command = KK_EditGoPgUp;            break;
    case CRC_EDITGORIGHT:         command = KK_EditGoRight;           break;
    case CRC_EDITMAINMENU:        command = KK_EditMainMenu;          break;
    case CRC_EDITGOTOPLINE:       command = KK_EditGoTopLine;         break;
    case CRC_EDITGOTOPMSG:        command = KK_EditGoTopMsg;          break;
    case CRC_EDITGOUP:            command = KK_EditGoUp;              break;
    case CRC_EDITGOWORDLEFT:      command = KK_EditGoWordLeft;        break;
    case CRC_EDITGOWORDRIGHT:     command = KK_EditGoWordRight;       break;
    case CRC_EDITIMPORTQUOTEBUF:  command = KK_EditImportQuotebuf;    break;
    case CRC_EDITIMPORTTEXT:      command = KK_EditImportText;        break;
    case CRC_EDITKILLQUOTES:      command = KK_EditKillQuotes;        break;
    case CRC_EDITLOADFILE:        command = KK_EditLoadFile;          break;
    case CRC_EDITLOOKUPCURSOR:    command = KK_EditLookupCursor;      break;
    case CRC_EDITLOOKUPDEST:      command = KK_EditLookupDest;        break;
    case CRC_EDITLOOKUPORIG:      command = KK_EditLookupOrig;        break;
    case CRC_EDITMACRO:           command = KK_EditMacro;             break;
    case CRC_EDITMENU:            command = KK_EditMenu;              break;
    case CRC_EDITNEWLINE:         command = KK_EditNewline;           break;
    case CRC_EDITPASTE:           command = KK_EditPaste;             break;
    case CRC_EDITQUITNOW:         command = KK_EditQuitNow;           break;
    case CRC_EDITREFLOW:          command = KK_EditReflow;            break;
    case CRC_EDITSAVEMSG:         command = KK_EditSaveMsg;           break;
    case CRC_EDITSAVEFILE:        command = KK_EditSaveFile;          break;
    case CRC_EDITSOUNDKILL:       command = KK_EditSoundkill;         break;
    case CRC_EDITSPELLCHECK:      command = KK_EditSpellCheck;        break;
    case CRC_EDITTAB:             command = KK_EditTab;               break;
    case CRC_EDITTOLOWER:         command = KK_EditToLower;           break;
    case CRC_EDITTOUPPER:         command = KK_EditToUpper;           break;
    case CRC_EDITTOGGLECASE:      command = KK_EditToggleCase;        break;
    case CRC_EDITTOGGLEINSERT:    command = KK_EditToggleInsert;      break;
    case CRC_EDITUNDEFINE:        command = KK_EditUndefine;          break;
    case CRC_EDITUNDELETE:        command = KK_EditUnDelete;          break;
    case CRC_EDITZAPQUOTEBELOW:   command = KK_EditZapQuoteBelow;     break;
  }


  if(command) {
    add(edit, KK_EditMacro);
    return;
  }

  switch(command_crc) {
    case CRC_EXTERNUTIL01:        command = KK_ExternUtil01;          break;
    case CRC_EXTERNUTIL02:        command = KK_ExternUtil02;          break;
    case CRC_EXTERNUTIL03:        command = KK_ExternUtil03;          break;
    case CRC_EXTERNUTIL04:        command = KK_ExternUtil04;          break;
    case CRC_EXTERNUTIL05:        command = KK_ExternUtil05;          break;
    case CRC_EXTERNUTIL06:        command = KK_ExternUtil06;          break;
    case CRC_EXTERNUTIL07:        command = KK_ExternUtil07;          break;
    case CRC_EXTERNUTIL08:        command = KK_ExternUtil08;          break;
    case CRC_EXTERNUTIL09:        command = KK_ExternUtil09;          break;
    case CRC_EXTERNUTIL10:        command = KK_ExternUtil10;          break;
    case CRC_EXTERNUTIL11:        command = KK_ExternUtil11;          break;
    case CRC_EXTERNUTIL12:        command = KK_ExternUtil12;          break;
    case CRC_EXTERNUTIL13:        command = KK_ExternUtil13;          break;
    case CRC_EXTERNUTIL14:        command = KK_ExternUtil14;          break;
    case CRC_EXTERNUTIL15:        command = KK_ExternUtil15;          break;
    case CRC_EXTERNUTIL16:        command = KK_ExternUtil16;          break;
    case CRC_EXTERNUTIL17:        command = KK_ExternUtil17;          break;
    case CRC_EXTERNUTIL18:        command = KK_ExternUtil18;          break;
    case CRC_EXTERNUTIL19:        command = KK_ExternUtil19;          break;
    case CRC_EXTERNUTIL20:        command = KK_ExternUtil20;          break;
    case CRC_EXTERNUTIL21:        command = KK_ExternUtil21;          break;
    case CRC_EXTERNUTIL22:        command = KK_ExternUtil22;          break;
    case CRC_EXTERNUTIL23:        command = KK_ExternUtil23;          break;
    case CRC_EXTERNUTIL24:        command = KK_ExternUtil24;          break;
  }

  add(read, KK_ReadMacro);
}


//  ------------------------------------------------------------------

void golded_kbd::switch_file() {

  switch(command_crc) {
    case CRC_FILEABORT:           command = KK_FileAbort;             break;
    case CRC_FILEASKEXIT:         command = KK_FileAskExit;           break;
    case CRC_FILEDOSSHELL:        command = KK_FileDosShell;          break;
    case CRC_FILEMACRO:           command = KK_FileMacro;             break;
    case CRC_FILEMAINMENU:        command = KK_FileMainMenu;          break;
    case CRC_FILEGOTOFIRST:       command = KK_FileGotoFirst;         break;
    case CRC_FILEGOTOLAST:        command = KK_FileGotoLast;          break;
    case CRC_FILEGOTONEXT:        command = KK_FileGotoNext;          break;
    case CRC_FILEGOTOPREV:        command = KK_FileGotoPrev;          break;
    case CRC_FILEMARK:            command = KK_FileMark;              break;
    case CRC_FILEMARKALL:         command = KK_FileMarkAll;           break;
    case CRC_FILEMENU:            command = KK_FileMenu;              break;
    case CRC_FILEQUITNOW:         command = KK_FileQuitNow;           break;
    case CRC_FILESELECT:          command = KK_FileSelect;            break;
    case CRC_FILETOGGLEMARK:      command = KK_FileToggleMark;        break;
    case CRC_FILEUNDEFINE:        command = KK_FileUndefine;          break;
    case CRC_FILEUNMARK:          command = KK_FileUnMark;            break;
    case CRC_FILEUNMARKALL:       command = KK_FileUnMarkAll;         break;
  }

  add(edit, KK_FileMacro);
}


//  ------------------------------------------------------------------

void golded_kbd::switch_list() {

  switch(command_crc) {
    case CRC_LISTABORT:           command = KK_ListAbort;             break;
    case CRC_LISTASKEXIT:         command = KK_ListAskExit;           break;
    case CRC_LISTDOSSHELL:        command = KK_ListDosShell;          break;
    case CRC_LISTGOTOBOOKMARK:    command = KK_ListGotoBookMark;      break;
    case CRC_LISTMAINMENU:        command = KK_ListMainMenu;          break;
    case CRC_LISTGOTOFIRST:       command = KK_ListGotoFirst;         break;
    case CRC_LISTGOTOLAST:        command = KK_ListGotoLast;          break;
    case CRC_LISTGOTONEXT:        command = KK_ListGotoNext;          break;
    case CRC_LISTGOTOPREV:        command = KK_ListGotoPrev;          break;
    case CRC_LISTMACRO:           command = KK_ListMacro;             break;
    case CRC_LISTMARKINGOPTIONS:  command = KK_ListMarkingOptions;    break;
    case CRC_LISTMENU:            command = KK_ListMenu;              break;
    case CRC_LISTQUITNOW:         command = KK_ListQuitNow;           break;
    case CRC_LISTSELECT:          command = KK_ListSelect;            break;
    case CRC_LISTTOGGLEBOOKMARK:  command = KK_ListToggleBookMark;    break;
    case CRC_LISTTOGGLEDATE:      command = KK_ListToggleDate;        break;
    case CRC_LISTTOGGLEMARK:      command = KK_ListToggleMark;        break;
    case CRC_LISTTOGGLEWIDESUBJ:  command = KK_ListToggleWideSubj;    break;
    case CRC_LISTUNDEFINE:        command = KK_ListUndefine;          break;
  }

  add(edit, KK_ListMacro);
}


//  ------------------------------------------------------------------

void golded_kbd::switch_node() {

  switch(command_crc) {
    case CRC_NODEABORT:           command = KK_NodeAbort;             break;
    case CRC_NODEASKEXIT:         command = KK_NodeAskExit;           break;
    case CRC_NODEDOSSHELL:        command = KK_NodeDosShell;          break;
    case CRC_NODEMACRO:           command = KK_NodeMacro;             break;
    case CRC_NODEMAINMENU:        command = KK_NodeMainMenu;          break;
    case CRC_NODEGOTOFIRST:       command = KK_NodeGotoFirst;         break;
    case CRC_NODEGOTOLAST:        command = KK_NodeGotoLast;          break;
    case CRC_NODEGOTONEXT:        command = KK_NodeGotoNext;          break;
    case CRC_NODEGOTOPREV:        command = KK_NodeGotoPrev;          break;
    case CRC_NODEMENU:            command = KK_NodeMenu;              break;
    case CRC_NODEQUITNOW:         command = KK_NodeQuitNow;           break;
    case CRC_NODESELECT:          command = KK_NodeSelect;            break;
    case CRC_NODEUNDEFINE:        command = KK_NodeUndefine;          break;
  }

  add(edit, KK_NodeMacro);
}


//  ------------------------------------------------------------------

void golded_kbd::switch_read() {

  switch(command_crc) {
    case CRC_READADDTOUSERLIST:    command = KK_ReadAddToUserlist;    break;
    case CRC_READASKEXIT:          command = KK_ReadAskExit;          break;
    case CRC_READCHANGEAKA:        command = KK_ReadChangeAka;        break;
    case CRC_READCHANGEATTRS:      command = KK_ReadChangeAttrs;      break;
    case CRC_READCHANGEMOOD:       command = KK_ReadChangeMood;       break;
    case CRC_READCHANGEMSG:        command = KK_ReadChangeMsg;        break;
    case CRC_READCHANGEORIGIN:     command = KK_ReadChangeOrigin;     break;
    case CRC_READCHANGETAGLINE:    command = KK_ReadChangeTagline;    break;
    case CRC_READCHANGETEMPLATE:   command = KK_ReadChangeTemplate;   break;
    case CRC_READCHANGEUSERNAME:   command = KK_ReadChangeUsername;   break;
    case CRC_READCHANGEXLATIMPORT: command = KK_ReadChangeXlatImport; break;
    case CRC_READCOPYMOVEFORWARD:  command = KK_ReadCopyMoveForward;  break;
    case CRC_READDECREASEMARGIN:   command = KK_ReadDecreaseMargin;   break;
    case CRC_READDELETEMSG:        command = KK_ReadDeleteMsg;        break;
    case CRC_READDOSSHELL:         command = KK_ReadDosShell;         break;
    case CRC_READEXTERNUTILMENU:   command = KK_ReadExternUtilMenu;   break;
    case CRC_READFIDORENUMBER:     command = KK_ReadFidoRenumber;     break;
    case CRC_READFILEREQUEST:      command = KK_ReadFileRequest;      break;
    case CRC_READFINDALL:          command = KK_ReadFindAll;          break;
    case CRC_READFINDHEADER:       command = KK_ReadFindHeader;       break;
    case CRC_READGOTOBOOKMARK:     command = KK_ReadGotoBookMark;     break;
    case CRC_READMAINMENU:         command = KK_ReadMainMenu;         break;
    case CRC_READGOTODOWNLINK:     command = KK_ReadGotoReplyPrev;    break;
    case CRC_READGOTOFIRSTMSG:     command = KK_ReadGotoFirstMsg;     break;
    case CRC_READGOTOLASTMSG:      command = KK_ReadGotoLastMsg;      break;
    case CRC_READGOTOMSGNO:        command = KK_ReadGotoMsgno;        break;
    case CRC_READGOTONEXTAREA:     command = KK_ReadGotoNextArea;     break;
    case CRC_READGOTONEXTMSG:      command = KK_ReadGotoNextMsg;      break;
    case CRC_READGOTONEXTUNREAD:   command = KK_ReadGotoNextUnread;   break;
    case CRC_READGOTOPREVAREA:     command = KK_ReadGotoPrevArea;     break;
    case CRC_READGOTOPREVMSG:      command = KK_ReadGotoPrevMsg;      break;
    case CRC_READGOTOPREVUNREAD:   command = KK_ReadGotoPrevUnread;   break;
    case CRC_READGOTOREPLIES:      command = KK_ReadGotoReplies;      break;
    case CRC_READGOTOREPLY1ST:     command = KK_ReadGotoReply1st;     break;
    case CRC_READGOTOREPLYNEXT:    command = KK_ReadGotoReplyNext;    break;
    case CRC_READGOTOREPLYPREV:    command = KK_ReadGotoReplyPrev;    break;
    case CRC_READGOTOUPLINK:       command = KK_ReadGotoReplies;      break;
    case CRC_READINCREASEMARGIN:   command = KK_ReadIncreaseMargin;   break;
    case CRC_READLOOKUPDEST:       command = KK_ReadLookupDest;       break;
    case CRC_READLOOKUPORIG:       command = KK_ReadLookupOrig;       break;
    case CRC_READMACRO:            command = KK_ReadMacro;            break;
    case CRC_READMAKEUSERLIST:     command = KK_ReadMakeUserlist;     break;
    case CRC_READMARKINGOPTIONS:   command = KK_ReadMarkingOptions;   break;
    case CRC_READMENU:             command = KK_ReadMenu;             break;
    case CRC_READMESSAGELIST:      command = KK_ReadMessageList;      break;
    case CRC_READMOVECOMMENTMSG:   command = KK_ReadMoveCommentMsg;   break;
    case CRC_READMOVEQUOTEMSG:     command = KK_ReadMoveQuoteMsg;     break;
    case CRC_READMSGCONTINUE:      command = KK_ReadMsgContinue;      break;
    case CRC_READMSGEND:           command = KK_ReadMsgEnd;           break;
    case CRC_READMSGHOME:          command = KK_ReadMsgHome;          break;
    case CRC_READMSGLINEDOWN:      command = KK_ReadMsgLineDown;      break;
    case CRC_READMSGLINEUP:        command = KK_ReadMsgLineUp;        break;
    case CRC_READMSGPGDN:          command = KK_ReadMsgPgDn;          break;
    case CRC_READMSGPGUP:          command = KK_ReadMsgPgUp;          break;
    case CRC_READNEWAREA:          command = KK_ReadNewArea;          break;
    case CRC_READNEWMSG:           command = KK_ReadNewMsg;           break;
    case CRC_READQUITNOW:          command = KK_ReadQuitNow;          break;
    case CRC_READQUOTEBUF:         command = KK_ReadQuoteBuf;         break;
    case CRC_READQUOTEMSG:         command = KK_ReadQuoteMsg;         break;
    case CRC_READCOMMENTMSG:       command = KK_ReadCommentMsg;       break;
    case CRC_READREPLYMSG:         command = KK_ReadReplyMsg;         break;
    case CRC_READSOUNDKILL:        command = KK_ReadSoundkill;        break;
    case CRC_READSTEALTAGLINE:     command = KK_ReadStealTagline;     break;
    case CRC_READTOGGLEBOOKMARK:   command = KK_ReadToggleBookMark;   break;
    case CRC_READTOGGLEHEXDUMP:    command = KK_ReadToggleHexdump;    break;
    case CRC_READTOGGLEHIDDKLUD:   command = KK_ReadToggleHiddKlud;   break;
    case CRC_READTOGGLEHIDDEN:     command = KK_ReadToggleHidden;     break;
    case CRC_READTOGGLEKLUDGE:     command = KK_ReadToggleKludge;     break;
    case CRC_READTOGGLEMARK:       command = KK_ReadToggleMark;       break;
    case CRC_READTOGGLEMARKREAD:   command = KK_ReadToggleMarkRead;   break;
    case CRC_READTOGGLEPAGEBAR:    command = KK_ReadTogglePageBar;    break;
    case CRC_READTOGGLEQUOTE:      command = KK_ReadToggleQuote;      break;
    case CRC_READTOGGLEROT13:      command = KK_ReadToggleROT13;      break;
    case CRC_READTOGGLEREALMSGNO:  command = KK_ReadToggleRealMsgno;  break;
    case CRC_READTOGGLETWITS:      command = KK_ReadToggleTwits;      break;
    case CRC_READTOUCHNETSCAN:     command = KK_ReadTouchNetscan;     break;
    case CRC_READTOUCHSEMAPHORE:   command = KK_ReadTouchSemaphore;   break;
    case CRC_READUNDEFINE:         command = KK_ReadUndefine;         break;
    case CRC_READUUDECODE:         command = KK_ReadUUDecode;         break;
    case CRC_READWRITEMSG:         command = KK_ReadWriteMsg;         break;
  }

  add(read, KK_ReadMacro);
}


//  ------------------------------------------------------------------

int golded_kbd::switch_keyboard(char cmd, word cmdcrc, word keycrc, char* extra) {

  gkey key = gkeyname_to_keycode(keycrc);
  if(key == 0)
    return error_unknown_keycode;

  command = 0;
  macrostring = extra;
  command_crc = cmdcrc;

  if(cmdkey == CRC_MACRO) {
    gkeymacro macro(key);
    error = add_macro(glob, macro);
    return error;
  }

  add_it = true;
  switch_it(cmd);

  return error;
}


//  ------------------------------------------------------------------

