
//  ------------------------------------------------------------------
//  GoldED. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gelang.cpp,v 1.1.1.1 1998/11/21 19:38:04 odinn Exp $
//  ------------------------------------------------------------------
//  Language handling.
//  ------------------------------------------------------------------


#include "gelang.h"
#include "gclang.h"


//  ------------------------------------------------------------------

glangcrc GoldedLng::langdefault[] = {

  { CRC_MS_SWSUN              , "\0Sun" },
  { CRC_MS_SWMON              , "\0Mon" },
  { CRC_MS_SWTUE              , "\0Tue" },
  { CRC_MS_SWWED              , "\0Wed" },
  { CRC_MS_SWTHU              , "\0Thu" },
  { CRC_MS_SWFRI              , "\0Fri" },
  { CRC_MS_SWSAT              , "\0Sat" },

  { CRC_MS_LWSUNDAY           , "\0Sunday" },
  { CRC_MS_LWMONDAY           , "\0Monday" },
  { CRC_MS_LWTUESDAY          , "\0Tuesday" },
  { CRC_MS_LWWEDNESDAY        , "\0Wednesday" },
  { CRC_MS_LWTHURSDAY         , "\0Thursday" },
  { CRC_MS_LWFRIDAY           , "\0Friday" },
  { CRC_MS_LWSATURDAY         , "\0Saturday" },

  { CRC_MS_SMJAN              , "\0Jan" },
  { CRC_MS_SMFEB              , "\0Feb" },
  { CRC_MS_SMMAR              , "\0Mar" },
  { CRC_MS_SMAPR              , "\0Apr" },
  { CRC_MS_SMMAY              , "\0May" },
  { CRC_MS_SMJUN              , "\0Jun" },
  { CRC_MS_SMJUL              , "\0Jul" },
  { CRC_MS_SMAUG              , "\0Aug" },
  { CRC_MS_SMSEP              , "\0Sep" },
  { CRC_MS_SMOCT              , "\0Oct" },
  { CRC_MS_SMNOV              , "\0Nov" },
  { CRC_MS_SMDEC              , "\0Dec" },

  { CRC_MS_LMJANUARY          , "\0January" },
  { CRC_MS_LMFEBRUARY         , "\0February" },
  { CRC_MS_LMMARCH            , "\0March" },
  { CRC_MS_LMAPRIL            , "\0April" },
  { CRC_MS_LMMAY              , "\0May" },
  { CRC_MS_LMJUNE             , "\0June" },
  { CRC_MS_LMJULY             , "\0July" },
  { CRC_MS_LMAUGUST           , "\0August" },
  { CRC_MS_LMSEPTEMBER        , "\0September" },
  { CRC_MS_LMOCTOBER          , "\0October" },
  { CRC_MS_LMNOVEMBER         , "\0November" },
  { CRC_MS_LMDECEMBER         , "\0December" },

  { CRC_ST_IMPORTFILE         , "\0Import File" },
  { CRC_WT_IMPORTWHICHFILE    , "\0 Import which file? " },
  { CRC_WT_IMPORTPICK         , "\0 Import " },
  { CRC_ST_IMPORTSTATUS       , "\0Importing from %s" },
  { CRC_ST_EXPORTFILE         , "\0Export File" },
  { CRC_WT_EXPORTWHATFILE     , "\0 Export to what file? " },
  { CRC_ST_EXPORTSTATUS       , "\0Exporting to %s" },
  { CRC_ST_EDITSTATUS         , "\0Edit %i,%i. %s" },
  { CRC_ST_SELECTFILES        , "\0Select Files" },
  { CRC_WL_SELECTEDFILES      , "\0Selected Files      " },
  { CRC_WL_SELECTEDBYTES      , "\0         Bytes      " },
  { CRC_WL_TOTALFILES         , "\0Total    Files      " },
  { CRC_WL_TOTALBYTES         , "\0         Bytes      " },
  { CRC_WL_MOVEFILEBAR        , "\0Cursor/Page  Move Selection Bar" },
  { CRC_WL_TOGGLEFILE         , "\0Space/Ins    Toggle Selection" },
  { CRC_WL_ACCEPTFILES        , "\0Enter        Accept Selections" },
  { CRC_WL_SELECTALLFILES     , "\0Ctrl-Enter   Select All" },
  { CRC_WL_ABORTFILES         , "\0ESC          Abort Selection" },
  { CRC_WL_SCANNINGDIRECTORY  , "\0             Scanning Directory             " },
  { CRC_WL_NOFILESFOUND       , "\0             * NO FILES FOUND *             " },
  { CRC_ST_FILESPRESSKEY      , "\0Press any key to continue" },
  { CRC_WT_AREA               , "\0Area" },
  { CRC_WT_DESCRIPTION        , "\0Description" },
  { CRC_WT_MSGS               , "\0Msgs" },
  { CRC_WT_LAST               , "\0Last" },
  { CRC_WT_ECHOID             , "\0EchoID" },
  { CRC_ST_UNREAD             , "\0unread" },
  { CRC_WT_SCANAREAS          , "\0 Scan Areas " },
  { CRC_MI_SCANALL            , "\0A Scan All       " },
  { CRC_MI_SCANMARKED         , "\0M Scan Marked    " },
  { CRC_MI_SCANCURRENT        , "\0C Scan Current   " },
  { CRC_MI_SCANMATCHING       , "\0t Scan Matching  " },
  { CRC_MI_SCANUNSCANNED      , "\0U Scan Unscanned " },
  { CRC_MI_NOSCAN             , "\0N No Scan  / ESC " },
  { CRC_WT_HEATAREAS          , "\0 Heat Areas " },
  { CRC_MI_HEATALL            , "\0A Heat All      " },
  { CRC_MI_HEATMARKED         , "\0M Heat Marked   " },
  { CRC_MI_HEATCURRENT        , "\0C Heat Current  " },
  { CRC_MI_NOHEAT             , "\0N No Heat / ESC " },
  { CRC_WT_ZAPAREAS           , "\0 Zap Areas " },
  { CRC_MI_ZAPALL             , "\0A Zap All      " },
  { CRC_MI_ZAPMARKED          , "\0M Zap Marked   " },
  { CRC_MI_ZAPCURRENT         , "\0C Zap Current  " },
  { CRC_MI_NOZAP              , "\0N No Zap / ESC " },
  { CRC_MS_DOS_SHELL          , "\0GoldED Shell. Type EXIT To Return." },
  { CRC_IL_SCANNINGAREA       , "\0 Scanning Area:" },
  { CRC_IL_SEARCHINGFOR       , "\0 Searching for" },
  { CRC_ST_READINGMSG         , "\0Reading Msg %u of %u" },
  { CRC_ER_OUTOFMEM           , "\0Out of memory!" },
  { CRC_MS_HEXDUMPHEAD        , "\0Hexdump of message header:" },
  { CRC_MS_HEXDUMPTEXT        , "\0Hexdump of message text:" },
  { CRC_ST_RENUMBERING        , "\0Renumbering" },
  { CRC_ST_LOCKED             , "\0 (locked)" },
  { CRC_ST_RENUMBERED         , "\0Messages Renumbered - Press Key" },
  { CRC_WL_BLANKMSG           , "\0" },
  { CRC_WL_WAIT               , "\0 Wait " },
  { CRC_IL_GENHEXDUMP         , "\0 Generating Hexdump - Please Wait " },
  { CRC_ST_PROCESSCC          , "\0Processing Carbon Copies" },
  { CRC_ST_STATUSCC           , "\0CC: %s of %u:%u/%u.%u" },
  { CRC_ST_DESTINATIONCC      , "\0Select Carbon Copy Destination" },
  { CRC_MS_LISTCC             , "\0%s  %u:%u/%u.%u" },
  { CRC_WT_DELORIG            , "\0 Delete Original? " },
  { CRC_MI_DELORIGYES         , "\0Y       Yes Please.      " },
  { CRC_MI_DELORIGNO          , "\0N           No!          " },
  { CRC_WT_DROPMSG            , "\0 Drop This Msg? " },
  { CRC_MI_DROPMSGYES         , "\0Y       Yes Please.      " },
  { CRC_MI_DROPMSGNO          , "\0N           No!          " },
  { CRC_WT_ZONEGATE           , "\0 Send via ZoneGate? " },
  { CRC_MI_ZONEGATEYES        , "\0Y       Yes Please.      " },
  { CRC_MI_ZONEGATENO         , "\0N           No!          " },
  { CRC_ST_QUOTEPCT           , "\0Your Msg Contains %i%% Quotes%s" },
  { CRC_WT_SAVEMSG            , "\0 Save these %i lines? " },
  { CRC_MI_YESGREAT           , "\0Y Yes, it's great stuff " },
  { CRC_MI_KICKIT             , "\0N No, drop it..   / ESC " },
  { CRC_MI_CONTINUE           , "\0C Continue writing      " },
  { CRC_MI_ROT13              , "\0R ROT13 Crypting        " },
  { CRC_MI_ATTRS              , "\0A Change Attributes     " },
  { CRC_MI_ORIGS              , "\0O Change Origin         " },
  { CRC_MI_VIEW               , "\0V View the message      " },
  { CRC_ST_SELECTDESTNODE     , "\0Select Destination Node" },
  { CRC_WT_ATTACHFILES        , "\0 Attach Files " },
  { CRC_WT_UPDREQFILES        , "\0 Update Request Files " },
  { CRC_ST_EDITHEADER         , "\0Edit Header Data" },
  { CRC_WT_EDITING            , "\0 Editing " },
  { CRC_MI_INTERNALED         , "\0I Internal Editor " },
  { CRC_MI_EXTERNALED         , "\0E External Editor " },
  { CRC_MI_SAVEMESSAGE        , "\0S Save Message    " },
  { CRC_MI_ATTRO              , "\0A Attributes      " },
  { CRC_MI_TEMPLATE           , "\0T Templates       " },
  { CRC_MI_ORIGIN             , "\0O Origins         " },
  { CRC_MI_QUITMESSAGE        , "\0Q Quit      / ESC " },
  { CRC_ST_TEMPLATES          , "\0 Templates " },
  { CRC_WT_CHANGETEMPLATES    , "\0Change Default Template" },
  { CRC_WT_CARBONCOPY         , "\0 Carbon Copy " },
  { CRC_MI_CCPROCESS          , "\0P Process CC's " },
  { CRC_MI_CCIGNORE           , "\0I Ignore  CC's " },
  { CRC_MI_CCATTRIBS          , "\0C Change Attrs " },
  { CRC_MI_CCLISTFMT          , "\0L List Format  " },
  { CRC_WT_CCLIST             , "\0 CC List " },
  { CRC_MI_CCLISTKEEP         , "\0K Keep       " },
  { CRC_MI_CCLISTNAMES        , "\0N Names only " },
  { CRC_MI_CCLISTVISIBLE      , "\0V Visible    " },
  { CRC_MI_CCLISTHIDDEN       , "\0H Hidden     " },
  { CRC_MI_CCLISTREMOVE       , "\0R Remove     " },
  { CRC_WT_ATTRTITLE          , "\0 Attributes " },
  { CRC_MI_ATTR01             , "\0 Private             <Alt-P>   Archive/Sent         <Alt-B> " },
  { CRC_MI_ATTR02             , "\0 Crash               <Alt-C>   Direct               <Alt-D> " },
  { CRC_MI_ATTR03             , "\0 Received            <Alt-R>   Zonegate             <Alt-G> " },
  { CRC_MI_ATTR04             , "\0 Sent                <Alt-S>   Hub/Host-Route       <Alt-V> " },
  { CRC_MI_ATTR05             , "\0 File Attach         <Alt-A>   Immediate            <Alt-I> " },
  { CRC_MI_ATTR06             , "\0 Transit             <Alt-J>   Xmail                <Alt-X> " },
  { CRC_MI_ATTR07             , "\0 Orphan              <Alt-O>   Erase File/Sent      <Alt-E> " },
  { CRC_MI_ATTR08             , "\0 Kill/Sent           <Alt-K>   Trunc File/Sent      <Alt-T> " },
  { CRC_MI_ATTR09             , "\0 Local               <Alt-W>   Locked               <Alt-L> " },
  { CRC_MI_ATTR10             , "\0 Hold                <Alt-H>   Confirm Rcpt Request <Alt-Y> " },
  { CRC_MI_ATTR11             , "\0 File Request        <Alt-F>   FTS1 Reserved        <Alt-1> " },
  { CRC_MI_ATTR12             , "\0 Return Rcpt Request <Alt-M>   QBBS Reserved, Net   <Alt-2> " },
  { CRC_MI_ATTR13             , "\0 Return Rcpt         <Alt-N>   QBBS Reserved, Echo  <Alt-3> " },
  { CRC_MI_ATTR14             , "\0 Audit Request       <Alt-Q>   Squish Scanned       <Alt-4> " },
  { CRC_MI_ATTR15             , "\0 File Update Request <Alt-U>   Zap all attribs      <Alt-Z> " },
  { CRC_HD_FROM               , "\0 From : " },
  { CRC_HD_TO                 , "\0 To   : " },
  { CRC_HD_SUBJ               , "\0 Subj : " },
  { CRC_HD_FILE               , "\0 File : " },
  { CRC_MS_EMPTYMSG           , "\0\r" },
  { CRC_MS_AUTOATTACHMSG      , "\0\r" },
  { CRC_MS_AUTOREQUESTMSG     , "\0\r" },
  { CRC_MS_AUTOUPDREQMSG      , "\0\r" },
  { CRC_WT_FILEATTACH         , "\0 File Attach " },
  { CRC_WT_FILEREQUEST        , "\0 File Request " },
  { CRC_WT_FILEUPDREQ         , "\0 Update Request " },
  { CRC_ST_FILEATTACHING      , "\0File Attaching [%i/%i] to %u:%u/%u.%u" },
  { CRC_ST_FILEREQUESTING     , "\0File Requesting [%i/%i] from %u:%u/%u.%u" },
  { CRC_ST_FILEUPDREQING      , "\0Update Requesting [%i/%i] from %u:%u/%u.%u" },
  { CRC_ST_READMARKED         , "\0Read Marked - Msg %u of %u (%u left)" },
  { CRC_ST_READALL            , "\0Read All - Msg %u of %u (%u left)" },
  { CRC_ST_NOQRENUM           , "\0This area cannot be renumbered" },
  { CRC_MS_FROMTWIT           , "\0Message from Twit - Press <Home> to read." },
  { CRC_HD_VIA                , "\0via" },
  { CRC_WT_CHANGEATTRS        , "\0Change Message Attributes" },
  { CRC_WT_HEADERTEXT         , "\0 Enter Searchstring (Header+Text) " },
  { CRC_WT_HEADERONLY         , "\0 Enter Searchstring (Header Only) " },
  { CRC_WT_NEWAREA            , "\0>>Pick New Area: " },
  { CRC_WT_REPLYAREA          , "\0>>Answer In Area: " },
  { CRC_WT_COPYAREA           , "\0>>Copy To Area: " },
  { CRC_WT_MOVEAREA           , "\0>>Move To Area: " },
  { CRC_WT_FORWARDAREA        , "\0>>Forward To Area: " },
  { CRC_WT_FREQAREA           , "\0>>Filerequest In Area: " },
  { CRC_WT_FREQMENUTITLE      , "\0Requestable files" },
  { CRC_ST_FREQSTAT           , "\0Pick files to request" },
  { CRC_IL_FREQINFONOFILES    , "\0 No requestable files were found in this msg! " },
  { CRC_WT_COPY               , "\0 Copy " },
  { CRC_WT_MOVE               , "\0 Move " },
  { CRC_WT_COPYING            , "\0 Copying " },
  { CRC_WT_MOVING             , "\0 Moving " },
  { CRC_ST_COPYINGMSG         , "\0Copying Msg %u of %u to %s" },
  { CRC_ST_MOVINGMSG          , "\0Moving Msg %u of %u to %s" },
  { CRC_WT_DELETE             , "\0 Delete " },
  { CRC_WT_DELETING           , "\0 Deleting " },
  { CRC_ST_DELETINGMSG        , "\0Deleting Msg %u of %u" },
  { CRC_WT_WRITE              , "\0 Write " },
  { CRC_WT_WRITEMSGS          , "\0 Write Msg(s) to File " },
  { CRC_WT_WRITING            , "\0 Writing " },
  { CRC_ST_WRITINGMSG         , "\0Writing Msg %u of %u" },
  { CRC_WT_WRITINGFILE        , "\0 Writing Msg(s) to File %s " },
  { CRC_WT_WRITINGPRN         , "\0 Writing Msg(s) to Print Device " },
  { CRC_IL_READONLYWARN       , "\0 This area is READ ONLY! " },
  { CRC_WT_ISREADONLY         , "\0 Write msg anyway? " },
  { CRC_MI_READONLYYES        , "\0Y       Yes Please.      " },
  { CRC_MI_READONLYNO         , "\0N           No!          " },
  { CRC_IL_CHANGEWARN         , "\0 This msg is not from you! " },
  { CRC_WT_CHANGE             , "\0 Change this msg? " },
  { CRC_MI_CHANGEYES          , "\0Y       Yes Please.      " },
  { CRC_MI_CHANGENO           , "\0N           No!          " },
  { CRC_WT_DELETETHIS         , "\0 Delete this msg? " },
  { CRC_MI_DELETEYES          , "\0Y       Yes Please.      " },
  { CRC_MI_DELETENO           , "\0N           No!          " },
  { CRC_MI_DELETENOASK        , "\0D       Don't ask..      " },
  { CRC_WT_GOTONEXT           , "\0 Goto Next Area? " },
  { CRC_MI_GOTONEXTYES        , "\0Y       Yes Please.      " },
  { CRC_MI_GOTONEXTNO         , "\0N           No!          " },
  { CRC_WT_MSG                , "\0Msg" },
  { CRC_WT_MSGREAL            , "\0Msg#" },
  { CRC_WT_FROML              , "\0From" },
  { CRC_WT_TOL                , "\0To" },
  { CRC_WT_SUBJL              , "\0Subj" },
  { CRC_ST_MSGLISTER          , "\0Lister - Msg %u of %u (%u left)" },
  { CRC_ST_COPYMOVEFORWARD    , "\0Copy, Move or Forward this message" },
  { CRC_WT_SELECTACTION       , "\0 Action " },
  { CRC_MI_FORWARDMESSAGE     , "\0F Forward Msg " },
  { CRC_MI_MOVEMESSAGE        , "\0M Move    Msg " },
  { CRC_MI_COPYMESSAGE        , "\0C Copy    Msg " },
  { CRC_MI_QUITCMF            , "\0Q Quit  / ESC " },
  { CRC_ST_ARE                , "\0messages are" },
  { CRC_ST_IS                 , "\0message is" },
  { CRC_ST_MARKED             , "\0marked" },
  { CRC_MI_MARKEDMSG          , "\0M Marked Msgs " },
  { CRC_MI_CURRENTMSG         , "\0C Current Msg " },
  { CRC_MI_QUITMSGS           , "\0Q Quit  / ESC " },
  { CRC_ST_WRITEMSGSTO        , "\0Write Msg(s) to File or Printer" },
  { CRC_WT_WRITETO            , "\0 Write To: " },
  { CRC_MI_DISKFILE           , "\0D Disk File    " },
  { CRC_MI_PRINTER            , "\0P Print device " },
  { CRC_MI_QUITWRITE          , "\0Q Quit   / ESC " },
  { CRC_ST_MARKINGOPTIONS     , "\0Message Marking" },
  { CRC_WT_MARKWHAT           , "\0 Mark What? " },
  { CRC_MI_YOURMAIL           , "\0Y Your personal mail     " },
  { CRC_MI_FROMTOSUBJ         , "\0H Header (From/To/Subj)  " },
  { CRC_MI_TEXTHDR            , "\0T Text and header        " },
  { CRC_MI_THREAD             , "\0R Reply thread           " },
  { CRC_MI_NEWMSGS            , "\0N New msgs      >current " },
  { CRC_MI_OLDMSGS            , "\0O Old msgs      <current " },
  { CRC_MI_ALLMSGS            , "\0A All msgs               " },
  { CRC_MI_UNMARK             , "\0U Unmark all msgs        " },
  { CRC_MI_RANGE              , "\0M Msg range (bookm-curr) " },
  { CRC_MI_MARKSTOGGLE        , "\0g Toggle all marks       " },
  { CRC_MI_QUITMARKS          , "\0Q Quit             / ESC " },
  { CRC_WT_ENTERMARKSTRING    , "\0 Enter Marking String " },
  { CRC_ST_SEARCHINGMSG       , "\0Searching Msg %u of %u. Marked: %u" },
  { CRC_ST_MARKINGCHAIN       , "\0Marking Thread. Marked: %u" },
  { CRC_WT_USERLISTNAME       , "\0 Userlist filename? " },
  { CRC_IL_GENUSERLIST        , "\0 Generating Userlist " },
  { CRC_WT_FILEEXISTS         , "\0 File Exists! " },
  { CRC_MI_APPEND             , "\0A Append to end of file   " },
  { CRC_MI_OVERWRITE          , "\0O Overwrite the file      " },
  { CRC_MI_QUITEXIST          , "\0R Re-enter filename / ESC " },
  { CRC_IL_WARNUNSENT         , "\0 WARNING! This message is not sent! " },
  { CRC_ST_CHANGEORIGIN       , "\0Change Default Origin" },
  { CRC_WT_ORIGINS            , "\0 Origins " },
  { CRC_ST_CHANGEUSERNAME     , "\0Change Default Username" },
  { CRC_WT_USERNAMES          , "\0 Usernames " },
  { CRC_ST_CHANGEAKA          , "\0Change Default Address AKA" },
  { CRC_WT_AKAS               , "\0 AKA's " },
  { CRC_WT_LOOKUP             , "\0 Lookup: %s " },
  { CRC_WL_PHONE              , "\0Phone" },
  { CRC_WT_QUITGOLDED         , "\0 Quit GoldED? " },
  { CRC_MI_QUITYES            , "\0Y       Yes Please.      " },
  { CRC_MI_QUITNO             , "\0N           No!          " },
  { CRC_MS_EDITCMD            , "\0Editor: %s" },
  { CRC_IL_NOORIGDEFINED      , "\0 No origins defined. Press key " },
  { CRC_IL_NOUSERDEFINED      , "\0 No usernames defined. Press key " },
  { CRC_IL_NOAKADEFINED       , "\0 No AKA's defined. Press key " },
  { CRC_IL_NOTPLDEFINED       , "\0 No templates defined. Press key " },
  { CRC_MS_SKIPPINGTWIT       , "\0Skipping Twit Message..." },
  { CRC_IL_WRITINGCFG         , "\0 Writing Configuration " },
  { CRC_IL_COULDNOTOPEN       , "\0 Couldn't open %s " },
  { CRC_MS_PROMPT             , "\0Enter the command \"EXIT\" to return to GoldED.\r\n" },
  { CRC_IL_UNFINISHEDMSG      , "\0 Unfinished message found! " },
  { CRC_ST_LOADUNFINISHED     , "\0Press any key to load it or <ESC> to ignore" },
  { CRC_IL_READINGECHOLIST    , "\0Reading Echolist Files" },
  { CRC_IL_READINGADDRMACROS  , "\0Reading Address Macros" },
  { CRC_IL_CHECKINGNODELISTS  , "\0Checking Nodelists" },
  { CRC_ST_CROSSPOSTING       , "\0Crossposting in %s" },
  { CRC_IL_TWITBLANKED        , "\0 Twit Msgs Blanked " },
  { CRC_IL_TWITSKIPPED        , "\0 Twit Msgs Skipped " },
  { CRC_IL_TWITIGNORESKIP     , "\0 Twit Msgs Ignored and Skipped " },
  { CRC_IL_TWITDISPLAYED      , "\0 Twit Msgs Displayed " },
  { CRC_ST_GENCFMRECEIPT      , "\0Generating Confirmation Receipt" },
  { CRC_WT_NEW                , "\0New" },
  { CRC_ST_LOOKUPINFO         , "\0Nodelist Lookup Information" },
  { CRC_MS_DATETIMEFMT        , "\0%d %b %y  %H:%M:%S" },
  { CRC_MS_DATEFMT            , "\0%d %b %y" },
  { CRC_MS_TIMEFMT            , "\0%H:%M" },
  { CRC_MS_CROSSPOSTEDIN      , "\0* Crossposted in %s" },
  { CRC_ST_STATUSLINEHELP     , "\0F1 Help" },
  { CRC_HD_OF                 , "\0of" },
  { CRC_MS_ROBOTMSG           , "\0\r--- @longpid @version\r" },
  { CRC_ST_STATUSLINETIMEFMT  , "\0%H:%M:%S" },

  { CRC_WT_REPLIES            , "\0 Replies " },
  { CRC_ST_SELECTREPLY        , "\0Select the reply you want to see" },
  { CRC_IL_WAITOREXIT         , "\0 At this point you must either wait or exit GoldED entirely - Sorry! " },
  { CRC_WT_REALLYEXIT         , "\0 Really exit? " },
  { CRC_MI_TAGLINES           , "\0T Change Tagline" },
  { CRC_MI_HEADEREDIT         , "\0H Edit Header" },
  { CRC_MI_SCANGROUP          , "\0G Scan Group" },
  { CRC_WT_QWKPACKET          , "\0QWK Packet" },
  { CRC_MI_SCANQWK            , "\0Q QWK Packet" },
  { CRC_WT_SOUPPACKET         , "\0 SOUP Packet " },
  { CRC_MI_SCANSOUP           , "\0S SOUP Packet" },
  { CRC_MI_SCANIMPORT         , "\0I Import" },
  { CRC_MI_SCANEXPORT         , "\0E Export" },
  { CRC_WT_SCANPM             , "\0 Scan PM " },
  { CRC_MI_TAGLINE            , "\0g Taglines" },
  { CRC_WT_CONFIRM            , "\0 Honor receipt request? " },
  { CRC_MI_CONFIRMYES         , "\0Y Yes, send a receipt msg " },
  { CRC_MI_CONFIRMNO          , "\0N No, ignore the request  " },
  { CRC_IL_CONFIRMINFO        , "\0 The sender of this message requests confirmation of receipt (CFM) " },
  { CRC_ST_MSG                , "\0msg" },
  { CRC_ST_MSGS               , "\0msgs" },
  { CRC_ST_PERSONAL           , "\0personal" },
  { CRC_WT_GRP                , "\0Grp" },
  { CRC_IL_FOUNDPERSONAL      , "\0 Found %u personal mail%s in %u area%s " },
  { CRC_IL_NOPERSONAL         , "\0 No personal mail found " },
  { CRC_ST_ESCORCONTINUE      , "\0ESC exits. Other keys: Tries to continue" },
  { CRC_MS_SPELLCHECKER       , "\0SpellChecker: %s" },
  { CRC_WT_INS                , "\0 Ins " },
  { CRC_MI_FILELISTFROM       , "\0Filelist from %s" },
  { CRC_ST_INITIALIZING       , "\0Initializing ..." },
  { CRC_ST_CHECKING           , "\0Checking" },
  { CRC_ST_LOCKSHARECAP       , "\0%s Lock/Share Capability" },
  { CRC_WT_ATTRTURNOFF        , "\0 Press Alt-F1 to turn off this window " },
  { CRC_WT_TAGLINES           , "\0 Taglines " },
  { CRC_ST_CHANGETAGLINE      , "\0Change Default Tagline" },
  { CRC_IL_NOTAGLINE          , "\0 No taglines defined. Press key " },
  { CRC_WT_CHARSETS           , "\0 Charsets " },
  { CRC_ST_CHANGEXLATIMP      , "\0Change Default Import Charset" },
  { CRC_IL_NOXLATIMPORT       , "\0 No XLATIMPORT's defined. Press key " },
  { CRC_WT_N_A                , "\0n/a" },
  { CRC_WT_WRITTEN            , "\0Written" },
  { CRC_WT_ARRIVED            , "\0Arrived" },
  { CRC_WT_RECEIVED           , "\0Received" },
  { CRC_IL_NONODELIST         , "\0 Unable to access the nodelist or index files " },
  { CRC_IL_NODELISTMISSING    , "\0Nodelist missing:" },
  { CRC_IL_NODELISTOUTDATED   , "\0Nodelist out of date:" },
  { CRC_MS_REPLYLINKER        , "\0Replylinker: %s" },
  { CRC_WT_ENTERMSGNO         , "\0 Enter msgno " },
  { CRC_IL_WAITUUDECODING     , "\0 Wait - uudecoding the current message " },
  { CRC_IL_COMPLETEDUUDECODE  , "\0 Completed uudecode of %s " },
  { CRC_IL_NOTUUENCODED       , "\0 Could not find anything to uudecode in this message " },
  { CRC_IL_ERRORINSOUP        , "\0 Error in SOUP file %s " },
  { CRC_IL_WARNALREADYSENT    , "\0 WARNING: This message is already sent! " },
  { CRC_IL_WAITLOCKED         , "\0 Wait: %s is locked " },
  { CRC_ST_RETRYORESC         , "\0%s retry (%lu). Press ESC to exit GoldED." },
  { CRC_ST_RETRYLOCK          , "\0Lock" },
  { CRC_ST_RETRYOPEN          , "\0Open" },
  { CRC_WT_TOUCHSEMAPHORE     , "\0 Enter name of semaphore file to touch " },
  { CRC_MI_DISKFILENOHDR      , "\0f Disk file, without header " },
  { CRC_MI_PRINTERNOHDR       , "\0r Printer, without header " },

  { CRC_LAST_CRC              , "\0" }
};


//  ------------------------------------------------------------------

GoldedLng::GoldedLng() {

  lang = langdefault;
  langmax = LNG_MAX;
}


//  ------------------------------------------------------------------

GoldedLng::~GoldedLng() {

}


//  ------------------------------------------------------------------

GoldedLng language;


//  ------------------------------------------------------------------

