
//  ------------------------------------------------------------------
//  GoldED. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gelang.h,v 1.1.1.1 1998/11/21 19:38:04 odinn Exp $
//  ------------------------------------------------------------------
//  Language handling.
//  ------------------------------------------------------------------


#include <glang.h>


//  ------------------------------------------------------------------

enum {

  LNG_MS_SWSUN,
  LNG_MS_SWMON,
  LNG_MS_SWTUE,
  LNG_MS_SWWED,
  LNG_MS_SWTHU,
  LNG_MS_SWFRI,
  LNG_MS_SWSAT,

  LNG_MS_LWSUNDAY,
  LNG_MS_LWMONDAY,
  LNG_MS_LWTUESDAY,
  LNG_MS_LWWEDNESDAY,
  LNG_MS_LWTHURSDAY,
  LNG_MS_LWFRIDAY,
  LNG_MS_LWSATURDAY,

  LNG_MS_SMJAN,
  LNG_MS_SMFEB,
  LNG_MS_SMMAR,
  LNG_MS_SMAPR,
  LNG_MS_SMMAY,
  LNG_MS_SMJUN,
  LNG_MS_SMJUL,
  LNG_MS_SMAUG,
  LNG_MS_SMSEP,
  LNG_MS_SMOCT,
  LNG_MS_SMNOV,
  LNG_MS_SMDEC,

  LNG_MS_LMJANUARY,
  LNG_MS_LMFEBRUARY,
  LNG_MS_LMMARCH,
  LNG_MS_LMAPRIL,
  LNG_MS_LMMAY,
  LNG_MS_LMJUNE,
  LNG_MS_LMJULY,
  LNG_MS_LMAUGUST,
  LNG_MS_LMSEPTEMBER,
  LNG_MS_LMOCTOBER,
  LNG_MS_LMNOVEMBER,
  LNG_MS_LMDECEMBER,

  LNG_ST_IMPORTFILE,
  LNG_WT_IMPORTWHICHFILE,
  LNG_WT_IMPORTPICK,
  LNG_ST_IMPORTSTATUS,
  LNG_ST_EXPORTFILE,
  LNG_WT_EXPORTWHATFILE,
  LNG_ST_EXPORTSTATUS,
  LNG_ST_EDITSTATUS,
  LNG_ST_SELECTFILES,
  LNG_WL_SELECTEDFILES,
  LNG_WL_SELECTEDBYTES,
  LNG_WL_TOTALFILES,
  LNG_WL_TOTALBYTES,
  LNG_WL_MOVEFILEBAR,
  LNG_WL_TOGGLEFILE,
  LNG_WL_ACCEPTFILES,
  LNG_WL_SELECTALLFILES,
  LNG_WL_ABORTFILES,
  LNG_WL_SCANNINGDIRECTORY,
  LNG_WL_NOFILESFOUND,
  LNG_ST_FILESPRESSKEY,
  LNG_WT_AREA,
  LNG_WT_DESCRIPTION,
  LNG_WT_MSGS,
  LNG_WT_LAST,
  LNG_WT_ECHOID,
  LNG_ST_UNREAD,
  LNG_WT_SCANAREAS,
  LNG_MI_SCANALL,
  LNG_MI_SCANMARKED,
  LNG_MI_SCANCURRENT,
  LNG_MI_SCANMATCHING,
  LNG_MI_SCANUNSCANNED,
  LNG_MI_NOSCAN,
  LNG_WT_HEATAREAS,
  LNG_MI_HEATALL,
  LNG_MI_HEATMARKED,
  LNG_MI_HEATCURRENT,
  LNG_MI_NOHEAT,
  LNG_WT_ZAPAREAS,
  LNG_MI_ZAPALL,
  LNG_MI_ZAPMARKED,
  LNG_MI_ZAPCURRENT,
  LNG_MI_NOZAP,
  LNG_MS_DOS_SHELL,
  LNG_IL_SCANNINGAREA,
  LNG_IL_SEARCHINGFOR,
  LNG_ST_READINGMSG,
  LNG_ER_OUTOFMEM,
  LNG_MS_HEXDUMPHEAD,
  LNG_MS_HEXDUMPTEXT,
  LNG_ST_RENUMBERING,
  LNG_ST_LOCKED,
  LNG_ST_RENUMBERED,
  LNG_WL_BLANKMSG,
  LNG_WL_WAIT,
  LNG_IL_GENHEXDUMP,
  LNG_ST_PROCESSCC,
  LNG_ST_STATUSCC,
  LNG_ST_DESTINATIONCC,
  LNG_MS_LISTCC,
  LNG_WT_DELORIG,
  LNG_MI_DELORIGYES,
  LNG_MI_DELORIGNO,
  LNG_WT_DROPMSG,
  LNG_MI_DROPMSGYES,
  LNG_MI_DROPMSGNO,
  LNG_WT_ZONEGATE,
  LNG_MI_ZONEGATEYES,
  LNG_MI_ZONEGATENO,
  LNG_ST_QUOTEPCT,
  LNG_WT_SAVEMSG,
  LNG_MI_YESGREAT,
  LNG_MI_KICKIT,
  LNG_MI_CONTINUE,
  LNG_MI_ROT13,
  LNG_MI_ATTRS,
  LNG_MI_ORIGS,
  LNG_MI_VIEW,
  LNG_ST_SELECTDESTNODE,
  LNG_WT_ATTACHFILES,
  LNG_WT_UPDREQFILES,
  LNG_ST_EDITHEADER,
  LNG_WT_EDITING,
  LNG_MI_INTERNALED,
  LNG_MI_EXTERNALED,
  LNG_MI_SAVEMESSAGE,
  LNG_MI_ATTRO,
  LNG_MI_TEMPLATE,
  LNG_MI_ORIGIN,
  LNG_MI_QUITMESSAGE,
  LNG_ST_TEMPLATES,
  LNG_WT_CHANGETEMPLATES,
  LNG_WT_CARBONCOPY,
  LNG_MI_CCPROCESS,
  LNG_MI_CCIGNORE,
  LNG_MI_CCATTRIBS,
  LNG_MI_CCLISTFMT,
  LNG_WT_CCLIST,
  LNG_MI_CCLISTKEEP,
  LNG_MI_CCLISTNAMES,
  LNG_MI_CCLISTVISIBLE,
  LNG_MI_CCLISTHIDDEN,
  LNG_MI_CCLISTREMOVE,
  LNG_WT_ATTRTITLE,
  LNG_MI_ATTR01,
  LNG_MI_ATTR02,
  LNG_MI_ATTR03,
  LNG_MI_ATTR04,
  LNG_MI_ATTR05,
  LNG_MI_ATTR06,
  LNG_MI_ATTR07,
  LNG_MI_ATTR08,
  LNG_MI_ATTR09,
  LNG_MI_ATTR10,
  LNG_MI_ATTR11,
  LNG_MI_ATTR12,
  LNG_MI_ATTR13,
  LNG_MI_ATTR14,
  LNG_MI_ATTR15,
  LNG_HD_FROM,
  LNG_HD_TO,
  LNG_HD_SUBJ,
  LNG_HD_FILE,
  LNG_MS_EMPTYMSG,
  LNG_MS_AUTOATTACHMSG,
  LNG_MS_AUTOREQUESTMSG,
  LNG_MS_AUTOUPDREQMSG,
  LNG_WT_FILEATTACH,
  LNG_WT_FILEREQUEST,
  LNG_WT_FILEUPDREQ,
  LNG_ST_FILEATTACHING,
  LNG_ST_FILEREQUESTING,
  LNG_ST_FILEUPDREQING,
  LNG_ST_READMARKED,
  LNG_ST_READALL,
  LNG_ST_NOQRENUM,
  LNG_MS_FROMTWIT,
  LNG_HD_VIA,
  LNG_WT_CHANGEATTRS,
  LNG_WT_HEADERTEXT,
  LNG_WT_HEADERONLY,
  LNG_WT_NEWAREA,
  LNG_WT_REPLYAREA,
  LNG_WT_COPYAREA,
  LNG_WT_MOVEAREA,
  LNG_WT_FORWARDAREA,
  LNG_WT_FREQAREA,
  LNG_WT_FREQMENUTITLE,
  LNG_ST_FREQSTAT,
  LNG_IL_FREQINFONOFILES,
  LNG_WT_COPY,
  LNG_WT_MOVE,
  LNG_WT_COPYING,
  LNG_WT_MOVING,
  LNG_ST_COPYINGMSG,
  LNG_ST_MOVINGMSG,
  LNG_WT_DELETE,
  LNG_WT_DELETING,
  LNG_ST_DELETINGMSG,
  LNG_WT_WRITE,
  LNG_WT_WRITEMSGS,
  LNG_WT_WRITING,
  LNG_ST_WRITINGMSG,
  LNG_WT_WRITINGFILE,
  LNG_WT_WRITINGPRN,
  LNG_IL_READONLYWARN,
  LNG_WT_ISREADONLY,
  LNG_MI_READONLYYES,
  LNG_MI_READONLYNO,
  LNG_IL_CHANGEWARN,
  LNG_WT_CHANGE,
  LNG_MI_CHANGEYES,
  LNG_MI_CHANGENO,
  LNG_WT_DELETETHIS,
  LNG_MI_DELETEYES,
  LNG_MI_DELETENO,
  LNG_MI_DELETENOASK,
  LNG_WT_GOTONEXT,
  LNG_MI_GOTONEXTYES,
  LNG_MI_GOTONEXTNO,
  LNG_WT_MSG,
  LNG_WT_MSGREAL,
  LNG_WT_FROML,
  LNG_WT_TOL,
  LNG_WT_SUBJL,
  LNG_ST_MSGLISTER,
  LNG_ST_COPYMOVEFORWARD,
  LNG_WT_SELECTACTION,
  LNG_MI_FORWARDMESSAGE,
  LNG_MI_MOVEMESSAGE,
  LNG_MI_COPYMESSAGE,
  LNG_MI_QUITCMF,
  LNG_ST_ARE,
  LNG_ST_IS,
  LNG_ST_MARKED,
  LNG_MI_MARKEDMSG,
  LNG_MI_CURRENTMSG,
  LNG_MI_QUITMSGS,
  LNG_ST_WRITEMSGSTO,
  LNG_WT_WRITETO,
  LNG_MI_DISKFILE,
  LNG_MI_PRINTER,
  LNG_MI_QUITWRITE,
  LNG_ST_MARKINGOPTIONS,
  LNG_WT_MARKWHAT,
  LNG_MI_YOURMAIL,
  LNG_MI_FROMTOSUBJ,
  LNG_MI_TEXTHDR,
  LNG_MI_THREAD,
  LNG_MI_NEWMSGS,
  LNG_MI_OLDMSGS,
  LNG_MI_ALLMSGS,
  LNG_MI_UNMARK,
  LNG_MI_RANGE,
  LNG_MI_MARKSTOGGLE,
  LNG_MI_QUITMARKS,
  LNG_WT_ENTERMARKSTRING,
  LNG_ST_SEARCHINGMSG,
  LNG_ST_MARKINGCHAIN,
  LNG_WT_USERLISTNAME,
  LNG_IL_GENUSERLIST,
  LNG_WT_FILEEXISTS,
  LNG_MI_APPEND,
  LNG_MI_OVERWRITE,
  LNG_MI_QUITEXIST,
  LNG_IL_WARNUNSENT,
  LNG_ST_CHANGEORIGIN,
  LNG_WT_ORIGINS,
  LNG_ST_CHANGEUSERNAME,
  LNG_WT_USERNAMES,
  LNG_ST_CHANGEAKA,
  LNG_WT_AKAS,
  LNG_WT_LOOKUP,
  LNG_WL_PHONE,
  LNG_WT_QUITGOLDED,
  LNG_MI_QUITYES,
  LNG_MI_QUITNO,
  LNG_MS_EDITCMD,
  LNG_IL_NOORIGDEFINED,
  LNG_IL_NOUSERDEFINED,
  LNG_IL_NOAKADEFINED,
  LNG_IL_NOTPLDEFINED,
  LNG_MS_SKIPPINGTWIT,
  LNG_IL_WRITINGCFG,
  LNG_IL_COULDNOTOPEN,
  LNG_MS_PROMPT,
  LNG_IL_UNFINISHEDMSG,
  LNG_ST_LOADUNFINISHED,
  LNG_IL_READINGECHOLIST,
  LNG_IL_READINGADDRMACROS,
  LNG_IL_CHECKINGNODELISTS,
  LNG_ST_CROSSPOSTING,
  LNG_IL_TWITBLANKED,
  LNG_IL_TWITSKIPPED,
  LNG_IL_TWITIGNORESKIP,
  LNG_IL_TWITDISPLAYED,
  LNG_ST_GENCFMRECEIPT,
  LNG_WT_NEW,
  LNG_ST_LOOKUPINFO,
  LNG_MS_DATETIMEFMT,
  LNG_MS_DATEFMT,
  LNG_MS_TIMEFMT,
  LNG_MS_CROSSPOSTEDIN,
  LNG_ST_STATUSLINEHELP,
  LNG_HD_OF,
  LNG_MS_ROBOTMSG,
  LNG_ST_STATUSLINETIMEFMT,

  LNG_WT_REPLIES,
  LNG_ST_SELECTREPLY,
  LNG_IL_WAITOREXIT,
  LNG_WT_REALLYEXIT,
  LNG_MI_TAGLINES,
  LNG_MI_HEADEREDIT,
  LNG_MI_SCANGROUP,
  LNG_WT_QWKPACKET,
  LNG_MI_SCANQWK,
  LNG_WT_SOUPPACKET,
  LNG_MI_SCANSOUP,
  LNG_MI_SCANIMPORT,
  LNG_MI_SCANEXPORT,
  LNG_WT_SCANPM,
  LNG_MI_TAGLINE,
  LNG_WT_CONFIRM,
  LNG_MI_CONFIRMYES,
  LNG_MI_CONFIRMNO,
  LNG_IL_CONFIRMINFO,
  LNG_ST_MSG,
  LNG_ST_MSGS,
  LNG_ST_PERSONAL,
  LNG_WT_GRP,
  LNG_IL_FOUNDPERSONAL,
  LNG_IL_NOPERSONAL,
  LNG_ST_ESCORCONTINUE,
  LNG_MS_SPELLCHECKER,
  LNG_WT_INS,
  LNG_MI_FILELISTFROM,
  LNG_ST_UNREGWAIT,
  LNG_ST_INITIALIZING,
  LNG_ST_CHECKING,
  LNG_ST_LOCKSHARECAP,
  LNG_WT_ATTRTURNOFF,
  LNG_WT_TAGLINES,
  LNG_ST_CHANGETAGLINE,
  LNG_IL_NOTAGLINE,
  LNG_WT_CHARSETS,
  LNG_ST_CHANGEXLATIMP,
  LNG_IL_NOXLATIMPORT,
  LNG_WT_N_A,
  LNG_WT_WRITTEN,
  LNG_WT_ARRIVED,
  LNG_WT_RECEIVED,
  LNG_IL_NONODELIST,
  LNG_IL_NODELISTMISSING,
  LNG_IL_NODELISTOUTDATED,
  LNG_MS_REPLYLINKER,
  LNG_WT_ENTERMSGNO,
  LNG_IL_WAITUUDECODING,
  LNG_IL_COMPLETEDUUDECODE,
  LNG_IL_NOTUUENCODED,
  LNG_IL_ERRORINSOUP,
  LNG_IL_WARNALREADYSENT,
  LNG_IL_WAITLOCKED,
  LNG_ST_RETRYORESC,
  LNG_ST_RETRYLOCK,
  LNG_ST_RETRYOPEN,
  LNG_WT_TOUCHSEMAPHORE,
  LNG_MI_DISKFILENOHDR,
  LNG_MI_PRINTERNOHDR,

  LNG_MAX
};


//  ------------------------------------------------------------------

class golded_lng : public glang {

protected:

  static glangcrc langdefault[LNG_MAX+1];

public:

  golded_lng();
  ~golded_lng();

};


//  ------------------------------------------------------------------

