
//  ------------------------------------------------------------------
//  GoldED. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gelmsg.cpp,v 1.1.1.1 1998/11/21 19:38:04 odinn Exp $
//  ------------------------------------------------------------------
//  Load message or header. Save header.
//  ------------------------------------------------------------------


#include "golded.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif


//  ------------------------------------------------------------------

GMsg::GMsg() {

  area = NULL;
  reset(false);
}


//  ------------------------------------------------------------------

GMsg::~GMsg() {

  reset();
}


//  ------------------------------------------------------------------

void GMsg::reset(bool normal) {

  gmsg::reset(normal);

  if(normal) {
    line.reset();
    display.reset();
    area = NULL;
  }
  quotepct = 0;
  foundwhere = 0;
  foundtopline = 0;
  line_width = 0;
  orig_timesread = 0;
}


//  ------------------------------------------------------------------

int gactivearea::loadhdr(GMsg& msg, ulong msgno) {

  msg.reset();
  msg.area = this;
  msg.msgno = msgno;
  return area.load_hdr(msg);
}


//  ------------------------------------------------------------------

int gactivearea::loadmsg(GMsg& msg, ulong msgno, int margin, int mode) {

  msg.reset();
  msg.area = this;
  msg.msgno = msgno;
  if(msgno and area.load_msg(msg)) {
    if(mode & (GMSG_COPY|GMSG_MOVE)) {
      if(not ((mode & GMSG_MOVE) and (mode & GMSG_UNS_NOT_RCV)))
        return true;
      if(not (msg.attr.uns() and not msg.attr.rcv()))
        return true;
    }
    msg.text_to_lines(margin);
    return true;
  }
  return false;
}


//  ------------------------------------------------------------------

void gactivearea::savehdr(int mode, GMsg& msg) {

////////////  area.save_hdr(mode, msg);
  update_data();
}


//  ------------------------------------------------------------------

