
//  ------------------------------------------------------------------
//  GoldED. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gemenu.cpp,v 1.1.1.1 1998/11/21 19:38:04 odinn Exp $
//  ------------------------------------------------------------------
//  Menus.
//  ------------------------------------------------------------------


#include "golded.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif


//  ------------------------------------------------------------------

GMsg* MenuMsgPtr;
gactivearea* MenuAreaPtr;


//  ------------------------------------------------------------------

void DispHeadAttrs(GMsg& msg) {

  char atrs[200];
  msg.attr.make_string(atrs);
  strsetsz(atrs, gvid.numcols-CFG->disphdrnodeset.pos);

  HeaderView.window.prints(1, CFG->disphdrnodeset.pos, HeaderView.window_color, atrs);
  HeaderView.window.prints(4, 0, HeaderView.window_color, (msg.attr.att() or msg.attr.frq() or msg.attr.urq()) ? CFG->language[LNG_File] : CFG->language[LNG_Subj]);
}


//  ------------------------------------------------------------------

static void DispHeadAttrs() {

  DispHeadAttrs(*MenuMsgPtr);
}


//  ------------------------------------------------------------------

static void toggle_pvt() {

  MenuMsgPtr->attr.pvtX();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_received() {

  MenuMsgPtr->attr.rcvX();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_crash() {

  MenuMsgPtr->attr.craX();
  if(MenuMsgPtr->attr.cra())
    MenuMsgPtr->attr.hld0();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_hold() {

  MenuMsgPtr->attr.hldX();
  if(MenuMsgPtr->attr.hld()) {
    MenuMsgPtr->attr.cra0();
    MenuMsgPtr->attr.imm0();
  }
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_file() {

  MenuMsgPtr->attr.attX();
  if(MenuMsgPtr->attr.att()) {
    MenuMsgPtr->attr.add(CFG->attribsattach);
    MenuMsgPtr->attr.urq0();
    MenuMsgPtr->attr.frq0();
  }
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_freq() {

  MenuMsgPtr->attr.frqX();
  if(MenuMsgPtr->attr.frq()) {
    MenuMsgPtr->attr.att0();
    MenuMsgPtr->attr.urq0();
  }
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_updreq() {

  MenuMsgPtr->attr.urqX();
  if(MenuMsgPtr->attr.urq()) {
    MenuMsgPtr->attr.att0();
    MenuMsgPtr->attr.frq0();
  }
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_kill() {

  MenuMsgPtr->attr.k_sX();
  if(MenuMsgPtr->attr.k_s())
    MenuMsgPtr->attr.a_s0();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_sent() {

  MenuMsgPtr->attr.sntX();
  if(MenuMsgPtr->attr.snt()) {
    MenuMsgPtr->attr.uns0();
    MenuMsgPtr->attr.scn1();
  }
  else {
    MenuMsgPtr->attr.uns1();
    MenuMsgPtr->attr.scn0();
    MenuMsgPtr->attr.loc1();
    AL.update_exportlist(MenuAreaPtr);
  }

  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_trunc() {

  MenuMsgPtr->attr.tfsX();
  if(MenuMsgPtr->attr.tfs())
    MenuMsgPtr->attr.kfs0();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_delsent() {

  MenuMsgPtr->attr.kfsX();
  if(MenuMsgPtr->attr.kfs())
    MenuMsgPtr->attr.tfs0();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_direct() {

  MenuMsgPtr->attr.dirX();
  if(MenuMsgPtr->attr.dir()) {
    MenuMsgPtr->attr.zon0();
    MenuMsgPtr->attr.hub0();
  }
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_imm() {

  MenuMsgPtr->attr.immX();
  if(MenuMsgPtr->attr.imm())
    MenuMsgPtr->attr.hld0();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_locked() {

  MenuMsgPtr->attr.lokX();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_reserved() {

  MenuMsgPtr->attr.rsvX();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_groupmsg() {

  MenuMsgPtr->attr.grpX();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_arcsent() {

  MenuMsgPtr->attr.a_sX();
  if(MenuMsgPtr->attr.a_s())
    MenuMsgPtr->attr.k_s0();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_zonegate() {

  MenuMsgPtr->attr.zonX();
  if(MenuMsgPtr->attr.zon()) {
    MenuMsgPtr->attr.dir0();
    MenuMsgPtr->attr.hub0();
  }
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_transit() {

  MenuMsgPtr->attr.trsX();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_retrecreq() {

  MenuMsgPtr->attr.rrqX();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_retrec() {

  MenuMsgPtr->attr.rrcX();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_orphan() {

  MenuMsgPtr->attr.orpX();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_audit() {

  MenuMsgPtr->attr.arqX();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_hubhost() {

  MenuMsgPtr->attr.hubX();
  if(MenuMsgPtr->attr.hub()) {
    MenuMsgPtr->attr.dir0();
    MenuMsgPtr->attr.zon0();
  }
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_local() {

  MenuMsgPtr->attr.locX();
  if(MenuMsgPtr->attr.loc())
    MenuMsgPtr->attr.trs0();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_xmail() {

  MenuMsgPtr->attr.xmaX();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_cfmrecreq() {

  MenuMsgPtr->attr.cfmX();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void toggle_scanned() {

  MenuMsgPtr->attr.scnX();
  if(MenuMsgPtr->attr.scn()) {
    MenuMsgPtr->attr.snt1();
    MenuMsgPtr->attr.uns0();
  }
  else {
    MenuMsgPtr->attr.snt0();
    MenuMsgPtr->attr.uns1();
    MenuMsgPtr->attr.loc1();
    AL.update_exportlist(MenuAreaPtr);
  }
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void clear_attrib() {

  MenuMsgPtr->attr.reset();
  DispHeadAttrs();
}


//  ------------------------------------------------------------------

static void DispAttrWindow(int show=-1) {

  static int wh_background = -1;
  static int wh_attributes = -1;

  if(show == -1)
    show = wh_attributes == -1;

  if(show) {
    wh_background = whandle();
    int wide = maximum_of_two(strlen(CFG->language[LNG_AttrTitle])+2, strlen(CFG->language[LNG_AttrPvt])+2);
    wh_attributes = wopen_(6,0,17, wide, W_BMENU, C_MENUB, C_MENUW);
    set_title(CFG->language[LNG_AttrTitle], TCENTER, C_MENUT);
    if(*CFG->language[LNG_AttrTurnOff])
      wtitle(CFG->language[LNG_AttrTurnOff], TCENTER|TBOTTOM, C_MENUT);
    title_shadow();
    int n = 0;
    wprints(n++, 0, C_MENUW, CFG->language[LNG_AttrPvt]);
    wprints(n++, 0, C_MENUW, CFG->language[LNG_AttrRcv]);
    wprints(n++, 0, C_MENUW, CFG->language[LNG_AttrSnt]);
    wprints(n++, 0, C_MENUW, CFG->language[LNG_AttrCrs]);
    wprints(n++, 0, C_MENUW, CFG->language[LNG_AttrHld]);
    wprints(n++, 0, C_MENUW, CFG->language[LNG_AttrFil]);
    wprints(n++, 0, C_MENUW, CFG->language[LNG_AttrFrq]);
    wprints(n++, 0, C_MENUW, CFG->language[LNG_AttrUpd]);
    wprints(n++, 0, C_MENUW, CFG->language[LNG_AttrKS] );
    wprints(n++, 0, C_MENUW, CFG->language[LNG_AttrKfs]);
    wprints(n++, 0, C_MENUW, CFG->language[LNG_AttrTfs]);
    wprints(n++, 0, C_MENUW, CFG->language[LNG_AttrDir]);
    wprints(n++, 0, C_MENUW, CFG->language[LNG_AttrImm]);
    wprints(n++, 0, C_MENUW, CFG->language[LNG_AttrLok]);
    wprints(n++, 0, C_MENUW, CFG->language[LNG_AttrZap]);
    wactiv_(wh_background);
  }
  else if(wh_attributes != -1) {
    wactiv_(wh_attributes);
    wclose();
    wactiv_(wh_background);
    wh_attributes = -1;
  }
}


//  ------------------------------------------------------------------

static void toggle_dispattrwindow() {

  DispAttrWindow();
}


//  ------------------------------------------------------------------

void ChgAttrs(int mode, GMsg& msg, gactivearea* area) {

  static KBnd* k1;

  if(mode) {
    MenuMsgPtr = &msg;
    MenuAreaPtr = area;
    if(CFG->editheaderattrs or (mode == ALWAYS))
      DispAttrWindow(true);
    k1 = chgonkey(NULL);
    setonkey(Key_A_F1, toggle_dispattrwindow, 0);
    setonkey(Key_A_1, toggle_reserved   , 0);
    setonkey(Key_A_2, toggle_groupmsg   , 0);
    setonkey(Key_A_4, toggle_scanned    , 0);
    setonkey(Key_A_A, toggle_file       , 0);
    setonkey(Key_A_B, toggle_arcsent    , 0);
    setonkey(Key_A_C, toggle_crash      , 0);
    setonkey(Key_A_D, toggle_direct     , 0);
    setonkey(Key_A_E, toggle_delsent    , 0);
    setonkey(Key_A_F, toggle_freq       , 0);
    setonkey(Key_A_G, toggle_zonegate   , 0);
    setonkey(Key_A_H, toggle_hold       , 0);
    setonkey(Key_A_I, toggle_imm        , 0);
    setonkey(Key_A_J, toggle_transit    , 0);
    setonkey(Key_A_K, toggle_kill       , 0);
    setonkey(Key_A_L, toggle_locked     , 0);
    setonkey(Key_A_M, toggle_retrecreq  , 0);
    setonkey(Key_A_N, toggle_retrec     , 0);
    setonkey(Key_A_O, toggle_orphan     , 0);
    setonkey(Key_A_P, toggle_pvt        , 0);
    setonkey(Key_A_Q, toggle_audit      , 0);
    setonkey(Key_A_R, toggle_received   , 0);
    setonkey(Key_A_S, toggle_sent       , 0);
    setonkey(Key_A_T, toggle_trunc      , 0);
    setonkey(Key_A_U, toggle_updreq     , 0);
    setonkey(Key_A_V, toggle_hubhost    , 0);
    setonkey(Key_A_W, toggle_local      , 0);
    setonkey(Key_A_X, toggle_xmail      , 0);
    setonkey(Key_A_Y, toggle_cfmrecreq  , 0);
    setonkey(Key_A_Z, clear_attrib      , 0);
  }
  else {
    DispAttrWindow(false);
    freonkey();
    chgonkey(k1);
  }
}


//  ------------------------------------------------------------------

void AskAttributes(GMsg& msg, gactivearea* area) {

  ChgAttrs(ALWAYS, msg, area);
  update_statusline(CFG->language[LNG_ChangeAttrs]);
  whelpdef(CFG->helpged, Key_F1, C_HELPB, C_HELPW, C_HELPQ, C_HELPS, NULL);
  whelppcat(H_Attributes);
  getxch();
  whelpop();
  ChgAttrs(false, msg, area);
}


//  ------------------------------------------------------------------

void ChangeMenuFree(char** list, int lines) {

  for(int n=0; n<lines; n++)
    throw_free(list[n]);
  throw_free(list);
}


//  ------------------------------------------------------------------

void ChangeMenuNolines(const char* info) {

  w_info(info);
  waitkeyt(10000);
  w_info(NULL);
}


//  ------------------------------------------------------------------

int ChangeMenu(uint lines, const char* title, const char* statusline, int help, char** list, int startat) {

  set_title(title,TCENTER,C_ASKT);

  if(statusline)
    update_statusline(statusline);

  if(help != -1)
    whelppcat(help);

  lines = wpickstr(6,0,6+minimum_of_two(lines, (gvid.numrows-10))+1,-1,W_BASK,C_ASKB,C_ASKW,C_ASKS,list,startat,title_shadow);

  if(help != -1)
    whelpop();

  return lines;
}


//  ------------------------------------------------------------------

int SelectFromFile(const char* file, char* selection, const char* title, const char* nolines, const char* statusline, int help) {

  char buf[256];
  register uint n;
  bool retval=false;
  char** Listi;
  uint lines = 0;

  FILE* fp = fsopen(AddPath(CFG->goldpath, file), "rt", CFG->sharemode);
  if(fp) {
    while(fgets(buf, sizeof(buf), fp))
      lines++;
  }

  if(lines) {
    Listi = (char**)throw_calloc(lines+1, sizeof(char*));
    rewind(fp);
    for(n=0; n<lines; n++) {
      fgets(buf, sizeof(buf), fp);
      strsetsz(buf, gvid.numcols-2-2);
      strtrim(buf);
      Listi[n] = throw_strdup(buf);
    }
    n = ChangeMenu(n, title, statusline, help, Listi, 0);
    if(n != (uint)-1) {
      strcpy(selection, Listi[n]);
      retval = true;
    }
    ChangeMenuFree(Listi, lines);
  }
  else {
    ChangeMenuNolines(nolines);
  }

  if(fp)
    fclose(fp);

  return retval;
}


//  ------------------------------------------------------------------

int ChangeTagline(gactivearea* area) {

  char buf[256];
  register uint n;
  bool retval=false;
  char** Listi;

  if(CFG->tagline.size()) {
    Listi = (char**)throw_calloc(CFG->tagline.size()+1, sizeof(char*));
    for(n=0; n<CFG->tagline.size(); n++) {
      sprintf(buf, " %s ", CFG->tagline[n]);
      Listi[n] = throw_strdup(buf);
    }
    n = ChangeMenu(n, CFG->language[LNG_Taglines], CFG->language[LNG_ChangeTagline], H_ChangeTagline, Listi, CFG->taglineno);
    if(n != (uint)-1) {
      if(CFG->tagline[n][0] == '@') {
        if(SelectFromFile(CFG->tagline[n]+1, buf, CFG->language[LNG_Taglines], CFG->language[LNG_NoTagline], CFG->language[LNG_ChangeTagline], H_ChangeTagline)) {
          area->set_tagline(buf);
          retval = true;
        }
      }
      else {
        CFG->taglineno = n;
        area->set_tagline(CFG->tagline[n]);
        retval = true;
      }
    }
    ChangeMenuFree(Listi, CFG->tagline.size());
  }
  else {
    ChangeMenuNolines(CFG->language[LNG_NoTagline]);
  }

  return retval;
}


//  ------------------------------------------------------------------

int ChangeOrigin(gactivearea* area) {

  char buf[256];
  register uint n;
  bool retval=false;
  char** Listi;

  if(CFG->origin.size()) {
    Listi = (char**)throw_calloc(CFG->origin.size()+1, sizeof(char*));
    for(n=0; n<CFG->origin.size(); n++) {
      sprintf(buf, " %s ", CFG->origin[n]);
      Listi[n] = throw_strdup(buf);
    }
    n = ChangeMenu(n, CFG->language[LNG_Origins], CFG->language[LNG_ChangeOrigin], H_ChangeOrigin, Listi, CFG->originno);
    if(n != (uint)-1) {
      if(CFG->origin[n][0] == '@') {
        if(SelectFromFile(CFG->origin[n]+1, buf, CFG->language[LNG_Origins], CFG->language[LNG_NoOrigDefined], CFG->language[LNG_ChangeOrigin], H_ChangeOrigin)) {
          area->set_origin(buf);
          retval = true;
        }
      }
      else {
        CFG->originno = n;
        area->set_origin(CFG->origin[n]);
        retval = true;
      }
    }
    ChangeMenuFree(Listi, CFG->origin.size());
  }
  else {
    ChangeMenuNolines(CFG->language[LNG_NoOrigDefined]);
  }

  return retval;
}


//  ------------------------------------------------------------------

int ChangeUsername(gactivearea* area) {

  char buf[256], adrs[40];
  register uint n;
  char** Listi;

  if(CFG->usernames) {
    Listi = (char**)throw_calloc(CFG->usernames+1, sizeof(char*));
    for(n=0; n<CFG->usernames; n++) {
      CFG->username[n].addr.make_string(adrs);
      sprintf(buf, " %-35s %s ", CFG->username[n].name, adrs);
      Listi[n] = throw_strdup(buf);
    }
    n = ChangeMenu(n, CFG->language[LNG_Usernames], CFG->language[LNG_ChangeUsername], H_ChangeUsername, Listi, CFG->usernameno);
    if(n != (uint)-1) {
      CFG->usernameno = n;
      area->set_username(CFG->username[n]);
      for(uint a=0; a<CFG->akas; a++) {
        if(area->username().addr.match(CFG->aka[a].addr)) {
          area->set_aka(CFG->aka[a].addr);
          break;
        }
      }
    }
    ChangeMenuFree(Listi, CFG->usernames);
  }
  else {
    ChangeMenuNolines(CFG->language[LNG_NoUserDefined]);
  }

  return true;
}


//  ------------------------------------------------------------------

int ChangeTemplate(gactivearea* area) {

  char buf[256];
  register uint n;
  int selected=-1;
  char** Listi;

  if(CFG->tpls) {
    Listi = (char**)throw_calloc(CFG->tpls+1, sizeof(char*));
    for(n=0; n<CFG->tpls; n++) {
      sprintf(buf, " %s ", CFG->tpl[n].name);
      Listi[n] = throw_strdup(buf);
    }
    n = ChangeMenu(n, CFG->language[LNG_Templates], CFG->language[LNG_ChangeTemplate], H_ChangeTemplate, Listi, CFG->tplno);
    if(n != (uint)-1) {
      area->set_tpl(CFG->tpl[n].file);
      tplselected = true;
      CFG->tplno = n;
    }
    selected = n;
    ChangeMenuFree(Listi, CFG->tpls);
  }
  else {
    ChangeMenuNolines(CFG->language[LNG_NoTplDefined]);
  }

  return selected;
}


//  ------------------------------------------------------------------

int ChangeAka(gactivearea* area) {

  uint n, startat = 0;
  char** Listi;
  char addr[100], buf[100];

  if(CFG->akas > 1) {
    Listi = (char**)throw_calloc(CFG->akas+1, sizeof(char*));
    gftnaddrs aka;
    for(n=0; n<CFG->akas; n++) {
      aka = CFG->aka[n];
      sprintf(buf, " %s ", aka.c_str());
      Listi[n] = throw_strdup(buf);
      if(area->address().ieql(aka))
        startat = n;
    }
    n = ChangeMenu(n, CFG->language[LNG_Akas], CFG->language[LNG_ChangeAka], H_ChangeAka, Listi, startat);
    if(n != (uint)-1) {
      aka = CFG->aka[n];
      area->set_aka(aka);
    }
    ChangeMenuFree(Listi, CFG->akas);
  }
  else {
    ChangeMenuNolines(CFG->language[LNG_NoAkaDefined]);
  }

  return true;
}


//  ------------------------------------------------------------------

int ChangeXlatImport(gactivearea* area) {

  #define H_ChangeXlatImport        1010

  uint n, startat = 0;
  uint xlatimports = 0;
  int maximport = 0;
  int maxexport = 0;
  char** Listi;
  char buf[100];

  if(XLAT.charset.size() > 1) {
    Listi = (char**)throw_calloc(XLAT->charset.size()+1, sizeof(char*));
    for(n=0; n<XLAT->charset.size(); n++) {
      if(XLAT->localset.ieql(XLAT->charset[n].export)) {
        maximport = maximum_of_two(maximport, (int)strlen(XLAT->charset[n].import));
        maxexport = maximum_of_two(maxexport, (int)strlen(XLAT->charset[n].export));
        if(area->xlatimport().ieql(XLAT->charset[n].import))
          startat = xlatimports;
        xlatimports++;
      }
    }
    xlatimports = 0;
    for(n=0; n<XLAT->charset.size(); n++) {
      if(XLAT->localset.ieql(XLAT->charset[n].export)) {
        sprintf(buf, " %*.*s -> %-*.*s ",
          maximport, maximport, XLAT->charset[n].import,
          maxexport, maxexport, XLAT->charset[n].export
        );
        Listi[xlatimports++] = throw_strdup(buf);
      }
    }
    n = ChangeMenu(xlatimports, CFG->language[LNG_Charsets], CFG->language[LNG_ChangeXlatImp], H_ChangeXlatImport, Listi, startat);
    if(n != (uint)-1)
      area->set_xlatimport(strtok(Listi[n], " "));
    ChangeMenuFree(Listi, xlatimports);
  }
  else {
    ChangeMenuNolines(CFG->language[LNG_NoXlatImport]);
  }

  return true;
}


//  ------------------------------------------------------------------

int ChangeMood(gactivearea* area) {

  #define LNG__Moods " Moods "
  #define LNG__ChangeMood "Change Default Mood"
  #define LNG__NoMood " No moods defined. Press key "
  #define LNG__MoodOff " [Don't use mood] "
  #define H_ChangeMood 1011

  char buf[256];
  register uint n;
  bool retval=false;
  char** Listi;

  if(CFG->mood.size()) {
    Listi = (char**)throw_calloc(CFG->mood.size()+2, sizeof(char*));
    Listi[0] = throw_strdup(LNG__MoodOff);
    for(n=0; n<CFG->mood.size(); n++) {
      sprintf(buf, " %s ", CFG->mood[n]);
      Listi[n+1] = throw_strdup(buf);
    }
    n = ChangeMenu(n, LNG__Moods, LNG__ChangeMood, H_ChangeMood, Listi, CFG->moodno);
    if(n != (uint)-1) {
      if(CFG->mood[n-1][0] == '@') {
        if(SelectFromFile(CFG->mood[n]+1, buf, LNG__Moods, LNG__NoMood, LNG__ChangeMood, H_ChangeMood)) {
          area->set_mood(buf);
          retval = true;
        }
      }
      else {
        CFG->moodno = n;
        area->set_mood(n ? CFG->mood[n-1] : "");
        retval = true;
      }
    }
    ChangeMenuFree(Listi, CFG->mood.size());
  }
  else {
    ChangeMenuNolines(LNG__NoMood);
  }

  return retval;
}


//  ------------------------------------------------------------------

