
//  ------------------------------------------------------------------
//  GoldED. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: genodo.h,v 1.1.1.1 1998/11/21 19:38:05 odinn Exp $
//  ------------------------------------------------------------------


//  ------------------------------------------------------------------
//  GoldED nodelist index items

#if defined(GOLD_CANPACK)
#pragma pack(1)
#endif


const uint MAX_ITEM =  25;        // Max number of nodelists
const uint MAX_NODE =  50;        // Max number of node masks


typedef word Nix;

struct GNidx {
  long     pos;              // File Number ORed with pos in nodelist file
  ftn_addr addr;             // Node address
  ftn_name name;             // Nodename, reversed
};


//  ------------------------------------------------------------------
//  Structure for GOLDNODE.LIX

struct NodeLix {

  // Nodelists
  int      nodelists;
  gstamp    nodelist[MAX_ITEM];

  // Excludenodes
  int      excludenodes;
  ftn_addr excludenode[MAX_NODE];

  // Includenodes
  int      includenodes;
  ftn_addr includenode[MAX_NODE];

  // Index files
  Path     addrindex;
  Path     nodeindex;
};


//  ------------------------------------------------------------------
//  Structure for GOLDNODE.IXL

struct NodeIxl {

  // Nodelists
  int    nodelists;
  gstamp* nodelist;

  // Index files
  Path addrindex;
  Path nodeindex;

};


#if defined(GOLD_CANPACK)
#pragma pack()
#endif



//  ------------------------------------------------------------------

struct NInf {
  char  entry[256];
  char  str[160];
  GNidx nlst;
};


//  ------------------------------------------------------------------

