
//  ------------------------------------------------------------------
//  GoldED. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gepost.cpp,v 1.1.1.1 1998/11/21 19:38:05 odinn Exp $
//  ------------------------------------------------------------------
//  Mega-function to handle creation of msgs :-(
//  ------------------------------------------------------------------


#include "golded.h"

#ifdef __BORLANDC__
#pragma hdrstop
//#pragma option -Od
#endif


//  ------------------------------------------------------------------

void MakeMsg(int mode, GMsg& omsg, gactivearea* destarea, gactivearea* origarea) {

  GFTRK("MakeMsg");

  w_info(CFG->language[LNG_Wait]);

  int xparea[512];
  gvector<int> xparea;

  if(origarea == NULL)
    origarea = destarea;

  _in_editor = true;

  GMsg msg;
  ulong reply_msgno = 0;

  destarea->randomize(true);

  if(destarea->forcetemplate() and (mode != MODE_CHANGE))
    ChangeTemplate(destarea);

  bool confirm = false;
  if(mode == MODE_CONFIRM) {
    confirm = true;
    mode = MODE_REPLY;
  }

  bool savedirect = msg.attr.frq() and (CFG->frqoptions & FREQ_FAST);

  int status = STATUS_SAVE;
  int hardlines = CFG->edithardlines;

  int topline = 0;
  fspecs = specfiles = 0;
  fspec = (FileSpec*)throw_realloc(fspec, sizeof(FileSpec));
  memset(fspec, 0, sizeof(FileSpec));

  msg.timesread = 1;

  if(mode & MODE_FORWARD) {
    msg.copy(omsg);
    msg.header.reset();
    msg.kludge.replyaddr = "";
    msg.kludge.replyto = "";
  }
  if(mode & (MODE_CHANGE|MODE_FORWARD)) {
    msg.copy(omsg);
    msg.area = destarea;
  }
  if(mode == MODE_NEW) {
    BodyView.Clear();
  }
  if(mode & MODE_REPLYING) {
    msg.area = destarea;
    destarea->newmsgno(msg);
  }

  msg.origaddr = msg.oaddress;
  msg.destaddr = msg.daddress;

  if(destarea->isinternet())
    msg.oaddress = destarea->internetaddress();

  bool dochgdate = true;
  if(mode == MODE_CHANGE) {
    dochgdate = CFG->editchangedate;
    if((dochgdate == true) and not msg.attr.fmu())
      dochgdate = false;
  }
  if(dochgdate) {
    msg.date.written = gtime(NULL);
    msg.date.written.utc_offset = CFG->timezoneoffset;
    msg.date.arrived = msg.date.received = 0;
    if(destarea->isinternet())
      msg.header.date = msg.date.written.rfc822();
  }

  if(mode != MODE_CHANGE)
    msg.attr = destarea->attr();

  if(mode & (MODE_QUOTE|MODE_COMMENT)) {
    omsg.text_to_lines(-CFG->quotemargin);
    if(omsg.attr.rot())
      Rot13(omsg);
  }

  if(mode & MODE_REPLYING) {

    if(confirm)
      msg.attr = CFG->attribscfm;
    if(omsg.attr.pvt())
      msg.attr.pvt1();
    if(omsg.attr.frq() and (mode == MODE_REPLY) and (not confirm)) {
      msg.attr = CFG->attribsfrq;
      msg.attr.frq1();
    }

    if((mode == MODE_COMMENT) and omsg.kludge.fwdorig) {
      omsg.oname    = omsg.kludge.fwdfrom;
      omsg.origaddr = omsg.kludge.fwdorig;
      omsg.oaddress = omsg.kludge.fwdorig;
      omsg.dname    = omsg.kludge.fwdto;
      omsg.destaddr = omsg.kludge.fwddest;
      omsg.daddress = omsg.kludge.fwddest;
      omsg.subject  = omsg.kludge.fwdsubj;
    }

    if(destarea->akamatching()) {
      ftn_addr aka_addr = destarea->address();
      if(aka_addr == destarea->orig_aka()) {
        gstring akaaddr = destarea->address();
        AkaMatch(akaaddr, omsg.oaddress);
        destarea->set_address(akaaddr);
      }
    }

    if((mode == MODE_COMMENT) and not omsg.kludge.fwdorig) {
      msg.dname = omsg.dname;
      msg.daddress = omsg.daddress;
    }
    else {
      if(omsg.header.reply_to) {
        gstring name;
        gstring addr;
        ParseInternetAddr(omsg.header.reply_to, name, addr);
        if(name)
          msg.dname = addr;
        if(addr)
          msg.daddress = addr;
      }
      else {
        msg.dname = omsg.oname;
        msg.daddress = omsg.oaddress;
      }
    }

    msg.subject = omsg.subject;

    if(destarea->editreplyre() or destarea->isinternet()) {
      if(msg.subject.nicmp("Re:", 3))
        msg.subject = ((msg.attr.frq() or msg.attr.urq()) ? "" : "Re: ") + msg.subject;
    }
    else {
      const char* stripped = msg.subject.c_str();
      while(strnieql(stripped, "Re:", 3))
        stripped = strskip_wht(stripped + 3);
      msg.subject = stripped;
    }

    msg.destaddr.domain = omsg.origaddr.domain;

    if((mode == MODE_COMMENT) and omsg.kludge.fwdorig)
      msg.kludge.reply = omsg.kludge.fwdmsgid;
    else
      msg.kludge.reply = omsg.kludge.msgid;

    if(destarea->isemail()) {
      msg.header.in_reply_to = omsg.header.message_id;
      msg.header.references  = omsg.header.message_id;
    }

    if(destarea->isnewsgroup()) {
      msg.header.references = omsg.header.references;
      if(omsg.header.message_id) {
        msg.header.references += " ";
        msg.header.references += omsg.header.message_id;
      }
      msg.header.newsgroups = omsg.header.newsgroups;
    }

    if(omsg.kludge.replyaddr) {
      msg.daddress = omsg.kludge.replyaddr;
      char* gateaddr = throw_xstrdup(msg.kludge.replyto.c_str());
      char* gatename = strchr(gateaddr, ' ');
      if(gatename)
        *gatename++ = NUL;
      else
        gatename = "UUCP";
      msg.destname = gatename;
      msg.destaddr = gateaddr;
      throw_xfree(gateaddr);
    }

    if(destarea == origarea) {
      if((CFG->replylink == REPLYLINK_DIRECT) or destarea->isjam())
        reply_msgno = omsg.msgno;
      else if(CFG->replylink == REPLYLINK_CHAIN) {
        GMsg uplink;
        uplink.msgno = omsg.msgno;
        uplink.link.first_set(omsg.link.first());
        if(uplink.link.first()) {
          while(destarea->msgnset.absolute_to_relative(uplink.link.first())) {
            if(not destarea->loadhdr(uplink, uplink.link.first()))
              uplink.msgno = 0;
          }
        }
        reply_msgno = uplink.msgno;
      }
      msg.link.to_set(reply_msgno);
      if(msg.link.to() == omsg.msgno)
        omsg.link.first_set(msg.msgno);
    }
  }

  if(mode == MODE_FORWARD) {
    if(not msg.kludge.fwdorig and _use_fwd) {
      msg.kludge.fwdfrom = msg.oname;
      msg.kludge.fwdorig = msg.oaddress;
      msg.kludge.fwdto   = msg.dname;
      msg.kludge.fwddest = msg.daddress;
      msg.kludge.fwdsubj = msg.subject;
      gactivearea* fwdarea = origarea;
      gstring empty;
      msg.kludge.fwdarea = fwdarea->isecho() ? fwdarea->echoid() : empty;
      msg.kludge.fwdmsgid = msg.kludge.msgid;
    }
  }

  if(mode & (MODE_NEW|MODE_REPLYING)) {
    msg.oname = destarea->username().name;
    msg.attr.nwm1();
    if(not destarea->islocal())
      msg.attr.uns1();
  }

  if(mode == MODE_CHANGE) {
    if(not destarea->islocal())
      msg.attr.uns1();
    msg.attr.snt0();
    msg.attr.rcv0();
  }

  if(mode & (MODE_NEW|MODE_FORWARD)) {
    msg.kludge.reply = "";
    msg.header.references = "";
    msg.header.in_reply_to = "";
    if(destarea->isnet()) {
      msg.dname = "";
      msg.daddress = "";
      msg.destaddr = 0;
    }
    if(not destarea->isnet() or (destarea->isemail() and strchr(destarea->whoto().c_str(), '@')))
      msg.dname = destarea->whoto();
  }

  if(mode != MODE_CHANGE) {
    msg.oaddress = destarea->address();
    if(not destarea->username().name.blank())
      msg.oname = destarea->username().name;
    if(CFG->emptytearline)
      msg.tearline = "";
  }

  if(mode != MODE_CHANGE) {

    if(destarea->taglinesupport()) {
      msg.tagline = destarea->tagline();
      if(msg.tagline[0] == '@')
        GetRandomLine(msg.tagline, msg.tagline.c_str()+1);
    }

    if(not CFG->emptytearline) {
      msg.tearline = destarea->tearline();
      if(msg.tearline[0] == '@')
        GetRandomLine(msg.tearline, msg.tearline.c_str()+1);
    }

    msg.origin = destarea->origin();
    msg.netname = destarea->netname();
    if(msg.origin[0] == '@')
      GetRandomLine(msg.origin, msg.origin.c_str()+1);

    msg.kludge.gif = destarea->gif();
    msg.kludge.mood = destarea->mood();
    msg.header.organization = destarea->organization();
    msg.header.followup_to = destarea->followupto();
    msg.header.reply_to = destarea->replyto();
    msg.header.sender = destarea->sender();
    if(msg.header.newsgroups.empty())
      msg.header.newsgroups = destarea->echoid();
    else
      msg.header.newsgroups = destarea->newsgroups();
    if(not msg.header.newsgroups.iinc(destarea->echoid())) {
      msg.header.newsgroups += ",";
      msg.header.newsgroups += destarea->echoid();
    }
  }

  if(msg.destaddr.invalid())
    msg.destaddr = msg.daddress;

  if(not confirm) {
    if(savedirect)
      CheckSubject(msg, msg.subject, destarea);
    else {
      GMenuEditHeader MenuEditHeader;
      status = MenuEditHeader.Run(mode, msg, destarea);
    }
  }

  bool forward_status = false;
  if(status == STATUS_SAVE) {
    if(mode == MODE_FORWARD)
      forward_status = true;
    if(mode != MODE_CHANGE and mode != MODE_FORWARD) {
      if(confirm) {
        throw_release(msg.txt);
        if(fexist(AddPath(CFG->goldpath, CFG->confirmfile)))
          msg.load_textfile(AddPath(CFG->goldpath, CFG->confirmfile), CFG->dispmargin-1);
        if(msg.txt == NULL)
          msg.txt = throw_strdup("\r\rConfirmation Receipt\r\r");
        TokenXlat(mode, msg.txt, msg, omsg, destarea, origarea);
      }
      else {
        CreateAutoMsg(msg, destarea);
      }
      msg.text_to_lines(CFG->dispmargin-1);
    }
  }

  if((status == STATUS_EDIT) or (mode == MODE_FORWARD and status == STATUS_SAVE)) {

    w_info(CFG->language[LNG_Wait]);

    if(mode == MODE_CHANGE) {
      if(msg.oname.icmp(destarea->username().name)) {
        bool found = false;
        for(int n=0; n<CFG->usernames; n++) {
          if(msg.oname.ieql(CFG->username[n].name)) {
            found = true;
            break;
          }
        }
        if(not found)
          status = STATUS_SAVE;
      }
    }

    if(mode != MODE_CHANGE or status == STATUS_SAVE) {
      if(TemplateToLines(mode, msg, omsg, destarea, origarea, CFG->dispmargin-1, true)) {
        HeaderView.Use(destarea, &msg);
        HeaderView.Paint();
      }
    }

    int position = reader_topline;
    int lineno = position;
    glineref line = msg.linearray;
    while(line.valid()) {
      if(not line.isquote())
        if(line.isposition())
          position = lineno;
      lineno++;
      line++;
    }

    int loop = 0;

    do {

      w_info(CFG->language[LNG_Wait]);

      if(loop) {
        status = STATUS_SAVE;
        forward_status = false;
      }
      else if(mode == MODE_FORWARD) {
        status = STATUS_SAVE;
      }

      if(not forward_status) {

        if(*CFG->editexternal and not CFG->editinternal) {

          gstring editfile = AddPath(CFG->goldpath, CFG->editfile);

          msg.save_textfile(editfile.c_str());

          char buf[256], buf2[256];
          strcpy(buf, CFG->editexternal);
          itoa(position+1, buf2, 10);
          strischg(buf, "@line", buf2);
          strischg(buf, "@file", editfile.c_str());
          long ftbefore = GetFiletime(editfile.c_str());
          sprintf(buf2, CFG->language[LNG_EditCmd], buf);

          ShellToDos(buf, buf2, LGREY|_BLACK, YES, true, false, destarea, false);

          long ftafter = GetFiletime(editfile.c_str());
          if(status != STATUS_SAVE) {
            status = STATUS_SAVE;
            if(ftbefore == ftafter)
              status = STATUS_DROP;
          }

          if(status != STATUS_DROP)
            msg.load_textfile(AddPath(CFG->goldpath, CFG->editfile), CFG->dispmargin-1);

        }
        else if(CFG->editinternal or not *CFG->editexternal) {

          status = savedirect ? STATUS_SAVE : EditMsg(mode, position, msg, destarea);
        }
      }

      if(status == STATUS_SAVE) {

        glineref line = msg.linearray;
        while(line.valid()) {
          if(not line.isquote()) {

            if(striinc("@position", line.text())) {
              gstring text = line.text();
              text.ichange("@position", "");
              line.set_text(text);
            }

            if(strnieql(line.text(), "XC:", 3) or strnieql(line.text(), "XP:", 3)) {

              gstrarray crosspost;
              tokenize(crosspost, line.text()+3, ", ");

              if(CFG->crosspostlist != CC_KEEP)
                line.erase();

              for(int n=0; n<crosspost.size(); n++) {

                const char* id = crosspost[n];
                bool hide = false;
                if(*id == '#') {
                  hide = true;
                  id++;
                }

                garealistdata* ap = AL.echoid_to_pointer(id);
                if(ap) {
                  if(CFG->crosspostlist == CC_NAMES) {
                    bool own = destarea->echoid().ieql(id);
                    if(xparea.empty() and not (own and hide)) {
                      line.insert(gstrf(CFG->language[LNG_Crosspostedin], destarea->echoid().c_str()), GLINE_HARD);
                      line++;
                    }
                    if(not hide) {
                      line.insert(gstrf(CFG->language[LNG_Crosspostedin], id), GLINE_HARD);
                      line++;
                    }
                  }
                  xparea.push_back(ap->areaid());
                }
              }
              continue;
            }
          }
          line++;
        }

        msg.reindex_lines();

        w_info();

        if(not savedirect) {
          _in_editor = false;
          HeaderView.Use(destarea, &msg);
          HeaderView.Paint();
          BodyView.Use(destarea, &msg, topline);
          BodyView.Paint();
          do {
            if(gkbd.quitall)
              status = STATUS_SAVE;
            else {
              GMenuEditfile MenuEditfile;
              status = MenuEditfile.Run(msg, destarea);
            }
            if(status == STATUS_VIEW) {
              BodyView.Use(destarea, &msg, topline);
              BodyView.Paint();
              ViewMessage();
            }
          } while(status == STATUS_VIEW);
          _in_editor = true;
        }
      }

      loop++;

      if(status ==  STATUS_CONTINUE) {
        HeaderView.Use(destarea, &msg);
        HeaderView.Paint();
      }

    } while(status == STATUS_CONTINUE);
  }

  if(status == STATUS_SAVE) {

    if(destarea->xlatexport()) {
      XLAT->load_charset(XLAT->localset.c_str(), destarea->xlatexport().c_str());
      if(XLAT->set.charset.active())
        msg.kludge.charset = XLAT->set.charset.export;
    }

    DoCarboncopy(msg, destarea);
    if(msg.kludge.cc.size())
      update_statuslinef("CC: %s %s", msg.dname.c_str(), msg.daddress.c_str());

    do_fakenets(msg, destarea);

    replace_controllines(mode, msg, destarea);

    msg.lines_to_text();

    if(specfiles > 0) {
      CreateFileMsgs(mode, msg, destarea);
    }
    else {

      HeaderView.Use(destarea, &msg);
      HeaderView.Paint();

      do_zonegating(msg, destarea);

      if(msg.destaddr.invalid())
        msg.destaddr = msg.daddress;

      HeaderView.Use(destarea, &msg);
      HeaderView.Paint();

      w_info(CFG->language[LNG_Wait]);
      destarea->savemsg((mode == MODE_CHANGE) ? GMSG_UPDATE : GMSG_NEW, msg);
      w_info();
    }

    for(int n=0; n<msg.kludge.cc.size(); n++) {

      destarea->newmsgno(msg);

      const char* ptr = msg.kludge.cc[n];
      const char* rptr = strrchr(ptr, ' ');
      if(rptr) {
        msg.dname.copyn(ptr, rptr-ptr).trim();
        rptr++;
        msg.daddress = rptr;

        update_statuslinef("CC: %s %s", msg.dname.c_str(), msg.daddress.c_str());

        if(destarea->akamatching()) {
          gftnaddrs aka = CFG->aka[AkaMatch(msg.oaddress, msg.daddress)];
          msg.oaddress = aka.str();
        }

        do_fakenets(msg, destarea);
        replace_controllines(mode, msg, destarea);

        msg.lines_to_text();
        if(destarea->isnet() and (msg.attr.frq() or msg.attr.att() or msg.attr.urq())) {
          CreateFileMsgs(MODE_NEW, msg, destarea);
        }
        else {

          HeaderView.Use(destarea, &msg);
          HeaderView.Paint();

          do_zonegating(msg, destarea);

          if(msg.destaddr.invalid())
            msg.destaddr = msg.daddress;

          HeaderView.Use(destarea, &msg);
          HeaderView.Paint();

          w_info(CFG->language[LNG_Wait]);
          destarea->savemsg(GMSG_NEW, msg);
          w_info();
        }
      }
    }

    if(destarea == origarea) {

      if(mode & MODE_REPLYING) {

        if(destarea->msgnset.absolute_to_relative(reply_msgno)) {
          GMsg reply;
          if(destarea->loadhdr(reply, reply_msgno)) {
            ulong replynext;
            int ok2save = false;
            if(destarea->issquish()) {
              if(reply.link.first()) {
                for(int r=0; r<reply.link.list_max()-1; r++) {
                  if(reply.link.list(r) == 0) {
                    reply.link.list_set(r, msg.msgno);
                    ok2save = true;
                    break;
                  }
                }
              }
              else {
                reply.link.first_set(msg.msgno);
                ok2save = true;
              }
            }
            else if(destarea->isjam()) {
              if(reply.link.first()) {
                replynext = reply.link.first();
                do {
                  reply_msgno = replynext;
                  if(not destarea->loadhdr(reply, reply_msgno))
                    break;
                  replynext = reply.link.next();
                } while(reply.link.next());
                if(reply.link.next() == 0) {
                  reply.link.next_set(msg.msgno);
                  ok2save = true;
                }
              }
              else {
                reply.link.first_set(msg.msgno);
                ok2save = true;
              }
            }
            else {
              reply.link.first_set(msg.msgno);
              ok2save = true;
            }
            if(ok2save) {
              reply.pcboard.reply_written = msg.date.written;
              destarea->savehdr(GMSG_UPDATE, reply);
            }
          }
        }

        if(CFG->askdelorig and not confirm) {
          if(not destarea->isecho()) {
            topline = 0;
            omsg.text_to_lines(CFG->dispmargin-1);
            if(omsg.attr.rot())
              Rot13(omsg);
            HeaderView.Use(destarea, &omsg);
            HeaderView.Paint();
            BodyView.Use(destarea, &omsg, topline);
            BodyView.Paint();
            GMenuDelorig MenuDelorig;
            if(MenuDelorig.Run()) {
              destarea->markset.delete_absolute(omsg.msgno);
              destarea->pmrkset.delete_absolute(omsg.msgno);
              destarea->deletemsg(omsg, DIR_PREV);
            }
          }
        }
      }
    }
  }
  else {
    xparea.resize(0);
  }

  destarea->update_data();

  CFG->edithardlines = hardlines;
  for(int n=0; n<fspecs; n++)
    throw_release(fspec[n].fblk);
  fspecs = specfiles = 0;
  throw_release(fspec);

  if(xparea.size()) {
    destarea->close();
    AL.deactivate(destarea);
    msg.link.reset();
    for(int xp=0; n<xparea.size(); xp++) {
      destarea = AL.activate(xparea[xp]);
      if(destarea != origarea) {
        update_statuslinef(CFG->language[LNG_Crossposting], destarea->echoid().c_str());
        destarea->open();
        destarea->newmsgno(msg);
        msg.area = destarea;
        msg.text_to_lines(CFG->dispmargin-1);
        msg.oaddress = destarea->address();
        replace_controllines(0, msg, destarea);
        msg.lines_to_text();
        destarea->savemsg(GMSG_NEW, msg);
        destarea->update_data();
        destarea->close();
      }
      AL.deactivate(destarea);
    }
  }

  _in_editor = false;

  tplselected = false;

  omsg.reset();

  GFTRK(NULL);
}
    

//  ------------------------------------------------------------------

