
//  ------------------------------------------------------------------
//  GoldED. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: geview.h,v 1.1.1.1 1998/11/21 19:38:05 odinn Exp $
//  ------------------------------------------------------------------
//  Message viewer classes.
//  ------------------------------------------------------------------


#include <gwindow.h>


//  ------------------------------------------------------------------

class GMsgHeaderView {

  int alive;

protected:

public:

  gactivearea* area;
  GMsg* msg;
  gwindow window;

  GMsgHeaderView();
  ~GMsgHeaderView();

  // Window setup
  int at_row;
  int at_column;
  int width;
  int height;
  int border_type;
  int border_color;
  int window_color;
  int title_color;

  int highlight_color;
  int from_color;
  int to_color;
  int subject_color;

  void Use(gactivearea* areaptr, GMsg* msgptr);

  void Create();
  void Destroy();

  void Paint();
};


//  ------------------------------------------------------------------

class GMsgBodyView {

  int alive;

protected:

  // View data
  int visible_width;
  int scrollbar_visible;
  int can_pagedown;
  int upperline;
  int lowerline;

  void PaintLine(int row, int lineno);
  void UpdateScrollbar();

public:

  gactivearea* area;
  GMsg* msg;
  gwindow window;

  GMsgBodyView();
  ~GMsgBodyView();

  // Window setup
  int at_row;
  int at_column;
  int width;
  int height;
  int border_type;
  int border_color;
  int window_color;
  int scrollbar_color;

  int highlight_color;

  void Use(gactivearea* areaptr, GMsg* msgptr, int startline=0);

  int UpperLine() { return upperline; }

  void Create();
  void Destroy();

  void Clear();

  void Paint();

  int Top(int redraw=false);
  int Bottom();
  int PageUp();
  int PageDown();
  int LineUp();
  int LineDown();
  int Continue();
  int ThumbTrack(int pos);
  int ThumbPosition(int pos);
};


//  ------------------------------------------------------------------

