
##  ------------------------------------------------------------------
##  The Goldware Library. Copyright (C) Odinn Sorensen.
##  ------------------------------------------------------------------
##  This program is free software; you can redistribute it and/or
##  modify it under the terms of the GNU General Public License as
##  published by the Free Software Foundation; either version 2 of the
##  License, or (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
##  General Public License for more details.
##
##  You should have received a copy of the GNU General Public License
##  along with this program; if not, write to the Free Software
##  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
##  ------------------------------------------------------------------
##  $Id: conv_h2g.awk,v 1.1.1.1 1998/11/21 19:37:58 odinn Exp $
##  ------------------------------------------------------------------
##  AWK code to convert Hudson to Goldbase using substitution of
##  class, structure and macro names.
##  ------------------------------------------------------------------


##  ------------------------------------------------------------------
##  Switch __HUDSON define to __GOLDBASE

/#define __HUDSON/ {

  gsub(/__HUDSON/, "__GOLDBASE")
}


##  ------------------------------------------------------------------
##  Substitute some "HUDS_" macros

/HUDS_/ {

  gsub(/HUDS_/, "GOLD_")
}


##  ------------------------------------------------------------------
##  Substibute all "Huds", except if they are part of "Hudson"

/Huds/ && !/Hudson/ {

  gsub(/Huds/, "Gold")
}


##  ------------------------------------------------------------------
##  Substibute all "huds", except if they are part of "hudson"

/huds/ && !/hudson/ {

  gsub(/huds/, "gold")
}


##  ------------------------------------------------------------------
##  Substibute all "hudson"

/hudson/ {

  gsub(/hudson/, "goldbase")
}


##  ------------------------------------------------------------------
##  Substibute all "MT_HUDSON"

/MT_HUDSON/ {

  gsub(/MT_HUDSON/, "MT_GOLDBASE")
}


##  ------------------------------------------------------------------
##  Print the line, including substitutions

{
  print > "tmp"
}


##  ------------------------------------------------------------------

