
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gbmh.h,v 1.1.1.1 1998/11/21 19:38:08 odinn Exp $
//  ------------------------------------------------------------------
//  Case-Insensitive Boyer-Moore-Horspool pattern match
//  ------------------------------------------------------------------


#ifndef __GBMH_H
#define __GBMH_H

#include <gdefs.h>


//  ------------------------------------------------------------------

class gbmh {

protected:

  int   skip[256];   // skip-ahead count for test chars
  int   skip2;       // skip-ahead after non-match with matching final char
  char* pat;
  int   patlen;
  bool  ignore_case;

public:

  gbmh();
  ~gbmh();

  void init(const char* pattern, bool ignorecase);
  bool find(const char* string);

};


//  ------------------------------------------------------------------
//  Old style - Almost obsolete ...

const uint BmhMAXPAT = 64;    // max pattern length

struct BmhArg {

  int  patlen;               // # chars in pattern
  char pat[BmhMAXPAT+1];     // uppercase copy of pattern
  int  skip[256];            // skip-ahead count for test chars
  int  skip2;                // skip-ahead after non-match with matching final char
  int  ignore;               // ignore case flag
};

typedef char BmhPat[BmhMAXPAT];

void strbmhinit(const char* __pat, BmhArg* __arg, int __ignore);
const char* strbmhsearch(const char* __buffer, int __buflen, const BmhArg* __arg);


//  ------------------------------------------------------------------

#endif

//  ------------------------------------------------------------------

