
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gcmpall.h,v 1.2 1999/02/03 22:51:29 leonid Exp $
//  ------------------------------------------------------------------
//  Compiler dependent definitions.
//  ------------------------------------------------------------------


//  ------------------------------------------------------------------
//  Only include once!

#ifndef __GCMPALL_H
#define __GCMPALL_H


//  ------------------------------------------------------------------
//  Borland C++                                     DOS, Windows, OS/2

#if defined(__BORLANDC__)
# define GOLD_COMPILER __BORLANDC__
# define _extc cdecl
# define _extp pascal
# define _stdc
# define _fast
# if defined(__WIN32__) || defined(__OS2__)
#   define __NEAR
#   define __FAR
#   define __HUGE
#   define GOLD_CANPACK
# elif defined(__MSDOS__)
#   define __NEAR  near
#   define __FAR   far
#   define __HUGE  huge
# else
#   error Unknown Borland C++ compiler?!
# endif
# define NW(x) if(x) 0
# if __BORLANDC__ >= 0x500
#   define USING(n) using n
# else
#   define USING(n)
# endif
# if __TURBOC__ < 0x469
#   define GSTD_NO_BOOL 1
# endif
#endif


//  ------------------------------------------------------------------
//  Watcom C++                                      OS/2, Windows, DOS

#if defined(__WATCOMC__)
# define GOLD_COMPILER __WATCOMC__
# define _extc
# define _extp
# define _stdc
# define _fast
# define __NEAR
# define __FAR
# define __HUGE
# define GOLD_CANPACK
# define NW(x) x=x
# define USING(n)
# if __WATCOMC__ >= 1100
#  define __GOLDWARE_HAS_BOOL 1
# else
#  define GSTD_NO_BOOL 1
# endif
#endif


//  ------------------------------------------------------------------
//  GNU C++                                              All platforms

#if defined(__GNUC__)
# define GOLD_COMPILER __GNUC__
# define _extc
# define _extp
# define _stdc
# define _fast
# define __NEAR
# define __FAR
# define __HUGE
# define GOLD_CANPACK
# define NW(x) x=x
# define USING(n)
#endif


//  ------------------------------------------------------------------

#if !defined(__MSDOS__)
  #if defined(MSDOS)
    #define __MSDOS__ MSDOS
  #elif defined(__DOS__)
    #define __MSDOS__ __DOS__
  #endif
#endif

#if !defined(__OS2__)
  #if defined(OS2)
    #define __OS2__ OS2
  #elif defined(__EMX__) && !defined(__WIN32__)
    #define __OS2__ __EMX__
  #endif
#endif

#if !defined(__WIN32__)
  #if defined(__NT__)
    #define __WIN32__ __NT__
  #endif
#endif

#if !defined(__UNIX__)
  #if defined(__linux__)
    #define __UNIX__ __linux__
  #endif
#endif

#if !defined(__386__)
  #if defined(__GNUC__)
    #define __386__ 1
  #endif
#endif


//  ------------------------------------------------------------------

#if defined(__MSDOS__) || defined(__OS2__) || defined(__WIN32__)
# define GOLD_HAS_DRIVES 1
#endif


//  ------------------------------------------------------------------

#if (__BORLANDC__ > 0x460) || defined(__GNUC__)
#define __GOLDWARE_HAS_BOOL 1
#endif


//  ------------------------------------------------------------------
//  Check if type "char" is unsigned or signed

#if ('\x80' < 0) && !defined(GOLD_SIGNEDCHAR_OK)
# error Goldware Library: Type "char" must be unsigned!
#endif


//  ------------------------------------------------------------------
//  Bail out if compiler is unknown

#if !defined(GOLD_COMPILER)
# error Goldware Library: Unsupported Compiler!
#endif


//  ------------------------------------------------------------------
//  System-wide constants

//#define GOLD_MOUSE 1      // Enable mouse code

# define GTHROW_LOG
#if defined(__MSDOS__) && !defined(__386__)
#else
# define GTHROW_DEBUG
# define GTHROWCHKPTR_ENABLE
# define GFTRK_ENABLE
#endif


//  ------------------------------------------------------------------

#endif

//  ------------------------------------------------------------------

