
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gcrcchks.h,v 1.1.1.1 1998/11/21 19:38:08 odinn Exp $
//  ------------------------------------------------------------------
//  Checksum calculation.
//  ------------------------------------------------------------------


//  ------------------------------------------------------------------
//  Only include once!

#ifndef __GCRCCHKS_H
#define __GCRCCHKS_H


//  ------------------------------------------------------------------
//  Required headers

#include <gdefs.h>


//  ------------------------------------------------------------------
//  Checksum globals

extern long GChkCeor, GChkCsum, GChkCrot;


//  ------------------------------------------------------------------
//  Update file checksums

inline void GChkSumUpd(char __ch) {

  GChkCeor ^= __ch;
  GChkCsum += __ch + 1;

  if(GChkCrot & 0x80000000L) {
    GChkCrot <<= 1;
    GChkCrot++;
  }
  else {
    GChkCrot <<= 1;
  }

  GChkCrot += __ch;
}


//  ------------------------------------------------------------------

#endif

//  ------------------------------------------------------------------

