
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gcrchash.cpp,v 1.1.1.1 1998/11/21 19:38:06 odinn Exp $
//  ------------------------------------------------------------------
//  CRC-16, CRC-32 and Hashing
//  ------------------------------------------------------------------


#include <ctype.h>
#include <gcrcall.h>


//  ------------------------------------------------------------------
//  Hash value generation
//  ------------------------------------------------------------------
//  From the Maximus/Squish MSGAPI by Scott J. Dudley, 1991.
//  The prime is 65521. Whatever that means.. ;-)
//  ------------------------------------------------------------------


//  ------------------------------------------------------------------
//  Generate 32-bit hash value from string

dword strHash32(const char* s, int __case) {

  register const char* p = s;
  register dword g, hash = 0;

  while(*p) {

    hash = (hash << 4) + (__case ? tolower(*p) : *p);

    g = hash & 0xF0000000UL;
    if(g) {
      hash |= g >> 24;
      hash |= g;
    }
    p++;
  }

  return hash & 0x7FFFFFFFUL;   // Strip off high bit (used as a flag)
}


//  ------------------------------------------------------------------

