
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gdbgtrk.h,v 1.1.1.1 1998/11/21 19:38:08 odinn Exp $
//  ------------------------------------------------------------------
//  Function tracker.
//  ------------------------------------------------------------------


//  ------------------------------------------------------------------
//  Only include once!

#ifndef __GDBGTRCK_H
#define __GDBGTRCK_H


//  ------------------------------------------------------------------
//  Required headers

#include <gdefs.h>


//  ------------------------------------------------------------------

struct GFTrk {
  dword tick;
  char* text;
  int indent;
};


//  ------------------------------------------------------------------

extern int __gftrk;
extern int __gftrk_on;
extern int __gftrk_max;
extern int __gftrk_curr;
extern int __gftrk_indent;
extern GFTrk* __gftrk_ptr;
extern GFTrk* __gftrk_list;


//  ------------------------------------------------------------------

#if defined(GFTRK_ENABLE)
#define GFTRK(t)  if(__gftrk) __gftrk_track(t);
#define GFTrkInit(t) __gftrk_init(t)
#else
#define GFTRK(t)
#define GFTrkInit(t)
#endif


//  ------------------------------------------------------------------

void __gftrk_init(int trackmax=-1);
void _stdc __gftrk_term(void);
void __gftrk_track(char* text);
void __gftrk_log();


//  ------------------------------------------------------------------

#endif

//  ------------------------------------------------------------------
