
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gdirff.h,v 1.2 1999/01/12 02:59:01 damware Exp $
//  ------------------------------------------------------------------
//  Portable directory access class.
//  Based on Public Domain source from Bob Stouts C SNIPPETS archive.
//  ------------------------------------------------------------------


#ifndef __GDIR_H
#define __GDIR_H


//  ------------------------------------------------------------------

#include <gdefs.h>

#if defined(__UNIX__)
#include <gdirposx.h>
#endif

//  ------------------------------------------------------------------

class gdir {

protected:

  void* filedata;

  #if defined(__UNIX__)
  gposixdir ud;
  bool u_checkentry();
  #endif

public:

  gdir();
  ~gdir();

  const char* mask();

  long size();
  const char* name();

  int normal();
  int readonly();
  int hidden();
  int system();
  int directory();
  int archived();

  void find_normal();
  void find_readonly();
  void find_hidden();
  void find_system();
  void find_directory();
  void find_archived();

  int year();
  int month();
  int day();
  int hour();
  int minute();
  int second();

  int open(const char* mask);
  int first();
  int next();
  int close();
};


//  ------------------------------------------------------------------

#endif

//  ------------------------------------------------------------------

