
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gdirposx.h,v 1.3 1999/01/13 02:05:10 damware Exp $
//  ------------------------------------------------------------------
//  Posix-based directory class.
//  ------------------------------------------------------------------


#ifndef __GDIRPOSX_H
#define __GDIRPOSX_H

#include <sys/types.h>
#include <sys/stat.h>
#include <gdirect.h>
#include <gdefs.h>


//  ------------------------------------------------------------------

class gposixdir {

protected:

  DIR*           handle;
  struct dirent* entry;
  struct stat    info;
  char*          basepath;
  char*          longname;
  
  void statthis();
  void getinfo();
  void reset();

public:

  gposixdir();
  gposixdir(const char* dirpath);
  ~gposixdir();

  bool open(const char* dirpath);
  bool read();
  void rewind();
  void close();

  const char* path();
  const char* name();
  const char* fullname();

  long size();

  time_t accessed_time();
  time_t modified_time();
  time_t creation_time();

  bool is_file();
  bool is_directory();

  bool is_readonly();
  bool is_hidden();

};


//  ------------------------------------------------------------------

#endif

//  ------------------------------------------------------------------

