
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gevalhum.cpp,v 1.1.1.1 1998/11/21 19:38:06 odinn Exp $
//  ------------------------------------------------------------------
//  Human (left-to-right) expression evaluator class.
//  ------------------------------------------------------------------


#include <geval.h>


//  ------------------------------------------------------------------

gevalhum::gevalhum() {

}


//  ------------------------------------------------------------------

gevalhum::~gevalhum() {

}


//  ------------------------------------------------------------------

int gevalhum::evaluate() {

  while(vstk.size() and ostk.size()) {

    while(ostk.size()) {

      int* vptr = vstk.begin();
      ops* optr = ostk.begin();

      while(optr < ostk.end()) {

        if(optr < (ostk.end() - 1)) {

          if(*optr == parenthesis_left) {
            if(optr[1] == parenthesis_right) {
              ostk.erase(optr, optr+2);
              break;
            }
            else {
              optr++;
            }
            continue;
          }
          else if(((*optr == negation) or (*optr == logic_not)) and (optr[1] == parenthesis_left)) {
            optr++;
            continue;
          }
          else if((*optr < optr[1]) and (optr[1] != parenthesis_right)) {
            optr++;
            vptr++;
            continue;
          }
        }

        if(ostk.size()) {
          if((*optr == negation) or (*optr == logic_not))
            *vptr = evaluate_ops(optr, vptr, vptr);
          else {
            *vptr = evaluate_ops(optr, vptr, vptr+1);
            if(vptr+1 < vstk.end())
              vstk.erase(vptr+1);
          }
          ostk.erase(optr);
        }
        break;
      }
    }
  }

  return pop_value();
}


//  ------------------------------------------------------------------

