
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gevent.h,v 1.1.1.1 1998/11/21 19:38:08 odinn Exp $
//  ------------------------------------------------------------------
//  Event related classes.
//  ------------------------------------------------------------------


//  ------------------------------------------------------------------

#ifndef __GEVENT_H
#define __GEVENT_H


//  ------------------------------------------------------------------

class gevent {

public:

  virtual int get_type() = 0;
};


//  ------------------------------------------------------------------

class gevent_keyboard {

private:

  char ascii;
  char scancode;

public:

  int get_type() { return KEYBOARD_EVENT; }
  uint val();
};


//  ------------------------------------------------------------------

class gevent_mouse {

private:

  gpoint pos
  int buttons;

public:

  int get_type() { return MOUSE_EVENT; }
  int get_button();
  gpoint get_position();
};


//  ------------------------------------------------------------------

class gevent_loop {

public:

  int get_event();


};


//  ------------------------------------------------------------------

#endif

//  ------------------------------------------------------------------

