
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gfuzzy.h,v 1.1.1.1 1998/11/21 19:38:08 odinn Exp $
//  ------------------------------------------------------------------
//  Fuzzy string search.
//  ------------------------------------------------------------------


#ifndef __GFUZZY_H
#define __GFUZZY_H

#include <gdefs.h>


//  ------------------------------------------------------------------

class gfuzzy {

protected:

  const char* text;
  const char* pattern;  // Pointers to search strings
  int   textloc;  // Current search position in Text
  int   plen;     // Length of Pattern
  int   degree;   // Max degree of allowed mismatch
  int*  ldiffs;
  int*  ldiff;
  int*  rdiff;    // Dynamic difference arrays
  int*  loffs;
  int*  roffs;    // Used to calculate start of match
  bool  casing;

public:

  gfuzzy();
  ~gfuzzy();

  const char* start;
  const char* end;
  int howclose;
  int length()  { return end - start + 1; }

  void init(const char* pat, int fuzzydegree, bool case_sensitive);
  bool findfirst(const char* string);
  bool findnext();


};


//  ------------------------------------------------------------------

#endif

//  ------------------------------------------------------------------

