
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: ghdrpars.h,v 1.1.1.1 1998/11/21 19:38:08 odinn Exp $
//  ------------------------------------------------------------------
//  RFC822 mailbox parser.
//  ------------------------------------------------------------------


//  ------------------------------------------------------------------

#include <gstrgstr.h>


//  ------------------------------------------------------------------

class grfc822_mailbox {

protected:

  char* text;
  char* start;
  char* commaptr;
  gstring mbox;
  gstring phrase;
  gstring addr_spec;

  void process();

public:

  grfc822_mailbox();
  grfc822_mailbox(const gstring& s);
  ~grfc822_mailbox();

  void operator=(const gstring& s);

  bool first();
  bool next();

  const gstring& mailbox()    { return mbox; }
  const gstring& name()       { return phrase; }
  const gstring& address()    { return addr_spec; }

};


//  ------------------------------------------------------------------

gstring& ParseInternetAddr(const gstring& s, gstring& name, gstring& addr);


//  ------------------------------------------------------------------

