
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gkbdset2.cpp,v 1.1.1.1 1998/11/21 19:38:06 odinn Exp $
//  ------------------------------------------------------------------
//  Key command and macro sets.
//  ------------------------------------------------------------------

#if 0

#include <string.h>
#include <gfile.h>
#include <gkbdcode.h>
#include <gkbdsets.h>


//  ------------------------------------------------------------------

void gkeycommand::load(gfile& fp) {

  fp >> keycode >> command;
}


//  ------------------------------------------------------------------

void gkeycommand::save(gfile& fp) const {

  fp << keycode << command;
}


//  ------------------------------------------------------------------

gkeymacro& gkeymacro::operator=(const gkeymacro& a) {

  keycode = a.keycode;
  memcpy(commands, a.commands, sizeof(commands));
  return *this;
}


//  ------------------------------------------------------------------

void gkeymacro::load(gfile& fp) {

  fp >> keycode;
  fp.fread(commands, sizeof(commands));
}


//  ------------------------------------------------------------------

void gkeymacro::save(gfile& fp) const {

  fp << keycode;
  fp.fwrite(commands, sizeof(commands));
}


//  ------------------------------------------------------------------

void gkeyset::add_command(const gkeycommand& k) {

  gkeycommand* found = command.bfind(k, compare_gkeycommand);
  if(found < command.end()) {
    if(found->keycode == k.keycode) {
      *found = k;
      return;
    }
  }
  command.insert(found, k);
}


//  ------------------------------------------------------------------

void gkeyset::add_macro(const gkeymacro& k) {

  gkeymacro* found = macro.bfind(k, compare_gkeymacro);
  if(found < macro.end()) {
    if(found->keycode == k.keycode) {
      *found = k;
      return;
    }
  }
  macro.insert(found, k);
}


//  ------------------------------------------------------------------

gkey gkeyname_to_keycode(word crc) {

  const word CRC_K_F1      = 0x4631;
  const word CRC_K_F2      = 0x4632;
  const word CRC_K_F3      = 0x4633;
  const word CRC_K_F4      = 0x4634;
  const word CRC_K_F5      = 0x4635;
  const word CRC_K_F6      = 0x4636;
  const word CRC_K_F7      = 0x4637;
  const word CRC_K_F8      = 0x4638;
  const word CRC_K_F9      = 0x4639;
  const word CRC_K_F10     = 0x1932;
  const word CRC_K_F11     = 0x1933;
  const word CRC_K_F12     = 0x1930;

  const word CRC_K_SF1     = 0x5230;
  const word CRC_K_SF2     = 0x5233;
  const word CRC_K_SF3     = 0x5232;
  const word CRC_K_SF4     = 0x5235;
  const word CRC_K_SF5     = 0x5234;
  const word CRC_K_SF6     = 0x5237;
  const word CRC_K_SF7     = 0x5236;
  const word CRC_K_SF8     = 0x5239;
  const word CRC_K_SF9     = 0x5238;
  const word CRC_K_SF10    = 0x4A87;
  const word CRC_K_SF11    = 0x4A86;
  const word CRC_K_SF12    = 0x4A85;

  const word CRC_K_AF1     = 0x0EF5;
  const word CRC_K_AF2     = 0x0EF6;
  const word CRC_K_AF3     = 0x0EF7;
  const word CRC_K_AF4     = 0x0EF0;
  const word CRC_K_AF5     = 0x0EF1;
  const word CRC_K_AF6     = 0x0EF2;
  const word CRC_K_AF7     = 0x0EF3;
  const word CRC_K_AF8     = 0x0EFC;
  const word CRC_K_AF9     = 0x0EFD;
  const word CRC_K_AF10    = 0x14FE;
  const word CRC_K_AF11    = 0x14FF;
  const word CRC_K_AF12    = 0x14FC;

  const word CRC_K_CF1     = 0xFD0A;
  const word CRC_K_CF2     = 0xFD09;
  const word CRC_K_CF3     = 0xFD08;
  const word CRC_K_CF4     = 0xFD0F;
  const word CRC_K_CF5     = 0xFD0E;
  const word CRC_K_CF6     = 0xFD0D;
  const word CRC_K_CF7     = 0xFD0C;
  const word CRC_K_CF8     = 0xFD03;
  const word CRC_K_CF9     = 0xFD02;
  const word CRC_K_CF10    = 0x3482;
  const word CRC_K_CF11    = 0x3483;
  const word CRC_K_CF12    = 0x3480;

  const word CRC_K_A0      = 0x4030;
  const word CRC_K_A1      = 0x4031;
  const word CRC_K_A2      = 0x4032;
  const word CRC_K_A3      = 0x4033;
  const word CRC_K_A4      = 0x4034;
  const word CRC_K_A5      = 0x4035;
  const word CRC_K_A6      = 0x4036;
  const word CRC_K_A7      = 0x4037;
  const word CRC_K_A8      = 0x4038;
  const word CRC_K_A9      = 0x4039;

  const word CRC_K_AA      = 0x4041;
  const word CRC_K_AB      = 0x4042;
  const word CRC_K_AC      = 0x4043;
  const word CRC_K_AD      = 0x4044;
  const word CRC_K_AE      = 0x4045;
  const word CRC_K_AF      = 0x4046;
  const word CRC_K_AG      = 0x4047;
  const word CRC_K_AH      = 0x4048;
  const word CRC_K_AI      = 0x4049;
  const word CRC_K_AJ      = 0x404A;
  const word CRC_K_AK      = 0x404B;
  const word CRC_K_AL      = 0x404C;
  const word CRC_K_AM      = 0x404D;
  const word CRC_K_AN      = 0x404E;
  const word CRC_K_AO      = 0x404F;
  const word CRC_K_AP      = 0x4050;
  const word CRC_K_AQ      = 0x4051;
  const word CRC_K_AR      = 0x4052;
  const word CRC_K_AS      = 0x4053;
  const word CRC_K_AT      = 0x4054;
  const word CRC_K_AU      = 0x4055;
  const word CRC_K_AV      = 0x4056;
  const word CRC_K_AW      = 0x4057;
  const word CRC_K_AX      = 0x4058;
  const word CRC_K_AY      = 0x4059;
  const word CRC_K_AZ      = 0x405A;

  const word CRC_K_CA      = 0x5E41;
  const word CRC_K_CB      = 0x5E42;
  const word CRC_K_CC      = 0x5E43;
  const word CRC_K_CD      = 0x5E44;
  const word CRC_K_CE      = 0x5E45;
  const word CRC_K_CF      = 0x5E46;
  const word CRC_K_CG      = 0x5E47;
  const word CRC_K_CH      = 0x5E48;
  const word CRC_K_CI      = 0x5E49;
  const word CRC_K_CJ      = 0x5E4A;
  const word CRC_K_CK      = 0x5E4B;
  const word CRC_K_CL      = 0x5E4C;
  const word CRC_K_CM      = 0x5E4D;
  const word CRC_K_CN      = 0x5E4E;
  const word CRC_K_CO      = 0x5E4F;
  const word CRC_K_CP      = 0x5E50;
  const word CRC_K_CQ      = 0x5E51;
  const word CRC_K_CR      = 0x5E52;
  const word CRC_K_CS      = 0x5E53;
  const word CRC_K_CT      = 0x5E54;
  const word CRC_K_CU      = 0x5E55;
  const word CRC_K_CV      = 0x5E56;
  const word CRC_K_CW      = 0x5E57;
  const word CRC_K_CX      = 0x5E58;
  const word CRC_K_CY      = 0x5E59;
  const word CRC_K_CZ      = 0x5E5A;
  const word CRC_K_CMINUS  = 0x5E2D;

  const word CRC_K_ESC     = 0x4B22;

  const word CRC_K_TAB     = 0x5B33;
  const word CRC_K_STAB    = 0x0886;
  const word CRC_K_ATAB    = 0x56FF;

  const word CRC_K_BSPACE  = 0x0F07;
  const word CRC_K_ABSPACE = 0xF9D7;
  const word CRC_K_CBSPACE = 0x5A72;

  const word CRC_K_ENTER   = 0x87BD;
  const word CRC_K_AENTER  = 0xE921;
  const word CRC_K_CENTER  = 0x50DC;

  const word CRC_K_INS     = 0x97BE;
  const word CRC_K_CINS    = 0xBA0E;
  const word CRC_K_AINS    = 0x9A72;

  const word CRC_K_DEL     = 0x4D0C;
  const word CRC_K_CDEL    = 0x60BC;
  const word CRC_K_ADEL    = 0x40C0;

  const word CRC_K_HOME    = 0x700B;
  const word CRC_K_CHOME   = 0x35C4;
  const word CRC_K_AHOME   = 0x6DA6;

  const word CRC_K_END     = 0x5625;
  const word CRC_K_CEND    = 0x7B95;
  const word CRC_K_AEND    = 0x5BE9;

  const word CRC_K_PGUP    = 0x63CC;
  const word CRC_K_CPGUP   = 0x2603;
  const word CRC_K_APGUP   = 0x7E61;

  const word CRC_K_PGDN    = 0x72D2;
  const word CRC_K_CPGDN   = 0x371D;
  const word CRC_K_APGDN   = 0x6F7F;

  const word CRC_K_LEFT    = 0x1694;
  const word CRC_K_CLEFT   = 0x535B;
  const word CRC_K_ALEFT   = 0x0B39;

  const word CRC_K_RIGHT   = 0xF78D;
  const word CRC_K_CRIGHT  = 0x20EC;
  const word CRC_K_ARIGHT  = 0x9911;

  const word CRC_K_UP      = 0x5550;
  const word CRC_K_CUP     = 0xEE6B;
  const word CRC_K_AUP     = 0x1D94;

  const word CRC_K_DOWN    = 0x2F6D;
  const word CRC_K_CDOWN   = 0x6AA2;
  const word CRC_K_ADOWN   = 0x32C0;

  const word CRC_K_CGMUL   = 0x66CA;

  const word CRC_K_KEY5    = 0x9062;
  const word CRC_K_SPACE   = 0x1281;

  const word CRC_K_MACRO   = 0x4BE9;
  const word CRC_K_AUTO    = 0x60E2;

  switch(crc) {

    case CRC_K_F1:       return Key_F1;
    case CRC_K_F2:       return Key_F2;
    case CRC_K_F3:       return Key_F3;
    case CRC_K_F4:       return Key_F4;
    case CRC_K_F5:       return Key_F5;
    case CRC_K_F6:       return Key_F6;
    case CRC_K_F7:       return Key_F7;
    case CRC_K_F8:       return Key_F8;
    case CRC_K_F9:       return Key_F9;
    case CRC_K_F10:      return Key_F10;
    case CRC_K_F11:      return Key_F11;
    case CRC_K_F12:      return Key_F12;

    case CRC_K_SF1:      return Key_S_F1;
    case CRC_K_SF2:      return Key_S_F2;
    case CRC_K_SF3:      return Key_S_F3;
    case CRC_K_SF4:      return Key_S_F4;
    case CRC_K_SF5:      return Key_S_F5;
    case CRC_K_SF6:      return Key_S_F6;
    case CRC_K_SF7:      return Key_S_F7;
    case CRC_K_SF8:      return Key_S_F8;
    case CRC_K_SF9:      return Key_S_F9;
    case CRC_K_SF10:     return Key_S_F10;
    case CRC_K_SF11:     return Key_S_F11;
    case CRC_K_SF12:     return Key_S_F12;

    case CRC_K_AF1:      return Key_A_F1;
    case CRC_K_AF2:      return Key_A_F2;
    case CRC_K_AF3:      return Key_A_F3;
    case CRC_K_AF4:      return Key_A_F4;
    case CRC_K_AF5:      return Key_A_F5;
    case CRC_K_AF6:      return Key_A_F6;
    case CRC_K_AF7:      return Key_A_F7;
    case CRC_K_AF8:      return Key_A_F8;
    case CRC_K_AF9:      return Key_A_F9;
    case CRC_K_AF10:     return Key_A_F10;
    case CRC_K_AF11:     return Key_A_F11;
    case CRC_K_AF12:     return Key_A_F12;

    case CRC_K_CF1:      return Key_C_F1;
    case CRC_K_CF2:      return Key_C_F2;
    case CRC_K_CF3:      return Key_C_F3;
    case CRC_K_CF4:      return Key_C_F4;
    case CRC_K_CF5:      return Key_C_F5;
    case CRC_K_CF6:      return Key_C_F6;
    case CRC_K_CF7:      return Key_C_F7;
    case CRC_K_CF8:      return Key_C_F8;
    case CRC_K_CF9:      return Key_C_F9;
    case CRC_K_CF10:     return Key_C_F10;
    case CRC_K_CF11:     return Key_C_F11;
    case CRC_K_CF12:     return Key_C_F12;

    case CRC_K_A0:       return Key_A_0;
    case CRC_K_A1:       return Key_A_1;
    case CRC_K_A2:       return Key_A_2;
    case CRC_K_A3:       return Key_A_3;
    case CRC_K_A4:       return Key_A_4;
    case CRC_K_A5:       return Key_A_5;
    case CRC_K_A6:       return Key_A_6;
    case CRC_K_A7:       return Key_A_7;
    case CRC_K_A8:       return Key_A_8;
    case CRC_K_A9:       return Key_A_9;

    case CRC_K_AA:       return Key_A_A;
    case CRC_K_AB:       return Key_A_B;
    case CRC_K_AC:       return Key_A_C;
    case CRC_K_AD:       return Key_A_D;
    case CRC_K_AE:       return Key_A_E;
    case CRC_K_AF:       return Key_A_F;
    case CRC_K_AG:       return Key_A_G;
    case CRC_K_AH:       return Key_A_H;
    case CRC_K_AI:       return Key_A_I;
    case CRC_K_AJ:       return Key_A_J;
    case CRC_K_AK:       return Key_A_K;
    case CRC_K_AL:       return Key_A_L;
    case CRC_K_AM:       return Key_A_M;
    case CRC_K_AN:       return Key_A_N;
    case CRC_K_AO:       return Key_A_O;
    case CRC_K_AP:       return Key_A_P;
    case CRC_K_AQ:       return Key_A_Q;
    case CRC_K_AR:       return Key_A_R;
    case CRC_K_AS:       return Key_A_S;
    case CRC_K_AT:       return Key_A_T;
    case CRC_K_AU:       return Key_A_U;
    case CRC_K_AV:       return Key_A_V;
    case CRC_K_AW:       return Key_A_W;
    case CRC_K_AX:       return Key_A_X;
    case CRC_K_AY:       return Key_A_Y;
    case CRC_K_AZ:       return Key_A_Z;

    case CRC_K_CA:       return Key_C_A;
    case CRC_K_CB:       return Key_C_B;
    case CRC_K_CC:       return Key_C_C;
    case CRC_K_CD:       return Key_C_D;
    case CRC_K_CE:       return Key_C_E;
    case CRC_K_CF:       return Key_C_F;
    case CRC_K_CG:       return Key_C_G;
    case CRC_K_CH:       return Key_C_H;
    case CRC_K_CI:       return Key_C_I;
    case CRC_K_CJ:       return Key_C_J;
    case CRC_K_CK:       return Key_C_K;
    case CRC_K_CL:       return Key_C_L;
    case CRC_K_CM:       return Key_C_M;
    case CRC_K_CN:       return Key_C_N;
    case CRC_K_CO:       return Key_C_O;
    case CRC_K_CP:       return Key_C_P;
    case CRC_K_CQ:       return Key_C_Q;
    case CRC_K_CR:       return Key_C_R;
    case CRC_K_CS:       return Key_C_S;
    case CRC_K_CT:       return Key_C_T;
    case CRC_K_CU:       return Key_C_U;
    case CRC_K_CV:       return Key_C_V;
    case CRC_K_CW:       return Key_C_W;
    case CRC_K_CX:       return Key_C_X;
    case CRC_K_CY:       return Key_C_Y;
    case CRC_K_CZ:       return Key_C_Z;
    case CRC_K_CMINUS:   return Key_C_Min;

    case CRC_K_ESC:      return Key_Esc;

    case CRC_K_TAB:      return Key_Tab;
    case CRC_K_STAB:     return Key_S_Tab;
    case CRC_K_ATAB:     return Key_A_Tab;

    case CRC_K_BSPACE:   return Key_BS;
    case CRC_K_ABSPACE:  return Key_A_BS;
    case CRC_K_CBSPACE:  return Key_C_BS;

    case CRC_K_ENTER:    return Key_Ent;
    case CRC_K_AENTER:   return Key_A_Ent;
    case CRC_K_CENTER:   return Key_C_Ent;

    case CRC_K_INS:      return Key_Ins;
    case CRC_K_CINS:     return Key_C_Ins;
    case CRC_K_AINS:     return Key_A_InsG;

    case CRC_K_DEL:      return Key_Del;
    case CRC_K_CDEL:     return Key_C_Del;
    case CRC_K_ADEL:     return Key_A_DelG;

    case CRC_K_HOME:     return Key_Home;
    case CRC_K_CHOME:    return Key_C_Home;
    case CRC_K_AHOME:    return Key_A_HomeG;

    case CRC_K_END:      return Key_End;
    case CRC_K_CEND:     return Key_C_End;
    case CRC_K_AEND:     return Key_A_EndG;

    case CRC_K_PGUP:     return Key_PgUp;
    case CRC_K_CPGUP:    return Key_C_PgUp;
    case CRC_K_APGUP:    return Key_A_PgUpG;

    case CRC_K_PGDN:     return Key_PgDn;
    case CRC_K_CPGDN:    return Key_C_PgDn;
    case CRC_K_APGDN:    return Key_A_PgDnG;

    case CRC_K_LEFT:     return Key_Lft;
    case CRC_K_CLEFT:    return Key_C_Lft;
    case CRC_K_ALEFT:    return Key_A_LftG;

    case CRC_K_RIGHT:    return Key_Rgt;
    case CRC_K_CRIGHT:   return Key_C_Rgt;
    case CRC_K_ARIGHT:   return Key_A_RgtG;

    case CRC_K_UP:       return Key_Up;
    case CRC_K_CUP:      return Key_C_Up;
    case CRC_K_AUP:      return Key_A_UpG;

    case CRC_K_DOWN:     return Key_Dwn;
    case CRC_K_CDOWN:    return Key_C_Dwn;
    case CRC_K_ADOWN:    return Key_A_DwnG;

    case CRC_K_CGMUL:    return Key_C_StrG;

    case CRC_K_KEY5:     return Key_Cent;
    case CRC_K_SPACE:    return Key_Space;

    case CRC_K_MACRO:    return Key_Macro;
    case CRC_K_AUTO:     return Key_Auto;
  }

  return gkey(0);
}


//  ------------------------------------------------------------------

#endif

