
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gkbdunix.h,v 1.1.1.1 1998/11/21 19:38:08 odinn Exp $
//  ------------------------------------------------------------------
//  Unix keyboard functions. Based on SLang source code.
//  ------------------------------------------------------------------


#ifndef __GKBDUNIX_H
#define __GKBDUNIX_H

#include <gdefs.h>


//  ------------------------------------------------------------------

const int GKBD_MAX_INPUT_BUFFER_LEN = 1024;


//  ------------------------------------------------------------------

extern int gkbd_stdin;


//  ------------------------------------------------------------------

int  gkbd_tty_init();
void gkbd_tty_reset();
int  gkbd_sys_input_pending(int tsecs=0);
uint gkbd_sys_getkey();


//  ------------------------------------------------------------------

extern uint gkbd_last_key_char;

uint gkbd_getkey();
void gkbd_ungetkey_string(char *s, uint n);
int  gkbd_input_pending(int tsecs=0);
void gkbd_flush_input();
void gkbd_keymap_init();
void gkbd_keymap_reset();
int  gkbd_define_keysym(char* s, uint keysym);
uint gkbd_getmappedkey();


//  ------------------------------------------------------------------

#endif

//  ------------------------------------------------------------------

