
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gkbdwait.cpp,v 1.1.1.1 1998/11/21 19:38:06 odinn Exp $
//  ------------------------------------------------------------------
//  Keyboard functions
//  ------------------------------------------------------------------


#include <gkbdbase.h>
#include <gkbdcode.h>
#include <gtimall.h>
#include <gutlmtsk.h>


//  ------------------------------------------------------------------
//  Halts execution until a key is pressed

Key waitkey() {

  clearkeys();
  return getxch();
}


//  ------------------------------------------------------------------
//  Halts execution until a key is pressed or the specified time
//  period has expired

Key waitkeyt(int duration) {

  clearkeys();
  Clock stop = gclock() + duration;
  Clock sliced_time = gclock();
  while(1) {
    if(kbmhit())
      return getxch();
    if(gclock() >= stop)
      return 0;
    if(gclock() - sliced_time >= 1000) {
      if(gkbd.tickfunc)
        (*gkbd.tickfunc)();
      sliced_time = gclock();
    }
    gmtsk.timeslice();
  }
}


//  ------------------------------------------------------------------

