
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: glang.h,v 1.1.1.1 1998/11/21 19:38:08 odinn Exp $
//  ------------------------------------------------------------------
//  Language handling.
//  ------------------------------------------------------------------


//  ------------------------------------------------------------------

#include <gfile.h>


//  ------------------------------------------------------------------

class glangcrc {

public:

  word  crc;
  char* str;

  int allocated()      { return *str; }
  const char* c_str()  { return *str ? str : str+1; }
};                   


//  ------------------------------------------------------------------

class glang {

protected:

  int       langmax;
  glangcrc* lang;

  const char* get(int n);

public:

  glang();
  ~glang();

  void reset();

  int  crc2no(word crc);
  void change(int n, const char* s);

  bool switch_language(word crc, char* str);
  bool load_language(const char* file);

  const char* operator[](int n)  { return get(n); }

  void save(gfile& f);
  void load(gfile& f);

};


//  ------------------------------------------------------------------

