
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: glog.h,v 1.1.1.1 1998/11/21 19:38:08 odinn Exp $
//  ------------------------------------------------------------------
//  Log file class.
//  ------------------------------------------------------------------


#ifndef __GLOG_H
#define __GLOG_H


//  ------------------------------------------------------------------

#include <gfile.h>
#include <gtimall.h>


//  ------------------------------------------------------------------
//  Log types

const int GLOG_NONE = -1;
const int GLOG_FD   = 0;
const int GLOG_MAX  = 1;
const int GLOG_BINK = 2;
const int GLOG_QBBS = 3;
const int GLOG_DB   = 4;


//  ------------------------------------------------------------------

const int GLOG_STORELINES = 10;


//  ------------------------------------------------------------------
//  Logfile base class

class glog {

private:

  gfile fp;

  static int        count;
  static struct tm* time_now;
  static time_t     secs_now;
  static char       timebuf[20];

protected:

  uint  bufsize;
  int   logtype;
  const char* progname;
  const char* shortprogname;
  int   lineswritten;

public:

  int status;

  char storeline[GLOG_STORELINES][79];
  int  storelines;

  glog();
  ~glog();

  int open(const char* filename, const char* name, const char* shortname=NULL, int type=GLOG_NONE, uint bufsz=0, int shflag=SH_DENYWR);
  void close();

  void init(const char* name=NULL, const char* shortname=NULL, int type=GLOG_NONE);
  void _stdc printf(const char* format, ...);

  void store();

};


//  ------------------------------------------------------------------

typedef glog GLog;


//  ------------------------------------------------------------------

#endif

//  ------------------------------------------------------------------

