
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gmsgmime.cpp,v 1.1.1.1 1998/11/21 19:38:06 odinn Exp $
//  ------------------------------------------------------------------
//  MIME utility classes.
//  ------------------------------------------------------------------


#include <gstrmail.h>
#include <gmsgmime.h>


//  ------------------------------------------------------------------

bool gmime_content_type::crack(const char* field) {

  const char* prms = strchr(field, ';');
  if(prms)
    type.copyn(field, (int)(prms-field));
  else
    type = field;

  const char* slash = type.find_char('/');

  if(slash == NULL)
    return false;

  subtype = slash + 1;
  subtype.btrim();
  type.erase(slash);
  type.btrim();

  if(type.empty() or subtype.empty())
    return false;

  if(prms++) {

    parameter prm;
    const char* nextprms;

    do {
      prms = strskip_lwsp(prms);
      const char* attribute = prms;
      while(is_mime_ct_token_valid(*prms))
        prms++;
      prm.attribute.copyn(attribute, (int)(prms-attribute));
      while(*prms and (*prms != '='))
        prms++;
      if(*prms == '=') {
        prms = strskip_lwsp(++prms);
        const char* value = prms;
        if(*prms == '\"') {
          prms = strskip_mail_quote(value);
          char valuebuf[512];
          strxcpy(valuebuf, value, (int)(1+prms-value));
          strmail_unquote(valuebuf, valuebuf);
          prm.value = valuebuf;
        }
        else {
          while(is_mime_ct_token_valid(*prms))
            prms++;
          prm.value.copyn(value, (int)(prms-value));
        }
        parameters.push_back(prm);
      }
      nextprms = strchr(prms, ';');
      if(nextprms)
        prms = nextprms + 1;
    } while(*prms);
  }

  return true;
}


//  ------------------------------------------------------------------

