
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gprnutil.cpp,v 1.1.1.1 1998/11/21 19:38:06 odinn Exp $
//  ------------------------------------------------------------------
//  GoldED printer definition helper.
//  ------------------------------------------------------------------


#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <gstrall.h>


//  ------------------------------------------------------------------
//  Convert printer definition string to binary codes

char* CvtPrnstr(char* str, char* prn) {

  int value;
  byte len=0;
  char buf[256];
  char* ptr=prn;

  while(*ptr) {
    switch(*ptr) {
      case '$':
        ptr++;
        do {
          sscanf(ptr, "%2x", &value);
          buf[len++] = (byte)value;
          if(isxdigit(*ptr) and *ptr)   // Skip first digit
            ptr++;
          if(isxdigit(*ptr) and *ptr)   // Skip second digit
            ptr++;
        } while(isxdigit(*ptr) and *ptr);
        break;
      case '#':
        ptr++;
        value = atoi(ptr);
        buf[len++] = (byte)value;
        while(isdigit(*ptr) and *ptr)
          ptr++;
        break;
      case '\"':
        ptr++;
        while(*ptr != '\"' and *ptr)
          buf[len++] = *ptr++;
        if(*ptr)
          ptr++;
        break;
      case '\'':
        ptr++;
        while(*ptr != '\'' and *ptr)
          buf[len++] = *ptr++;
        if(*ptr)
          ptr++;
        break;
      default:
        ptr++;
    }
  }

  *str = len;
  memcpy(str+1, buf, len);

  return str;
}


//  ------------------------------------------------------------------

