
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gregex.cpp,v 1.1.1.1 1998/11/21 19:38:06 odinn Exp $
//  ------------------------------------------------------------------
//  Regular expressions C++ wrapper class.
//  ------------------------------------------------------------------


#include <sys/types.h>
#include <stddef.h>
#include <gregex2.h>
#include <gregex.h>
#include <gmemdbg.h>


//  ------------------------------------------------------------------

gregex::gregex() {

  preg = NULL;
}


//  ------------------------------------------------------------------

gregex::~gregex() {

  reset();
}


//  ------------------------------------------------------------------

void gregex::reset() {

  if(preg) {
    regfree((regex_t*)preg);
    delete (regex_t*)preg;
  }
}


//  ------------------------------------------------------------------

bool gregex::compile(const char* pattern, int cflags) {

  int cflgs = REG_NOSUB;
  if(cflags & extended) cflgs |= REG_EXTENDED;
  if(cflags & icase)    cflgs |= REG_ICASE;
  if(cflags & newline)  cflgs |= REG_NEWLINE;

  if(not preg) {
    preg = new regex_t;
    throw_new(preg);
  }

  return (bool)regcomp((regex_t*)preg, pattern, cflgs);
}


//  ------------------------------------------------------------------

bool gregex::match(const char* string, int eflags) {

  int eflgs = 0;
  if(eflags & notbol) eflgs |= REG_NOTBOL;
  if(eflags & noteol) eflgs |= REG_NOTEOL;

  return not regexec((regex_t*)preg, string, 0, NULL, eflgs);
}


//  ------------------------------------------------------------------

