
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gregex.h,v 1.1.1.1 1998/11/21 19:38:08 odinn Exp $
//  ------------------------------------------------------------------
//  Regular expressions C++ wrapper class.
//  ------------------------------------------------------------------


#ifndef __GREGEX_H
#define __GREGEX_H

#include <gdefs.h>


//  ------------------------------------------------------------------

class gregex {

protected:

  void* preg;

public:

  enum {

    // cflags
    extended = 0x01,
    icase    = 0x02,
    newline  = 0x04,

    // eflags
    notbol   = 0x10,
    noteol   = 0x20
  };

  gregex();
  ~gregex();

  void reset();

  bool compile(const char* pattern, int cflags=0);
  bool match(const char* string, int eflags=0);

};


//  ------------------------------------------------------------------

#endif

//  ------------------------------------------------------------------

