
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gsndall.h,v 1.1.1.1 1998/11/21 19:38:09 odinn Exp $
//  ------------------------------------------------------------------
//  Sound interface class.
//  ------------------------------------------------------------------


#ifndef __GSNDALL_H
#define __GSNDALL_H


//  ------------------------------------------------------------------

#include <gsndsapi.h>


//  ------------------------------------------------------------------

#ifdef DEBUG
extern int debug;
#endif


//  ------------------------------------------------------------------

class gsnd {

protected:

  #if defined(__DOS__)
  int mpx;
  #if (defined(__WATCOMC__) and defined(__MSDOS__) and defined(__386__)) or defined(__DJGPP__)
  long buffer;
  #else
  char* buffer;
  #endif
  gsapidata* data;
  uint key_value;
  int call_api(uint al, uint bx=0);
  #endif

  int api_open;
  int file_open;

  void free_buffer();

public:

  gsnd();
  ~gsnd();

  // API open/close
  int open_api();
  int close_api();

  // Sound file open/close
  int open(const char* file);
  int close();

  // Sound play and control
  int play(uint sample_rate=0);
  int stop();
  int pause();
  int resume();
  int break_loop(int method=0);
  void speaker(int onoff);

  // Information   
  uint get_sample_rate();
  int api_is_open()  { return api_open; }
  int is_playing();
};


//  ------------------------------------------------------------------

class gsound {

protected:

  int installed;

public:

  gsound();
  ~gsound();

  int load(const char* file);
  int unload();
  int play();
  int stop();

  int is_playing();

  int is_installed() { return installed; }
};


//  ------------------------------------------------------------------

#endif

//  ------------------------------------------------------------------

