
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gsndwrap.cpp,v 1.1.1.1 1998/11/21 19:38:06 odinn Exp $
//  ------------------------------------------------------------------
//  Sound interface class.
//  ------------------------------------------------------------------


//  ------------------------------------------------------------------

#include <stdlib.h>
#include <gsndall.h>


//  ------------------------------------------------------------------

static gsnd* snd = NULL;


//  ------------------------------------------------------------------

gsound::gsound() {

  snd = new gsnd;
  installed = (snd->open_api() != -1);
}


//  ------------------------------------------------------------------

gsound::~gsound() {

  snd->close_api();
  delete snd;
}


//  ------------------------------------------------------------------

int gsound::load(const char* file) {

  return snd->open(file);
}


//  ------------------------------------------------------------------

int gsound::unload() {

  return snd->close();
}


//  ------------------------------------------------------------------

int gsound::play() {

  return snd->play();
}


//  ------------------------------------------------------------------

int gsound::stop() {

  return snd->stop();
}


//  ------------------------------------------------------------------

int gsound::is_playing() {

  return snd->is_playing();
}


//  ------------------------------------------------------------------

