
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gsrchmgr.cpp,v 1.1.1.1 1998/11/21 19:38:07 odinn Exp $
//  ------------------------------------------------------------------
//  Search manager.
//  ------------------------------------------------------------------


#include <gsrchmgr.h>


//  ------------------------------------------------------------------

search_item::search_item() {

  logic = logic_or;

  where.from      = false;
  where.to        = false;
  where.subject   = false;
  where.body      = false;
  where.tagline   = false;
  where.tearline  = false;
  where.origin    = false;
  where.signature = false;
  where.kludges   = false;
}


//  ------------------------------------------------------------------

search_item::~search_item() {

}


//  ------------------------------------------------------------------

search_item& search_item::operator=(const search_item& a) {

  gsearch::operator=(a);

  logic           = a.logic;
  where.from      = a.where.from;
  where.to        = a.where.to;
  where.subject   = a.where.subject;
  where.body      = a.where.body;
  where.tagline   = a.where.tagline;
  where.tearline  = a.where.tearline;
  where.origin    = a.where.origin;
  where.signature = a.where.signature;
  where.kludges   = a.where.kludges;

  return *this;
}


//  ------------------------------------------------------------------

search_manager::search_manager() : gwinput2(window) {

  direction = direction_forward;
  messages = messages_new;
  action = action_read;
  areas = areas_current;
}


//  ------------------------------------------------------------------

search_manager::~search_manager() {

}


//  ------------------------------------------------------------------

