
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gstrblks.cpp,v 1.1.1.1 1998/11/21 19:38:07 odinn Exp $
//  ------------------------------------------------------------------
//  String blocks.
//  ------------------------------------------------------------------


#include <gmemdbg.h>
#include <gstrblks.h>


//  ------------------------------------------------------------------

int gstrarray::add(const char* s) {

  return gmemblock::add(s, strlen(s)+1);
}


//  ------------------------------------------------------------------

int gstrarray::add(const gstring& s) {

  return gmemblock::add(s.c_str(), s.length()+1);
}


//  ------------------------------------------------------------------

int gstrarray::set(int n, const char* s) {

  return gmemblock::set(n, s, strlen(s)+1);
}


//  ------------------------------------------------------------------

int gstrarray::set(int n, const gstring& s) {

  return gmemblock::set(n, s.c_str(), s.length()+1);
}


//  ------------------------------------------------------------------

int gstrarray::insert(int n, const char* s) {

  return gmemblock::insert(n, s, strlen(s)+1);
}


//  ------------------------------------------------------------------

int gstrarray::insert(int n, const gstring& s) {

  return gmemblock::insert(n, s.c_str(), s.length()+1);
}


//  ------------------------------------------------------------------

void tokenize(gstrarray& array, const char* str, const char* delim) {

  if(not delim)
    delim = ", \t";

  char* tmp = throw_xstrdup(str);

  char* token = strtok(tmp, delim);
  while(token) {
    array += token;
    token = strtok(NULL, delim);
  }

  throw_xfree(tmp);
}


//  ------------------------------------------------------------------

