
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gstroman.cpp,v 1.1.1.1 1998/11/21 19:38:07 odinn Exp $
//  ------------------------------------------------------------------
//  Roman numerals conversion functions.
//  ------------------------------------------------------------------


#include <gstrall.h>
#include <gstroman.h>


//  ------------------------------------------------------------------

int roman_ch_to_i(char ch) {

  switch(ch) {
    case 'm': return 1000;
    case 'd': return 500;
    case 'c': return 100;
    case 'l': return 50;
    case 'x': return 10;
    case 'v': return 5;
    case 'i': return 1;
  }
  return 0;
}


//  ------------------------------------------------------------------

int roman_to_i(char* roman) {

  int i = 0;
  char* ptr = roman;
  while(*ptr) {
    int v1 = roman_ch_to_i(ptr[0]);
    int v2 = roman_ch_to_i(ptr[1]);
    i += (v1 >= v2) ? v1 : -v1;
    ptr++;
  }
  return i;
}


//  ------------------------------------------------------------------

char* i_to_roman(char* roman, int i) {

  *roman = NUL;
  while(i >= 1000) {
    strcat(roman, "m");
    i -= 1000;
  }
  if(i >= 900) {
    strcat(roman, "cm");
    i -= 900;
  }
  while(i >= 500) {
    strcat(roman, "d");
    i -= 500;
  }
  if(i >= 400) {
    strcat(roman, "cd");
    i -= 400;
  }
  while(i >= 100) {
    strcat(roman, "c");
    i -= 100;
  }
  if(i >= 90) {
    strcat(roman, "xc");
    i -= 90;
  }
  while(i >= 50) {
    strcat(roman, "l");
    i -= 50;
  }
  if(i >= 40) {
    strcat(roman, "xl");
    i -= 40;
  }
  while(i >= 10) {
    strcat(roman, "x");
    i -= 10;
  }
  if(i >= 9) {
    strcat(roman, "ix");
    i -= 9;
  }
  while(i >= 5) {
    strcat(roman, "v");
    i -= 5;
  }
  if(i >= 4) {
    strcat(roman, "iv");
    i -= 4;
  }
  while(i > 0) {
    strcat(roman, "i");
    i--;
  }

  return roman;
}


//  ------------------------------------------------------------------

