
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gstrxlat.h,v 1.1.1.1 1998/11/21 19:38:09 odinn Exp $
//  ------------------------------------------------------------------
//  Character translation.
//  ------------------------------------------------------------------


#ifndef __GSTRXLAT_H
#define __GSTRXLAT_H


#include <gvector.h>


//  ------------------------------------------------------------------

typedef char gcharalias[6];


//  ------------------------------------------------------------------

struct gchariso {
  char ch;
  word iso;
};


//  ------------------------------------------------------------------

struct gcharisoalias {
  word iso;
  gcharalias alias;
};


//  ------------------------------------------------------------------

class gcharxlat {

protected:

  gcharalias* charset;

  gvector<gchariso> xlat_to;
  gvector<gchariso> xlat_from;
  gvector<gcharisoalias> xlat_alias;

  gstring to_charset;
  gstring from_charset;

  bool active;

public:

  gcharxlat();
  ~gcharxlat();

  void initialize();

  void reset_table();
  void reset_from_charset();

  void build_table();

  const char* get_charset_name(const char* name);

  void set_to_charset(const gstring& to);

  void set_from_charset(const char* from);
  void set_from_codepage(int from);

  const char* translate(const char* from, char* to);


  bool load_charsets();

};


//  ------------------------------------------------------------------

#endif

//  ------------------------------------------------------------------

