
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gusrwcat.h,v 1.1.1.1 1998/11/21 19:38:09 odinn Exp $
//  ------------------------------------------------------------------
//  WildCat! derived userfile class.
//  ------------------------------------------------------------------


//  ------------------------------------------------------------------
//  Only include once!

#ifndef __GUSRWCAT_H
#define __GUSRWCAT_H


//  ------------------------------------------------------------------
//  Required

#include <gfile.h>
#include <gusrbase.h>

#if defined(GOLD_CANPACK)
#pragma pack(1)
#endif


//  ------------------------------------------------------------------

struct WCatUserConfFileHdr {
  word  totalconfs;
};


//  ------------------------------------------------------------------

const byte ucrIndex = 0;
const byte ucrData  = 1;

struct WCatUserConfIndex {
  word  reclen;
  byte  rectype;
  long  offsets[32];
};

struct WCatUserConfData {
  byte  flags;
  word  lastread;
  word  firstunread;
};
  
typedef WCatUserConfData WCatUserConfArray[1024];

struct WCatUserConfPageHeader {
  word  reclen;
  byte  rectype;
  long  userid;
  short  page;
  long  thisx;
};
  
struct WCatUserConfPage {
  word              reclen;
  byte              rectype;
  long              userid;
  short              page;
  long              thisx;
  WCatUserConfArray userconfdata;
};
                              
#define MaxChunk 1024
#define MaxPages(MaxConfAreas) ((MaxConfAreas+MaxChunk-1)/MaxChunk)


//  ------------------------------------------------------------------

#if defined(GOLD_CANPACK)
#pragma pack()
#endif


//  ------------------------------------------------------------------
//  WildCat! userfile class

class WCatUser : public GUser {

public:

  uint maxindex;
  int firstread;
  WCatUserConfIndex header;
  
  WCatUser();
  ~WCatUser();

  int  isvalid();
  int  read();

  void  founduser();
  void  recinit(const char* __name);
};


//  ------------------------------------------------------------------

#endif

//  ------------------------------------------------------------------

