
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gutlbfnd.cpp,v 1.1.1.1 1998/11/21 19:38:07 odinn Exp $
//  ------------------------------------------------------------------
//  Utility functions.
//  ------------------------------------------------------------------


#include <gutlmisc.h>


//  ------------------------------------------------------------------
//  Binary search to the closest match that is >= the key

void* bfind(const void *key, const void *base, size_t nelem, size_t width, int (_stdc *fcmp)(const void *, const void *)) {

  char* probe = (char*)base;
  size_t elem = nelem;
  char* kmin = (char*)base;
  while(elem > 0) {
    int i = elem >> 1;
    probe = kmin + i * width;
    int j = (*fcmp)(key, probe);
    if (j == 0)
      return probe;
    else if (j < 0)
      elem = i;
    else  {
      kmin = probe + width;
      elem = elem - i - 1;
    }
  }

  if(nelem) {
    if((*fcmp)(key, probe) > 0)
      probe += width;
  }

  return probe;
}


//  ------------------------------------------------------------------

