
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gutlclip.h,v 1.1.1.1 1998/11/21 19:38:09 odinn Exp $
//  ------------------------------------------------------------------
//  Goldware misc. clipboards support.
//  ------------------------------------------------------------------


#ifndef __GUTLCLIP_H
#define __GUTLCLIP_H


//  ------------------------------------------------------------------

#include <gdefs.h>


//  ------------------------------------------------------------------

#ifdef __WIN32__
#include <windows.h>
#endif

#ifdef __OS2__
#define INCL_DOSERRORS
#define INCL_DOSMEMMGR
#define INCL_DOSPROCESS
#define INCL_WINCLIPBOARD
#define INCL_WINSWITCHLIST
#include <os2.h>
#include <process.h>
#endif

//  ------------------------------------------------------------------

#if defined(__OS2__)
#define CLIP_NAME "OS/2 Clipboard"
#else
#define CLIP_NAME "Windows Clipboard"
#endif

//  ------------------------------------------------------------------

class gclipbrd {

  char* clipdata;
  int len;

  #ifdef __WIN32__
  HGLOBAL hglb;
  #endif

  #ifdef __OS2__
  HAB whnd;
  #endif

public:

  bool openread();
  char* read(char* buffer, int maxlen);
  void close();

  bool writeclipbrd(char* buf);

  gclipbrd();

};


//  ------------------------------------------------------------------

#endif

//  ------------------------------------------------------------------

