
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gutlmisc.h,v 1.1.1.1 1998/11/21 19:38:09 odinn Exp $
//  ------------------------------------------------------------------
//  Utility functions.
//  ------------------------------------------------------------------


//  ------------------------------------------------------------------
//  Only include once!

#ifndef __GUTLMISC_H
#define __GUTLMISC_H


//  ------------------------------------------------------------------
//  Required headers

#include <ctype.h>
#include <stdlib.h>
#if defined(__WATCOMC__)
#include <search.h>
#endif
#include <gdefs.h>


//  ------------------------------------------------------------------
//  Prototypes

#if defined(__GNUC__)
char* itoa(int __value, char* __string, int __radix);
char* ltoa(long __value, char* __string, int __radix);
char* ultoa(unsigned long __value, char* __string, int __radix);
#endif

inline word atow(const char* p) { return (word)atoi(p); }

//inline int ctox(char c) { return isdigit(c) ? (c - '0') : (toupper(c) - ('A' - 10)); }
inline int xtoi(char c)  { return isdigit(c) ? (c - '0') : (toupper(c) - ('A' - 10)); }

int  atox(const char* s);
ulong atoulx(const char* s);

char* ltob(char* dst, ulong value, int fill=32);

int GetYesno(const char* value);
inline int get_yesno(const char* s) { return GetYesno(s); }
inline bool get_bool(const char* s) { return (bool)GetYesno(s); }
int Pct(dword x, dword y);
int tabstop(int col, int tabwidth);
void _stdoutch(char ch);

void ggetosversion();

// Convert between Microsoft MKS format and long int
dword B2L(dword b);
dword L2B(dword l);

inline void SwapWord32(long* dw) { *dw = (long)(((dword)(*dw) << 16) | ((dword)(*dw) >> 16)); }

void beep();

#if defined(__GNUC__)
void* lfind(const void *key, const void *base, size_t* nelem, size_t width, int (_stdc *fcmp)(const void *, const void *));
#endif
void* bfind(const void *key, const void *base, size_t nelem, size_t width, int (_stdc *fcmp)(const void *, const void *));

struct gstrvaltable {
  const char* str;
  int         val;
};

bool gtable2value(const char* str, int& val, const gstrvaltable* table, int tablesize);


//  ------------------------------------------------------------------

#endif

//  ------------------------------------------------------------------

