
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gutlmous.h,v 1.1.1.1 1998/11/21 19:38:09 odinn Exp $
//  ------------------------------------------------------------------
//  Microsoft compatible mouse functions.
//  ------------------------------------------------------------------


//  ------------------------------------------------------------------
//  Only include once!

#ifndef __GOLD_MOU_H
#define __GOLD_MOU_H


//  ------------------------------------------------------------------
//  Required headers

#include <gdefs.h>


//  ------------------------------------------------------------------
//  Mouse support definitions

#define MS_NONE     0   /* no mouse support                         */
#define MS_KEYS     1   /* mouse movement emulates arrow keys       */
#define MS_CURS     2   /* free-moving mouse cursor where supported */
#define MS_FULL     3   /* full mouse support (MS_KEYS | MS_CURS)   */


//  ------------------------------------------------------------------
//  Mouse support level

extern int _mouse;


//  ------------------------------------------------------------------
//  Function prototypes

int msinit();
void msbclear();
void msbpress(int button, int* bstat, int* bcount, int* row, int* col);
void msbreles(int button, int* bstat, int* bcount, int* row, int* col);
void mscursor(uint curtype, uint smask, uint cmask);
void msgotoxy(int row, int col);
void mshidecur();
void msshowcur();
void msstatus(int* bstat, int* row, int* col);
void mssupport(int type);

//void mscondoff(int,int,int,int) {}
//void mshbounds(int,int) {}
//void msmotion(int*,int*) {}
//void msspeed(int,int) {}
//void msvbounds(int,int) {}


//  ------------------------------------------------------------------

#endif

//  ------------------------------------------------------------------

