
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gutlmtsk.h,v 1.1.1.1 1998/11/21 19:38:09 odinn Exp $
//  ------------------------------------------------------------------
//  Multitasking.
//  ------------------------------------------------------------------


//  ------------------------------------------------------------------
//  Only include once!

#ifndef __GUTLMTSK_H
#define __GUTLMTSK_H


//  ------------------------------------------------------------------
//  Required headers

#include <gdefs.h>


//  ------------------------------------------------------------------
//  Supported multitaskers

const int GMTSK_NONE     = 0;
const int GMTSK_OS2      = 1;
const int GMTSK_WINDOWS  = 2;
const int GMTSK_DESQVIEW = 3;
const int GMTSK_DOS      = 4;
const int GMTSK_W32      = 5;
const int GMTSK_LINUX    = 6;


//  ------------------------------------------------------------------
//  Multitasker base class

class GMTsk {

public:

  int detected;
  char* name;

  int os2();
  int win32();
  int windows();
  int desqview();
  int dosint28();

  void timeslice();

  GMTsk();
};


//  ------------------------------------------------------------------
//  Globals

extern GMTsk gmtsk;


//  ------------------------------------------------------------------

#endif

//  ------------------------------------------------------------------

