
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gutlswap.h,v 1.1.1.1 1998/11/21 19:38:09 odinn Exp $
//  ------------------------------------------------------------------
//  Swap program to EMS, XMS or DISK.
//  ------------------------------------------------------------------


//  ------------------------------------------------------------------
//  Only include once!

#ifndef __GUTLSWAP_H
#define __GUTLSWAP_H


//  ------------------------------------------------------------------
//  Return codes (only upper byte significant)

#define RC_PREPERR   0x0100
#define RC_NOFILE    0x0200
#define RC_EXECERR   0x0300
#define RC_ENVERR    0x0400
#define RC_SWAPERR   0x0500


//  ------------------------------------------------------------------
//  Swap method and option flags

#define USE_EMS      0x01
#define USE_XMS      0x02
#define USE_FILE     0x04

#define USE_ALL      (USE_EMS | USE_XMS | USE_FILE)

#define EMS_FIRST    0x00
#define XMS_FIRST    0x10
#define HIDE_FILE    0x40
#define NO_PREALLOC  0x100
#define CHECK_NET    0x200

#define CREAT_TEMP      0x0080
#define DONT_SWAP_ENV   0x4000


//  ------------------------------------------------------------------
//  Prototypes

extern "C" int do_spawn(int swapping, char *xeqfn, char *cmdtail, unsigned envlen, char *envp);
extern "C" int prep_swap(int method, char *swapfn);


//  ------------------------------------------------------------------

#endif

//  ------------------------------------------------------------------

