
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gutlunix.h,v 1.1.1.1 1998/11/21 19:38:09 odinn Exp $
//  ------------------------------------------------------------------
//  Unix keyboard functions. Based on SLang source code.
//  ------------------------------------------------------------------


#ifndef __GUTLUNIX_H
#define __GUTLUNIX_H


//  ------------------------------------------------------------------

#ifdef _POSIX_VDISABLE
#  define NULL_VALUE (unsigned)_POSIX_VDISABLE
#else
#  define NULL_VALUE 255
#endif


//  ------------------------------------------------------------------

#ifndef FD_SET
#define FD_SET(fd, tthis)    *(tthis) = 1 << (fd)
#define FD_ZERO(tthis)       *(tthis) = 0
#define FD_ISSET(fd, tthis) (*(tthis) & (1 << fd))
typedef int fd_set;
#endif


//  ------------------------------------------------------------------

#define GET_TERMIOS(fd, x) tcgetattr(fd, x)
#define SET_TERMIOS(fd, x) tcsetattr(fd, TCSADRAIN, x)


//  ------------------------------------------------------------------

#endif

//  ------------------------------------------------------------------

