
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gwildmat.h,v 1.1.1.1 1998/11/21 19:38:09 odinn Exp $
//  ------------------------------------------------------------------
//  A wildcard pattern matching function. Based on TIN source.
//  ------------------------------------------------------------------


#ifndef __GWILDMAT_H
#define __GWILDMAT_H

#include <gdefs.h>


//  ------------------------------------------------------------------

class gwildmatch {

protected:

  int match_internal(const char* text, const char* pattern, bool ignorecase);

public:

  bool match(const char* text, const char* pattern, bool ignorecase);

};


//  ------------------------------------------------------------------

inline bool gwildmat(const char* text, const char* pattern) {

  class gwildmatch m;
  return m.match(text, pattern, true);
}


//  ------------------------------------------------------------------

inline bool gwildmati(const char* text, const char* pattern) {

  class gwildmatch m;
  return m.match(text, pattern, true);
}


//  ------------------------------------------------------------------

inline bool gwildmatch(const char* text, const char* pattern, bool ignorecase) {

  class gwildmatch m;
  return m.match(text, pattern, ignorecase);
}


//  ------------------------------------------------------------------
//  4DOS-style wildcard pattern match

bool strwild(const char* str, const char* wild);


//  ------------------------------------------------------------------

#endif

//  ------------------------------------------------------------------

