
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gwindow.cpp,v 1.1.1.1 1998/11/21 19:38:07 odinn Exp $
//  ------------------------------------------------------------------
//  Windowing wrapper class.
//  ------------------------------------------------------------------


#include <stdio.h>
#include <stdarg.h>
#include <gwindow.h>


//  ------------------------------------------------------------------

int _stdc gwindow::printf(const char* format, ...) {

  char buf[255];
  va_list argptr;
  va_start(argptr,format);
  int result = vsprintf(buf,format,argptr);
  va_end(argptr);
  puts(buf);
  return result;
}


//  ------------------------------------------------------------------

int _stdc gwindow::printf(int color, const char* format, ...) {

  char buf[255];
  va_list argptr;
  va_start(argptr,format);
  int result = vsprintf(buf,format,argptr);
  va_end(argptr);
  text_color(color);
  puts(buf);
  return result;
}


//  ------------------------------------------------------------------

int _stdc gwindow::printf(int row, int col, const char* format, ...) {

  va_list argptr;
  char buf[256];
  *buf = NUL;
  va_start(argptr, format);
  int result = vsprintf(buf, format, argptr);
  va_end(argptr);
  prints(row, col, window_color, buf);
  return result;
}


//  ------------------------------------------------------------------

int _stdc gwindow::printf(int row, int col, int color, const char* format, ...) {

  va_list argptr;
  char buf[256];
  *buf = NUL;
  va_start(argptr, format);
  int result = vsprintf(buf, format, argptr);
  va_end(argptr);
  prints(row, col, color, buf);
  return result;
}


//  ------------------------------------------------------------------

