
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Library General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
//
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Library General Public License for more details.
//
//  You should have received a copy of the GNU Library General Public
//  License along with this library; if not, write to the Free
//  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gs_fech1.h,v 1.1.1.1 1998/11/21 19:38:10 odinn Exp $
//  ------------------------------------------------------------------


#if defined(GOLD_CANPACK)
#pragma pack(1)
#endif


//  ------------------------------------------------------------------
//  FastEcho 1.0x configuration structures
//  ------------------------------------------------------------------
//  Contents of the file:
//
//  FASTECHO.CFG =
//    CONFIG +
//    (CONFIG.BossCnt * BossNode) +
//    (CONFIG.AreaCnt * Areas)
//  ------------------------------------------------------------------


/* BossNode.flags */
#define DDDD        0x0001
#define TOSSCAN     0x0002
#define DIRECT      0x0004
#define CRASH       0x0008
#define UMLAUT_NET  0x0010
#define UMLAUT_ECHO 0x0020
#define HOLD        0x0080
#define DBUG        0x0100
#define ARCMAIL060  0x0200
#define PACKER      0x7000

/* CONFIG.flags */
#define C_RETEAR    0x0001
#define AUTOCREATE  0x0002
#define KILLEMPTY   0x0004
#define FRODO       0x0010
#define DBRIDGE     0x0020
#define BINKLEY     0x0040
//#define SWAP_XMS    0x0100
//#define SWAP_EMS    0x0200
//#define SWAP_DISK   0x0400

typedef unsigned char uchar;
typedef unsigned short uint;
typedef unsigned long ulong, UCRC;

typedef struct {
  ftn_addr boss;
  short  aka;
  dword  flags;
  char  password[10];
  ftn_addr routes[15];
  char  resv[10];
} BossNode;

typedef struct {
  char  name[42];
  short  board;
  short  messages;
  word  flags;            /* unused, 0x8000 = deleted *not written* */
  short  days;
  ftn_addr addr;
} Areas;

#define _MAXPATH 56

typedef struct CONFIGURATION1 {
  short  revision;
  dword  flags;
  short  BossCnt;
  short  AreaCnt;
  short  Recovery;
  char  NetMPath[_MAXPATH],
        MsgBase[_MAXPATH],
        InBound[_MAXPATH],
        OutBound[_MAXPATH],
        Unpacker[_MAXPATH],
        LogFile[_MAXPATH],
        OriginLine[8][_MAXPATH],
        StatFile[_MAXPATH],
        SwapPath[_MAXPATH];
  char  RetearFrom[5][40],
        RetearTo[5][40];
  struct {
    char  tag[4];
    char  name[_MAXPATH];
  } Packer[8];
  struct {
    char  what;
    char  object[31];
    byte  board;
    byte  len;
  } CC[10];
  short  security;
  short  def_days;
  short  def_messages;
  struct {
    ftn_addr main;
    char  domain[28];
    short  pointnet;
    dword  flags;
  } akas[11];
  short  autorenum;
  long  resv1;
  word  duperecords;
  word  msglen;
  short  dupeboard;
  char  resv2[2036];
} CONFIG1;


#if defined(GOLD_CANPACK)
#pragma pack()
#endif


