
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Library General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
//
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Library General Public License for more details.
//
//  You should have received a copy of the GNU Library General Public
//  License along with this library; if not, write to the Free
//  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gs_fm092.h,v 1.1.1.1 1998/11/21 19:38:11 odinn Exp $
//  ------------------------------------------------------------------
//  Structures for FMail 0.92
//  ------------------------------------------------------------------


#if defined(GOLD_CANPACK)
#pragma pack(1)
#endif


#define MAX_AKAS 11

typedef unsigned char bit;

typedef struct
{ unsigned short zone;
  unsigned short net;
  unsigned short node;
  unsigned short point; } nodeNumType;

typedef struct
{ nodeNumType nodeNum;
  unsigned short    fakeNet; } nodeFakeType;

typedef       char pathType[48];

typedef       char tempStrType[128];


/* FMAIL.CFG */

typedef nodeFakeType akaListType[MAX_AKAS];

typedef char archiverInfo[48];

typedef struct
{
   bit            useEMS       :  1; /* BIT 0 */
   bit                         :  1;
   bit            swap         :  1; /* BIT 2 */
   bit            swapEMS      :  1; /* BIT 3 */
   bit            swapXMS      :  1; /* BIT 4 */
   bit                         :  1;
   bit            monochrome   :  1; /* BIT 6 */
   bit            commentFFD   :  1; /* BIT 7 */
   bit            PTAreasBBS   :  1; /* BIT 8 */
   bit            commentFRA   :  1; /* BIT 9 */
   bit            keepReceipt  :  1; /* BIT 10 */
   bit                         :  1;
   bit                         :  1;
   bit                         :  1;
   bit                         :  1;
   bit            extraHandles :  1; /* BIT 15 */  } genOptionsType;

typedef struct
{
   bit            removeNetKludges : 1; /* Bit 0 */
   bit                             : 1;
   bit            checkPktDest     : 1; /* Bit 2 */
   bit            areaMgrPwdChange : 1; /* Bit 3 */
   bit            packetPwdChange  : 1; /* Bit 4 */
   bit                             : 1;
   bit                             : 1;
   bit                             : 1;
   bit            dupDetection     : 1; /* Bit 8 */
   bit            /*strictGroups*/ : 1; /* Bit 9 */
   bit                             : 1; /* Bit 10 */
   bit                             : 1;
   bit            persNetmail      : 1; /* Bit 12 */
   bit                             : 1;
   bit                             : 1;
   bit                             : 1; /* Bit 15 */  } mailOptionsType;

typedef struct
{
   bit            sortNew      : 1; /* bit  0   */
   bit            sortSubject  : 1; /* bit  1   */
   bit            updateChains : 1; /* bit  2   */
   bit                         : 1; /* bit  3   */
   bit            _importSeenBy: 1; /* bit  4   */
   bit            _removePID   : 1; /* bit  5 not USED */
   bit            removeRe     : 1; /* bit  6   */
   bit            removeLfSr   : 1; /* bit  7   */
   bit            scanAlways   : 1; /* bit  8   */
   bit            scanUpdate   : 1; /* bit  9   */
   bit            multiLine    : 1; /* bit 10   */
   bit                         : 1; /* bit 11   */
   bit            quickToss    : 1; /* bit 12   */
   bit                         : 1; /* bit 13-14 */
   bit                         : 1; /* bit 13-14 */
   bit            sysopImport  : 1; /* bit 15   */ } mbOptionsType;

typedef struct
{
   bit            active      : 1; /* Bit  0 */
   bit            tinySeenBy  : 1; /* Bit  1 */
   bit            security    : 1; /* Bit  2 */
   bit                        : 1; /* Bit  3 */
   bit            Private     : 1; /* Bit  4 */
   bit            impSeenBy   : 1; /* Bit  5 */
   bit            checkSeenBy : 1; /* Bit  6 */
   bit            /*compChar*/: 1; /* Bit  7 */
   bit            local       : 1; /* Bit  8 */
   bit                        : 1; /* Bit  9 */
   bit            passThrough : 1; /* Bit 10 */
   bit                        : 1; /* Bit 11-13 */
   bit                        : 1; /* Bit 11-13 */
   bit                        : 1; /* Bit 11-13 */
   bit            arrivalDate : 1; /* Bit 14 */
   bit            sysopRead   : 1; /* Bit 15 */     } defaultOptionsType;

typedef struct
{
   char            versionMajor;
   char            versionMinor;
   long            creationDate;
   unsigned long   key;
   unsigned long   reservedKey;
   char            sysopNameOld[32];
   akaListType     akaList;
   nodeFakeType    reservedAka[16-MAX_AKAS];
   unsigned short        netmailBoard[MAX_AKAS];
   unsigned short        reservedNet[16-MAX_AKAS];
   genOptionsType  genOptions;
   mbOptionsType   mbOptions;
   mailOptionsType mailOptions;
   unsigned short        maxPktSize;
   unsigned short        logLevel;
   unsigned short        mailer;
   unsigned short        bbsProgram;
   char            reserved1[86];
   char            sysopName[36];
   unsigned short        defaultArc;
   char            reserved2[98];
   unsigned short        recBoard;
   unsigned short        badBoard;
   unsigned short        dupBoard;
   char            topic1[16];
   char            topic2[16];
   pathType        bbsPath;
   pathType        netPath;
   pathType        sentPath;
   pathType        rcvdPath;
   pathType        inPath;
   pathType        outPath;
   pathType        securePath;
   pathType        logName;
   pathType        swapPath;
   pathType        semaphorePath;
   pathType        pmailPath;
   pathType        areaMgrLogName;
   pathType        autoRAPath;
   pathType        autoFolderFdPath;
   pathType        autoAreasBBSPath;
   pathType        autoGoldEdAreasPath;
   archiverInfo    unArc;
   archiverInfo    unZip;
   archiverInfo    unLzh;
   archiverInfo    unPak;
   archiverInfo    unZoo;
   archiverInfo    unArj;
   archiverInfo    reservedArc1;
   archiverInfo    reservedArc2;
   archiverInfo    arc;
   archiverInfo    zip;
   archiverInfo    lzh;
   archiverInfo    pak;
   archiverInfo    zoo;
   archiverInfo    arj;
   archiverInfo    reservedArc3;
   archiverInfo    reservedArc4;
   char            defaultOriginLine[59];
   defaultOptionsType
                   defaultOptions;
   unsigned short        defaultDays;
   unsigned short        defaultMsgs;
   unsigned short        defaultReadSecRA;
   char            defaultReadFlagsRA[4];
   unsigned short        defaultWriteSecRA;
   char            defaultWriteFlagsRA[4];
   unsigned short        defaultSysopSecRA;
   char            defaultSysopFlagsRA[4];
   char            defaultAttrRA;
   char            reserved3[428];
   char            groupDescr[26][27];
   char            reserved4[20];
   char            attrRA[11];
   unsigned short        readSecRA[11];
   char            readFlagsRA[11][4];
   unsigned short        writeSecRA[11];
   char            writeFlagsRA[11][4];
   unsigned short        sysopSecRA[11];
   char            sysopFlagsRA[11][4];
   unsigned short        daysAKA[11];
   unsigned short        msgsAKA[11];
   char            descrAKA[11][51];    } configType;



/* FMAIL.NOD */

typedef struct
{
   bit            fixDate     : 1;
   bit            tinySeenBy  : 1;
   bit            ignorePwd   : 1; /* Bit 3 */
   bit                        : 1;
   bit            active      : 1;
   bit                        : 1;
   bit                        : 1;
   bit                        : 1;
   bit            autoDetect  : 1;
   bit                        : 1;
   bit                        : 1;
   bit                        : 1;
   bit                        : 1;
   bit                        : 1;
   bit            allowRescan : 1; /* Bit 14 */
   bit            notify      : 1;   } nodeOptionsType;


typedef struct
{
   nodeNumType     node;
   char            reserved1[2];
   unsigned short        capability;
   unsigned short        archiver;
   nodeOptionsType options;
   unsigned long   groups;
   unsigned short        outStatus;
   char            reserved2[32];
   char            password[18];
   char            packetPwd[10];
   char            reserved[10];
   char            sysopName[36];   } nodeInfoType;



/* FMAIL.AR */

#define ECHONAME_LEN_OLD  25
#define ECHONAME_LEN      51
#define COMMENT_LEN   51
#define ORGLINE_LEN   59
#define MAX_FORWARD   64

typedef struct
{
   bit            active      : 1; /* Bit  0 */
   bit            tinySeenBy  : 1; /* Bit  1 */
   bit            security    : 1; /* Bit  2 */
   bit                        : 1; /* Bit  3 */
   bit            Private     : 1; /* Bit  4 */
   bit            impSeenBy   : 1; /* Bit  5 */
   bit            checkSeenBy : 1; /* Bit  6 */
   bit            /*compChar*/: 1; /* Bit  7 */
   bit            local       : 1; /* Bit  8 */
   bit                        : 1; /* Bit  9 */
   bit            reserved    : 1; /* Bit 10 */ /* default pass-thru bit */
   bit                        : 1; /* Bit 11-13 */
   bit                        : 1; /* Bit 11-13 */
   bit                        : 1; /* Bit 11-13 */
   bit            arrivalDate : 1; /* Bit 14 */
   bit            sysopRead   : 1; /* Bit 15 */   } areaOptionsType;

typedef struct
{
   char            areaNameOld[ECHONAME_LEN_OLD];
   char            comment[COMMENT_LEN];
   long            group;
   unsigned short        board;
   unsigned short        address;
   unsigned short        alsoSeenBy;
   char            reserved1[8];
   areaOptionsType options;
   unsigned short        outStatus;
   unsigned short        days;
   unsigned short        msgs;
   char            reserved2[4];
   unsigned short        readSecRA;
   char            flagsRdRA[4];
   unsigned short        writeSecRA;
   char            flagsWrRA[4];
   unsigned short        sysopSecRA;
   char            flagsSysRA[4];
   char            attrRA;
   char            msgKindsRA;
   unsigned short        attrSBBS;
   char            replyStatSBBS;
   char            areaName[ECHONAME_LEN];
   char            reserved3[17];
   char            originLine[ORGLINE_LEN];
   nodeNumType     export[MAX_FORWARD];  } rawEchoType;


//  ------------------------------------------------------------------

#if defined(GOLD_CANPACK)
#pragma pack()
#endif


//  ------------------------------------------------------------------
