
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Library General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
//
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Library General Public License for more details.
//
//  You should have received a copy of the GNU Library General Public
//  License along with this library; if not, write to the Free
//  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gs_max3.h,v 1.1.1.1 1998/11/21 19:38:11 odinn Exp $
//  ------------------------------------------------------------------

/*# name=Main Maximus header file
*/

#ifndef __MAX_H_DEFINED
#define __MAX_H_DEFINED

/*# name=General include file.  Lots of machine-dependant stuff here.
*/

#ifndef __PROG_H_DEFINED
#define __PROG_H_DEFINED

#ifdef PATHLEN
#undef PATHLEN
#endif

#define PATHLEN           120   /* Max. length of a path                   */
#ifdef __cplusplus
extern "C" {
#endif

#include <stdio.h>
#include <time.h>
#include <stdlib.h>
/*# name=Compiler-determination and memory-model-determination routines
    name=Support for WATCOM C (DOS, OS/2 and 386 flat), Microsoft C
    name=(all memory models, DOS & OS/2), Turbo C 2.0, Turbo/Borland C++
    name=and IBM C Set/2 (flat model).
*/

/* Non-DOS systems...  Just do a "#define __FARCODE__",                     *
 * "#define __FARDATA__" and "#define __LARGE__" in place of this file.     */

#if 0
#ifndef __COMPILER_H_DEFINED
#define __COMPILER_H_DEFINED


#ifdef _lint  /* default to large segmented model when linting */
#define __LARGE__
#endif

/* Topaz - Borland C++ for OS/2 */

#if defined(__BORLANDC__) && defined(__OS2__)
  #define __TOPAZ__  __BORLANDC__
  #define __FLAT__
  #define __386__
#endif

#ifdef __GNUC__
  #define __FLAT__
  #define __386__
  #define __POSIX__
#endif

#ifdef __IBMC__ /* Set default library options for IBM's C Set/2 */
  #define __FLAT__
  #define __386__
#endif

#if defined(NT) && !defined(__FLAT__)
  #define __FLAT__
#endif

/* WATCOM includes both M_I86xxx and __modeltype__ macros */

#ifndef __WATCOMC__

  #if (!defined(_lint) && (defined(M_I86SM) || defined(M_I86MM) || \
                           defined(M_I86CM) || defined(M_I86LM) || \
                           defined(M_I86HM) || defined(_MSC_VER)))
    #define __MSC__
  #endif

  #ifdef M_I86SM
    #define __SMALL__
  #endif

  #ifdef M_I86MM
    #define __MEDIUM__
  #endif

  #ifdef M_I86CM
    #define __COMPACT__
  #endif

  #ifdef M_I86LM
    #define __LARGE__
  #endif

  #ifdef M_I86HM
    #define __HUGE__
  #endif

#endif /* ! __WATCOMC__ */




/* Handle 386 "flat" memory model, currently for IBM C Set/2 and WC386 */

#ifdef __FLAT__

  /* Other macros may get defined by braindead compilers */

  #ifdef __SMALL__
    #undef __SMALL_
  #endif

  #ifdef __TINY__
    #undef __TINY__
  #endif

  #ifdef __MEDIUM__
    #undef __MEDIUM__
  #endif

  #ifdef __COMPACT__
    #undef __COMPACT__
  #endif

  #ifdef __LARGE__
    #undef __LARGE__
  #endif

  #ifdef __HUGE__
    #undef __HUGE__
  #endif

  /* Code is really "near", but "far" in this context means that we want    *
   * a 32 bit ptr (vice 16 bit).                                            */

  #define __FARCODE__
  #define __FARDATA__

  /* Everything should be "near" in the flat model */

  #ifdef far
    #undef far
  #endif

  #ifdef near
    #undef near
  #endif

  #ifdef huge
    #undef huge
  #endif

  #define far
  #define near
  #define huge


  /* Since we're using flat model OS/2, we never need to load DS */

  #ifdef OS_2
    #ifdef _loadds
      #undef _loadds
    #endif

    #ifdef __loadds
      #undef __loadds
    #endif

    #define _loadds
    #define __loadds
  #endif

#else /* !FLAT */
  #define __far16 far
#endif


/* Now handle the segmented memory models */

#if defined(__SMALL__) || defined(__TINY__)
  #define __NEARCODE__
  #define __NEARDATA__
#endif

#ifdef __MEDIUM__
  #define __FARCODE__
  #define __NEARDATA__
#endif

#ifdef __COMPACT__
  #define __NEARCODE__
  #define __FARDATA__
#endif

#if defined(__LARGE__) || defined(__HUGE__)
  #define __FARCODE__
  #define __FARDATA__
#endif


/* Default to MS-DOS compile */

#if !defined(OS_2) && !defined(__MSDOS__) && !defined(NT) && !defined(UNIX)
  #define __MSDOS__
#endif


/* Compiler-specific stuff:                                                 *
 *                                                                          *
 *  _stdc - Standard calling sequence.  This should be the type of          *
 *          function required for function ptrs for qsort() et al.          *
 *                                                                          *
 *  _vstdc- Same as _stdc, but for variables.  In some compilers (WC, MSC), *
 *          this determines whether or not a function has a leading         *
 *          underscore.  Unfortunately, using _stdc is invalid when working *
 *          with IBM C Set/2.                                               *
 *                                                                          *
 *  _fast - Fastest calling sequence supported.  If the default             *
 *          calling sequence is the fastest, or if your compiler            *
 *          only has one, define this to nothing.                           *
 *                                                                          *
 *  _intr - For defining interrupt functions.  For some idiotic             *
 *          reason, MSC requires that interrupts be declared                *
 *          as "cdecl interrupt", instead of just "interrupt".              */


/****************************************************************************
                      Turbo C 2.0, Turbo C++ and Borland C++
 ****************************************************************************/

#if defined(__TURBOC__)

  #define _stdc     cdecl
  #define _vstdc    cdecl
  #define _intcast  void (_intr *)()
  #define _veccast  _intcast

  #ifdef __TOPAZ__
    #define _fast     __fastcall
    #define _intr     __interrupt __far
    #define _System   _syscall
  #else
    #define _fast     pascal
    #define _intr     interrupt far
  #endif

  #define _loadds

  #define NW(var) (void)var
  /* structs are packed in TC by default, accd to TURBOC.CFG */

/****************************************************************************
                             Microsoft C 6.0
 ****************************************************************************/

#elif defined(__MSC__)

  #define _stdc     cdecl
  #define _vstdc    cdecl
  #define _intr     cdecl interrupt far
  #define _intcast  void (_intr *)()
  #define _veccast  _intcast

  #if _MSC_VER >= 600
    #define _fast _fastcall
  #else
    #define _fast pascal
  #endif

  #pragma pack(1)                 /* Structures should not be padded */
  #define NW(var)  var = var      /* NW == No Warning */

/****************************************************************************
                             WATCOM C 8.0/8.5
 ****************************************************************************/

#elif defined(__WATCOMC__)

  #define _stdc
  #define _vstdc
  #define _intr     cdecl interrupt __far
  #define _intcast  void (_intr *)()
  #define _veccast  void (__interrupt __far *)()
  #define _fast

  #pragma pack(1)                 /* Structures should not be padded */
  #define NW(var)   (void)var


/****************************************************************************
                                IBM C Set/2
 ****************************************************************************/

#elif defined(__IBMC__)

#ifndef __MIG__
  #define cdecl     /*_Cdecl*/
  #define pascal    /*_Pascal*/
#endif

  #define _stdc     /*_Optlink*/
  #define _vstdc
  #define _intr     /*_System*/
  #define _intcast  void (_intr *)()
  #define _veccast  void (_intr *)()
  #define _fast

  #pragma pack(1)                 /* Structures should not be padded */
  #define NW(var)   (void)var

/****************************************************************************
                                GNU C/C++
 ****************************************************************************/

#elif defined(__GNUC__)
  #define _stdc
  #define _vstdc
  #define _intr
  #define _intcast
  #define _veccast
  #define _fast
  #define _loadds

  #define pascal
  #define cdecl
  #define far
  #define near

  #define NW(var) (void)var

/****************************************************************************
                                    LINT
 ****************************************************************************/

#elif defined(_lint)

  #define _stdc
  #define _vstdc
  #define _intr     cdecl interrupt __far
  #define _intcast  void (_intr *)()
  #define _veccast  void (__interrupt __far *)()
  #define _fast

  #define NW(var)   (void)var

#else
  #error Unknown compiler!

  #define _stdc
  #define _intr     interrupt
  #define _intcast  void (_intr *)()
  #define _veccast  intr
  #define _fast
  #define NW(var)   (void)var
  #define __MSDOS__
#endif


#endif /* ! __COMPILER_H_DEFINED */
#endif

#ifndef __TYPEDEFS_H_DEFINED
#ifndef __TYPEDEFS_H_DEFINED
#define __TYPEDEFS_H_DEFINED

/* Handle the special defines for 32-bit flat model compilers */

#if defined(__386__) || defined(__FLAT__)
  typedef unsigned      bit;

  typedef unsigned char byte;
  typedef signed char   sbyte;

  typedef unsigned short word;
  typedef signed short   sword;

//  typedef unsigned int  dword;
  typedef signed int    sdword;

#if !defined(NT) && !defined(UNIX)
  typedef unsigned short ushort;
#endif

  typedef   signed short sshort;

  typedef unsigned long  ulong;
  typedef   signed long  slong;
#else
  typedef unsigned      bit;

  typedef unsigned char byte;
  typedef signed char   sbyte;

//  typedef unsigned int   word;
  typedef signed int    sword;

//  typedef unsigned long dword;
  typedef signed long   sdword;

//  typedef unsigned short ushort;
  typedef   signed short sshort;

//  typedef unsigned long  ulong;
  typedef   signed long  slong;
#endif

#endif

#endif

#ifndef __STAMP_H_DEFINED
#define __STAMP_H_DEFINED

struct _stamp   /* DOS-style datestamp */
{
  struct
  {
    /* IBM Cset/2 is allergic to "unsigned short" when declaring bitfields! */

#ifdef __IBMC__
    unsigned int da : 5;
    unsigned int mo : 4;
    unsigned int yr : 7;
#else
/*lint -e46 */
    word da : 5;
    word mo : 4;
    word yr : 7;
/*lint -restore */
#endif
  } date;

  struct
  {
#ifdef __IBMC__
    unsigned int ss : 5;
    unsigned int mm : 6;
    unsigned int hh : 5;
#else
/*lint -e46 */
    word ss : 5;
    word mm : 6;
    word hh : 5;
/*lint -restore */
#endif
  } time;
};


struct _dos_st
{
  word date;
  word time;
};

/* Union so we can access stamp as "int" or by individual components */

union stamp_combo   
{
  dword ldate;
  struct _stamp msg_st;
  struct _dos_st dos_st;
};

typedef union stamp_combo SCOMBO;

#endif /* __STAMP_H_DEFINED */


#ifdef __FARDATA__
/*# name=Include file to pick between MALLOC.H and ALLOC.H
*/

#ifndef __ALC_H_DEFINED
#define __ALC_H_DEFINED

#if defined(_lint) || defined(__MSC__) || defined(__WATCOMC__) || defined(__IBMC__) || defined(__TOPAZ__)
  #include <malloc.h>

  #ifdef __FARDATA__

  /* for some insane reason the turbo-c coreleft() function changes
   * it's return value based on the memory model.
   */

    unsigned long cdecl coreleft   (void);
  #else
    unsigned cdecl coreleft        (void);
  #endif

#elif defined(__TURBOC__)
  #include <alloc.h>
#else
  #include <string.h>
#endif

#ifdef __TURBOC__
#define halloc(x,y) ((char far *)farmalloc(x*y))
#define hfree(p)    farfree(p)
#endif

#endif /* __ALC_H_DEFINED */
#endif


#if defined(__WATCOMC__) || defined(__MSC__) || defined(_lint)

  #ifdef _MSC_VER
    #if _MSC_VER >= 600
      #define farcalloc(a,b) _fcalloc(a,b)
    #endif /* _MSC_VER >= 600 */
  #endif /* _MSC_VER */

  #define da_year year
  #define da_day day
  #define da_mon month

  #define ti_min minute
  #define ti_hour hour
  #define ti_hund hsecond
  #define ti_sec second

  #define getdate _dos_getdate
  #define gettime _dos_gettime

  #define NO_STRFTIME

/*  #ifndef __WATCOMC__*/
  #define NO_MKTIME
/*  #endif*/

#elif defined(__TURBOC__)

  #define dosdate_t date
  #define dostime_t time

  #if (__TURBOC__ >= 0x0295) || defined(__TOPAZ__)
    /* TC++ and above include a strftime() function */
    #define NO_STRFTIME
    #define NO_MKTIME
  #endif

#endif
 
#if defined(__FLAT__)
    #undef farcalloc
    #undef farmalloc
    #undef farrealloc
    #undef farfree
    #undef _fmalloc

    #define farcalloc  calloc
    #define farmalloc  malloc
    #define farrealloc realloc
    #define farfree    free
    #define _fmalloc   malloc
#endif

#ifndef __TURBOC__

  /* For ERRNO definitions */
  #define ENOTSAM EXDEV

  int _stdc fnsplit(const char *path,char *drive,char *dir,char *name,char *ext);
  int _stdc getcurdir(int drive, char *directory);

  int fossil_wherex(void);
  int fossil_wherey(void);
  void fossil_getxy(char *row, char *col);

  #define textattr(attr)
  #define getdisk()                  get_disk()
  #define setdisk(drive)             set_disk(drive)

  #define getvect(int)            _dos_getvect(int)
  #define setvect(int, func)      _dos_setvect(int, func)

  #ifndef inportb
    #define inportb(port)           inp(port)
  #endif

  #define inport(port)            inpw(port)

  #ifndef outportb
    #define outportb(port, byte)    outp(port, byte)
  #endif

  #define outport(port, byte)     outpw(port, byte)

  #if !defined(MK_FP) && !defined(_lint)
    #define MK_FP(seg, off)  (void far *)((unsigned long)(seg)<<16L | (off))
  #endif
#endif

#ifdef __MSC__
  int _fast lock(int fh, long offset, long len);
  int _fast unlock(int fh, long offset, long len);
  #undef toupper
  extern unsigned char _MyUprTab[256];      /* see _ctype.c */
  #define toupper(c)  ((int)_MyUprTab[(c)])
#endif
 
#ifndef cpp_begin
  #ifdef __cplusplus
    #define cpp_begin()   extern "C" {
    #define cpp_end()     }
  #else
    #define cpp_begin()
    #define cpp_end()
  #endif
#endif


#if !defined(offsetof) && !defined(__WATCOMC__) && !defined(_MSC_VER) && !defined(__TURBOC__) && !defined(__IBMC__) && !defined(__TOPAZ__) && !defined(_lint)
#define offsetof(typename,var) (size_t)(&(((typename *)0)->var))
#endif

#ifdef __TURBOC__
#if __TURBOC__ <= 0x0200
#define offsetof(typename,var) (size_t)(&(((typename *)0)->var))
#endif
#endif


typedef long timer_t;

#define REGISTER

#ifndef true
#define false 0
#define true 1
#endif


//#define LITTLE_ENDIAN           /* If compiling on a "back-words" (Intel)  *
//                                 * Otherwise, #define BIG_ENDIAN           */

#ifdef __MSDOS__
#define WILDCARD_ALL     "*.*"
#else
#define WILDCARD_ALL     "*"
#endif

#define PATH_DELIM       '\\'   /* Default separator for path specification */
#define PATH_DELIMS      "\\"   /* string format */
#define _PRIVS_NUM         12   /* Maximum priv levels for Maximus         */
#define CHAR_BITS           8   /* Number of bits in a `char' variable     */
#define MAX_DRIVES         26   /* Maximum number of drives on system;     *
                                 * for MS-DOS, A through Z.  Used by       *
                                 * Save_Dir()...                           */

#define INTBIT_C        0x0001  /* Carry */
#define INTBIT_P        0x0004  /* Parity */
#define INTBIT_AUX      0x0010  /* Aux carry */
#define INTBIT_Z        0x0040  /* Zero flag */
#define INTBIT_SIG      0x0080  /* Sign flag */
#define INTBIT_TRC      0x0100  /* Trace flag */
#define INTBIT_INT      0x0200  /* Interrupt flag */
#define INTBIT_D        0x0400  /* Direction flag */
#define INTBIT_OVF      0x0800  /* Overflow flag */

#define ZONE_ALL  56685u
#define NET_ALL   56685u
#define NODE_ALL  56685u
#define POINT_ALL 56685u


#define THIS_YEAR "1995"

#define Hello(prog,desc,version,year) (void)printf("\n" prog "  " desc ", Version %s.\nCopyright " year " by Lanius Corporation.  All rights reserved.\n\n",version)
#define shopen(path,access)   sopen(path,access,SH_DENYNONE,S_IREAD | S_IWRITE)
#define GTdate(s1, s2) (GEdate(s1, s2) && (s1)->ldate != (s2)->ldate)
#define carrier_flag          (prm.carrier_mask)
#define BitOff(a,x)           ((void)((a)[(x)/CHAR_BITS] &= ~(1 << ((x) % CHAR_BITS))))
#define BitOn(a,x)            ((void)((a)[(x)/CHAR_BITS] |= (1 << ((x) % CHAR_BITS))))
#define IsBit(a,x)            ((a)[(x)/CHAR_BITS] & (1 << ((x) % CHAR_BITS)))

/*#define lputs(handle,string)  write(handle,string,strlen(string))*/

#define dim(a)                (sizeof(a)/sizeof(a[0]))
#define eqstr(str1,str2)      (strcmp(str1,str2)==0)
#define eqstri(str1,str2)     (stricmp(str1,str2)==0)
#define eqstrn(str1,str2,n)   (strncmp(str1,str2,n)==0)
#define eqstrni(str1,str2,n)  (strnicmp(str1,str2,n)==0)
#define eqstrin(str1,str2,n)  eqstrni(str1,str2,n)
#define divby(num,div)        ((num % div)==0)
#define f_tolwr(c)            (_to_lwr[c])
#define f_toupr(c)            (_to_upr[c])

/* Macro to propercase MS-DOS filenames.  If your OS is case-dependent,     *
 * use "#define fancy_fn(s) (s)" instead.  Ditto for upper_fn().            */

#define fancy_fn(s)           fancy_str(s)
#define upper_fn(s)           strupr(s)
#define lower_fn(s)           strlwr(s)

#ifndef updcrc
#define updcrc(cp, crc)       (crctab[((crc >> 8) & 255) ^ cp] ^ (crc << 8))
#endif


#ifndef max
#define max(a,b)              (((a) > (b)) ? (a) : (b))
#define min(a,b)              (((a) < (b)) ? (a) : (b))
#endif


/* Don't change this struct!  The code in win_pick.c and max_locl.c relies  *
 * on it as being the same as PLIST...                                      */

struct __priv
{
  char *name;
  int priv;
};


#if 0
extern char _vstdc months[][10];
extern char _vstdc weekday[][10];

extern char _vstdc months_ab[][4];
extern char _vstdc weekday_ab[][4];
#endif

#ifndef NO_STRFTIME
  /* If compiler doesn't include a strftime(), use our own */

  #include <time.h>
  #include <sys/types.h>

  size_t _stdc strftime(char *,size_t,const char *,const struct tm *);
#endif


#ifndef NO_MKTIME
  /* If compiler doesn't include a mktime(), use our own */

  #include <time.h>
  #include <sys/types.h>

  time_t _stdc mktime(struct tm * tm_ptr);
#endif

/* MS docs use both SH_DENYNONE and SH_DENYNO */

#if !defined(SH_DENYNONE) && defined(SH_DENYNO)
  #define SH_DENYNONE SH_DENYNO
#endif

#ifdef __cplusplus
}
#endif

#endif /* __PROG_H_DEFINED */



/***************************************************************************
 *    Conditional flags for the entire program, and portability stuff      *
 ***************************************************************************/

#define CANENCRYPT          /* Do we support encryption of passwords? */
#define MUSTENCRYPT         /* Should we always encrypt the user's password
                             * at logon, even if they don't try to change it?
                             * (This requires CANENCRYPT.)
                             */
#define CHANGEENCRYPT       /* Passwords are always encrypted when the user
                             * changes it or logs on for the first time */
#define TTYVIDEO            /* Local video supported via fputc() et al */
#define MAXIMUS             /* Who are we? */
#define MEX                 /* Include MEX support */
#define MAX_TRACKER         /* Use message tracking subsystem */
/*#define FLUSH_LOG*/
#define INTERNAL_PROTOCOLS
#define SHORT_MDM_CMD

#if !defined(__FLAT__) && !defined(ORACLE)
  /*#define KEY*/               /* Use key file */
#endif

#ifdef OS_2
  #define MCP

  #ifndef ORACLE
    #define MCP_VIDEO
  #endif

  #ifndef __FLAT__
    /*#define MAXSNOOP*/
  #endif
#endif


/***************************************************************************
                          Initialization of variables
 ***************************************************************************/

#define extrn extern
#define IS(x)
#define LEN(x)

#include <time.h>
/*# name=Structs for utime()
*/

#ifndef __UTIME_H_DEFINED
#define __UTIME_H_DEFINED

#include <time.h>

#if 0
#if defined(__TURBOC__)
  struct utimbuf
  {
    time_t actime;  /* access time */
    time_t modtime; /* modification time */
  };
#elif defined(__POSIX__)
  #include <utime.h>
#else
  #include <sys/utime.h>
#endif
#endif

#endif



#ifdef BLINK
#undef BLINK
#endif

#ifdef DLE
#undef DLE
#endif

/***************************************************************************
                          Miscellanious Macros
 ***************************************************************************/

#ifdef __TURBOC__
#define isupsp(c) (_ctype[(c) + 1] & (_IS_UPP | _IS_SP))
#else
#define isupsp(c) (isupper(c) || isspace(c))
#endif

#define MNU(m,o)            (((m).menuheap)+(m).o)
#define MsgAreaHasLock(a,l) ((a).msglock & (1L << (dword)(l)))
#define FileAreaHasLock(a,l)((a).filelock & (1L << (dword)(l)))
#define GEPriv(p1,p2)       ((word)(p1) >= (word)(p2))
#define LEPriv(p1,p2)       ((word)(p1) <= (word)(p2))

/***************************************************************************
                            Constant #define's
 ***************************************************************************/


#define FFLAG_TAG         0x0001    /* File was T)agged                     */
#define FFLAG_THIS1       0x0002    /* Selected during THIS wcard expansion */
#define FFLAG_NOTIME      0x0004    /* Don't debit time for this file       */
#define FFLAG_NOBYTES     0x0008    /* Don't debit DL bytes for this file   */
#define FFLAG_EXP         0x0010    /* Filename was expanded from wildcard  */
#define FFLAG_NOENT       0x0020    /* This file is not on disk             */
#define FFLAG_OK          0x0040    /* This file previously verified for DL */
#define FFLAG_NOLIST      0x0080    /* File is not in FILES.BBS             */
#define FFLAG_GOT         0x0100    /* This file was uploaded               */
#define FFLAG_SENT        0x0200    /* This file was downloaded             */
#define FFLAG_STAGE       0x0400    /* Copy file to staging area before xfer*/
#define FFLAG_SLOW        0x0800    /* File is from from an FA_SLOW area    */
#define FFLAG_DUPE        0x8000    /* File is a dupe                       */

#define CMSG_PAGE       0x00   /* "You're being paged by another user!"     */
#define CMSG_ENQ        0x01   /* "Are you on this chat channel?"           */
#define CMSG_ACK        0x02   /* "Yes, I AM on this channel!"              */
#define CMSG_EOT        0x03   /* "I'm leaving this chat channel!"          */
#define CMSG_CDATA      0x04   /* Text typed by used while in chat          */
#define CMSG_HEY_DUDE   0x05   /* A normal messge.  Always displayed.       */
#define CMSG_DISPLAY    0x06   /* Display a file to the user                */

#define MAX_MENUNAME  PATHLEN   /* Max. length of menuname[].               */
#define RST_VER             3   /* Version number of RESTARxx.BBS           */
#define MAX_LINE          255   /* Max. length of a .CTL file line!         */
#define PREREGISTERED  0xfffe   /* Priv. value that means let no new        *
                                 * callers on the system.                   */
#define RESTART_MENU      0x00  /* If restarting at a menu                */
#define RESTART_DOTBBS    0x01  /* If restarting in middle of .BBS file   */

#define NUM_MENU           256  /* Max. # of options in a menu file       */


/* Defines for *.MNU: */

#define AREATYPE_LOCAL    0x01  /* Tells which type (and which type ONLY)  */
#define AREATYPE_MATRIX   0x02  /* that command can be used in.            */
#define AREATYPE_ECHO     0x04
#define AREATYPE_CONF     0x08

#define AREATYPE_ALL      (AREATYPE_LOCAL | AREATYPE_MATRIX | AREATYPE_ECHO | AREATYPE_CONF)

#define HEADER_NONE       0x00  /* The header type for each menu.          */
#define HEADER_MESSAGE    0x01
#define HEADER_FILE       0x02
#define HEADER_CHANGE     0x03
#define HEADER_CHAT       0x04

#define OFLAG_NODSP       0x0001 /* Don't display menu option on MENU, but */
                                 /* accept it as a command.                */
#define OFLAG_CTL         0x0002 /* Produce a .CTL file for this xtern cmd */
#define OFLAG_NOCLS       0x0004 /* Don't do a CLS for this display_menu   */
#define OFLAG_THEN        0x0008 /* Do only if last IF equation was true   */
#define OFLAG_ELSE        0x0010 /* Do only if last IF equation was false  */
#define OFLAG_ULOCAL      0x0020 /* Only display for local users           */
#define OFLAG_UREMOTE     0x0040 /* Only display for remote useres         */
#define OFLAG_REREAD      0x0080 /* Re-read LASTUSER.BBS upon re-entry     */
#define OFLAG_STAY        0x0100 /* Don't perform menu clean-up operations */
#define OFLAG_RIP         0x0200 /* Available for RIP callers only         */
#define OFLAG_NORIP       0x0400 /* Available for non-RIP callers only     */

/***************************************************************************
                       Structure Definitions
 ***************************************************************************/

typedef struct _netaddr NETADDR;

struct _netaddr
{
  word zone;
  word net;
  word node;
  word point;
};



struct _maxcol
{
  byte status_bar;        /* black on white */
  byte status_cht;        /* blinking black on white */
  byte status_key;        /* blinking black on white */

  byte pop_text;          /* white on blue */
  byte pop_border;        /* yellow on blue */
  byte pop_high;          /* yellow on blue */
  byte pop_list;          /* black on grey */
  byte pop_lselect;       /* grey on red */

  byte wfc_stat;          /* white on blue */
  byte wfc_stat_bor;      /* yellow on blue */
  byte wfc_modem;         /* gray on blue */
  byte wfc_modem_bor;     /* lgreen on blue */
  byte wfc_keys;          /* yellow on blue */
  byte wfc_keys_bor;      /* white on blue */
  byte wfc_activ;         /* white on blue */
  byte wfc_activ_bor;     /* lcyan on blue */
  byte wfc_name;          /* yellow on black */
  byte wfc_line;          /* white on black */
};



/* Typedefs */

typedef word zstr;      /* Offset of string within area heap */

#define CLS_ID  0x8f7c9321L

/*
 * Describes user privilege/class information API
 *
 */

#ifndef __UCLASS_H_DEFINED
#define __UCLASS_H_DEFINED

#define CLS_ID  0x8f7c9321L

  /* File header structure (internal) */

typedef struct _clshdr
{
  dword ulclhid;                                         /* ID signature */
  word  usclfirst;                             /* Offset of first record */
  word  usn;                     /* Number of user class records present */
  word  ussize;                      /* Size of individual class records */
  word  usstr;                                    /* Size of all strings */
} CLSHDR;

  /* This structure describes the priv file
   * structure and is subject to change
   */

typedef struct _clsrec
{
  word  usLevel;                               /* Numeric security level */
  word  usKey;              /* Keyletter for MECCA [?below] [?above] etc */

  zstr  zAbbrev;                          /* Abbreviation for this class */
  zstr  zDesc;                                        /* Long class name */
  zstr  zAlias;                            /* Alias for the abbreviation */

  word  usTimeDay;                    /* Daily time allowance in minutes */
  word  usTimeCall;                    /* Call time allowance in minutes */
  word  usCallsDay;                             /* Max calls/day -1=none */
  word  usMinBaud;                           /* Minimum logon baud / 100 */
  word  usFileBaud;                       /* Minimum download baud / 100 */
  word  usFileRatio;                       /* File upload:download ratio */
  word  usFreeRatio;     /* Download allowance before ratio takes effect */
  dword ulFileLimit;          /* Maximum download allowance in kilobytes */
  word  usUploadReward;                               /* % upload reward */

  zstr  zLoginFile;       /* Show this file (in misc directory) on login */

  dword ulAccFlags;                        /* Access related class flags */
  dword ulMailFlags;                         /* Mail related class flags */
  dword ulUsrFlags;                          /* User-defined class flags */

  word  usOldPriv;      /* 'old' user priv equivalent, for compatibility */

} CLSREC;

  /* Mail-related class access flags */

#define CFLAGM_PVT      0x01000000L             /* Show private messages */
#define CFLAGM_EDITOR   0x02000000L            /* External editor access */
#define CFLAGM_LEDITOR  0x04000000L      /* Local external editor access */
#define CFLAGM_NETFREE  0x08000000L                 /* Netmail is 'free' */
#define CFLAGM_ATTRANY  0x10000000L /* Allow 'sysop' attribute overrides */
#define CFLAGM_RDONLYOK 0x40000000L /* Allow write priv in readonly area */
#define CFLAGM_NOREALNM 0x80000000L      /* Don't add ^aREALNAME to msgs */

  /* General purpose access flags */

#define CFLAGA_ULBBSOK  0x00000001L        /* Uploading .?bs files is ok */
#define CFLAGA_FLIST    0x00000002L /* Allow file dloads not in filelist */
#define CFLAGA_FHIDDEN  0x00000004L       /* See/download 'hidden' files */
#define CFLAGA_UHIDDEN  0x00000008L /* Allow 'not in userlist' user view */
#define CFLAGA_HIDDEN   0x00000010L          /* Always hide in user list */
#define CFLAGA_HANGUP   0x00000020L                /* Hangup immediately */
#define CFLAGA_NOLIMIT  0x00000040L          /* Don't check dload limits */
#define CFLAGA_NOTIME   0x00000080L           /* Don't check time limits */

#define mailflag(b)   (!!(ClassGetInfo(cls,CIT_MAILFLAGS) & (b)))
#define acsflag(b)    (!!(ClassGetInfo(cls,CIT_ACCESSFLAGS) & (b)))

 /* The following determine the type of information
  * returned by ClassGetInfo()
  */

#define CIT_NUMCLASSES    -1
#define CIT_DAY_TIME      0
#define CIT_CALL_TIME     1
#define CIT_DL_LIMIT      2
#define CIT_RATIO         3
#define CIT_MIN_BAUD      4
#define CIT_MIN_XFER_BAUD 5
#define CIT_MAX_CALLS     6
#define CIT_FREE_RATIO    7
#define CIT_UPLOAD_REWARD 8
#define CIT_ACCESSFLAGS   9
#define CIT_MAILFLAGS     10
#define CIT_USERFLAGS     11
#define CIT_LEVEL         12
#define CIT_KEY           13
#define CIT_INDEX         14
#define CIT_OLDPRIV       15

  /* This structure is used in memory to
   * manage the API interface
   */

typedef struct _uclassh
{
  word    usn;                            /* Number of classes available */
  word    ussize;                                         /* Record size */
  CLSREC  *pcInfo;                 /* Pointer to class information array */
  char    *pHeap;                       /* Pointer to class strings heap */
} CLH, *PCLH;

  /* Privilege comparison operators */

enum _privcmp
{
  privGE  =0,   /* >= */
  privLE  =1,   /* <= */
  privGT  =2,   /* >  */
  privLT  =3,   /* <  */
  privEQ  =4,   /* == */
  privNE  =5    /* != */
};

#endif

/*# name=Maximus USER.BBS structure definition
*/

#ifndef __MAX_U_H_DEFINED
#define __MAX_U_H_DEFINED



#define MAX_ALEN         64     /* Max length of usr.msg[] and usr.files[]  */


/* Masks for usr.bits1, below */

#define BITS_HOTKEYS     0x0001 /* Hotkeys, independent of HOTFLASH level   */
#define BITS_NOTAVAIL    0x0002 /* If set, user is not normally available   *
                                 * for chat.                                */
#define BITS_FSR         0x0004 /* Full-screen reading in msg areas         */
#define BITS_NERD        0x0008 /* Yelling makes no noise on sysop console  */
#define BITS_NOULIST     0x0010 /* Don't display name in userlist           */
#define BITS_TABS        0x0020 /* User can handle being sent raw tabs      */
#define BITS_ENCRYPT     0x0040 /* pwd is a MD5 digest, not plaintext       */
#define BITS_RIP         0x0080 /* Remote Imaging Prototocol support        */


/* Masks for usr.bits2, below */

#define BITS2_BADLOGON   0x0001 /* MAX: if user's last logon attempt was bad*/
#define BITS2_IBMCHARS   0x0002 /* MAX: if user can receive high-bit chars  */
#define BITS2_RSVD1      0x0004 /* MAX: *obsolete* 1.02 avatar flag         */
#define BITS2_BORED      0x0008 /* Use the line-oriented editor             */
#define BITS2_MORE       0x0010 /* Wants the "MORE?" prompt                 */
#define BITS2_RSVD2      0x0020 /* OPUS: set=wants Ansi                     */
#define BITS2_CONFIGURED 0x0040 /* OPUS: set=used Maximus before            */
#define BITS2_CLS        0x0080 /* OPUS: set=transmit ^L, clear=ignore ^L   */
#define BITS2_BIT8       0x0100 /* used to be 'usr.keys'                    */
#define BITS2_BIT9       0x0200 /* used to be 'usr.keys'                    */
#define BITS2_BITA       0x0400 /* used to be 'usr.keys'                    */
#define BITS2_BITB       0x0800 /* used to be 'usr.keys'                    */
#define BITS2_BITC       0x1000 /* used to be 'usr.keys'                    */
#define BITS2_BITD       0x2000 /* used to be 'usr.keys'                    */
#define BITS2_BITE       0x4000 /* used to be 'usr.keys'                    */
#define BITS2_BITF       0x8000 /* used to be 'usr.keys'                    */

#define SEX_UNKNOWN       0x0000
#define SEX_MALE          0x0001
#define SEX_FEMALE        0x0002

/* Masks for usr.delflag, below.  WARNING!  Only the first eight bits       *
 * of this flag should be used for compatibility with df_save!              */

#define UFLAG_DEL   0x01
#define UFLAG_PERM  0x02

/* Masks for usr.xp_flag, below */

#define XFLAG_EXPDATE    0x0001 /* Use the xp_date to control access        */
#define XFLAG_EXPMINS    0x0002 /* Use the xp_mins number to control access */
#define XFLAG_DEMOTE     0x0004 /* Demote user to priv level in usr.xp_priv */
#define XFLAG_AXE        0x0008 /* Just hang up on user                     */

/* Constants for usr.video, below */

#define GRAPH_TTY         0x00 /* The current user's graphics setting...    */
#define GRAPH_ANSI        0x01 
#define GRAPH_AVATAR      0x02
#define GRAPH_RIP         0x03

typedef struct _usrndx
{
  dword hash_name;
  dword hash_alias;
} USRNDX;

struct   _usr
   {
      byte name[36];        /* Caller's name                               0*/
      byte city[36];        /* Caller's location                          36*/

      byte alias[21];       /* MAX: user's alias (handle)                 72*/
      byte phone[15];       /* MAX: user's phone number                   93*/

      word lastread_ptr;    /* MAX: a num which points to offset in      108*/
                            /* file -- Offset of lastread pointer will be   */
                            /* lastread_ptr*sizeof(int).                    */

      word timeremaining;   /* MAX: time left for current call (xtern pro110*/

      byte pwd[16];         /* Password                                  112*/
      word times;           /* Number of previous calls to this system   128*/
      byte help;            /* Help level                                130*/
      word group;           /* Group number (not implemented)            131*/
      byte video;           /* user's video mode (see GRAPH_XXXX)        133*/
      byte nulls;           /* Number of Nulls (delays) after <cr>       134*/

      byte bits;            /* Bit flags for user (number 1)             135*/

      word dob_year;        /* Date of birth: year (1900-)               136*/

      word bits2;           /* Bit flags for user (number 2)             138*/

      word max2priv;        /* Max 2.x priv level (not USED)             140*/
      char dataphone[19];   /* Data/business phone number                142*/
      byte struct_len;      /* len of struct, divided by 20. SEE ABOVE!  161*/
      word time;            /* Time on-line so far today                 162*/

      word delflag;         /* Used to hold baud rate for O)utside comman164*/
                            /* In USER.BBS, usr.flag uses the constants     */
                            /* UFLAG_xxx, defined earlier in this file.     */
      
      dword msgs_posted;    /* Total number of messages posted           166*/
      dword msgs_read;      /* Total number of messages read             170*/

      byte width;           /* Width of the caller's screen              174*/
      byte len;             /* Height of the caller's screen             175*/
      word credit;          /* Matrix credit, in cents                   176*/
      word debit;           /* Current matrix debit, in cents            178*/

      word xp_priv;         /* Priv to demote to, when time or minutes ru180*/
                            /* out.                                         */

      union stamp_combo xp_date;  /* Bit-mapped date of when user expires182*/
                                  /* If zero, then no expiry date.          */
 
      dword xp_mins;        /* How many minutes the user has left before 186*
                             * expiring.                                    */

      byte  xp_flag;        /* Flags for expiry.  See above XFLAG_XXX def190*/
      byte  sex;            /* Sex: SEX_MALE or SEX_FEMALE)              191*/

      union stamp_combo ludate;   /* Bit-mapped date of user's last call 192*/

      dword xkeys;          /* User's keys (all 32 of 'em)               196*/
      byte  lang;           /* The user's current language #             200*/
      sbyte def_proto;      /* Default file-transfer protocol            201*/

      dword up;             /* K-bytes uploaded, all calls               202*/
      dword down;           /* K-bytes downloaded, all calls             206*/
      sdword downtoday;     /* K-bytes downloaded, today                 210*/

      byte rsvd45[18];      /* Reserved by Maximus for future use        214*/

      word call;            /* Number of previous calls today            232*/

      byte compress;        /* Default compression program to use        234*/

      byte df_save;         /* Used for storing real usr.delflag in      235*
                             * LASTUSxx.BBS while in a door.                */

      dword extra;                                                     /*236*/
      SCOMBO date_1stcall;  /* Date of first call to system              240*/
      SCOMBO date_pwd_chg;  /* Date of last password change              244*/

      dword nup;            /* Number of files uploaded                  248*/
      dword ndown;          /* Number of files downloaded                252*/
      sdword ndowntoday;    /* Number of files downloaded today          256*/

      word time_added;      /* Time credited to the user for today       260*/
      byte msg[MAX_ALEN];   /* Current message area                      262*/
      byte files[MAX_ALEN]; /* Current file area                         326*/

      byte dob_day;         /* Date of birth: day (1-31)                 390*/
      byte dob_month;       /* Date of birth: month (1-12)               391*/
      dword point_credit;   /* Total points allocated                    392*/
      dword point_debit;    /* Total points used                         396*/
      SCOMBO date_newfile;  /* Date of last new-files check              400*/
      word priv;            /* Privilege level                           404*/
      byte rsvd6[54];       /* Reserved for future use                   406*/
                                                                       /*460*/
   };

#endif /* __MAX_U_H_DEFINED */

/*# name=Menu server enumerations and structures
*/

/* Enumeration `option' -- All possible values for menu.option[x].type */

typedef enum
{
  nothing,

  MISC_BLOCK=100, display_menu, display_file, message, file, other,
                  o_press_enter, key_poke, clear_stacked, o_if,
                  o_menupath, o_cls, mex, link_menu, o_return,


  XTERN_BLOCK=200, xtern_erlvl, xtern_dos, xtern_run, xtern_chain,
                   xtern_concur,

  MAIN_BLOCK=300, goodbye, statistics, o_yell, userlist, o_version,
                  user_editor, leave_comment, climax,

  MSG_BLOCK=400, same_direction, read_next, read_previous,
                 enter_message, msg_reply, read_nonstop,
                 read_original, read_reply, msg_list, msg_scan,
                 msg_inquir, msg_kill, msg_hurl, forward, msg_upload,
                 xport, read_individual, msg_checkmail, msg_change,
                 msg_tag, msg_browse, msg_current, msg_edit_user,
                 msg_upload_qwk, msg_toggle_kludges, msg_unreceive,
                 msg_restrict, msg_area, msg_track, msg_dload_attach,
                 msg_reply_area,

  FILE_BLOCK=500, locate, file_titles, file_type, upload, download, raw,
                  file_kill, contents, file_hurl, override_path,
                  newfiles, file_tag, file_area,

  /* Options generally found on the Change Setup menu */

  CHANGE_BLOCK=600, chg_city, chg_password, chg_help, chg_nulls,
                    chg_width, chg_length, chg_tabs, chg_more,
                    chg_video, chg_editor, chg_clear, chg_ibm,
                    chg_phone, chg_realname, chg_hotkeys,
                    chg_language, chg_userlist, chg_protocol,
                    chg_fsr, chg_archiver, chg_rip,

  EDIT_BLOCK=700, edit_save, edit_abort, edit_list, edit_edit,
                  edit_insert, edit_delete, edit_continue, edit_to,
                  edit_from, edit_subj, edit_handling, read_diskfile,
                  edit_quote,

  /* Stuff that was hacked on after the original implementation */

  CHAT_BLOCK=800, who_is_on, o_page, o_chat_cb, chat_toggle, o_chat_pvt,
    
  END_BLOCK,


  /* Everything below here is RESERVED by Maximus for future uses!         *
   * Also, everything ABOVE is fairly stable.  If changes have to be made, *
   * the old options above will not be re-used.  For example, if the       *
   * `edit_insert' command should become obsoleted for some reason, that   *
   * slot would either get retired and do nothing, or perform the NEW      *
   * edit_insert function.                                                 */

  rsvd=32766  /* This was stuck in to make sure that the `option'          *
               * enumeration uses a word, instead of a byte, in case we    *
               * really expand this structure sometime soon.               */

} option;

/*
 * Structure of Callers.Bbs
 * Maximus (optional) caller information & activity log
 */

#ifndef CALLINFO_H_DEFINED
#define CALLINFO_H_DEFINED

#define CALL_LOGON      0x8000                  /* Caller was logged on! */
#define CALL_CARRIER    0x0001                    /* Caller lost carrier */
#define CALL_EJECTED    0x0002    /* Caller was ejected by sysop or priv */
#define CALL_PAGED_AH   0x0004               /* Caller paged after hours */
#define CALL_DLEXCEED   0x0008         /* Caller attempted to exceed d/l */
#define CALL_EXPIRED    0x0010          /* Caller's subscription expired */
#define CALL_TIMELIMIT  0x0020             /* Caller exceeded time limit */
#define CALL_NERD       0x0040                     /* Caller was nerd'ed */
#define CALL_BARRPWD    0x0080             /* Barricade password failure */

struct callinfo
{
  byte              name[36];     /* User's name/alias                 0*/
  byte              city[36];     /* User's city                      36*/
  union stamp_combo login;        /* Time logged on                   72*/
  union stamp_combo logoff;       /* Time logged off                  76*/
  word              task;         /* Which node                       80*/
  word              flags;        /* Call flags                       82*/
  word              logon_priv;   /* Priv level on login              84*/
  word              logoff_priv;  /* Priv level on logoff             86*/
  dword             logon_xkeys;  /* Keys on login                    88*/
  dword             logoff_xkeys; /* Keys on logoff                   92*/
  word              filesup;      /* Number of files uploaded         96*/
  word              filesdn;      /* Number of files dnloaded         98*/
  word              kbup;         /* kb uploaded                     100*/
  word              kbdn;         /* kb dnloaded                     102*/
  word              calls;        /* Number of previous calls + 1    104*/
  word              read;         /* Number of messages read         106*/
  word              posted;       /* Number of messages posted       108*/
  word              paged;        /* Number of times user paged      110*/
  sword             added;        /* Time added during call          112*/
  byte              reserved[14];                                 /* 114*/
};                                                                /* 128*/

#endif


/* An individual menu option.  There are many of these contained in one    *
 * _menu file, following the _menu data header, optionally with some       *
 * NULL-terminated strings between each _opt structure, for the argument.  */

struct _opt
{
#ifdef __FLAT__
  /* force enum to be 16 bits */
  word type;
#else
  option type;  /* What this menu option does                              */
#endif

  zstr priv;    /* Priv level required to execute this command             */
  dword rsvd;   /* Bit-field locks for this particular menu option         */
  word flag;    /* See the OFLAG_xxx contants for more info.               */
  zstr name;    /* The menu option, as it appears to user                  */
  zstr keypoke; /* Auto-keypoke string                                     */
  zstr arg;     /* The argument for this menu option                       */
  byte areatype;/* If this particular option can only be used if the user  *
                 * is in a certain message-area type.                      */
  byte fill1;   /* Reserved by Maximus for future use                      */

  byte rsvd2[8]; /* Reserved for future uses */
};

#define DEFAULT_OPT_WIDTH 20

struct _menu
{
  word header,      /* What to display when the user enters menu, such as  *
                     * "The MESSAGE Section", "The CHG SETUP Section", etc */
       num_options, /* Total number of options (struct _opt's) in menu     */
       menu_length, /* Number of lines long the .?BS menu file is!         */
       opt_width;   /* Option width override                               */

  sword hot_colour; /* What colour to display if a user uses hotkeys to    *
                     * bypass a .?BS menu display, before displaying the   *
                     * key.  -1 == display nothing.                        */

  word title;       /* Length of the title string, not counting \0.        */
  word headfile;    /* Length of the header filename, not counting \0      */
  word dspfile;     /* Name of file to display for menu, instead of        *
                     * generating menu from .Mnu file.                     */
  word flag;        /* See MFLAG_XXX in MAX.H.                             */
};



/* Menu structure used INTERNALLY within Max itself */

typedef struct _amenu
{
  struct _menu m;
  struct _opt *opt;
  char *menuheap;
} AMENU, *PAMENU;


  #define MFLAG_MF_NOVICE   0x0001u /* MenuFile for these levels only */
  #define MFLAG_MF_REGULAR  0x0002u
  #define MFLAG_MF_EXPERT   0x0004u
  #define MFLAG_MF_RIP      0x0400u
  #define MFLAG_MF_ALL      (MFLAG_MF_NOVICE | MFLAG_MF_REGULAR | MFLAG_MF_EXPERT /*| MFLAG_MF_HOTFLASH*/)

  #define MFLAG_HF_NOVICE   0x0010u /* HeaderFile for these levels only */
  #define MFLAG_HF_REGULAR  0x0020u
  #define MFLAG_HF_EXPERT   0x0040u
  #define MFLAG_HF_RIP      0x0800u

  #define MFLAG_HF_ALL      (MFLAG_HF_NOVICE | MFLAG_HF_REGULAR | MFLAG_HF_EXPERT /*| MFLAG_HF_HOTFLASH*/)

  #define MFLAG_SILENT      0x0100u /* Silent menuheader option */
  #define MFLAG_RESET       0x0200u /* Reset term size on display */




#define STATS_VER           1   /* Version number of the BBSTATxx.BBS file */

struct _bbs_stats
{
  byte    version;      /* Version number of BBSTATxx.BBS file */
  dword   num_callers;
  dword   quote_pos;
  dword   msgs_written;
  time_t  online_date;
  dword   total_dl;
  dword   total_ul;
  sword   today_callers;
  union stamp_combo date;
  byte    lastuser[36];
};



/* Structure for entries in PROTOCOL.MAX */

struct _proto
{
  #define P_ISPROTO 0x01  /* This bit always set                            */
  #define P_BATCH   0x02  /* Can handle batch transfers                     */
  #define P_OPUS    0x04  /* Write an Opus-style .CTL file                  */
  #define P_ERL     0x08  /* Exit with xtern_erlvl                          */
  #define P_BI      0x10  /* Bidirectional transfer                         */

  word flag;

  char desc[40];
  char log[PATHLEN];
  char ctl[PATHLEN];
  char dlcmd[PATHLEN];
  char ulcmd[PATHLEN];
  char dlstr[40];
  char ulstr[40];
  char dlkey[40];
  char ulkey[40];
    
  word fnamword;
  word descword;
};



/*# name=.PRM file structure and definitions
*/

#if !defined(__PRM_H_DEFINED) || defined(FORCE)

#if defined(FORCE)
    #undef OFS
    typedef char OFS[PATHLEN];
#else
    #define OFS word
#endif


#ifndef __PRM_H_DEFINED
#ifndef MAX_DRIVES
  #define MAX_DRIVES         26   /* Maximum number of drives on system      */
#endif

#ifndef CHAR_BITS
  #define CHAR_BITS           8   /* Number of bits in a 'char'              */
#endif

  #define CTL_VER             9   /* Version number of BBS.PRM               */

  /* This macro is ONLY used for accessing *pointers* in the `prm' structure.
     This is required, due to the way Wynn has made OPUS_CTL write the strings
     out (which uses a lot less memory than some other ways).  If you want
     to access an INT, or a non-pointer in the structure, then you can use
     a `prm.var_name'-style reference.                                       */

  #define PRM(s) (offsets+(prm.s))

  #define MAX_LANG           8       /* Max. number of possible languages    */
  #define MAX_YELL          10       /* Max number of yell slots             */
  #define MAX_EXTERNP       16       /* max. number of external programs     */
  #define ALIAS_CNT         15       /* number of matrix addresses           */
  #define MAXCLASS          12       /* OBSOLETE!  Only used for             *
                                      * compatibility with Max 2.x.          */
            /** Definitions for the `prm.flags' variable **/

  #define FLAG_keyboard    0x0001 /* If local mode is on by default         1*/
  #define FLAG_watchdog    0x0002 /* Use watchdog for outside commands      2*/
  #define FLAG_snoop       0x0004 /* If snoop is on by default              3*/
  #define FLAG_norname     0x0008 /* If we should disable ^aREALNAME kludge 4*/
  #define FLAG_close_sf    0x0010 /* Close all standard files for O)utside  5*/
  #define FLAG_break_clr   0x0020 /* Send a break signal to dump modem's    6*
                                   * internal buffer                         */
  #define FLAG_log_echo    0x0040 /* Log user-written echomail              7*/
  #define FLAG_no_ulist    0x0080 /* User can't press '?' to list users in  8*
                                   * msg.                                    */
  #define FLAG_no_magnet   0x0100 /* Disable the MagnEt editor              9*/
  #define FLAG_autodate    0x0200 /* Automatically search directory for     0*/
                                  /* file size & date.                       */
  #define FLAG_statusline  0x0400 /* If SysOp wants a status line on screen 1*/
  #define FLAG_ask_phone   0x0800 /* If we should ask user for phone number 2*/
  #define FLAG_noyell      0x1000 /* If yell is toggled on or off by Sysop  3*/
  #define FLAG_lbaud96     0x2000 /* If we should use 9600 baud for local   4*
                                   * callers... (For Opus compatibility!)    */
  #define FLAG_alias       0x4000 /* If we're running a system which allows 5*
                                   * aliases or handles                      */
  #define FLAG_ask_name    0x8000 /* If we should ask user for their alias  6*
                                   * name too -- Only needed if using        *
                                   * FLAG_alias.                             */

  #define FLAG2_gate       0x0001 /* Gate netmail messages, use zonegate!   1*/
  #define FLAG2_has_snow   0x0002 /* Video adapter is slow CGA w/snow       2*/
  #define FLAG2_CHKRIP     0x0004 /* Check for RIP setting on login         3*/
  #define FLAG2_ltimeout   0x0008 /* Local keyboard timeout                 4*/
  #define FLAG2_noshare    0x0010 /* SHARE not used -- don't lock files!    5*/
  #define FLAG2_CAPTURE    0x0020 /* Sysop chat capture automatically on    6*/
  #define FLAG2_NOCRIT     0x0040 /* Don't use internal crit.err handler    7*/
  #define FLAG2_CHECKDUPE  0x0080 /* Check for duplicate uploads            8*/
  #define FLAG2_CHECKEXT   0x0100 /* Compare extension for duplicate uploads9*/
  #define FLAG2_GLOBALHB   0x0200 /* Global high bit allowed               10*/
  #define FLAG2_1NAME      0x0400 /* Allow one-word names                  11*/
  #define FLAG2_UMSGID     0x0800 /* Display UMSGIDs to user instead of    12*/
                                  /* virtual message numbers.                */
  #define FLAG2_SWAPOUT    0x1000 /* Swap to disk when shelling            13*/
  #define FLAG2_NOENCRYPT  0x2000 /* Disable password encryption           14*/
  #define FLAG2_STRICTXFER 0x4000 /* Kick users off in file transfers if   15*/
                                  /* time limit exceeded.                    */
  #define FLAG2_CHKANSI    0x8000 /* Check for ANSI setting on login       16*/

  #define LOG_TERSE       0x02
  #define LOG_VERBOSE     0x04
  #define LOG_TRACE       0x06

  #define LOG_terse       LOG_TERSE
  #define LOG_verbose     LOG_VERBOSE
  #define LOG_trace       LOG_TRACE

  #define MULTITASKER_AUTO        -1
  #define MULTITASKER_NONE        0
  #define MULTITASKER_DOUBLEDOS   1
  #define MULTITASKER_DESQVIEW    2
  #define MULTITASKER_TOPVIEW     3
  #define MULTITASKER_MLINK       4
  #define MULTITASKER_MSWINDOWS   5
  #define MULTITASKER_OS2         6
  #define MULTITASKER_PCMOS       7
  #define MULTITASKER_NT          8

  #define MULTITASKER_auto        MULTITASKER_AUTO
  #define MULTITASKER_none        MULTITASKER_NONE
  #define MULTITASKER_doubledos   MULTITASKER_DOUBLEDOS
  #define MULTITASKER_desqview    MULTITASKER_DESQVIEW
  #define MULTITASKER_topview     MULTITASKER_TOPVIEW
  #define MULTITASKER_mlink       MULTITASKER_MLINK
  #define MULTITASKER_mswindows   MULTITASKER_MSWINDOWS
  #define MULTITASKER_os2         MULTITASKER_OS2
  #define MULTITASKER_pcmos       MULTITASKER_PCMOS
  #define MULTITASKER_nt          MULTITASKER_NT




  /* Special values for the character set byte */

  #define CHARSET_SWEDISH   0x01
  #define CHARSET_CHINESE   0x02

  #define XTERNEXIT       0x40      /* If external protocl has erlvl exit */
  #define XTERNBATCH      0x80      /* If protocol can do batch transfers */

  #define NLVER_5         5
  #define NLVER_6         6
  #define NLVER_7         7
  #define NLVER_FD       32

  /* OBSOLETE!  Only used for compatibility purposes */

  struct   cl_rec
  {
    sword    priv;
    word     max_time;      /* max cume time per day         */
    word     max_call;      /* max time for one call         */
    word     max_dl;        /* max dl kbytes per day         */
    word     ratio;         /* ul:dl ratio                   */
    word     min_baud;      /* speed needed for logon        */
    word     min_file_baud; /* speed needed for file xfer    */
  };

#endif /* !__PRM_H_DEFINED */

/* Note: To read in the *.PRM structure, first read in the m_pointers       *
 * structure, which is always contained at the beginning of the file.       *
 * Then, seek to the offset prm.heap_offset, and read in everything         *
 * from there to EOF into heap[].  All of the 'OFS' type variables          *
 * are simply offsets into the variable-length heap which started at        *
 * heap_offset. To obtain a string from the .PRM heap, simply               *
 * add the offset in the m_pointers structure to the address of the         *
 * heap[] variable that the heap was read into.  For example, to access     *
 * the string for 'system_name', you'd use '(heap+prm.system_name)'.        *
 * Alternatively, you can declare a macro to do this, such as the           *
 * PRM() macro shown above.  (Maximus itself uses the variable              *
 * 'strings' instead of 'heap' to hold the varible-length strings,          *
 * but the concept is the same.)  When using the PRM() macro to             *
 * access the string for 'system_name', you'd simply write:                 *
 * 'PRM(system_name)', which is a lot clearer.  Also, please note that      *
 * NON-OFS variables should be accessed normally!  That means that          *
 * 'task_num', 'auto_kill', can be access with 'prm.task_num',              *
 * 'prm.auto_kill', etc.  The special heap manipulation is only needed      *
 * for strings.                                                             */

#ifdef FORCE
struct mfpointers
#else
struct m_pointers
#endif
{

        /*-----------------------------------------------------------*/
        /* DATA                                                      */
        /*-----------------------------------------------------------*/

  byte  id;             /* Always equal to 'M'               STABLE  */
  byte  version;        /* for safety                        STABLE  */
  word  heap_offset;    /* OFFSET OF BEGINNING OF HEAP!      STABLE  */
  byte  task_num;       /* for multi-tasking systems         STABLE  */
  sword com_port;       /* Com1=0, Com2=1, etc               STABLE  */
  byte  noise_ok;       /* If yell noise is currently on     STABLE  */

  /* Miscellanious system information */

  byte  video;          /* Mode for local video display              */
  byte  log_mode;       /* What style of logging to use              */
  word  max_baud;    /* fastest speed we can use                  */
  sbyte multitasker;    /* flag for DoubleDos (see below)            */
  byte  nlver;          /* Which nodelist version we use (NLVER_XXX) */

  sword min_ulist;      /* OBSOLETE!  Only used for compatibility    */
  sword max_ulist;      /* with Maximus 2.x!                         */

  /* Information about errorlevels */

  byte  exit_val;       /* Erl to use after caller if none of below  */
  byte  edit_exit;      /* erl to use after matrix mail written      */
  byte  echo_exit;      /* ERRORLEVEL for after inbound echomail     */
  byte  local_exit;     /* Errorlevel after entering local msgs      */

  /* Modem information */

  sword carrier_mask;
  sword handshake_mask;

  /* Log-on information */

  word logon_priv;      /* Access level for new users                */
  word  logon_time;     /* time to give for logons                   */
  word  min_baud;    /* minimum baud to get on-line               */
  word  speed_graphics; /* min baud for graphics                  */

  /* Information about message areas */

  byte  auto_kill;      /* RECD PVT msgs. 0=no 1=ask 2=yes            */

  word ctla_priv;       /* Priv to see CONTROL-A lines in messages    */
  word seenby_priv;     /* Min priv to see SEEN-BY line               */
  word pvt_priv;        /* Min priv to read pvt msgs                  */

  word msg_ask[16];     /* Array of privs. for message attr ask's     */
  word msg_assume[16];  /* Array of privs. for message attr assume's  */
  word  msg_fromfile;   /* Priv. for doing message from file          */
  word  speed_rip;      /* min baud for rip graphics                  */
  byte  rsvd1[2];       /* used to be high_msgarea, begin_msgarea     */
  word unlisted_priv;   /* Priv needed to send to unlisted node       */
  sword unlisted_cost;  /* Charge to send to unlisted node            */

  word mc_reply_priv;   /* Priv to reply to msg with mailchecker     */
  word mc_kill_priv;    /* Priv to kill msg with mailchecker         */


  /* Information about file areas */

  sword date_style;     /* Used for FILES.BBS display                */
  word rsvd20;          /* Reserved (used to be dlall_priv)          */
  word rsvd21;          /* Reserved (used to be ulbbs_priv)          */
  dword k_free;         /* The number of disk space (in K) which     *
                         * must be available before we let a user    *
                         * upload.                                   */
  word  rsvd7;          /* reserved - used to be upload reward       */
  word  ratio_threshold;/* OBSOLETE!  Only used for Max 2.x compat.  */
  byte  rsvd2[4];       /* used to be high_filearea, begin_filearea  */

  /* Our matrix address(es) */

  NETADDR address[ALIAS_CNT];


  /*  struct _yell yell[MAX_YELL]; */  /* Yell info moved to event file */
  byte rsvd3[60]; /* Reserved by Maximus for future use */


  /* About the users */
  struct cl_rec cls[MAXCLASS];  /* OBSOLETE!  Only used for compatibility */
                                /* with Maximus 2.x.                      */

  /* Flags for external protocols */

  sword protoexit;              /* Errorlevel for protocol exit      */
  char  protoflag[MAX_EXTERNP]; 

  /* General-purpose bit-flags  (See FLAGx_xxx definitions above.) */

  word  flags;
  word  flags2;
  word  flags3;
  word  flags4;

  /* Bit field containing drive letters to save when going outside */
  char  drives_to_save[(MAX_DRIVES/CHAR_BITS)+1];

  byte  fbbs_margin;      /* Margin to use for wrapping FILES.BBS comments */
  byte  kill_attach;      /* Kill file attaches 0=no 1=ask 2=yes           */

  word  max_ptrs;         /* Maximum size of pointers of ALL *.LTFs */
  word  max_heap;         /* Maximus heap size of all *.LTFs */
  byte  max_lang;         /* Current number of languages */
  byte  rsvd_lang;

  word  max_glh_ptrs;
  word  max_glh_len;

  word  max_syh_ptrs;
  word  max_syh_len;

  byte  input_timeout;   /* # of mins until Max hangs up due to no input    */

  byte  charset;         /* Character set support - see CHARSET_XXXX, above */
  word  max_pack;        /* Maximum # of msgs to pack into a .QWK packet    */
  word  msg_localattach; /* Priv. for doing local file attaches             */
  word  kill_attach_priv;/* Priv. for killing local file attaches           */
  word  mcp_sessions;    /* Max number of MCP sessions                      */
  dword max_msgsize;     /* Truncate uploaded messages to this size         */
  
  byte  rsvd65[2];       /* Reserved by Maximus for future use              */



  /* --------------------------------------------------------------- */
  /* -------------------------- OFFSETS ---------------------------- */
  /* --------------------------------------------------------------- */

  /* About your system */

#define PRM_HEAP_START sysop

  OFS   sysop;          /* sysop's name. MUST be first offset in prm file */
  OFS   system_name;    /* board's name                              */

  /* Modem commands */

  OFS   m_busy;         /* mdm cmd to take modem off hook            */

  /* Paths to various places */

  OFS   sys_path;       /* path to SYSTEM?.BBS files                 */
  OFS   misc_path;      /* path to `F-key files'                     */
  OFS   net_info;       /* path to NODELIST files                    */
  OFS   temppath;       /* place to put temporary files              */
  OFS   ipc_path;       /* path for inter-process communications     */

  /* General files needed by the system */

  OFS   user_file;      /* path/filename of User.Bbs                 */
  OFS   log_name;       /* name of the log file                      */
  OFS   chat_prog;      /* External chat program, if any             */
  OFS   chat_fbegin;    /* File to display instead of "CHAT: begin"  */
  OFS   chat_fend;      /* File to display instead of "END CHAT"     */
  OFS   local_editor;   /* Command for local editor, if any          */
  OFS   notfound;       /* User name not found in user file          */
  OFS   junk;           /* Don't use this for anything!              */

  /* General *.?BS files needed everywhere */

  OFS   logo;           /* first file shown to a caller              */
  OFS   bad_logon;      /* if user's last logon attempt was bad      */
  OFS   welcome;        /* shown after logon                         */
  OFS   quote;          /* For displaying "random" quotes from       */
  OFS   newuser1;       /* Asks user to type in password             */
  OFS   newuser2;       /* Replaces `welcome' for a new user         */
  OFS   rookie;         /* Replaces `welcome' for rookies            */
  OFS   application;    /* new user questionnaire                    */
  OFS   byebye;         /* file displayed at logoff                  */
  OFS   out_leaving;    /* Bon Voyage                                */
  OFS   out_return;     /* Welcome back from O)utside                */
  OFS   daylimit;       /* Sorry, you've been on too long...         */
  OFS   timewarn;       /* warning about forced hangup               */
  OFS   tooslow;        /* explains minimum logon baud rate          */
  OFS   barricade;      /* Displayed before prompt for access code   */
  OFS   shelltodos;     /* Displayed when Sysop hits Alt-J           */
  OFS   backfromdos;    /* Displayed when Sysop returns from Alt-J   */
  OFS   areanotexist;   /* File to display instead of "That area     *
                         * doesn't exist!"                           */

  /* User priv levels database */

  OFS   access;         /* Database of user privilege levels         */

  /* File-area items */

  OFS   xferbaud;       /* explains minimum file transfer baud rate  */
  OFS   file_area_list; /* dump file... used instead of Dir.Bbs      */
  OFS   no_space;       /* File to display if trying to UL with      *
                         * less than k_free space left on drive.     */
  OFS   fname_format;   /* Essay on MS-DOS filenames for U)ploads    */
  OFS   ul_log;         /* Log file for uploads                      */

  OFS   file_header;    /* Format for file area's A)rea command      */
  OFS   file_format;    /* Format for A)rea command entries          */
  OFS   file_footer;    /* Format for footer for file.area menu      */

  OFS   proto_dump;      /* Dump file for protocol screen            */

  /* Message-area items */

  OFS   msgarea_list;   /* dump file... used instead of Dir.Bbs      */
  OFS   echotoss_name;  /* Name of your echomail tosslog             */
  OFS   nomail;         /* Display by mailchecker if no mail wtng.   */

  OFS   msg_header;     /* Format for msg.area's A)rea command       */
  OFS   msg_format;     /* Format for A)reas command entries         */
  OFS   msg_footer;     /* Format for footer for msg.area menu       */

  /* Help files:  Used to explain various things */

  OFS   hlp_editor;     /* intro to msg editor for novices.          */
  OFS   hlp_replace;    /* Explain the Msg.Editor E)dit command      */
  OFS   msg_inquire;    /* Explain the Msg. I)nquire command         */
  OFS   hlp_locate;     /* Explain the Files L)ocate command         */
  OFS   hlp_contents;   /* Explain the Files C)ontents command       */
  OFS   oped_help;      /* help file for the full-screen editor      */
  OFS   hlp_scan;       /* help file for S)can                       */
  OFS   hlp_list;       /* help file for L)ist                       */

  /* External protocols */

  OFS   protocols[MAX_EXTERNP]; /* external file protocol programs   */
  OFS   protoname[MAX_EXTERNP]; /* name of protocol, on menu         */

  /* Date/Time format strings */

  OFS   timeformat;
  OFS   dateformat;

  /* **OBSOLETE** names of the old Max 2.x area.dat/idx files */

  OFS   adat_name;
  OFS   aidx_name;

  /* Menu paths/names */

  OFS   menupath;        /* The default place to look for the menus */
  OFS   first_menu;      /* The name of the first menu to display */
  OFS   edit_menu;       /* Name of the EDIT menu */
  
  /* Miscellaneous */
  
  OFS   achg_keys;       /* Characters used to change area -/+ */
  OFS   tune_file;       /* Path to TUNES.MAX */
  OFS   lang_path;       /* Path to *.LTF files */
  
  OFS   lang_file[MAX_LANG]; /* Array of all *.LTF names */
  
  OFS   m_init;          /* Modem initialization string */
  OFS   m_ring;          /* Command modem sends when phone ringing */
  OFS   m_answer;        /* Cmd to send to modem when ring detect */
  OFS   m_connect;       /* Connect string, as returned by modem */

  OFS   high_msgarea;
  OFS   begin_msgarea;  /* Msg area to put new users in              */
  
  OFS   high_filearea;
  OFS   begin_filearea; /* File area to put new users in             */
  
  OFS   fidouser;       /* Name of FIDOUSER.LST file to use          */
  OFS   cmtarea;        /* Message area to put comments in           */

  OFS   arc_ctl;        /* Control file for archiving programs       */
  OFS   olr_name;       /* OLR: Filename to use for DL packets       */
  OFS   olr_dir;        /* OLR: Directory for off-line stuff         */
  OFS   phone_num;
  OFS   viruschk;       /* Name of batch file to call for virus check*/
  OFS   protocol_max;   /* Name of compiled protocol data file       */
  OFS   track_privview; /* Priv req'd to see tracking info owned by others */
  OFS   track_privmod;  /* Priv req'd to modify track info owned by others */
  OFS   track_base;     /* Base name of the tracking database files  */
  OFS   track_exclude;  /* File containing list of names to exclude  */
  OFS   stagepath;      /* Path for staged CD-ROM transfers          */
  OFS   attach_base;    /* Base name of the local attach database    */
  OFS   attach_path;    /* Default path for local file attaches      */
  OFS   attach_archiver;/* File attach archiver                      */
  OFS   inbound_files;  /* Inbound FTS-1 attaches for users          */
  OFS   rippath;        /* Default icon & RIP screens path           */

  /* More help files */

  OFS   hlp_hdrentry;   /* Help screen for message header entry      */
  OFS   hlp_msgentry;   /* Help screen for start of message entry    */
  OFS   not_configured; /* Displayed if user is not configured       */

  /* MCP stuff */

  OFS   mcp_pipe;       /* Default MCP pipe                          */

  /* Paths to the new marea/farea message/file data files */

  OFS   marea_name;     /* Name of message area data file            */
  OFS   farea_name;     /* Name of file area data file               */

  /* Caller information log */

  OFS   caller_log;     /* Caller information log                    */

#define PRM_HEAP_END caller_log
};

#define __PRM_H_DEFINED
#endif

#ifndef __NEWAREA_H_DEFINED
#define __NEWAREA_H_DEFINED

/* General structure of MAREA.DAT and FAREA.DAT:

   MAREA_ID or FAREA_ID
   _msgarea
       _ovride ...
       zstr heap
   _msgarea
       _ovride ...
       zstr heap
   eof
*/


/* This key is present at the beginning of an area file.  MAREA_ID is
 * used for the message data file and FAREA_ID is used for the
 * file data file.
 */

#define MAREA_ID      0x1a49023fL
#define FAREA_ID      0x1a01953aL

#define ADATA_START   4L          /* The area data info starts at offset 4 */

typedef struct _ovride
{
  /* Only one of 'opt' or 'name' should be used.  If opt==0, use name.  If  *
   * name==0, use opt.                                                      */

  option opt;           /* Type of menu option to override     ...OR...     */
  byte   name;          /* First letter of command to override              */
  byte   rsvd1;         /* Reserved for future use                          */
  zstr   acs;           /* New ACS required to access option                */
  zstr   menuname;      /* Use this access level on the given menu only     */
} OVERRIDE;


/* Bit masks for the ma.attribs field */

#define MA_PVT      0x0001  /* Private msgs allowed */
#define MA_PUB      0x0002  /* Public msgs allowed */
#define MA_HIBIT    0x0004  /* High bit msgs allowed */

#define MA_NET      0x0008  /* Netmail area */
#define MA_ECHO     0x0010  /* Echomail area */
#define MA_CONF     0x0020  /* Conference area */

#define MA_ANON     0x0040  /* Anonymous messages are OK */
#define MA_NORNK    0x0080  /* Don't use the REALNAME kludge for this area */
#define MA_REAL     0x0100  /* Force  use of       real name for this area */
#define MA_ALIAS    0x0200  /* Force  use of alias      name for this area */
#define MA_AUDIT    0x0400  /* Use auditing (msg tracking) controls in area*/
#define MA_READONLY 0x0800  /* Area is read-only */
#define MA_HIDDN    0x1000  /* Area does not display on normal area list   */
#define MA_ATTACH   0x2000  /* Area allows local file attaches             */
#define MA_DIVBEGIN 0x4000  /* A message area division, not a real area    */
#define MA_DIVEND   0x8000  /* End of the message area division            */

#define MA2_NOMCHK  0x0001  /* Don't do personal mail check in this area   */

#define MA_SHARED   (MA_ECHO | MA_CONF)


/* Bit masks for fa.attribs */

#define FA_SLOW     0x0001  /* Slow-access medium: skip existence checks */
#define FA_STAGED   0x0002  /* Used staged transfer area for downloads */
#define FA_NONEW    0x0004  /* Permanent storage - skip for new file checks */
#define FA_HIDDN    0x0008  /* Area does not display on normal area list */
#define FA_DIVBEGIN 0x4000  /* A file area division, not a real area */
#define FA_DIVEND   0x8000  /* End of file area division */
#define FA_AUTODATE 0x0010  /* Auto-date override */
#define FA_MANDATE  0x0020  /* Manual date override */
#define FA_LISTDATE 0x0040  /* List-date override */
#define FA_FREETIME 0x0100  /* Free download time for all files */
#define FA_FREESIZE 0x0200  /* Free download bytes for all files */
#define FA_NOINDEX  0x0400  /* Don't add this area to maxfiles.idx */

#define FA_CDROM    (FA_SLOW | FA_STAGED | FA_NONEW)
#define FA_FREEALL  (FA_FREETIME | FA_FREESIZE)

typedef struct _msgarea
{
  word cbArea;          /* Length of THIS INDIVIDUAL RECORD                0*/
  word num_override;    /* Number of overrides following this record       2*/
  word cbHeap;          /* Length of the zstr heap following the overrides 4*/
  word division;        /* Reserved for future use                         6*/
  zstr name;            /* String format of area's name.                   8*/
  zstr acs;             /* Access control string for this area            10*/
  zstr path;            /* Path to messages (but for MA_DIVBEGIN only,    12*
                         * used instead as name of custom .bbs file).       */
  zstr echo_tag;        /* The 'tag' of the area, for use in ECHOTOSS.LOG 14*/
  zstr descript;        /* The DIR.BBS-like description for msg section   16*/
  zstr origin;          /* The ORIGIN line for this area                  18*/
  zstr menuname;        /* Custom menu name                               20*/
  zstr menureplace;     /* Replace this menu name with menuname from above22*/

  word attribs;         /* Attributes for this area                       24*/

  NETADDR primary;      /* Use as primary address for this area           26*/
  NETADDR seenby;       /* Use as address in seen-bys                     34*/
  word attribs_2;       /* More attributes                                42*/
  word type;            /* Message base type.  MSGTYPE_SDM = *.MSG.       44*
                         * MSGTYPE_SQUISH = SquishMail.  (Constants are     *
                         * in MSGAPI.H)                                     */
  word killbyage;       /* Make sure msgs are less than X days old        46*/
  word killbynum;       /* Make sure there are less than X msgs           48*/
  word killskip;        /* Exempt the first X msgs from this processing   50*/
  zstr barricade;       /* Barricade file                                 52*/
  zstr barricademenu;   /* Apply barricade priv while using this menu     54*/
  sdword cbPrior;       /* Seek offset from start of this area to get back56*
                         * to prior area.                                   */
  zstr attachpath;      /* Reserved for future use                        58*/
  dword rsvd4;                                                          /*60*/
} MAREA;                                                                /*64*/


#define MSGTYPE_SDM     0x01
#define MSGTYPE_SQUISH  0x02


typedef struct _filearea
{
  word cbArea;          /* Length of THIS INDIVIDUAL RECORD                0*/
  word num_override;    /* Number of overrides following this record       2*/
  word cbHeap;          /* Length of the zstr heap following the overrides 4*/
  word division;        /* Reserved for future use                         6*/

  zstr acs;             /* Access control string for this area             8*/
  zstr name;            /* String format of area's name.                  10*/
  zstr downpath;        /* Path for downloads.                            12*/
  zstr uppath;          /* Path for uploads                               14*/
  zstr filesbbs;        /* Path to FILES.BBS-like catalog for this area   16*
                         * (For FA_DIVBEGIN only, also used as name of      *
                         * custom .bbs display file.)                       */
  zstr descript;        /* The DIR.BBS-like description for file section  18*/
  zstr menuname;        /* Custom menu for this file area                 20*/
  zstr menureplace;     /* Replace this menu name with menuname from above22*/
  zstr barricade;       /* Barricade file                                 24*/
  zstr barricademenu;   /* Barricade file                                 26*/
  sdword cbPrior;       /* Offset to prior area                           28*/
  word attribs;         /* Attributes for this file area                  32*/
  sword date_style;     /* Date style override for this area              34*/
  byte rsvd1[28];       /* Reserved by Maximus for future use             36*/
} FAREA;                                                                /*64*/


typedef struct _barinfo
{
  int use_barpriv;            /* Use the privs in this structure? */
  word priv;                  /* New priv level to use while in this area */
  dword keys;                 /* New keys to use while in this area */
} BARINFO;

/* In-memory handles for accessing message and file areas */

typedef struct _mahandle
{
  OVERRIDE *pov;
  char *heap;
  MAREA ma;
  int heap_size;

  BARINFO bi;
} MAH, *PMAH;

typedef struct _fahandle
{
  OVERRIDE *pov;
  char *heap;
  FAREA fa;
  int heap_size;

  BARINFO bi;
} FAH, *PFAH;


/* Macros for accessing the zstr values of the MAH/FAH structures. */

#define MAS(ah, var) ((ah).heap + (ah).ma.var)
#define PMAS(ah, var) ((ah)->heap + (ah)->ma.var)

#define FAS(ah, var) ((ah).heap + (ah).fa.var)
#define PFAS(ah, var) ((ah)->heap + (ah)->fa.var)


/* Index structure for message/file areas */

typedef struct _mfidx
{
  char name[16];        /* First 15 chars of area name                      */
  dword name_hash;      /* SquishHash of full area name                     */
  dword ofs;            /* Offset within data file                          */
} MFIDX;

#endif /* __NEWAREA_H_DEFINED */




/* IPCxx.BBS header structure */

struct _cstat
{
  word avail;

  byte username[36];
  byte status[80];

#ifndef MCP
  word msgs_waiting;

  dword next_msgofs;
  dword new_msgofs;
#endif
};



/* Data element in IPCxx.BBS file (see MAX_CHAT.C) */

struct _cdat
{
  word tid;
  word type;
  word len;

#ifdef MCP
  word dest_tid;
  dword rsvd1;
#else
  dword rsvd1;
  word  rsvd2;
#endif
};

/* Handle for saving CHAT status.  Mainly used internally, but also        *
 * in RESTARxx.BBS.                                                        */

struct _css
{
  word avail;
  byte status[80];
};


/* NOTE: The following structure is not completely stable.  Unless         *
 * rst.rst_ver is equal to RST_VER, then the ONLY items you're guaranteed  *
 * to be able to read are those marked with "*STABLE*".  Those items       *
 * are guaranteed to be stored at those offsets for all future versions    *
 * of Maximus, regardless of the version number.  However, everything      *
 * else is likely to change at a moment's notice.                          */

struct _restart
{
  byte rst_ver; /* Version number of restart data                 *STABLE* */

  sdword timeon;  /* Date user got on system, seconds since 1970  *STABLE* */
  sdword timeoff; /* Date user must be OFF system, secs since '70 *STABLE* */
  sdword restart_offset; /* Offset in .BBS file to restart at     *STABLE* */

  dword baud;             /* User's baud rate                   *STABLE*   */
  dword max_time;         /* Max time, as given by '-t' param   *STABLE*   */

  sword port;             /* Current COM port, 0=COM1, 1=COM2,  *STABLE*   */

  char written_echomail;  /* 0=user HASN'T written echomail     *STABLE*   */
  char written_matrix;    /* 0=user HASN'T entered matrix msg   *STABLE*   */
  char local;             /* 0=NOT local                        *STABLE*   */

  struct _stamp laston;   /* Time the user was last on system   *STABLE*   */
  
  word steady_baud;       /* Locked baud rate of user           *STABLE*   */

  sdword starttime;       /* Start time, for external protocol             */
  sdword timestart;       /* Time when MAX.EXE was started                 */
  sdword ultoday;         /* KB's the user has uploaded today              */

  union stamp_combo next_ludate;
  
  byte restart_type;      /* 1 if started via .BBS file, 0 otherwise       */
  char restart_name[PATHLEN]; /* Name of .BBS file to restart in           */
  char menupath[PATHLEN]; /* The current menu path                         */
  char firstname[36];     /* The user's first name                         */
  char last_onexit[PATHLEN]; /* The 'onexit' filename for current .BBS file*/
  char parm[PATHLEN];     /* Parms for external program, if any            */
  char fix_menupath[PATHLEN]; /* Readjust menu name                        */

  char lastmenu;          /* Last ^oR menu choice                          */
  char snoop;             /* If snoop is currently on or off               */

  char locked;            /* If priv is locked via keyboard 'L' command    */

  char keyboard;          /* If the Sysop's keyboard is turned on          */
  char protocol_letter;   /* Letter representing current protocol choice   */

  char chatreq;           /* If user wanted to chat with SysOp             */
  char mn_dirty;          /* If menuname buf is dirty                      */

  char barricade_ok;      /* If current barricade area is OK               */
  char no_zmodem;         /* If zmodem not allowed                         */

  sword usr_time;         /* User's usr.time value                         */
  sword rsvdxx1;          /* reserved for future use                       */
  sword lockpriv;         /* If rst.locked (above), then this is real priv */
  sword ctltype;          /* Control-file type (for xternal protocol)      */

  word current_baud;      /* User's baud rate, as a mask for mdm_baud() */

  /* Bit flags for ECHOTOSS.LOG */
  char rsvd[(1296/CHAR_BITS)+1];
  char rsvd2[1120]; /* old area data structure */
  struct _css css;
  
  char log_name[80];

  struct _usr origusr;    /* User record as it was at log-on */

  char event_num;
  char rsvd3;
  
  sword last_protocol;
  long getoff;
  char returning[PATHLEN];
  long steady_baud_l;             /* Locked baud rate (as integer) */
  SCOMBO date_newfile;            /* User's last newfiles date */
};


/***************************************************************************
                      Global Variables and Constant Strings
 ***************************************************************************/

#define PROTOCOL_NONE        (sword)-1 /* Protocol to use for sending/receiving   */
#define PROTOCOL_XMODEM      (sword)-2 /* files.  If we're using an EXTERNAL      */
#define PROTOCOL_YMODEM      (sword)-3 /* protocol, `protocol' will have a value  */
#define PROTOCOL_XMODEM1K    (sword)-4 /* >= 0.                                   */
#define PROTOCOL_SEALINK     (sword)-5
#define PROTOCOL_ZMODEM      (sword)-6
#define PROTOCOL_YMODEMG     (sword)-7

#define  EXPERT      (byte)0x02
#define  REGULAR     (byte)0x04
#define  NOVICE      (byte)0x06

#endif /* __MAX_H_DEFINED */

