
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Library General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
//
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Library General Public License for more details.
//
//  You should have received a copy of the GNU Library General Public
//  License along with this library; if not, write to the Free
//  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gxme2.cpp,v 1.1.1.1 1998/11/21 19:38:10 odinn Exp $
//  ------------------------------------------------------------------
//  Read areas from ME2
//  ------------------------------------------------------------------


#include <gstrall.h>
#include <gedacfg.h>


//  ------------------------------------------------------------------
//  Read AREADESC.ME2 and AREAS.BBS

void gareafile::ReadME2(char* tag) {

  AreaCfg aa;
  FILE* fp;
  Path file;
  char* ptr;
  char* ptr2;
  char* desc;
  char* group;
  char* echoid;
  char buf[256], options[80];

  if(*tag) {
    ptr2 = tag;
    ptr2 = strskip_wht(ptr2);
    if(*ptr2) {
      ptr = ptr2;
      ptr2 = strskip_txt(ptr2);
      ptr2 = NulTermNxt(ptr2);
      strcpy(options, ptr2);
      strcpy(file, ptr);

      MakePathname(file, areapath, file);

      fp = fsopen(file, "rt", sharemode);
      if(fp) {
        setvbuf(fp, NULL, _IOFBF, 8192);

        if(not quiet)
          printf("\n* Reading %s", file);
        ChkAddStamp(file, options);

        while(fgets(buf, 255, fp)) {

          ptr = strbtrim(buf);
          if(*ptr and *ptr != '*' and *ptr != ';') {
            if(strnieql(ptr, "LOCAL", 5) and (ptr[5] == ' ' or ptr[5] == HT)) {

              // Found local area - add it
              aa.reset();
              aa.type = GMB_LOCAL;
              aa.attr = attribslocal;
              aa.msgbase = fidomsgtype;
              ptr += 5;
              ptr = strskip_wht(ptr);
              ptr2 = ++ptr;
              ptr2 = strskip_to(ptr2, '\'');
              ptr2 = NulTermNxt(ptr2);
              aa.setdesc(ptr);
              ptr = ptr2;
              ptr = strskip_wht(ptr);
              ptr2 = ++ptr;
              ptr2 = strskip_to(ptr2, '\'');
              NulTermNxt(ptr2);
              aa.setpath(ptr);
              AddNewArea(aa);
            }
            else {
              ptr2 = ptr;
              ptr2 = strskip_txt(ptr2);
              ptr2 = NulTermNxt(ptr2);
              echoid = ptr;
              ptr2 = strskip_wht(ptr2);
              ptr = ++ptr2;
              ptr2 = strskip_to(ptr2, '\'');
              ptr2 = NulTermNxt(ptr2);
              desc = ptr;
              ptr = ptr2;
              ptr = strskip_wht(ptr);
              ptr2 = ++ptr;
              ptr2 = strskip_to(ptr2, '\'');
              NulTermNxt(ptr2);
              group = ptr;
              sprintf(file, "%-33s%-5s", desc, group);
              echolist.AddDesc(echoid, file);
            }
          }
        }
        ReadAreasBBS(options);
      }
    }
  }
}


//  ------------------------------------------------------------------

