
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gmoprot.h,v 1.1.1.1 1998/11/21 19:38:13 odinn Exp $
//  ------------------------------------------------------------------
//  Messagebase function prototypes
//  ------------------------------------------------------------------


//  ------------------------------------------------------------------

#include <goldall.h>


//  ------------------------------------------------------------------

void EzycomInit(const char* msgbasepath, const char* userbasepath, int userno);
void EzycomExit();

void EzycomWideOpen();
void EzycomWideClose();


//  ------------------------------------------------------------------

void FidoInit(const char* fidolastread, int fidohwmarks, int fidonullfix, int fidouserno, const char* squishuserpath);
void FidoExit();
void FidoRenumberProgress(const char* s);

void FidoWideOpen();
void FidoWideClose();


//  ------------------------------------------------------------------

void GoldInit(const char* path, const char* syspath, int userno, long sizewarn=0, int ra2usersbbs=0);
void GoldExit();

void GoldWideOpen();
void GoldWideClose();


//  ------------------------------------------------------------------

void HudsInit(const char* path, const char* syspath, int userno, long sizewarn, int ra2usersbbs);
void HudsExit();
void HudsSizewarn();

void HudsWideOpen();
void HudsWideClose();

void HGWarnRebuild();


//  ------------------------------------------------------------------

void JamInit(const char* jampath, int harddelete);
void JamExit();

void JamWideOpen();
void JamWideClose();


//  ------------------------------------------------------------------

void PcbInit(const char* path, int userno);
void PcbExit();
void PcbAdjustArea(uint rec, const char* msgfile);

void PcbWideOpen();
void PcbWideClose();


//  ------------------------------------------------------------------

void SquishInit(const char* userpath, int userno, int direct, int recycle, int squishscan);
void SquishExit();

void SquishWideOpen();
void SquishWideClose();


//  ------------------------------------------------------------------

void WCatInit(int userno);
void WCatExit();

void WCatWideOpen();
void WCatWideClose();


//  ------------------------------------------------------------------

void XbbsInit(const char* path, int userno);
void XbbsExit();

void XbbsWideOpen();
void XbbsWideClose();


//  ------------------------------------------------------------------

#if defined(__BORLANDC__) and defined(__MSDOS__)

inline void EzycomInit(const char*, const char*, int) { }
inline void EzycomExit() { }

inline void EzycomWideOpen() { }
inline void EzycomWideClose() { }

#endif


//  ------------------------------------------------------------------

#if defined(__BORLANDC__) and defined(__MSDOS__)

inline void GoldInit(const char*, const char*, int, long, int) { }
inline void GoldExit() { }

inline void GoldWideOpen() { }
inline void GoldWideClose() { }

#endif


//  ------------------------------------------------------------------

#if defined(__BORLANDC__) and defined(__MSDOS__)

inline void PcbInit(const char*, int) { }
inline void PcbExit() { }

inline void PcbWideOpen() { }
inline void PcbWideClose() { }

#endif


//  ------------------------------------------------------------------

#if defined(__BORLANDC__) and defined(__MSDOS__)

inline void WCatInit(int) { }
inline void WCatExit() { }

inline void WCatWideOpen() { }
inline void WCatWideClose() { }

#endif


//  ------------------------------------------------------------------
//  When not in OS/2, use DUMMY AdeptXBBS functions

#if not defined(__OS2__)

inline void XbbsInit(const char*, int) { }
inline void XbbsExit() { }

inline void XbbsWideOpen() { }
inline void XbbsWideClose() { }

#endif


//  ------------------------------------------------------------------

