
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gmowcat5.cpp,v 1.1.1.1 1998/11/21 19:38:12 odinn Exp $
//  ------------------------------------------------------------------
//  WildCat! 4.x messagebase engine.
//  ------------------------------------------------------------------


//  ------------------------------------------------------------------

#include <gdbgtrk.h>
#include <gmemall.h>
#include <gstrall.h>

#include <gmowcat.h>


//  ------------------------------------------------------------------

char* WCatArea::user_lookup(char* __lookfor) {

  NW(__lookfor);
  return NULL;
}


//  ------------------------------------------------------------------

int WCatArea::renumber() {

  return FALSE;
}


//  ------------------------------------------------------------------
//  Hexdump the current message header

Line* WCatArea::make_dump_msg(Line*& lin, gmsg* msg) {

  GFTRK("WCatMakeDump");

  WCatHdr _hdr;
  load_message(GMSG_HDRTXT, msg, _hdr);

  char buf[100];
  Line* line = lin =
  AddLine (NULL, "Hexdump of WildCat! message header and text");
  AddLineF(line, "------------------------------------------------------------------------------");
  AddLineF(line, "");
  AddLineF(line, "Path       : %s", path());
  AddLineF(line, "MagicNumber: %08lXh", _hdr.magicnumber);
  AddLineF(line, "MsgNumber  : %u", _hdr.msgno);
  AddLineF(line, "Orig       : %s", STRNP2C(_hdr.from));
  AddLineF(line, "OrigTitle  : %s", STRNP2C(_hdr.fromtitle));
  AddLineF(line, "OrigUserID : %li", _hdr.fromuserid);
  AddLineF(line, "Dest       : %s", STRNP2C(_hdr.to));
  AddLineF(line, "DestTitle  : %s", STRNP2C(_hdr.totitle));
  AddLineF(line, "DestUserID : %li", _hdr.touserid);
  AddLineF(line, "Subject    : %s", STRNP2C(_hdr.subject));
  AddLineF(line, "Network    : %s", STRNP2C(_hdr.network));
  AddLineF(line, "MsgTime    : %s (%u, %li)", strftimeip(buf, 100, "%d %b %y  %H:%M:%S", glocaltime(&msg->written)), _hdr.msgdate, _hdr.msgtime);
  AddLineF(line, "ReadTime   : %s (%u, %li)", strftimeip(buf, 100, "%d %b %y  %H:%M:%S", glocaltime(&msg->received)), _hdr.readdate, _hdr.readtime);
  AddLineF(line, "mFlags     : %u (%04Xh)", _hdr.mflags, _hdr.mflags);
  AddLineF(line, "Reference  : %u", _hdr.reference);
  AddLineF(line, "FidoFrom   : %u:%u/%u.%u", _hdr.origaddr.zone, _hdr.origaddr.net, _hdr.origaddr.node, _hdr.origaddr.point);
  AddLineF(line, "FidoTo     : %u:%u/%u.%u", _hdr.origaddr.zone, _hdr.destaddr.net, _hdr.destaddr.node, _hdr.destaddr.point);
  AddLineF(line, "MsgBytes   : %u", _hdr.msgbytes);
  AddLineF(line, "Int.Attach : %s", STRNP2C(_hdr.internalattach));
  AddLineF(line, "Ext.Attach : %s", STRNP2C(_hdr.externalattach));
  AddLineF(line, "PrevUnread : %u", _hdr.prevunread);
  AddLineF(line, "NextUnread : %u", _hdr.nextunread);
  AddLineF(line, "FidoFlags  : %u (%04Xh)", _hdr.fidoflags, _hdr.fidoflags);
  AddLineF(line, "Cost       : %li", _hdr.cost);
  AddLineF(line, "Reserved   : %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X",
    _hdr.reserved[0], _hdr.reserved[1], _hdr.reserved[2],
    _hdr.reserved[3], _hdr.reserved[4], _hdr.reserved[5],
    _hdr.reserved[6], _hdr.reserved[7], _hdr.reserved[8],
    _hdr.reserved[9], _hdr.reserved[10], _hdr.reserved[11],
    _hdr.reserved[12], _hdr.reserved[13], _hdr.reserved[14],
    _hdr.reserved[15], _hdr.reserved[16], _hdr.reserved[17],
    _hdr.reserved[18], _hdr.reserved[19]
  );
  AddLineF(line, "");
  AddLineF(line, "UserRecno  : %u (%s)", wide->userno, WideUsername[0]);
  AddLineF(line, "");
  AddLineF(line, "Hexdump of message header:");
  AddLineF(line, "");

  int _count;
  char* _ptr = (char*)&_hdr;
  for(_count=0; _count<sizeof(WCatHdr); _ptr+=16,_count+=16) {
    sprintf(buf, "%04X   ", _count);
    HexDump16(buf+7, _ptr, 16, HEX_DUMP2);
    line = AddLine(line, buf);
  }
  sprintf(buf, "%04X   ", _count);
  HexDump16(buf+7, _ptr, 14, HEX_DUMP2);
  line = AddLine(line, buf);

  GFTRK(NULL);

  return line;
}


//  ------------------------------------------------------------------

