
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gmbarea.cpp,v 1.1.1.1 1998/11/21 19:38:13 odinn Exp $
//  ------------------------------------------------------------------
//  Area structures and classes.
//  ------------------------------------------------------------------


//  ------------------------------------------------------------------

#include <gmbarea.h>


//  ------------------------------------------------------------------

glog*        gmb_wide_log = NULL;
int          gmb_wide_debug = false;
int          gmb_wide_canlock = true;
const char** gmb_wide_username = NULL;
int          gmb_wide_usernames = 0;
uint         gmb_wide_sharemode = SH_DENYNO;
int          gmb_wide_dispsoftcr = false;
int          gmb_wide_personalmail = 0;
int          gmb_wide_timesread = TIMESREAD_NO;

#if defined(__MSDOS__) and not defined(__386__)
long         gmb_wide_msgsize = 64000L;
#else
long         gmb_wide_msgsize = 512000L;
#endif


//  ------------------------------------------------------------------

void gmb_area::init(gareacfg* c) {

  cfg = c;
  lastreadentry = 0;
  refs = open_refs = lock_refs = 0;
  scan_count = pmscan_count = lastread = 0;
}


//  ------------------------------------------------------------------

gmb_area::~gmb_area() {

}



//  ------------------------------------------------------------------

gmb_area_manager::gmb_area_manager() {

}


//  ------------------------------------------------------------------

gmb_area_manager::~gmb_area_manager() {

}


//  ------------------------------------------------------------------

gmb_area* gmb_area_manager::find(gareacfg* a) const {

  for(int n=0; n<active.size(); n++) {
    if(active[n]->areaid() == a->areaid())
      return active[n];
  }

  return NULL;
}


//  ------------------------------------------------------------------

gmb_area* gmb_area_manager::find_inactive() const {

  for(int n=0; n<active.size(); n++) {
    if(active[n]->references() == 0)
      return active[n];
  }

  return NULL;
}


//  ------------------------------------------------------------------

gmb_area* gmb_area_manager::activate(gareacfg* c) {

  gmb_area* area = find(c);
  if(area == NULL) {
    area = find_inactive();
    if(area)
      init_area(area, c);
    else {
      area = new_area(c);
      active.add(area);
    }
  }

  area->activate();

  return area;
}


//  ------------------------------------------------------------------

