
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gmbezyc5.cpp,v 1.1.1.1 1998/11/21 19:38:13 odinn Exp $
//  ------------------------------------------------------------------
//  Ezycom msgbase handling.
//  ------------------------------------------------------------------


//  ------------------------------------------------------------------

#include <gmemdbg.h>
#include <gdbgtrk.h>
#include <gmemall.h>
#include <gstrall.h>
#include <gutlmisc.h>

#include <gmbezyc.h>


//  ------------------------------------------------------------------

bool gmb_ezycom_area::user_lookup(gstring& lookfor) {

  wide->user.fh = ::sopen(AddPath(wide->userbasepath.c_str(), "USERS.BBS"), O_RDWR|O_BINARY, gmb_wide_sharemode, S_STDRW);
  if(wide->user.fh) {
    char buf[256];
    if(wide->user.findwild(lookfor.c_str(), buf))
      lookfor = buf;
    ::close(wide->user.fh);
  }

  return wide->user.found;
}


//  ------------------------------------------------------------------

bool gmb_ezycom_area::renumber() {

  return false;
}


//  ------------------------------------------------------------------

void gmb_ezycom_area::hexdump_msg(gmsg& msg, gstring& dump) {

  GFTRK("EzycomMakeDump");

  EzycHdr hdr;

  memset(&hdr, 0, sizeof(EzycHdr));
  lseekset(fhhdr, msg.msgno-1, sizeof(EzycHdr));
  read(fhhdr, &hdr, sizeof(EzycHdr));

  char* txt = (char*)throw_calloc(1, (uint)(hdr.messagelength+256));
  lseekset(fhtxt, hdr.startposition);
  read(fhtxt, txt, (uint)hdr.messagelength);

  char buf[100];

  dump =  "Hexdump of Ezycom-style message header and text\n";
  dump += "------------------------------------------------------------------------------\n";
  dump += "\n";
  dump += gstrf("Msgbase  : %s\n", wide->msgbasepath.c_str());
  dump += gstrf("BoardNo  : %u\n", board());
  dump += gstrf("From     : %-35.35s\n", strnp2c(hdr.whofrom, EZYC_MAXNAME-1));
  dump += gstrf("To       : %-35.35s\n", strnp2c(hdr.whoto,   EZYC_MAXNAME-1));
  dump += gstrf("Subject  : %-72.72s\n", strnp2c(hdr.subject, EZYC_MAXSUBJ-1));
  dump += gstrf("Orig     : %u:%u/%u.%u\n", hdr.orignet.zone, hdr.orignet.net, hdr.orignet.node, hdr.orignet.point);
  dump += gstrf("Dest     : %u:%u/%u.%u\n", hdr.destnet.zone, hdr.destnet.net, hdr.destnet.node, hdr.destnet.point);
  dump += gstrf("Reply    : %u  See : %u\n", hdr.replyto, hdr.reply1st);
  dump += gstrf("Cost     : %u\n", hdr.cost);
  dump += gstrf("MsgAttr  : %02Xh (%sb)\n", hdr.msgattr, ltob(buf, hdr.msgattr, 8));
  dump += gstrf("NetAttr  : %02Xh (%sb)\n", hdr.netattr, ltob(buf, hdr.netattr, 8));
  dump += gstrf("ExtAttr  : %02Xh (%sb)\n", hdr.extattr, ltob(buf, hdr.extattr, 8));
  dump += gstrf("PostDate : %s (%08lXh)\n", hdr.posttimedate.c_str(buf), hdr.posttimedate.number());
  dump += gstrf("RecvDate : %s (%08lXh)\n", hdr.recvtimedate.c_str(buf), hdr.recvtimedate.number());
  dump += gstrf("StartPos : %lu\n", hdr.startposition);
  dump += gstrf("MsgLength: %lu\n", hdr.messagelength);
  dump += gstrf("UserRecno: %u (%s)\n", wide->userno, gmb_wide_username[0]);

  dump += "\n";
  dump += "Hexdump of message header:\n";
  dump += "\n";

  addhexdump(dump, &hdr, sizeof(EzycHdr), "\n");

  throw_free(txt);

  GFTRK(NULL);
}


//  ------------------------------------------------------------------

