
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gmbwcat5.cpp,v 1.1.1.1 1998/11/21 19:38:14 odinn Exp $
//  ------------------------------------------------------------------
//  WildCat! 4.x messagebase engine.
//  ------------------------------------------------------------------


//  ------------------------------------------------------------------

#include <gdbgtrk.h>
#include <gmemall.h>
#include <gstrall.h>

#include <gmbwcat.h>


//  ------------------------------------------------------------------

bool gmb_wildcat_area::user_lookup(gstring&) {

  return false;
}


//  ------------------------------------------------------------------

bool gmb_wildcat_area::renumber() {

  return false;
}


//  ------------------------------------------------------------------
//  Hexdump the current message header

void gmb_wildcat_area::hexdump_msg(gmsg& msg, gstring& dump) {

  GFTRK("gmb_wildcat_area::MakeDump");

  WCatHdr _hdr;
  load_message(GMSG_HDRTXT, msg, _hdr);

  dump =  "Hexdump of WildCat! message header and text\n";
  dump += "------------------------------------------------------------------------------\n";
  dump += "\n";
  dump += gstrf("Path       : %s\n", path().c_str());
  dump += gstrf("MagicNumber: %08lXh\n", _hdr.magicnumber);
  dump += gstrf("MsgNumber  : %u\n", _hdr.msgno);
  dump += gstrf("Orig       : %s\n", _hdr.from);
  dump += gstrf("OrigTitle  : %s\n", STRNP2C(_hdr.fromtitle));
  dump += gstrf("OrigUserID : %li\n", _hdr.fromuserid);
  dump += gstrf("Dest       : %s\n", _hdr.to);
  dump += gstrf("DestTitle  : %s\n", STRNP2C(_hdr.totitle));
  dump += gstrf("DestUserID : %li\n", _hdr.touserid);
  dump += gstrf("Subject    : %s\n", _hdr.subject);
  dump += gstrf("Network    : %s\n", STRNP2C(_hdr.network));
  dump += gstrf("MsgTime    : %s (%u, %li)\n", msg.date.written.fts1(), _hdr.msgdate, _hdr.msgtime);
  dump += gstrf("ReadTime   : %s (%u, %li)\n", msg.date.received.fts1(), _hdr.readdate, _hdr.readtime);
  dump += gstrf("mFlags     : %u (%04Xh)\n", _hdr.mflags, _hdr.mflags);
  dump += gstrf("Reference  : %u\n", _hdr.reference);
  dump += gstrf("FidoFrom   : %u:%u/%u.%u\n", _hdr.origaddr.zone, _hdr.origaddr.net, _hdr.origaddr.node, _hdr.origaddr.point);
  dump += gstrf("FidoTo     : %u:%u/%u.%u\n", _hdr.origaddr.zone, _hdr.destaddr.net, _hdr.destaddr.node, _hdr.destaddr.point);
  dump += gstrf("MsgBytes   : %u\n", _hdr.msgbytes);
  dump += gstrf("Int.Attach : %s\n", STRNP2C(_hdr.internalattach));
  dump += gstrf("Ext.Attach : %s\n", STRNP2C(_hdr.externalattach));
  dump += gstrf("PrevUnread : %u\n", _hdr.prevunread);
  dump += gstrf("NextUnread : %u\n", _hdr.nextunread);
  dump += gstrf("FidoFlags  : %u (%04Xh)\n", _hdr.fidoflags, _hdr.fidoflags);
  dump += gstrf("Cost       : %li\n", _hdr.cost);
  dump += gstrf("Reserved   : %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X\n",
    _hdr.reserved[0], _hdr.reserved[1], _hdr.reserved[2],
    _hdr.reserved[3], _hdr.reserved[4], _hdr.reserved[5],
    _hdr.reserved[6], _hdr.reserved[7], _hdr.reserved[8],
    _hdr.reserved[9], _hdr.reserved[10], _hdr.reserved[11],
    _hdr.reserved[12], _hdr.reserved[13], _hdr.reserved[14],
    _hdr.reserved[15], _hdr.reserved[16], _hdr.reserved[17],
    _hdr.reserved[18], _hdr.reserved[19]
  );
  dump += "\n";
  dump += gstrf("UserRecno  : %u (%s)\n", wide->userno, gmb_wide_username[0]);

  dump += "\n";
  dump += "Hexdump of message header:\n";
  dump += "\n";

  addhexdump(dump, &_hdr, sizeof(WCatHdr), "\n");

  GFTRK(NULL);
}


//  ------------------------------------------------------------------

