
//  ------------------------------------------------------------------
//  The Goldware Library. Copyright (C) Odinn Sorensen.
//  ------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License as
//  published by the Free Software Foundation; either version 2 of the
//  License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//  ------------------------------------------------------------------
//  $Id: gmbxbbs5.cpp,v 1.1.1.1 1998/11/21 19:38:14 odinn Exp $
//  ------------------------------------------------------------------
//  AdeptXBBS messagebase engine.
//  ------------------------------------------------------------------


//  ------------------------------------------------------------------

#include <gdbgtrk.h>
#include <gmemall.h>
#include <gstrall.h>

#include <gmbxbbs.h>


//  ------------------------------------------------------------------

#if defined(__OS2__)


//  ------------------------------------------------------------------

bool gmb_adeptxbbs_area::user_lookup(gstring& lookfor) {

  char buf[256];
  if(wide->user.findwild(lookfor.c_str(), buf))
    lookfor = buf;

  return wide->user.found;
}


//  ------------------------------------------------------------------

bool gmb_adeptxbbs_area::renumber() {

  return false;
}


//  ------------------------------------------------------------------
//  Hexdump the current message header

void gmb_adeptxbbs_area::hexdump_msg(gmsg& msg, gstring& dump) {

  GFTRK("gmb_adeptxbbs_area::MakeDump");

  XbbsHdr hdr;
  load_message(GMSG_HDRTXT, msg, hdr);
  XbbsIdx* idxp = idx + (msg.msgno - 1);

  char buf[100];

  dump =  "Hexdump of AdeptXBBS message header and text\n";
  dump += "------------------------------------------------------------------------------\n";
  dump += "\n";
  dump += gstrf("Path       : %s\n", path().c_str());
  dump += gstrf("UserRecno  : %u (%s)\n", wide->userno, gmb_wide_username[0]);
  dump += "\n";
  dump += "Header Record:\n";
  dump += "\n";
  dump += gstrf("Version    : %u.%u\n", hdr.majorversion, hdr.minorversion);
  dump += gstrf("StructLen  : %u\n", hdr.structlen);
  dump += gstrf("From       : %s\n", hdr.from);
  dump += gstrf("To         : %s\n", hdr.to);
  dump += gstrf("Subj       : %s\n", hdr.subj);
  dump += gstrf("Date       : %s\n", hdr.date);
  dump += gstrf("InDate     : %u-%u-%u\n", hdr.indate[0]+1989, hdr.indate[1], hdr.indate[2]);
  dump += gstrf("MsgNum     : %lu\n", hdr.msgnum);
  dump += gstrf("TimesRead  : %lu\n", hdr.timesread);
  dump += gstrf("TimeRecv   : %s (%08lXh)\n", TimeToStr(buf, hdr.timerecv), hdr.timerecv);
  dump += gstrf("Length     : %lu\n", hdr.length);
  dump += gstrf("Start      : %lu\n", hdr.start);
  dump += gstrf("Extra1,2,3 : %lu, %lu, %lu\n", hdr.extra1, hdr.extra2, hdr.extra3);
  dump += gstrf("OrigAddr   : %u:%u/%u.%u\n", hdr.origaddr.zone, hdr.origaddr.net, hdr.origaddr.node, hdr.origaddr.point);
  dump += gstrf("DestAddr   : %u:%u/%u.%u\n", hdr.origaddr.zone, hdr.destaddr.net, hdr.destaddr.node, hdr.destaddr.point);
  dump += gstrf("Cost       : %u\n", hdr.cost);
  dump += gstrf("FFlags     : %u (%04Xh)\n", hdr.fflags, hdr.fflags);
  dump += gstrf("XFlags     : %u (%04Xh)\n", hdr.xflags, hdr.xflags);
  dump += gstrf("IFlags     : %lu (%08lXh)\n", hdr.iflags, hdr.iflags);
  dump += gstrf("OFlags     : %lu (%08lXh)\n", hdr.oflags, hdr.oflags);
  dump += "\n";
  dump += "Index Record:\n";
  dump += "\n";
  dump += gstrf("CheckSumTo      : %04Xh (%u)\n", idxp->to,   idxp->to);
  dump += gstrf("CheckSumFrom    : %04Xh (%u)\n", idxp->from, idxp->from);
  dump += gstrf("CheckSumSubj    : %04Xh (%u)\n", idxp->subj, idxp->subj);
  dump += gstrf("MsgidCrc        : %08lXh (%lu)\n", idxp->msgidcrc,      idxp->msgidcrc);
  dump += gstrf("MsgidSerialNo   : %08lXh (%lu)\n", idxp->msgidserialno, idxp->msgidserialno);
  dump += gstrf("ReplyidCrc      : %08lXh (%lu)\n", idxp->replycrc,      idxp->replycrc);
  dump += gstrf("ReplyidSerialNo : %08lXh (%lu)\n", idxp->replyserialno, idxp->replyserialno);
  dump += "\n";

  dump += "\n";
  dump += "Hexdump of message header:\n";
  dump += "\n";

  addhexdump(dump, &hdr, sizeof(XbbsHdr), "\n");

  GFTRK(NULL);
}


//  ------------------------------------------------------------------

#endif

//  ------------------------------------------------------------------

