
##  ------------------------------------------------------------------
##  The Goldware Library. Copyright (C) Odinn Sorensen.
##  ------------------------------------------------------------------
##  This program is free software; you can redistribute it and/or
##  modify it under the terms of the GNU General Public License as
##  published by the Free Software Foundation; either version 2 of the
##  License, or (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
##  General Public License for more details.
##
##  You should have received a copy of the GNU General Public License
##  along with this program; if not, write to the Free Software
##  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
##  ------------------------------------------------------------------
##  $Id: mkexebcc.mak,v 1.2 1998/12/27 16:08:11 odinn Exp $
##  ------------------------------------------------------------------
##  Makefile to build linker and exe files for Borland.
##  ------------------------------------------------------------------

!include bld$(PLATFORM).inc

##  ------------------------------------------------------------------

$(TARGETEXE).exe: INIT bld$(PLATFORM).lnk  $(objs)
  @echo Linking ...
  @echo ------------------------------------------------------------------------------- >>bldbcc.lst
!if $d(PLATFORM_BCD)
  @$(BCC_BASE)\bin\tlink.exe -L$(LIBPATH);$(BCC_BASE)\lib @bldbcd.lnk                 >>bldbcc.lst
!elif $d(PLATFORM_BCO)
  @$(BCC_BASE)\bin\tlink.exe -L$(LIBPATH);$(BCC_BASE)\lib @bldbco.lnk                 >>bldbcc.lst
!elif $d(PLATFORM_BCX)
  @$(BCC_BASE)\bin\tlink32.exe -L$(LIBPATH);$(BCC_BASE)\lib @bldbcx.lnk               >>bldbcc.lst
!endif
  @echo ------------------------------------------------------------------------------- >>bldbcc.lst
  @rm bldbcc.cfg
  @echo Done!

##  ------------------------------------------------------------------

!if $d(PLATFORM_BCD)
bldbcd.lnk : $(TARGET).all
  @gbuild.exe $(TARGET).all bldbcd.tmp $(OBJPATH) link borland bcd
  @echo /o- $(BCD_BASE)\lib\c0l+           > bldbcd.lnk
  @type bldbcd.tmp                        >> bldbcd.lnk
  @echo $(TARGETEXE).exe                  >> bldbcd.lnk
  @echo /c /s /v-                         >> bldbcd.lnk
  @echo /o- $(LIBS)+                      >> bldbcd.lnk
!ifdef MKOVL
  @echo /o+ $(LIBSO)+                     >> bldbcd.lnk
  @echo /o- overlay.lib+                  >> bldbcd.lnk
!else
  @echo /o- $(LIBSO)+                     >> bldbcd.lnk
!endif
  @echo /o- noehl.lib+                    >> bldbcd.lnk
  @echo /o- cl.lib                        >> bldbcd.lnk
  @rm bldbcd.tmp
!endif

##  ------------------------------------------------------------------

!if $d(PLATFORM_BCO)
bldbco.lnk : $(TARGET).all
  @gbuild.exe $(TARGET).all bldbco.tmp $(OBJPATH) link borland bco
  @echo $(BCO_BASE)\lib\c02+               > bldbco.lnk
  @type bldbco.tmp                        >> bldbco.lnk
  @echo $(TARGETEXE).exe                  >> bldbco.lnk
  @echo -B:0x10000 -c -s -Oc -Toe -ap -v  >> bldbco.lnk
  @echo $(LIBS)+                          >> bldbco.lnk
  @echo c2.lib+                           >> bldbco.lnk
  @echo os2.lib                           >> bldbco.lnk
  @if exist $(TARGETEXE).def             echo $(TARGETEXE).def                  >> bldbco.lnk
  @if exist resource\$(TARGETEXE).res echo resource\$(TARGETEXE).res            >> bldbco.lnk
  @rm bldbco.tmp
!endif

##  ------------------------------------------------------------------

!if $d(PLATFORM_BCX)
bldbcx.lnk : $(TARGET).all
  @gbuild.exe $(TARGET).all bldbcx.tmp $(OBJPATH) link borland bcx
  @echo $(BCX_BASE)\lib\c0x32+             > bldbcx.lnk
  @type bldbcx.tmp                        >> bldbcx.lnk
  @echo $(TARGETEXE).exe                  >> bldbcx.lnk
  @echo -Tpe -ap -c -s -v                 >> bldbcx.lnk
  @echo $(LIBS)+                          >> bldbcx.lnk
  @echo import32.lib+                     >> bldbcx.lnk
  @echo cw32.lib                          >> bldbcx.lnk
  @if exist $(TARGETEXE).def             echo $(TARGETEXE).def >> bldbcx.lnk
  @if exist resource\$(TARGETEXE).res echo resource\$(TARGETEXE).res >> bldbcx.lnk
  @rm bldbcx.tmp
!endif

##  ------------------------------------------------------------------

INIT:
  @echo Preparing compilation ...
  @echo -------------------------------------------------------------------------------  >bldbcc.lst
  @echo Making $(TARGETEXE).exe                                                         >>bldbcc.lst
  @echo $(BCC_CFLAGS) > bldbcc.cfg
  @echo $(BCC_INC)   >> bldbcc.cfg
!ifdef BCC_INC2
  @echo $(BCC_INC2)  >> bldbcc.cfg
!endif
  @echo $(BCC_LIB)   >> bldbcc.cfg
  @echo $(CFLAGS)    >> bldbcc.cfg
  @touch $(TARGET).cpp >nul
  @echo Checking dependencies ...

##  ------------------------------------------------------------------

