
##  ------------------------------------------------------------------
##  The Goldware Library. Copyright (C) Odinn Sorensen.
##  ------------------------------------------------------------------
##  This program is free software; you can redistribute it and/or
##  modify it under the terms of the GNU General Public License as
##  published by the Free Software Foundation; either version 2 of the
##  License, or (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
##  General Public License for more details.
##
##  You should have received a copy of the GNU General Public License
##  along with this program; if not, write to the Free Software
##  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
##  ------------------------------------------------------------------
##  $Id: mkexewcc.mak,v 1.1.1.1 1998/11/21 19:37:58 odinn Exp $
##  ------------------------------------------------------------------
##  Makefile to build linker and exe files for Watcom.
##  ------------------------------------------------------------------

cflags2=-fh=$(OBJPATH)\$(TARGET).pch

##  ------------------------------------------------------------------

!include bld$(PLATFORM).inc

##  ------------------------------------------------------------------

$(TARGETEXE).exe: INIT bld$(PLATFORM).lnk $(objs)
  @echo ------------------------------------------------------------------------------- >>bldwcc.lst
  @echo Linking ...
  @wlink.exe @bld$(PLATFORM).lnk                                                        >>bldwcc.lst
  @echo ------------------------------------------------------------------------------- >>bldwcc.lst
  @echo Done!

##  ------------------------------------------------------------------

bldwcn.lnk : $(TARGET).all
  @gbuild $(TARGET).all bldwcn.tmp $(OBJPATH) link watcom wcn
  @echo system nt                             > bldwcn.lnk
  @echo option dosseg                        >> bldwcn.lnk
  @echo option caseexact                     >> bldwcn.lnk
  @echo option eliminate                     >> bldwcn.lnk
  @echo option stack=32768                   >> bldwcn.lnk
  @echo option map=$(TARGETEXE).map          >> bldwcn.lnk
  @type bldwcn.tmp                           >> bldwcn.lnk
  @echo name $(TARGETEXE)                    >> bldwcn.lnk
  @echo libpath $(LIBPATH)                   >> bldwcn.lnk
  @echo library $(LIBS)                      >> bldwcn.lnk
  @rm bldwcn.tmp

##  ------------------------------------------------------------------

bldwco.lnk : $(TARGET).all
  @gbuild $(TARGET).all bldwco.tmp $(OBJPATH) link watcom wco
  @echo system os2v2                          > bldwco.lnk
  @echo option dosseg                        >> bldwco.lnk
  @echo option caseexact                     >> bldwco.lnk
  @echo option eliminate                     >> bldwco.lnk
  @echo option stack=32768                   >> bldwco.lnk
  @echo option offset=0x10000                >> bldwco.lnk
  @echo option map=$(TARGETEXE).map          >> bldwco.lnk
  @type bldwco.tmp                           >> bldwco.lnk
  @echo name $(TARGETEXE)                    >> bldwco.lnk
  @echo libpath $(LIBPATH)                   >> bldwco.lnk
  @echo library $(LIBS)                      >> bldwco.lnk
  @rm bldwco.tmp

##  ------------------------------------------------------------------

bldwcx.lnk : $(TARGET).all
  @gbuild $(TARGET).all bldwcx.tmp $(OBJPATH) link watcom wcx
  @echo system dos4g                          > bldwcx.lnk
  @echo option dosseg                        >> bldwcx.lnk
  @echo option caseexact                     >> bldwcx.lnk
  @echo option eliminate                     >> bldwcx.lnk
  @echo option stack=32768                   >> bldwcx.lnk
  @echo option map=$(TARGETEXE).map          >> bldwcx.lnk
  @type bldwcx.tmp                           >> bldwcx.lnk
  @echo name $(TARGETEXE)                    >> bldwcx.lnk
  @echo libpath $(LIBPATH)                   >> bldwcx.lnk
  @echo library $(LIBS)                      >> bldwcx.lnk
  @rm bldwcx.tmp

##  ------------------------------------------------------------------

INIT: .symbolic
  @echo Preparing compilation ...
  @echo -------------------------------------------------------------------------------  >bldwcc.lst
  @echo Making $(TARGETEXE).exe                                                         >>bldwcc.lst
  @set WCCFLAGS=$(cflags) $(cflags2) -fo=$(OBJPATH)\.obj
  @wtouch.exe $(TARGET).cpp
  @echo Checking dependencies ...

##  ------------------------------------------------------------------

