
##  ------------------------------------------------------------------
##  The Goldware Library. Copyright (C) Odinn Sorensen.
##  ------------------------------------------------------------------
##  This program is free software; you can redistribute it and/or
##  modify it under the terms of the GNU General Public License as
##  published by the Free Software Foundation; either version 2 of the
##  License, or (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
##  General Public License for more details.
##
##  You should have received a copy of the GNU General Public License
##  along with this program; if not, write to the Free Software
##  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
##  ------------------------------------------------------------------
##  $Id: rulesgnu.mak,v 1.4 1999/01/26 01:39:12 damware Exp $
##  ------------------------------------------------------------------
##  Makefile rules for GNU MAKE.
##  ------------------------------------------------------------------

ifeq ($(GNU),27X)
  GNU27X=1
else
  GNU28X=1
endif

ifdef PLATFORM_DJG
PLATFORM=djg
DEBUG=-g
GGXX=gcc
CFLAGS3=-O2
endif

ifdef PLATFORM_EMX
PLATFORM=emx
DEBUG=-g
GNU27X=1
GGXX=gxx
CFLAGS3=-O2
endif

ifdef PLATFORM_LNX
PLATFORM=lnx
DEBUG=-g
GGXX=g++
ifdef GNU28X
CFLAGS3=-O6 -mpentium
endif
endif

ifdef PLATFORM_RSX
PLATFORM=rsx
DEBUG=-g
GNU28X=1
GGXX=gxx
CFLAGS3=-Zwin32 -O2
endif

##  ------------------------------------------------------------------

GSRCG=$(subst \,/,$(GSRC))
GLIBG=$(subst \,/,$(GLIB))
GOBJG=$(subst \,/,$(GOBJ))
SRCPATH=$(GSRCG)/$(TARGET)
LIBPATH=$(GLIBG)/$(PLATFORM)
OBJPATH=$(GOBJG)/$(PLATFORM)/$(TARGET)

##  ------------------------------------------------------------------

## GNU 2.8.x
ifdef GNU28X
#CFLAGS1=-Wno-sign-compare -fno-exceptions -fomit-frame-pointer
CFLAGS1=-Wno-sign-compare -fno-exceptions
endif

## GNU 2.7.x
ifdef GNU27X
CFLAGS1=
endif

CFLAGS=$(DEBUG) -Wall -funsigned-char $(CFLAGS1) $(CFLAGS3) $(CFLAGS2) -I$(GSRCG)/goldlib/gall -I$(GSRCG)/goldlib/gcfg -I$(GSRCG)/goldlib/gmb3
vpath %.o $(OBJPATH)
OBJS=$(objs)
DOBJS=$(notdir $(OBJS))
DIROBJS=$(patsubst %.o,$(OBJPATH)/%.o,$(DOBJS))

##  ------------------------------------------------------------------

